// Generated by psc-bundle 0.8.5.0
var PS = {};
(function(exports) {
  /* global exports */
  "use strict";

  // module Prelude

  //- Functor --------------------------------------------------------------------

  exports.arrayMap = function (f) {
    return function (arr) {
      var l = arr.length;
      var result = new Array(l);
      for (var i = 0; i < l; i++) {
        result[i] = f(arr[i]);
      }
      return result;
    };
  };

  //- Monoid ---------------------------------------------------------------------

  exports.concatString = function (s1) {
    return function (s2) {
      return s1 + s2;
    };
  };

  exports.concatArray = function (xs) {
    return function (ys) {
      return xs.concat(ys);
    };
  };

  //- Semiring -------------------------------------------------------------------

  exports.intAdd = function (x) {
    return function (y) {
      /* jshint bitwise: false */
      return x + y | 0;
    };
  };

  exports.intMul = function (x) {
    return function (y) {
      /* jshint bitwise: false */
      return x * y | 0;
    };
  };

  //- Eq -------------------------------------------------------------------------

  exports.refEq = function (r1) {
    return function (r2) {
      return r1 === r2;
    };
  };

  exports.eqArrayImpl = function (f) {
    return function (xs) {
      return function (ys) {
        if (xs.length !== ys.length) return false;
        for (var i = 0; i < xs.length; i++) {
          if (!f(xs[i])(ys[i])) return false;
        }
        return true;
      };
    };
  };

  //- Ord ------------------------------------------------------------------------

  exports.unsafeCompareImpl = function (lt) {
    return function (eq) {
      return function (gt) {
        return function (x) {
          return function (y) {
            return x < y ? lt : x > y ? gt : eq;
          };
        };
      };
    };
  };                                          

  //- BooleanAlgebra -------------------------------------------------------------

  exports.boolOr = function (b1) {
    return function (b2) {
      return b1 || b2;
    };
  };

  exports.boolAnd = function (b1) {
    return function (b2) {
      return b1 && b2;
    };
  };

  exports.boolNot = function (b) {
    return !b;
  };

  //- Show -----------------------------------------------------------------------

  exports.showIntImpl = function (n) {
    return n.toString();
  };

  exports.showNumberImpl = function (n) {
    /* jshint bitwise: false */
    return n === (n | 0) ? n + ".0" : n.toString();
  };

  exports.showCharImpl = function (c) {
    var code = c.charCodeAt(0);
    if (code < 0x20 || code === 0x7F) {
      switch (c) {
        case "\x07": return "'\\a'";
        case "\b": return "'\\b'";
        case "\f": return "'\\f'";
        case "\n": return "'\\n'";
        case "\r": return "'\\r'";
        case "\t": return "'\\t'";
        case "\v": return "'\\v'";
      }
      return "'\\" + code.toString(10) + "'";
    }
    return c === "'" || c === "\\" ? "'\\" + c + "'" : "'" + c + "'";
  };

  exports.showStringImpl = function (s) {
    var l = s.length;
    return "\"" + s.replace(
      /[\0-\x1F\x7F"\\]/g,
      function (c, i) { // jshint ignore:line
        switch (c) {
          case "\"":
          case "\\":
            return "\\" + c;
          case "\x07": return "\\a";
          case "\b": return "\\b";
          case "\f": return "\\f";
          case "\n": return "\\n";
          case "\r": return "\\r";
          case "\t": return "\\t";
          case "\v": return "\\v";
        }
        var k = i + 1;
        var empty = k < l && s[k] >= "0" && s[k] <= "9" ? "\\&" : "";
        return "\\" + c.charCodeAt(0).toString(10) + empty;
      }
    ) + "\"";
  };

  exports.showArrayImpl = function (f) {
    return function (xs) {
      var ss = [];
      for (var i = 0, l = xs.length; i < l; i++) {
        ss[i] = f(xs[i]);
      }
      return "[" + ss.join(",") + "]";
    };
  };
})(PS["Prelude"] = PS["Prelude"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Prelude"];
  var LT = (function () {
      function LT() {

      };
      LT.value = new LT();
      return LT;
  })();
  var GT = (function () {
      function GT() {

      };
      GT.value = new GT();
      return GT;
  })();
  var EQ = (function () {
      function EQ() {

      };
      EQ.value = new EQ();
      return EQ;
  })();
  var Semigroupoid = function (compose) {
      this.compose = compose;
  };
  var Category = function (__superclass_Prelude$dotSemigroupoid_0, id) {
      this["__superclass_Prelude.Semigroupoid_0"] = __superclass_Prelude$dotSemigroupoid_0;
      this.id = id;
  };
  var Functor = function (map) {
      this.map = map;
  };
  var Apply = function (__superclass_Prelude$dotFunctor_0, apply) {
      this["__superclass_Prelude.Functor_0"] = __superclass_Prelude$dotFunctor_0;
      this.apply = apply;
  };
  var Applicative = function (__superclass_Prelude$dotApply_0, pure) {
      this["__superclass_Prelude.Apply_0"] = __superclass_Prelude$dotApply_0;
      this.pure = pure;
  };
  var Bind = function (__superclass_Prelude$dotApply_0, bind) {
      this["__superclass_Prelude.Apply_0"] = __superclass_Prelude$dotApply_0;
      this.bind = bind;
  };
  var Monad = function (__superclass_Prelude$dotApplicative_0, __superclass_Prelude$dotBind_1) {
      this["__superclass_Prelude.Applicative_0"] = __superclass_Prelude$dotApplicative_0;
      this["__superclass_Prelude.Bind_1"] = __superclass_Prelude$dotBind_1;
  };
  var Semigroup = function (append) {
      this.append = append;
  };
  var Semiring = function (add, mul, one, zero) {
      this.add = add;
      this.mul = mul;
      this.one = one;
      this.zero = zero;
  };
  var Eq = function (eq) {
      this.eq = eq;
  };
  var Ord = function (__superclass_Prelude$dotEq_0, compare) {
      this["__superclass_Prelude.Eq_0"] = __superclass_Prelude$dotEq_0;
      this.compare = compare;
  };
  var Bounded = function (bottom, top) {
      this.bottom = bottom;
      this.top = top;
  };
  var BooleanAlgebra = function (__superclass_Prelude$dotBounded_0, conj, disj, not) {
      this["__superclass_Prelude.Bounded_0"] = __superclass_Prelude$dotBounded_0;
      this.conj = conj;
      this.disj = disj;
      this.not = not;
  };
  var Show = function (show) {
      this.show = show;
  };
  var zero = function (dict) {
      return dict.zero;
  };
  var unsafeCompare = $foreign.unsafeCompareImpl(LT.value)(EQ.value)(GT.value);
  var unit = {};
  var top = function (dict) {
      return dict.top;
  }; 
  var showString = new Show($foreign.showStringImpl);
  var showNumber = new Show($foreign.showNumberImpl);
  var showInt = new Show($foreign.showIntImpl);
  var showChar = new Show($foreign.showCharImpl);
  var showBoolean = new Show(function (v) {
      if (v) {
          return "true";
      };
      if (!v) {
          return "false";
      };
      throw new Error("Failed pattern match at Prelude line 842, column 3 - line 843, column 3: " + [ v.constructor.name ]);
  });
  var show = function (dict) {
      return dict.show;
  };
  var showArray = function (dictShow) {
      return new Show($foreign.showArrayImpl(show(dictShow)));
  };                                                                            
  var semiringInt = new Semiring($foreign.intAdd, $foreign.intMul, 1, 0);
  var semigroupoidFn = new Semigroupoid(function (f) {
      return function (g) {
          return function (x) {
              return f(g(x));
          };
      };
  });
  var semigroupString = new Semigroup($foreign.concatString);
  var semigroupArray = new Semigroup($foreign.concatArray);
  var pure = function (dict) {
      return dict.pure;
  };
  var $$return = function (dictApplicative) {
      return pure(dictApplicative);
  };
  var otherwise = true;
  var one = function (dict) {
      return dict.one;
  };
  var not = function (dict) {
      return dict.not;
  };
  var mul = function (dict) {
      return dict.mul;
  };
  var map = function (dict) {
      return dict.map;
  };
  var $less$dollar$greater = function (dictFunctor) {
      return map(dictFunctor);
  };
  var $less$hash$greater = function (dictFunctor) {
      return function (fa) {
          return function (f) {
              return $less$dollar$greater(dictFunctor)(f)(fa);
          };
      };
  };
  var id = function (dict) {
      return dict.id;
  };
  var functorArray = new Functor($foreign.arrayMap);
  var flip = function (f) {
      return function (b) {
          return function (a) {
              return f(a)(b);
          };
      };
  }; 
  var eqString = new Eq($foreign.refEq);
  var ordString = new Ord(function () {
      return eqString;
  }, unsafeCompare);
  var eqOrdering = new Eq(function (v) {
      return function (v1) {
          if (v instanceof LT && v1 instanceof LT) {
              return true;
          };
          if (v instanceof GT && v1 instanceof GT) {
              return true;
          };
          if (v instanceof EQ && v1 instanceof EQ) {
              return true;
          };
          return false;
      };
  });               
  var eqInt = new Eq($foreign.refEq);
  var ordInt = new Ord(function () {
      return eqInt;
  }, unsafeCompare);
  var eqChar = new Eq($foreign.refEq);
  var eqBoolean = new Eq($foreign.refEq);
  var eq = function (dict) {
      return dict.eq;
  };
  var $eq$eq = function (dictEq) {
      return eq(dictEq);
  };
  var eqArray = function (dictEq) {
      return new Eq($foreign.eqArrayImpl($eq$eq(dictEq)));
  };
  var disj = function (dict) {
      return dict.disj;
  };
  var $$const = function (a) {
      return function (v) {
          return a;
      };
  };
  var $$void = function (dictFunctor) {
      return function (fa) {
          return $less$dollar$greater(dictFunctor)($$const(unit))(fa);
      };
  };
  var conj = function (dict) {
      return dict.conj;
  };
  var compose = function (dict) {
      return dict.compose;
  };
  var compare = function (dict) {
      return dict.compare;
  };
  var $less = function (dictOrd) {
      return function (a1) {
          return function (a2) {
              var $80 = compare(dictOrd)(a1)(a2);
              if ($80 instanceof LT) {
                  return true;
              };
              return false;
          };
      };
  };
  var $greater = function (dictOrd) {
      return function (a1) {
          return function (a2) {
              var $82 = compare(dictOrd)(a1)(a2);
              if ($82 instanceof GT) {
                  return true;
              };
              return false;
          };
      };
  };
  var $greater$eq = function (dictOrd) {
      return function (a1) {
          return function (a2) {
              var $83 = compare(dictOrd)(a1)(a2);
              if ($83 instanceof LT) {
                  return false;
              };
              return true;
          };
      };
  };
  var categoryFn = new Category(function () {
      return semigroupoidFn;
  }, function (x) {
      return x;
  });
  var boundedBoolean = new Bounded(false, true);
  var bottom = function (dict) {
      return dict.bottom;
  };
  var booleanAlgebraBoolean = new BooleanAlgebra(function () {
      return boundedBoolean;
  }, $foreign.boolAnd, $foreign.boolOr, $foreign.boolNot);
  var $div$eq = function (dictEq) {
      return function (x) {
          return function (y) {
              return not(booleanAlgebraBoolean)($eq$eq(dictEq)(x)(y));
          };
      };
  };
  var bind = function (dict) {
      return dict.bind;
  };
  var liftM1 = function (dictMonad) {
      return function (f) {
          return function (a) {
              return bind(dictMonad["__superclass_Prelude.Bind_1"]())(a)(function (v) {
                  return $$return(dictMonad["__superclass_Prelude.Applicative_0"]())(f(v));
              });
          };
      };
  };
  var $greater$greater$eq = function (dictBind) {
      return bind(dictBind);
  }; 
  var apply = function (dict) {
      return dict.apply;
  };
  var $less$times$greater = function (dictApply) {
      return apply(dictApply);
  };
  var liftA1 = function (dictApplicative) {
      return function (f) {
          return function (a) {
              return $less$times$greater(dictApplicative["__superclass_Prelude.Apply_0"]())(pure(dictApplicative)(f))(a);
          };
      };
  }; 
  var append = function (dict) {
      return dict.append;
  };
  var $plus$plus = function (dictSemigroup) {
      return append(dictSemigroup);
  };
  var $less$greater = function (dictSemigroup) {
      return append(dictSemigroup);
  };
  var ap = function (dictMonad) {
      return function (f) {
          return function (a) {
              return bind(dictMonad["__superclass_Prelude.Bind_1"]())(f)(function (v) {
                  return bind(dictMonad["__superclass_Prelude.Bind_1"]())(a)(function (v1) {
                      return $$return(dictMonad["__superclass_Prelude.Applicative_0"]())(v(v1));
                  });
              });
          };
      };
  }; 
  var add = function (dict) {
      return dict.add;
  };
  var $plus = function (dictSemiring) {
      return add(dictSemiring);
  };
  exports["LT"] = LT;
  exports["GT"] = GT;
  exports["EQ"] = EQ;
  exports["Show"] = Show;
  exports["BooleanAlgebra"] = BooleanAlgebra;
  exports["Bounded"] = Bounded;
  exports["Ord"] = Ord;
  exports["Eq"] = Eq;
  exports["Semiring"] = Semiring;
  exports["Semigroup"] = Semigroup;
  exports["Monad"] = Monad;
  exports["Bind"] = Bind;
  exports["Applicative"] = Applicative;
  exports["Apply"] = Apply;
  exports["Functor"] = Functor;
  exports["Category"] = Category;
  exports["Semigroupoid"] = Semigroupoid;
  exports["show"] = show;
  exports["not"] = not;
  exports["disj"] = disj;
  exports["conj"] = conj;
  exports["bottom"] = bottom;
  exports["top"] = top;
  exports["unsafeCompare"] = unsafeCompare;
  exports[">="] = $greater$eq;
  exports[">"] = $greater;
  exports["<"] = $less;
  exports["compare"] = compare;
  exports["/="] = $div$eq;
  exports["=="] = $eq$eq;
  exports["eq"] = eq;
  exports["+"] = $plus;
  exports["one"] = one;
  exports["mul"] = mul;
  exports["zero"] = zero;
  exports["add"] = add;
  exports["++"] = $plus$plus;
  exports["<>"] = $less$greater;
  exports["append"] = append;
  exports["ap"] = ap;
  exports["liftM1"] = liftM1;
  exports["return"] = $$return;
  exports[">>="] = $greater$greater$eq;
  exports["bind"] = bind;
  exports["liftA1"] = liftA1;
  exports["pure"] = pure;
  exports["<*>"] = $less$times$greater;
  exports["apply"] = apply;
  exports["void"] = $$void;
  exports["<#>"] = $less$hash$greater;
  exports["<$>"] = $less$dollar$greater;
  exports["map"] = map;
  exports["id"] = id;
  exports["compose"] = compose;
  exports["otherwise"] = otherwise;
  exports["const"] = $$const;
  exports["flip"] = flip;
  exports["unit"] = unit;
  exports["semigroupoidFn"] = semigroupoidFn;
  exports["categoryFn"] = categoryFn;
  exports["functorArray"] = functorArray;
  exports["semigroupString"] = semigroupString;
  exports["semigroupArray"] = semigroupArray;
  exports["semiringInt"] = semiringInt;
  exports["eqBoolean"] = eqBoolean;
  exports["eqInt"] = eqInt;
  exports["eqChar"] = eqChar;
  exports["eqString"] = eqString;
  exports["eqArray"] = eqArray;
  exports["eqOrdering"] = eqOrdering;
  exports["ordInt"] = ordInt;
  exports["ordString"] = ordString;
  exports["boundedBoolean"] = boundedBoolean;
  exports["booleanAlgebraBoolean"] = booleanAlgebraBoolean;
  exports["showBoolean"] = showBoolean;
  exports["showInt"] = showInt;
  exports["showNumber"] = showNumber;
  exports["showChar"] = showChar;
  exports["showString"] = showString;
  exports["showArray"] = showArray;
})(PS["Prelude"] = PS["Prelude"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];        
  var Alt = function (__superclass_Prelude$dotFunctor_0, alt) {
      this["__superclass_Prelude.Functor_0"] = __superclass_Prelude$dotFunctor_0;
      this.alt = alt;
  };                                         
  var alt = function (dict) {
      return dict.alt;
  };
  var $less$bar$greater = function (dictAlt) {
      return alt(dictAlt);
  };
  exports["Alt"] = Alt;
  exports["<|>"] = $less$bar$greater;
  exports["alt"] = alt;
})(PS["Control.Alt"] = PS["Control.Alt"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Alt = PS["Control.Alt"];        
  var Plus = function (__superclass_Control$dotAlt$dotAlt_0, empty) {
      this["__superclass_Control.Alt.Alt_0"] = __superclass_Control$dotAlt$dotAlt_0;
      this.empty = empty;
  };       
  var empty = function (dict) {
      return dict.empty;
  };
  exports["Plus"] = Plus;
  exports["empty"] = empty;
})(PS["Control.Plus"] = PS["Control.Plus"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Plus = PS["Control.Plus"];        
  var Alternative = function (__superclass_Control$dotPlus$dotPlus_1, __superclass_Prelude$dotApplicative_0) {
      this["__superclass_Control.Plus.Plus_1"] = __superclass_Control$dotPlus$dotPlus_1;
      this["__superclass_Prelude.Applicative_0"] = __superclass_Prelude$dotApplicative_0;
  };
  exports["Alternative"] = Alternative;
})(PS["Control.Alternative"] = PS["Control.Alternative"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];        
  var $less$times = function (dictApply) {
      return function (a) {
          return function (b) {
              return Prelude["<*>"](dictApply)(Prelude["<$>"](dictApply["__superclass_Prelude.Functor_0"]())(Prelude["const"])(a))(b);
          };
      };
  };
  var $times$greater = function (dictApply) {
      return function (a) {
          return function (b) {
              return Prelude["<*>"](dictApply)(Prelude["<$>"](dictApply["__superclass_Prelude.Functor_0"]())(Prelude["const"](Prelude.id(Prelude.categoryFn)))(a))(b);
          };
      };
  };
  exports["*>"] = $times$greater;
  exports["<*"] = $less$times;
})(PS["Control.Apply"] = PS["Control.Apply"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var $eq$less$less = function (dictBind) {
      return function (f) {
          return function (m) {
              return Prelude[">>="](dictBind)(m)(f);
          };
      };
  };
  exports["=<<"] = $eq$less$less;
})(PS["Control.Bind"] = PS["Control.Bind"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];        
  var Lazy = function (defer) {
      this.defer = defer;
  };
  var defer = function (dict) {
      return dict.defer;
  };
  exports["Lazy"] = Lazy;
  exports["defer"] = defer;
})(PS["Control.Lazy"] = PS["Control.Lazy"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Control.Monad.Eff

  exports.returnE = function (a) {
    return function () {
      return a;
    };
  };

  exports.bindE = function (a) {
    return function (f) {
      return function () {
        return f(a())();
      };
    };
  };

  exports.runPure = function (f) {
    return f();
  };
})(PS["Control.Monad.Eff"] = PS["Control.Monad.Eff"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Control.Monad.Eff"];
  var Prelude = PS["Prelude"];        
  var monadEff = new Prelude.Monad(function () {
      return applicativeEff;
  }, function () {
      return bindEff;
  });
  var bindEff = new Prelude.Bind(function () {
      return applyEff;
  }, $foreign.bindE);
  var applyEff = new Prelude.Apply(function () {
      return functorEff;
  }, Prelude.ap(monadEff));
  var applicativeEff = new Prelude.Applicative(function () {
      return applyEff;
  }, $foreign.returnE);
  var functorEff = new Prelude.Functor(Prelude.liftA1(applicativeEff));
  exports["functorEff"] = functorEff;
  exports["applyEff"] = applyEff;
  exports["applicativeEff"] = applicativeEff;
  exports["bindEff"] = bindEff;
  exports["monadEff"] = monadEff;
  exports["runPure"] = $foreign.runPure;
})(PS["Control.Monad.Eff"] = PS["Control.Monad.Eff"] || {});
(function(exports) {
  /* global exports, console */
  "use strict";

  // module Control.Monad.Eff.Console

  exports.log = function (s) {
    return function () {
      console.log(s);
      return {};
    };
  };
})(PS["Control.Monad.Eff.Console"] = PS["Control.Monad.Eff.Console"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Control.Monad.Eff.Console"];
  var Prelude = PS["Prelude"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  exports["log"] = $foreign.log;
})(PS["Control.Monad.Eff.Console"] = PS["Control.Monad.Eff.Console"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  exports.error = function (msg) {
    return new Error(msg);
  };

  exports.throwException = function (e) {
    return function () {
      throw e;
    };
  };
})(PS["Control.Monad.Eff.Exception"] = PS["Control.Monad.Eff.Exception"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Alternative = PS["Control.Alternative"];
  var Control_Plus = PS["Control.Plus"];        
  var MonadPlus = function (__superclass_Control$dotAlternative$dotAlternative_1, __superclass_Prelude$dotMonad_0) {
      this["__superclass_Control.Alternative.Alternative_1"] = __superclass_Control$dotAlternative$dotAlternative_1;
      this["__superclass_Prelude.Monad_0"] = __superclass_Prelude$dotMonad_0;
  }; 
  var guard = function (dictMonadPlus) {
      return function (v) {
          if (v) {
              return Prelude["return"]((dictMonadPlus["__superclass_Control.Alternative.Alternative_1"]())["__superclass_Prelude.Applicative_0"]())(Prelude.unit);
          };
          if (!v) {
              return Control_Plus.empty((dictMonadPlus["__superclass_Control.Alternative.Alternative_1"]())["__superclass_Control.Plus.Plus_1"]());
          };
          throw new Error("Failed pattern match at Control.MonadPlus line 36, column 1 - line 37, column 1: " + [ v.constructor.name ]);
      };
  };
  exports["MonadPlus"] = MonadPlus;
  exports["guard"] = guard;
})(PS["Control.MonadPlus"] = PS["Control.MonadPlus"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];        
  var Monoid = function (__superclass_Prelude$dotSemigroup_0, mempty) {
      this["__superclass_Prelude.Semigroup_0"] = __superclass_Prelude$dotSemigroup_0;
      this.mempty = mempty;
  };               
  var monoidString = new Monoid(function () {
      return Prelude.semigroupString;
  }, "");  
  var mempty = function (dict) {
      return dict.mempty;
  };
  exports["Monoid"] = Monoid;
  exports["mempty"] = mempty;
  exports["monoidString"] = monoidString;
})(PS["Data.Monoid"] = PS["Data.Monoid"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Alternative = PS["Control.Alternative"];
  var Control_Extend = PS["Control.Extend"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_Plus = PS["Control.Plus"];
  var Data_Functor_Invariant = PS["Data.Functor.Invariant"];
  var Data_Monoid = PS["Data.Monoid"];        
  var Nothing = (function () {
      function Nothing() {

      };
      Nothing.value = new Nothing();
      return Nothing;
  })();
  var Just = (function () {
      function Just(value0) {
          this.value0 = value0;
      };
      Just.create = function (value0) {
          return new Just(value0);
      };
      return Just;
  })();
  var showMaybe = function (dictShow) {
      return new Prelude.Show(function (v) {
          if (v instanceof Just) {
              return "Just (" + (Prelude.show(dictShow)(v.value0) + ")");
          };
          if (v instanceof Nothing) {
              return "Nothing";
          };
          throw new Error("Failed pattern match at Data.Maybe line 290, column 3 - line 291, column 3: " + [ v.constructor.name ]);
      });
  };
  var maybe$prime = function (v) {
      return function (v1) {
          return function (v2) {
              if (v2 instanceof Nothing) {
                  return v(Prelude.unit);
              };
              if (v2 instanceof Just) {
                  return v1(v2.value0);
              };
              throw new Error("Failed pattern match at Data.Maybe line 40, column 1 - line 41, column 1: " + [ v.constructor.name, v1.constructor.name, v2.constructor.name ]);
          };
      };
  };
  var maybe = function (v) {
      return function (v1) {
          return function (v2) {
              if (v2 instanceof Nothing) {
                  return v;
              };
              if (v2 instanceof Just) {
                  return v1(v2.value0);
              };
              throw new Error("Failed pattern match at Data.Maybe line 27, column 1 - line 28, column 1: " + [ v.constructor.name, v1.constructor.name, v2.constructor.name ]);
          };
      };
  };
  var isNothing = maybe(true)(Prelude["const"](false));
  var isJust = maybe(false)(Prelude["const"](true));
  var functorMaybe = new Prelude.Functor(function (v) {
      return function (v1) {
          if (v1 instanceof Just) {
              return new Just(v(v1.value0));
          };
          return Nothing.value;
      };
  });
  var fromMaybe = function (a) {
      return maybe(a)(Prelude.id(Prelude.categoryFn));
  }; 
  var eqMaybe = function (dictEq) {
      return new Prelude.Eq(function (v) {
          return function (v1) {
              if (v instanceof Nothing && v1 instanceof Nothing) {
                  return true;
              };
              if (v instanceof Just && v1 instanceof Just) {
                  return Prelude["=="](dictEq)(v.value0)(v1.value0);
              };
              return false;
          };
      });
  };
  var applyMaybe = new Prelude.Apply(function () {
      return functorMaybe;
  }, function (v) {
      return function (v1) {
          if (v instanceof Just) {
              return Prelude["<$>"](functorMaybe)(v.value0)(v1);
          };
          if (v instanceof Nothing) {
              return Nothing.value;
          };
          throw new Error("Failed pattern match at Data.Maybe line 122, column 3 - line 123, column 3: " + [ v.constructor.name, v1.constructor.name ]);
      };
  });
  var bindMaybe = new Prelude.Bind(function () {
      return applyMaybe;
  }, function (v) {
      return function (v1) {
          if (v instanceof Just) {
              return v1(v.value0);
          };
          if (v instanceof Nothing) {
              return Nothing.value;
          };
          throw new Error("Failed pattern match at Data.Maybe line 181, column 3 - line 182, column 3: " + [ v.constructor.name, v1.constructor.name ]);
      };
  });
  var applicativeMaybe = new Prelude.Applicative(function () {
      return applyMaybe;
  }, Just.create);
  var monadMaybe = new Prelude.Monad(function () {
      return applicativeMaybe;
  }, function () {
      return bindMaybe;
  });
  var altMaybe = new Control_Alt.Alt(function () {
      return functorMaybe;
  }, function (v) {
      return function (v1) {
          if (v instanceof Nothing) {
              return v1;
          };
          return v;
      };
  });
  var plusMaybe = new Control_Plus.Plus(function () {
      return altMaybe;
  }, Nothing.value);
  var alternativeMaybe = new Control_Alternative.Alternative(function () {
      return plusMaybe;
  }, function () {
      return applicativeMaybe;
  });
  var monadPlusMaybe = new Control_MonadPlus.MonadPlus(function () {
      return alternativeMaybe;
  }, function () {
      return monadMaybe;
  });
  exports["Nothing"] = Nothing;
  exports["Just"] = Just;
  exports["isNothing"] = isNothing;
  exports["isJust"] = isJust;
  exports["fromMaybe"] = fromMaybe;
  exports["maybe'"] = maybe$prime;
  exports["maybe"] = maybe;
  exports["functorMaybe"] = functorMaybe;
  exports["applyMaybe"] = applyMaybe;
  exports["applicativeMaybe"] = applicativeMaybe;
  exports["altMaybe"] = altMaybe;
  exports["plusMaybe"] = plusMaybe;
  exports["alternativeMaybe"] = alternativeMaybe;
  exports["bindMaybe"] = bindMaybe;
  exports["monadMaybe"] = monadMaybe;
  exports["monadPlusMaybe"] = monadPlusMaybe;
  exports["eqMaybe"] = eqMaybe;
  exports["showMaybe"] = showMaybe;
})(PS["Data.Maybe"] = PS["Data.Maybe"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Control.Monad.Eff.Exception"];
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  exports["throwException"] = $foreign.throwException;
  exports["error"] = $foreign.error;
})(PS["Control.Monad.Eff.Exception"] = PS["Control.Monad.Eff.Exception"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];        
  var MonadReader = function (__superclass_Prelude$dotMonad_0, ask, local) {
      this["__superclass_Prelude.Monad_0"] = __superclass_Prelude$dotMonad_0;
      this.ask = ask;
      this.local = local;
  };                                                                         
  var local = function (dict) {
      return dict.local;
  };
  var ask = function (dict) {
      return dict.ask;
  };
  exports["MonadReader"] = MonadReader;
  exports["local"] = local;
  exports["ask"] = ask;
})(PS["Control.Monad.Reader.Class"] = PS["Control.Monad.Reader.Class"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];        
  var Bifunctor = function (bimap) {
      this.bimap = bimap;
  };
  var bimap = function (dict) {
      return dict.bimap;
  };
  var lmap = function (dictBifunctor) {
      return function (f) {
          return bimap(dictBifunctor)(f)(Prelude.id(Prelude.categoryFn));
      };
  };
  exports["Bifunctor"] = Bifunctor;
  exports["lmap"] = lmap;
  exports["bimap"] = bimap;
})(PS["Data.Bifunctor"] = PS["Data.Bifunctor"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.Foldable

  exports.foldrArray = function (f) {
    return function (init) {
      return function (xs) {
        var acc = init;
        var len = xs.length;
        for (var i = len - 1; i >= 0; i--) {
          acc = f(xs[i])(acc);
        }
        return acc;
      };
    };
  };

  exports.foldlArray = function (f) {
    return function (init) {
      return function (xs) {
        var acc = init;
        var len = xs.length;
        for (var i = 0; i < len; i++) {
          acc = f(acc)(xs[i]);
        }
        return acc;
      };
    };
  };
})(PS["Data.Foldable"] = PS["Data.Foldable"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Comonad = PS["Control.Comonad"];
  var Control_Extend = PS["Control.Extend"];
  var Data_Monoid = PS["Data.Monoid"];        
  var Conj = function (x) {
      return x;
  };
  var semigroupConj = function (dictBooleanAlgebra) {
      return new Prelude.Semigroup(function (v) {
          return function (v1) {
              return Prelude.conj(dictBooleanAlgebra)(v)(v1);
          };
      });
  };
  var runConj = function (v) {
      return v;
  };
  var monoidConj = function (dictBooleanAlgebra) {
      return new Data_Monoid.Monoid(function () {
          return semigroupConj(dictBooleanAlgebra);
      }, Prelude.top(dictBooleanAlgebra["__superclass_Prelude.Bounded_0"]()));
  };
  exports["Conj"] = Conj;
  exports["runConj"] = runConj;
  exports["semigroupConj"] = semigroupConj;
  exports["monoidConj"] = monoidConj;
})(PS["Data.Monoid.Conj"] = PS["Data.Monoid.Conj"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Comonad = PS["Control.Comonad"];
  var Control_Extend = PS["Control.Extend"];
  var Data_Monoid = PS["Data.Monoid"];        
  var Disj = function (x) {
      return x;
  };
  var semigroupDisj = function (dictBooleanAlgebra) {
      return new Prelude.Semigroup(function (v) {
          return function (v1) {
              return Prelude.disj(dictBooleanAlgebra)(v)(v1);
          };
      });
  };
  var runDisj = function (v) {
      return v;
  };
  var monoidDisj = function (dictBooleanAlgebra) {
      return new Data_Monoid.Monoid(function () {
          return semigroupDisj(dictBooleanAlgebra);
      }, Prelude.bottom(dictBooleanAlgebra["__superclass_Prelude.Bounded_0"]()));
  };
  exports["Disj"] = Disj;
  exports["runDisj"] = runDisj;
  exports["semigroupDisj"] = semigroupDisj;
  exports["monoidDisj"] = monoidDisj;
})(PS["Data.Monoid.Disj"] = PS["Data.Monoid.Disj"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Foldable"];
  var Prelude = PS["Prelude"];
  var Control_Apply = PS["Control.Apply"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Maybe_First = PS["Data.Maybe.First"];
  var Data_Maybe_Last = PS["Data.Maybe.Last"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Monoid_Additive = PS["Data.Monoid.Additive"];
  var Data_Monoid_Conj = PS["Data.Monoid.Conj"];
  var Data_Monoid_Disj = PS["Data.Monoid.Disj"];
  var Data_Monoid_Dual = PS["Data.Monoid.Dual"];
  var Data_Monoid_Endo = PS["Data.Monoid.Endo"];
  var Data_Monoid_Multiplicative = PS["Data.Monoid.Multiplicative"];        
  var Foldable = function (foldMap, foldl, foldr) {
      this.foldMap = foldMap;
      this.foldl = foldl;
      this.foldr = foldr;
  };
  var foldr = function (dict) {
      return dict.foldr;
  };
  var traverse_ = function (dictApplicative) {
      return function (dictFoldable) {
          return function (f) {
              return foldr(dictFoldable)(function ($161) {
                  return Control_Apply["*>"](dictApplicative["__superclass_Prelude.Apply_0"]())(f($161));
              })(Prelude.pure(dictApplicative)(Prelude.unit));
          };
      };
  };
  var for_ = function (dictApplicative) {
      return function (dictFoldable) {
          return Prelude.flip(traverse_(dictApplicative)(dictFoldable));
      };
  };
  var foldl = function (dict) {
      return dict.foldl;
  };
  var intercalate = function (dictFoldable) {
      return function (dictMonoid) {
          return function (sep) {
              return function (xs) {
                  var go = function (v) {
                      return function (x) {
                          if (v.init) {
                              return {
                                  init: false, 
                                  acc: x
                              };
                          };
                          return {
                              init: false, 
                              acc: Prelude["<>"](dictMonoid["__superclass_Prelude.Semigroup_0"]())(v.acc)(Prelude["<>"](dictMonoid["__superclass_Prelude.Semigroup_0"]())(sep)(x))
                          };
                      };
                  };
                  return (foldl(dictFoldable)(go)({
                      init: true, 
                      acc: Data_Monoid.mempty(dictMonoid)
                  })(xs)).acc;
              };
          };
      };
  };
  var maximumBy = function (dictFoldable) {
      return function (cmp) {
          var max$prime = function (v) {
              return function (v1) {
                  if (v instanceof Data_Maybe.Nothing) {
                      return new Data_Maybe.Just(v1);
                  };
                  if (v instanceof Data_Maybe.Just) {
                      return new Data_Maybe.Just((function () {
                          var $87 = cmp(v.value0)(v1);
                          if ($87 instanceof Prelude.GT) {
                              return v.value0;
                          };
                          return v1;
                      })());
                  };
                  throw new Error("Failed pattern match at Data.Foldable line 246, column 3 - line 247, column 3: " + [ v.constructor.name, v1.constructor.name ]);
              };
          };
          return foldl(dictFoldable)(max$prime)(Data_Maybe.Nothing.value);
      };
  };
  var sum = function (dictFoldable) {
      return function (dictSemiring) {
          return foldl(dictFoldable)(Prelude["+"](dictSemiring))(Prelude.zero(dictSemiring));
      };
  }; 
  var foldMapDefaultR = function (dictFoldable) {
      return function (dictMonoid) {
          return function (f) {
              return function (xs) {
                  return foldr(dictFoldable)(function (x) {
                      return function (acc) {
                          return Prelude["<>"](dictMonoid["__superclass_Prelude.Semigroup_0"]())(f(x))(acc);
                      };
                  })(Data_Monoid.mempty(dictMonoid))(xs);
              };
          };
      };
  };
  var foldableArray = new Foldable(function (dictMonoid) {
      return foldMapDefaultR(foldableArray)(dictMonoid);
  }, $foreign.foldlArray, $foreign.foldrArray);
  var foldMap = function (dict) {
      return dict.foldMap;
  };
  var any = function (dictFoldable) {
      return function (dictBooleanAlgebra) {
          return function (p) {
              return function ($164) {
                  return Data_Monoid_Disj.runDisj(foldMap(dictFoldable)(Data_Monoid_Disj.monoidDisj(dictBooleanAlgebra))(function ($165) {
                      return Data_Monoid_Disj.Disj(p($165));
                  })($164));
              };
          };
      };
  };
  var elem = function (dictFoldable) {
      return function (dictEq) {
          return function ($166) {
              return any(dictFoldable)(Prelude.booleanAlgebraBoolean)(Prelude["=="](dictEq)($166));
          };
      };
  };
  var notElem = function (dictFoldable) {
      return function (dictEq) {
          return function (x) {
              return function ($167) {
                  return !elem(dictFoldable)(dictEq)(x)($167);
              };
          };
      };
  };
  var all = function (dictFoldable) {
      return function (dictBooleanAlgebra) {
          return function (p) {
              return function ($168) {
                  return Data_Monoid_Conj.runConj(foldMap(dictFoldable)(Data_Monoid_Conj.monoidConj(dictBooleanAlgebra))(function ($169) {
                      return Data_Monoid_Conj.Conj(p($169));
                  })($168));
              };
          };
      };
  };
  exports["Foldable"] = Foldable;
  exports["maximumBy"] = maximumBy;
  exports["notElem"] = notElem;
  exports["elem"] = elem;
  exports["sum"] = sum;
  exports["all"] = all;
  exports["any"] = any;
  exports["intercalate"] = intercalate;
  exports["for_"] = for_;
  exports["traverse_"] = traverse_;
  exports["foldMapDefaultR"] = foldMapDefaultR;
  exports["foldMap"] = foldMap;
  exports["foldl"] = foldl;
  exports["foldr"] = foldr;
  exports["foldableArray"] = foldableArray;
})(PS["Data.Foldable"] = PS["Data.Foldable"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.Traversable

  // jshint maxparams: 3

  exports.traverseArrayImpl = function () {
    function Cont (fn) {
      this.fn = fn;
    }

    var emptyList = {};

    var ConsCell = function (head, tail) {
      this.head = head;
      this.tail = tail;
    };

    function consList (x) {
      return function (xs) {
        return new ConsCell(x, xs);
      };
    }

    function listToArray (list) {
      var arr = [];
      while (list !== emptyList) {
        arr.push(list.head);
        list = list.tail;
      }
      return arr;
    }

    return function (apply) {
      return function (map) {
        return function (pure) {
          return function (f) {
            var buildFrom = function (x, ys) {
              return apply(map(consList)(f(x)))(ys);
            };

            var go = function (acc, currentLen, xs) {
              if (currentLen === 0) {
                return acc;
              } else {
                var last = xs[currentLen - 1];
                return new Cont(function () {
                  return go(buildFrom(last, acc), currentLen - 1, xs);
                });
              }
            };

            return function (array) {
              var result = go(pure(emptyList), array.length, array);
              while (result instanceof Cont) {
                result = result.fn();
              }

              return map(listToArray)(result);
            };
          };
        };
      };
    };
  }();
})(PS["Data.Traversable"] = PS["Data.Traversable"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Traversable"];
  var Prelude = PS["Prelude"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Maybe_First = PS["Data.Maybe.First"];
  var Data_Maybe_Last = PS["Data.Maybe.Last"];
  var Data_Monoid_Additive = PS["Data.Monoid.Additive"];
  var Data_Monoid_Conj = PS["Data.Monoid.Conj"];
  var Data_Monoid_Disj = PS["Data.Monoid.Disj"];
  var Data_Monoid_Dual = PS["Data.Monoid.Dual"];
  var Data_Monoid_Multiplicative = PS["Data.Monoid.Multiplicative"];
  var Traversable = function (__superclass_Data$dotFoldable$dotFoldable_1, __superclass_Prelude$dotFunctor_0, sequence, traverse) {
      this["__superclass_Data.Foldable.Foldable_1"] = __superclass_Data$dotFoldable$dotFoldable_1;
      this["__superclass_Prelude.Functor_0"] = __superclass_Prelude$dotFunctor_0;
      this.sequence = sequence;
      this.traverse = traverse;
  };
  var traverse = function (dict) {
      return dict.traverse;
  };
  var sequenceDefault = function (dictTraversable) {
      return function (dictApplicative) {
          return function (tma) {
              return traverse(dictTraversable)(dictApplicative)(Prelude.id(Prelude.categoryFn))(tma);
          };
      };
  };
  var traversableArray = new Traversable(function () {
      return Data_Foldable.foldableArray;
  }, function () {
      return Prelude.functorArray;
  }, function (dictApplicative) {
      return sequenceDefault(traversableArray)(dictApplicative);
  }, function (dictApplicative) {
      return $foreign.traverseArrayImpl(Prelude.apply(dictApplicative["__superclass_Prelude.Apply_0"]()))(Prelude.map((dictApplicative["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]()))(Prelude.pure(dictApplicative));
  });
  var sequence = function (dict) {
      return dict.sequence;
  };
  exports["Traversable"] = Traversable;
  exports["sequenceDefault"] = sequenceDefault;
  exports["sequence"] = sequence;
  exports["traverse"] = traverse;
  exports["traversableArray"] = traversableArray;
})(PS["Data.Traversable"] = PS["Data.Traversable"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Biapplicative = PS["Control.Biapplicative"];
  var Control_Biapply = PS["Control.Biapply"];
  var Control_Comonad = PS["Control.Comonad"];
  var Control_Extend = PS["Control.Extend"];
  var Control_Lazy = PS["Control.Lazy"];
  var Data_Bifoldable = PS["Data.Bifoldable"];
  var Data_Bifunctor = PS["Data.Bifunctor"];
  var Data_Bitraversable = PS["Data.Bitraversable"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Functor_Invariant = PS["Data.Functor.Invariant"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Maybe_First = PS["Data.Maybe.First"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Traversable = PS["Data.Traversable"];        
  var Tuple = (function () {
      function Tuple(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Tuple.create = function (value0) {
          return function (value1) {
              return new Tuple(value0, value1);
          };
      };
      return Tuple;
  })();
  var uncurry = function (f) {
      return function (v) {
          return f(v.value0)(v.value1);
      };
  };
  var snd = function (v) {
      return v.value1;
  };                                                                                                    
  var fst = function (v) {
      return v.value0;
  };
  var bifunctorTuple = new Data_Bifunctor.Bifunctor(function (f) {
      return function (g) {
          return function (v) {
              return new Tuple(f(v.value0), g(v.value1));
          };
      };
  });
  exports["Tuple"] = Tuple;
  exports["uncurry"] = uncurry;
  exports["snd"] = snd;
  exports["fst"] = fst;
  exports["bifunctorTuple"] = bifunctorTuple;
})(PS["Data.Tuple"] = PS["Data.Tuple"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Tuple = PS["Data.Tuple"];        
  var MonadState = function (__superclass_Prelude$dotMonad_0, state) {
      this["__superclass_Prelude.Monad_0"] = __superclass_Prelude$dotMonad_0;
      this.state = state;
  };
  var state = function (dict) {
      return dict.state;
  };
  var put = function (dictMonadState) {
      return function (s) {
          return state(dictMonadState)(function (v) {
              return new Data_Tuple.Tuple(Prelude.unit, s);
          });
      };
  };
  var modify = function (dictMonadState) {
      return function (f) {
          return state(dictMonadState)(function (s) {
              return new Data_Tuple.Tuple(Prelude.unit, f(s));
          });
      };
  };
  var get = function (dictMonadState) {
      return state(dictMonadState)(function (s) {
          return new Data_Tuple.Tuple(s, s);
      });
  };
  exports["MonadState"] = MonadState;
  exports["modify"] = modify;
  exports["put"] = put;
  exports["get"] = get;
  exports["state"] = state;
})(PS["Control.Monad.State.Class"] = PS["Control.Monad.State.Class"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];        
  var MonadTrans = function (lift) {
      this.lift = lift;
  };
  var lift = function (dict) {
      return dict.lift;
  };
  exports["MonadTrans"] = MonadTrans;
  exports["lift"] = lift;
})(PS["Control.Monad.Trans"] = PS["Control.Monad.Trans"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Extend = PS["Control.Extend"];
  var Data_Bifoldable = PS["Data.Bifoldable"];
  var Data_Bifunctor = PS["Data.Bifunctor"];
  var Data_Bitraversable = PS["Data.Bitraversable"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Traversable = PS["Data.Traversable"];        
  var Left = (function () {
      function Left(value0) {
          this.value0 = value0;
      };
      Left.create = function (value0) {
          return new Left(value0);
      };
      return Left;
  })();
  var Right = (function () {
      function Right(value0) {
          this.value0 = value0;
      };
      Right.create = function (value0) {
          return new Right(value0);
      };
      return Right;
  })();
  var functorEither = new Prelude.Functor(function (v) {
      return function (v1) {
          if (v1 instanceof Left) {
              return new Left(v1.value0);
          };
          if (v1 instanceof Right) {
              return new Right(v(v1.value0));
          };
          throw new Error("Failed pattern match at Data.Either line 53, column 3 - line 54, column 3: " + [ v.constructor.name, v1.constructor.name ]);
      };
  });
  var either = function (v) {
      return function (v1) {
          return function (v2) {
              if (v2 instanceof Left) {
                  return v(v2.value0);
              };
              if (v2 instanceof Right) {
                  return v1(v2.value0);
              };
              throw new Error("Failed pattern match at Data.Either line 29, column 1 - line 30, column 1: " + [ v.constructor.name, v1.constructor.name, v2.constructor.name ]);
          };
      };
  };
  var bifunctorEither = new Data_Bifunctor.Bifunctor(function (v) {
      return function (v1) {
          return function (v2) {
              if (v2 instanceof Left) {
                  return new Left(v(v2.value0));
              };
              if (v2 instanceof Right) {
                  return new Right(v1(v2.value0));
              };
              throw new Error("Failed pattern match at Data.Either line 57, column 3 - line 58, column 3: " + [ v.constructor.name, v1.constructor.name, v2.constructor.name ]);
          };
      };
  });
  var applyEither = new Prelude.Apply(function () {
      return functorEither;
  }, function (v) {
      return function (v1) {
          if (v instanceof Left) {
              return new Left(v.value0);
          };
          if (v instanceof Right) {
              return Prelude["<$>"](functorEither)(v.value0)(v1);
          };
          throw new Error("Failed pattern match at Data.Either line 93, column 3 - line 94, column 3: " + [ v.constructor.name, v1.constructor.name ]);
      };
  });
  var bindEither = new Prelude.Bind(function () {
      return applyEither;
  }, either(function (e) {
      return function (v) {
          return new Left(e);
      };
  })(function (a) {
      return function (f) {
          return f(a);
      };
  }));
  var applicativeEither = new Prelude.Applicative(function () {
      return applyEither;
  }, Right.create);
  var monadEither = new Prelude.Monad(function () {
      return applicativeEither;
  }, function () {
      return bindEither;
  });
  var altEither = new Control_Alt.Alt(function () {
      return functorEither;
  }, function (v) {
      return function (v1) {
          if (v instanceof Left) {
              return v1;
          };
          return v;
      };
  });
  exports["Left"] = Left;
  exports["Right"] = Right;
  exports["either"] = either;
  exports["functorEither"] = functorEither;
  exports["bifunctorEither"] = bifunctorEither;
  exports["applyEither"] = applyEither;
  exports["applicativeEither"] = applicativeEither;
  exports["altEither"] = altEither;
  exports["bindEither"] = bindEither;
  exports["monadEither"] = monadEither;
})(PS["Data.Either"] = PS["Data.Either"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Alternative = PS["Control.Alternative"];
  var Control_Monad_Cont_Class = PS["Control.Monad.Cont.Class"];
  var Control_Monad_Eff_Class = PS["Control.Monad.Eff.Class"];
  var Control_Monad_Error_Class = PS["Control.Monad.Error.Class"];
  var Control_Monad_Reader_Class = PS["Control.Monad.Reader.Class"];
  var Control_Monad_Rec_Class = PS["Control.Monad.Rec.Class"];
  var Control_Monad_State_Class = PS["Control.Monad.State.Class"];
  var Control_Monad_Trans = PS["Control.Monad.Trans"];
  var Control_Monad_Writer_Class = PS["Control.Monad.Writer.Class"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_Plus = PS["Control.Plus"];
  var Data_Distributive = PS["Data.Distributive"];
  var Data_Either = PS["Data.Either"];        
  var ReaderT = function (x) {
      return x;
  };
  var runReaderT = function (v) {
      return v;
  };
  var withReaderT = function (f) {
      return function (m) {
          return ReaderT(function ($27) {
              return runReaderT(m)(f($27));
          });
      };
  };
  var monadTransReaderT = new Control_Monad_Trans.MonadTrans(function (dictMonad) {
      return function ($28) {
          return ReaderT(Prelude["const"]($28));
      };
  });
  var mapReaderT = function (f) {
      return function (m) {
          return ReaderT(function ($29) {
              return f(runReaderT(m)($29));
          });
      };
  };
  var functorReaderT = function (dictFunctor) {
      return new Prelude.Functor(function (f) {
          return mapReaderT(Prelude["<$>"](dictFunctor)(f));
      });
  };
  var applyReaderT = function (dictApplicative) {
      return new Prelude.Apply(function () {
          return functorReaderT((dictApplicative["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]());
      }, function (f) {
          return function (v) {
              return function (r) {
                  return Prelude["<*>"](dictApplicative["__superclass_Prelude.Apply_0"]())(runReaderT(f)(r))(runReaderT(v)(r));
              };
          };
      });
  };
  var bindReaderT = function (dictMonad) {
      return new Prelude.Bind(function () {
          return applyReaderT(dictMonad["__superclass_Prelude.Applicative_0"]());
      }, function (m) {
          return function (k) {
              return function (r) {
                  return Prelude.bind(dictMonad["__superclass_Prelude.Bind_1"]())(runReaderT(m)(r))(function (v) {
                      return runReaderT(k(v))(r);
                  });
              };
          };
      });
  };
  var applicativeReaderT = function (dictApplicative) {
      return new Prelude.Applicative(function () {
          return applyReaderT(dictApplicative);
      }, function ($31) {
          return ReaderT(Prelude["const"](Prelude.pure(dictApplicative)($31)));
      });
  };
  var monadReaderT = function (dictMonad) {
      return new Prelude.Monad(function () {
          return applicativeReaderT(dictMonad["__superclass_Prelude.Applicative_0"]());
      }, function () {
          return bindReaderT(dictMonad);
      });
  };
  var monadReaderReaderT = function (dictMonad) {
      return new Control_Monad_Reader_Class.MonadReader(function () {
          return monadReaderT(dictMonad);
      }, Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]()), withReaderT);
  };
  var monadStateReaderT = function (dictMonadState) {
      return new Control_Monad_State_Class.MonadState(function () {
          return monadReaderT(dictMonadState["__superclass_Prelude.Monad_0"]());
      }, function (f) {
          return Control_Monad_Trans.lift(monadTransReaderT)(dictMonadState["__superclass_Prelude.Monad_0"]())(Control_Monad_State_Class.state(dictMonadState)(f));
      });
  };
  exports["ReaderT"] = ReaderT;
  exports["mapReaderT"] = mapReaderT;
  exports["withReaderT"] = withReaderT;
  exports["runReaderT"] = runReaderT;
  exports["functorReaderT"] = functorReaderT;
  exports["applyReaderT"] = applyReaderT;
  exports["applicativeReaderT"] = applicativeReaderT;
  exports["bindReaderT"] = bindReaderT;
  exports["monadReaderT"] = monadReaderT;
  exports["monadTransReaderT"] = monadTransReaderT;
  exports["monadReaderReaderT"] = monadReaderReaderT;
  exports["monadStateReaderT"] = monadStateReaderT;
})(PS["Control.Monad.Reader.Trans"] = PS["Control.Monad.Reader.Trans"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Control.Monad.ST

  exports.newSTRef = function (val) {
    return function () {
      return { value: val };
    };
  };

  exports.readSTRef = function (ref) {
    return function () {
      return ref.value;
    };
  };

  exports.writeSTRef = function (ref) {
    return function (a) {
      return function () {
        /* jshint boss: true */
        return ref.value = a;
      };
    };
  };
})(PS["Control.Monad.ST"] = PS["Control.Monad.ST"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Control.Monad.ST"];
  var Prelude = PS["Prelude"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  exports["writeSTRef"] = $foreign.writeSTRef;
  exports["readSTRef"] = $foreign.readSTRef;
  exports["newSTRef"] = $foreign.newSTRef;
})(PS["Control.Monad.ST"] = PS["Control.Monad.ST"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Tuple = PS["Data.Tuple"];
  var Data_Either = PS["Data.Either"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Alternative = PS["Control.Alternative"];
  var Control_Lazy = PS["Control.Lazy"];
  var Control_Monad_Cont_Class = PS["Control.Monad.Cont.Class"];
  var Control_Monad_Eff_Class = PS["Control.Monad.Eff.Class"];
  var Control_Monad_Error_Class = PS["Control.Monad.Error.Class"];
  var Control_Monad_Reader_Class = PS["Control.Monad.Reader.Class"];
  var Control_Monad_Rec_Class = PS["Control.Monad.Rec.Class"];
  var Control_Monad_State_Class = PS["Control.Monad.State.Class"];
  var Control_Monad_Trans = PS["Control.Monad.Trans"];
  var Control_Monad_Writer_Class = PS["Control.Monad.Writer.Class"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_Plus = PS["Control.Plus"];        
  var StateT = function (x) {
      return x;
  };
  var runStateT = function (v) {
      return v;
  };
  var monadStateT = function (dictMonad) {
      return new Prelude.Monad(function () {
          return applicativeStateT(dictMonad);
      }, function () {
          return bindStateT(dictMonad);
      });
  };
  var functorStateT = function (dictMonad) {
      return new Prelude.Functor(Prelude.liftM1(monadStateT(dictMonad)));
  };
  var bindStateT = function (dictMonad) {
      return new Prelude.Bind(function () {
          return applyStateT(dictMonad);
      }, function (v) {
          return function (f) {
              return function (s) {
                  return Prelude.bind(dictMonad["__superclass_Prelude.Bind_1"]())(v(s))(function (v1) {
                      return runStateT(f(v1.value0))(v1.value1);
                  });
              };
          };
      });
  };
  var applyStateT = function (dictMonad) {
      return new Prelude.Apply(function () {
          return functorStateT(dictMonad);
      }, Prelude.ap(monadStateT(dictMonad)));
  };
  var applicativeStateT = function (dictMonad) {
      return new Prelude.Applicative(function () {
          return applyStateT(dictMonad);
      }, function (a) {
          return StateT(function (s) {
              return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())(new Data_Tuple.Tuple(a, s));
          });
      });
  };
  var monadStateStateT = function (dictMonad) {
      return new Control_Monad_State_Class.MonadState(function () {
          return monadStateT(dictMonad);
      }, function (f) {
          return StateT(function ($63) {
              return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())(f($63));
          });
      });
  };
  exports["StateT"] = StateT;
  exports["runStateT"] = runStateT;
  exports["functorStateT"] = functorStateT;
  exports["applyStateT"] = applyStateT;
  exports["applicativeStateT"] = applicativeStateT;
  exports["bindStateT"] = bindStateT;
  exports["monadStateT"] = monadStateT;
  exports["monadStateStateT"] = monadStateStateT;
})(PS["Control.Monad.State.Trans"] = PS["Control.Monad.State.Trans"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Comonad = PS["Control.Comonad"];
  var Control_Extend = PS["Control.Extend"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Functor_Invariant = PS["Data.Functor.Invariant"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Traversable = PS["Data.Traversable"];        
  var Identity = function (x) {
      return x;
  };
  var runIdentity = function (v) {
      return v;
  };
  var functorIdentity = new Prelude.Functor(function (f) {
      return function (v) {
          return f(v);
      };
  });
  var applyIdentity = new Prelude.Apply(function () {
      return functorIdentity;
  }, function (v) {
      return function (v1) {
          return v(v1);
      };
  });
  var bindIdentity = new Prelude.Bind(function () {
      return applyIdentity;
  }, function (v) {
      return function (f) {
          return f(v);
      };
  });
  var applicativeIdentity = new Prelude.Applicative(function () {
      return applyIdentity;
  }, Identity);
  var monadIdentity = new Prelude.Monad(function () {
      return applicativeIdentity;
  }, function () {
      return bindIdentity;
  });
  exports["Identity"] = Identity;
  exports["runIdentity"] = runIdentity;
  exports["functorIdentity"] = functorIdentity;
  exports["applyIdentity"] = applyIdentity;
  exports["applicativeIdentity"] = applicativeIdentity;
  exports["bindIdentity"] = bindIdentity;
  exports["monadIdentity"] = monadIdentity;
})(PS["Data.Identity"] = PS["Data.Identity"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Monad_State_Class = PS["Control.Monad.State.Class"];
  var Control_Monad_State_Trans = PS["Control.Monad.State.Trans"];
  var Data_Identity = PS["Data.Identity"];
  var Data_Tuple = PS["Data.Tuple"];                   
  var runState = function (s) {
      return function ($0) {
          return Data_Identity.runIdentity(Control_Monad_State_Trans.runStateT(s)($0));
      };
  };
  var evalState = function (m) {
      return function (s) {
          return Data_Tuple.fst(runState(m)(s));
      };
  };
  exports["evalState"] = evalState;
  exports["runState"] = runState;
})(PS["Control.Monad.State"] = PS["Control.Monad.State"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Alt = PS["Control.Alt"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_Plus = PS["Control.Plus"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Either = PS["Data.Either"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Tuple = PS["Data.Tuple"];
  var mfromMaybe = function (dictMonadPlus) {
      return Data_Maybe.maybe(Control_Plus.empty((dictMonadPlus["__superclass_Control.Alternative.Alternative_1"]())["__superclass_Control.Plus.Plus_1"]()))(Prelude["return"]((dictMonadPlus["__superclass_Control.Alternative.Alternative_1"]())["__superclass_Prelude.Applicative_0"]()));
  };
  var mfilter = function (dictMonadPlus) {
      return function (f) {
          return function (m) {
              return Prelude.bind((dictMonadPlus["__superclass_Prelude.Monad_0"]())["__superclass_Prelude.Bind_1"]())(m)(function (v) {
                  var $15 = f(v);
                  if ($15) {
                      return Prelude["return"]((dictMonadPlus["__superclass_Control.Alternative.Alternative_1"]())["__superclass_Prelude.Applicative_0"]())(v);
                  };
                  if (!$15) {
                      return Control_Plus.empty((dictMonadPlus["__superclass_Control.Alternative.Alternative_1"]())["__superclass_Control.Plus.Plus_1"]());
                  };
                  throw new Error("Failed pattern match at Control.MonadPlus.Partial line 30, column 3 - line 32, column 1: " + [ $15.constructor.name ]);
              });
          };
      };
  };
  var mpartition = function (dictMonadPlus) {
      return function (f) {
          return function (m) {
              return new Data_Tuple.Tuple(mfilter(dictMonadPlus)(f)(m), mfilter(dictMonadPlus)(function ($24) {
                  return !f($24);
              })(m));
          };
      };
  };
  var mcatMaybes = function (dictMonadPlus) {
      return function (m) {
          return Prelude[">>="]((dictMonadPlus["__superclass_Prelude.Monad_0"]())["__superclass_Prelude.Bind_1"]())(m)(mfromMaybe(dictMonadPlus));
      };
  };
  var mlefts = function (dictMonadPlus) {
      var l = function (v) {
          if (v instanceof Data_Either.Left) {
              return new Data_Maybe.Just(v.value0);
          };
          if (v instanceof Data_Either.Right) {
              return Data_Maybe.Nothing.value;
          };
          throw new Error("Failed pattern match at Control.MonadPlus.Partial line 41, column 3 - line 42, column 3: " + [ v.constructor.name ]);
      };
      return function ($25) {
          return mcatMaybes(dictMonadPlus)(Prelude.liftM1(dictMonadPlus["__superclass_Prelude.Monad_0"]())(l)($25));
      };
  };
  var mrights = function (dictMonadPlus) {
      var r = function (v) {
          if (v instanceof Data_Either.Left) {
              return Data_Maybe.Nothing.value;
          };
          if (v instanceof Data_Either.Right) {
              return new Data_Maybe.Just(v.value0);
          };
          throw new Error("Failed pattern match at Control.MonadPlus.Partial line 47, column 3 - line 48, column 3: " + [ v.constructor.name ]);
      };
      return function ($27) {
          return mcatMaybes(dictMonadPlus)(Prelude.liftM1(dictMonadPlus["__superclass_Prelude.Monad_0"]())(r)($27));
      };
  };
  exports["mrights"] = mrights;
  exports["mlefts"] = mlefts;
  exports["mpartition"] = mpartition;
  exports["mfilter"] = mfilter;
  exports["mcatMaybes"] = mcatMaybes;
  exports["mfromMaybe"] = mfromMaybe;
})(PS["Control.MonadPlus.Partial"] = PS["Control.MonadPlus.Partial"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  exports.replicate = function (n) {
    return function (v) {
      if (n < 1) return [];
      var r = new Array(n);
      for (var i = 0; i < n; i++) r[i] = v;
      return r;
    };
  };

  //------------------------------------------------------------------------------
  // Array size ------------------------------------------------------------------
  //------------------------------------------------------------------------------

  exports.length = function (xs) {
    return xs.length;
  };

  //------------------------------------------------------------------------------
  // Extending arrays ------------------------------------------------------------
  //------------------------------------------------------------------------------

  exports.cons = function (e) {
    return function (l) {
      return [e].concat(l);
    };
  };

  //------------------------------------------------------------------------------
  // Non-indexed reads -----------------------------------------------------------
  //------------------------------------------------------------------------------

  exports["uncons'"] = function (empty) {
    return function (next) {
      return function (xs) {
        return xs.length === 0 ? empty({}) : next(xs[0])(xs.slice(1));
      };
    };
  };

  //------------------------------------------------------------------------------
  // Indexed operations ----------------------------------------------------------
  //------------------------------------------------------------------------------

  exports.indexImpl = function (just) {
    return function (nothing) {
      return function (xs) {
        return function (i) {
          return i < 0 || i >= xs.length ? nothing :  just(xs[i]);
        };
      };
    };
  };

  //------------------------------------------------------------------------------
  // Transformations -------------------------------------------------------------
  //------------------------------------------------------------------------------

  exports.reverse = function (l) {
    return l.slice().reverse();
  };

  exports.concat = function (xss) {
    var result = [];
    for (var i = 0, l = xss.length; i < l; i++) {
      var xs = xss[i];
      for (var j = 0, m = xs.length; j < m; j++) {
        result.push(xs[j]);
      }
    }
    return result;
  };

  exports.filter = function (f) {
    return function (xs) {
      return xs.filter(f);
    };
  };

  //------------------------------------------------------------------------------
  // Sorting ---------------------------------------------------------------------
  //------------------------------------------------------------------------------

  exports.sortImpl = function (f) {
    return function (l) {
      /* jshint maxparams: 2 */
      return l.slice().sort(function (x, y) {
        return f(x)(y);
      });
    };
  };

  //------------------------------------------------------------------------------
  // Subarrays -------------------------------------------------------------------
  //------------------------------------------------------------------------------

  exports.slice = function (s) {
    return function (e) {
      return function (l) {
        return l.slice(s, e);
      };
    };
  };

  exports.drop = function (n) {
    return function (l) {
      return n < 1 ? l : l.slice(n);
    };
  };
})(PS["Data.Array"] = PS["Data.Array"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.Maybe.Unsafe

  exports.unsafeThrow = function (msg) {
    throw new Error(msg);
  };
})(PS["Data.Maybe.Unsafe"] = PS["Data.Maybe.Unsafe"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Maybe.Unsafe"];
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];        
  var fromJust = function (v) {
      if (v instanceof Data_Maybe.Just) {
          return v.value0;
      };
      if (v instanceof Data_Maybe.Nothing) {
          return $foreign.unsafeThrow("Data.Maybe.Unsafe.fromJust called on Nothing");
      };
      throw new Error("Failed pattern match at Data.Maybe.Unsafe line 11, column 1 - line 12, column 1: " + [ v.constructor.name ]);
  };
  exports["fromJust"] = fromJust;
  exports["unsafeThrow"] = $foreign.unsafeThrow;
})(PS["Data.Maybe.Unsafe"] = PS["Data.Maybe.Unsafe"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Array"];
  var Prelude = PS["Prelude"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Alternative = PS["Control.Alternative"];
  var Control_Lazy = PS["Control.Lazy"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_Plus = PS["Control.Plus"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Functor_Invariant = PS["Data.Functor.Invariant"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Traversable = PS["Data.Traversable"];
  var Data_Tuple = PS["Data.Tuple"];
  var Data_Maybe_Unsafe = PS["Data.Maybe.Unsafe"];        
  var $colon = $foreign.cons;
  var uncons = $foreign["uncons'"](Prelude["const"](Data_Maybe.Nothing.value))(function (x) {
      return function (xs) {
          return new Data_Maybe.Just({
              head: x, 
              tail: xs
          });
      };
  });                          
  var tail = $foreign["uncons'"](Prelude["const"](Data_Maybe.Nothing.value))(function (v) {
      return function (xs) {
          return new Data_Maybe.Just(xs);
      };
  });
  var span = function (p) {
      var go = function (__copy_acc) {
          return function (__copy_xs) {
              var acc = __copy_acc;
              var xs = __copy_xs;
              tco: while (true) {
                  var $42 = uncons(xs);
                  if ($42 instanceof Data_Maybe.Just && p($42.value0.head)) {
                      var __tco_acc = $colon($42.value0.head)(acc);
                      acc = __tco_acc;
                      xs = $42.value0.tail;
                      continue tco;
                  };
                  return {
                      init: $foreign.reverse(acc), 
                      rest: xs
                  };
              };
          };
      };
      return go([  ]);
  };
  var takeWhile = function (p) {
      return function (xs) {
          return (span(p)(xs)).init;
      };
  };
  var sortBy = function (comp) {
      return function (xs) {
          var comp$prime = function (x) {
              return function (y) {
                  var $46 = comp(x)(y);
                  if ($46 instanceof Prelude.GT) {
                      return 1;
                  };
                  if ($46 instanceof Prelude.EQ) {
                      return 0;
                  };
                  if ($46 instanceof Prelude.LT) {
                      return -1;
                  };
                  throw new Error("Failed pattern match at Data.Array line 417, column 15 - line 422, column 1: " + [ $46.constructor.name ]);
              };
          };
          return $foreign.sortImpl(comp$prime)(xs);
      };
  };
  var sort = function (dictOrd) {
      return function (xs) {
          return sortBy(Prelude.compare(dictOrd))(xs);
      };
  };
  var singleton = function (a) {
      return [ a ];
  };
  var $$null = function (xs) {
      return $foreign.length(xs) === 0;
  };
  var some = function (dictAlternative) {
      return function (dictLazy) {
          return function (v) {
              return Prelude["<*>"]((dictAlternative["__superclass_Prelude.Applicative_0"]())["__superclass_Prelude.Apply_0"]())(Prelude["<$>"](((dictAlternative["__superclass_Control.Plus.Plus_1"]())["__superclass_Control.Alt.Alt_0"]())["__superclass_Prelude.Functor_0"]())($colon)(v))(Control_Lazy.defer(dictLazy)(function (v1) {
                  return many(dictAlternative)(dictLazy)(v);
              }));
          };
      };
  };
  var many = function (dictAlternative) {
      return function (dictLazy) {
          return function (v) {
              return Control_Alt["<|>"]((dictAlternative["__superclass_Control.Plus.Plus_1"]())["__superclass_Control.Alt.Alt_0"]())(some(dictAlternative)(dictLazy)(v))(Prelude.pure(dictAlternative["__superclass_Prelude.Applicative_0"]())([  ]));
          };
      };
  };                                                                                  
  var init = function (xs) {
      if ($$null(xs)) {
          return Data_Maybe.Nothing.value;
      };
      if (Prelude.otherwise) {
          return new Data_Maybe.Just($foreign.slice(0)($foreign.length(xs) - 1)(xs));
      };
      throw new Error("Failed pattern match at Data.Array line 228, column 1 - line 245, column 1: " + [ xs.constructor.name ]);
  };
  var index = $foreign.indexImpl(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);
  var $bang$bang = index;
  var last = function (xs) {
      return $bang$bang(xs)($foreign.length(xs) - 1);
  };
  var head = $foreign["uncons'"](Prelude["const"](Data_Maybe.Nothing.value))(function (x) {
      return function (v) {
          return new Data_Maybe.Just(x);
      };
  });
  var foldM = function (dictMonad) {
      return function (f) {
          return function (a) {
              return $foreign["uncons'"](function (v) {
                  return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())(a);
              })(function (b) {
                  return function (bs) {
                      return Prelude[">>="](dictMonad["__superclass_Prelude.Bind_1"]())(f(a)(b))(function (a$prime) {
                          return foldM(dictMonad)(f)(a$prime)(bs);
                      });
                  };
              });
          };
      };
  };
  exports["foldM"] = foldM;
  exports["span"] = span;
  exports["takeWhile"] = takeWhile;
  exports["sortBy"] = sortBy;
  exports["sort"] = sort;
  exports["index"] = index;
  exports["uncons"] = uncons;
  exports["init"] = init;
  exports["tail"] = tail;
  exports["last"] = last;
  exports["head"] = head;
  exports[":"] = $colon;
  exports["many"] = many;
  exports["some"] = some;
  exports["singleton"] = singleton;
  exports["drop"] = $foreign.drop;
  exports["slice"] = $foreign.slice;
  exports["filter"] = $foreign.filter;
  exports["concat"] = $foreign.concat;
  exports["cons"] = $foreign.cons;
  exports["length"] = $foreign.length;
  exports["replicate"] = $foreign.replicate;
})(PS["Data.Array"] = PS["Data.Array"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.Array.ST

  exports.runSTArray = function (f) {
    return f;
  };

  exports.emptySTArray = function () {
    return [];
  };

  exports.pushAllSTArray = function (xs) {
    return function (as) {
      return function () {
        return xs.push.apply(xs, as);
      };
    };
  };
})(PS["Data.Array.ST"] = PS["Data.Array.ST"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Array.ST"];
  var Prelude = PS["Prelude"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  var Control_Monad_ST = PS["Control.Monad.ST"];
  var Data_Maybe = PS["Data.Maybe"];
  var pushSTArray = function (arr) {
      return function (a) {
          return $foreign.pushAllSTArray(arr)([ a ]);
      };
  };
  exports["pushSTArray"] = pushSTArray;
  exports["emptySTArray"] = $foreign.emptySTArray;
  exports["runSTArray"] = $foreign.runSTArray;
})(PS["Data.Array.ST"] = PS["Data.Array.ST"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.Array.Unsafe

  exports.unsafeIndex = function (xs) {
    return function (n) {
      return xs[n];
    };
  };
})(PS["Data.Array.Unsafe"] = PS["Data.Array.Unsafe"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Array.Unsafe"];
  var Prelude = PS["Prelude"];
  var Data_Array = PS["Data.Array"];        
  var tail = function (xs) {
      return Data_Array.slice(1)(Data_Array.length(xs))(xs);
  };
  var head = function (xs) {
      return $foreign.unsafeIndex(xs)(0);
  };
  exports["tail"] = tail;
  exports["head"] = head;
})(PS["Data.Array.Unsafe"] = PS["Data.Array.Unsafe"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.Char

  exports.toString = function (c) {
    return c;
  };

  exports.toLower = function (c) {
    return c.toLowerCase();
  };
})(PS["Data.Char"] = PS["Data.Char"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Char"];
  var Prelude = PS["Prelude"];
  exports["toLower"] = $foreign.toLower;
  exports["toString"] = $foreign.toString;
})(PS["Data.Char"] = PS["Data.Char"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  exports.unsafeFromForeign = function (value) {
    return value;
  };

  exports.typeOf = function (value) {
    return typeof value;
  };

  exports.tagOf = function (value) {
    return Object.prototype.toString.call(value).slice(8, -1);
  };

  exports.isNull = function (value) {
    return value === null;
  };

  exports.isUndefined = function (value) {
    return value === undefined;
  };

  exports.isArray = Array.isArray || function (value) {
    return Object.prototype.toString.call(value) === "[object Array]";
  };
})(PS["Data.Foreign"] = PS["Data.Foreign"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  exports.mkFn2 = function (fn) {
    /* jshint maxparams: 2 */
    return function (a, b) {
      return fn(a)(b);
    };
  };

  exports.runFn4 = function (fn) {
    return function (a) {
      return function (b) {
        return function (c) {
          return function (d) {
            return fn(a, b, c, d);
          };
        };
      };
    };
  };
})(PS["Data.Function"] = PS["Data.Function"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Function"];
  var Prelude = PS["Prelude"];        
  var on = function (f) {
      return function (g) {
          return function (x) {
              return function (y) {
                  return f(g(x))(g(y));
              };
          };
      };
  };
  exports["on"] = on;
  exports["runFn4"] = $foreign.runFn4;
  exports["mkFn2"] = $foreign.mkFn2;
})(PS["Data.Function"] = PS["Data.Function"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.String

  exports._charAt = function (just) {
    return function (nothing) {
      return function (i) {
        return function (s) {
          return i >= 0 && i < s.length ? just(s.charAt(i)) : nothing;
        };
      };
    };
  };

  exports.fromCharArray = function (a) {
    return a.join("");
  };

  exports._indexOf = function (just) {
    return function (nothing) {
      return function (x) {
        return function (s) {
          var i = s.indexOf(x);
          return i === -1 ? nothing : just(i);
        };
      };
    };
  };

  exports._lastIndexOf = function (just) {
    return function (nothing) {
      return function (x) {
        return function (s) {
          var i = s.lastIndexOf(x);
          return i === -1 ? nothing : just(i);
        };
      };
    };
  };

  exports.length = function (s) {
    return s.length;
  };

  exports.take = function (n) {
    return function (s) {
      return s.substr(0, n);
    };
  };

  exports.drop = function (n) {
    return function (s) {
      return s.substr(n);
    };
  };

  exports.split = function (sep) {
    return function (s) {
      return s.split(sep);
    };
  };

  exports.toCharArray = function (s) {
    return s.split("");
  };

  exports.toLower = function (s) {
    return s.toLowerCase();
  };

  exports.toUpper = function (s) {
    return s.toUpperCase();
  };

  exports.trim = function (s) {
    return s.trim();
  };

  exports.joinWith = function (s) {
    return function (xs) {
      return xs.join(s);
    };
  };
})(PS["Data.String"] = PS["Data.String"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  exports.charAt = function (i) {
    return function (s) {
      if (i >= 0 && i < s.length) return s.charAt(i);
      throw new Error("Data.String.Unsafe.charAt: Invalid index.");
    };
  };
})(PS["Data.String.Unsafe"] = PS["Data.String.Unsafe"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.String.Unsafe"];
  exports["charAt"] = $foreign.charAt;
})(PS["Data.String.Unsafe"] = PS["Data.String.Unsafe"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.String"];
  var Prelude = PS["Prelude"];
  var Data_Char = PS["Data.Char"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_String_Unsafe = PS["Data.String.Unsafe"];        
  var uncons = function (v) {
      if (v === "") {
          return Data_Maybe.Nothing.value;
      };
      return new Data_Maybe.Just({
          head: Data_String_Unsafe.charAt(0)(v), 
          tail: $foreign.drop(1)(v)
      });
  };                                                                                                  
  var lastIndexOf = $foreign._lastIndexOf(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);  
  var indexOf = $foreign._indexOf(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);
  var stripPrefix = function (prefix) {
      return function (str) {
          var $4 = indexOf(prefix)(str);
          if ($4 instanceof Data_Maybe.Just && $4.value0 === 0) {
              return Data_Maybe.Just.create($foreign.drop($foreign.length(prefix))(str));
          };
          return Data_Maybe.Nothing.value;
      };
  };
  var fromChar = Data_Char.toString;
  var singleton = fromChar;
  var contains = function (x) {
      return function (s) {
          return Data_Maybe.isJust(indexOf(x)(s));
      };
  };                                                                                      
  var charAt = $foreign._charAt(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);
  exports["stripPrefix"] = stripPrefix;
  exports["singleton"] = singleton;
  exports["uncons"] = uncons;
  exports["lastIndexOf"] = lastIndexOf;
  exports["indexOf"] = indexOf;
  exports["contains"] = contains;
  exports["fromChar"] = fromChar;
  exports["charAt"] = charAt;
  exports["joinWith"] = $foreign.joinWith;
  exports["trim"] = $foreign.trim;
  exports["toUpper"] = $foreign.toUpper;
  exports["toLower"] = $foreign.toLower;
  exports["toCharArray"] = $foreign.toCharArray;
  exports["split"] = $foreign.split;
  exports["drop"] = $foreign.drop;
  exports["take"] = $foreign.take;
  exports["length"] = $foreign.length;
  exports["fromCharArray"] = $foreign.fromCharArray;
})(PS["Data.String"] = PS["Data.String"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Foreign"];
  var Prelude = PS["Prelude"];
  var Data_Either = PS["Data.Either"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Function = PS["Data.Function"];
  var Data_Int_1 = PS["Data.Int"];
  var Data_Int_1 = PS["Data.Int"];
  var Data_String = PS["Data.String"];        
  var TypeMismatch = (function () {
      function TypeMismatch(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      TypeMismatch.create = function (value0) {
          return function (value1) {
              return new TypeMismatch(value0, value1);
          };
      };
      return TypeMismatch;
  })();
  var ErrorAtProperty = (function () {
      function ErrorAtProperty(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      ErrorAtProperty.create = function (value0) {
          return function (value1) {
              return new ErrorAtProperty(value0, value1);
          };
      };
      return ErrorAtProperty;
  })();                                         
  var readArray = function (value) {
      if ($foreign.isArray(value)) {
          return Prelude.pure(Data_Either.applicativeEither)($foreign.unsafeFromForeign(value));
      };
      return new Data_Either.Left(new TypeMismatch("array", $foreign.tagOf(value)));
  };
  exports["TypeMismatch"] = TypeMismatch;
  exports["ErrorAtProperty"] = ErrorAtProperty;
  exports["readArray"] = readArray;
  exports["isUndefined"] = $foreign.isUndefined;
  exports["isNull"] = $foreign.isNull;
  exports["typeOf"] = $foreign.typeOf;
  exports["unsafeFromForeign"] = $foreign.unsafeFromForeign;
})(PS["Data.Foreign"] = PS["Data.Foreign"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.Foreign.Index

  // jshint maxparams: 4
  exports.unsafeReadPropImpl = function (f, s, key, value) {
    return value == null ? f : s(value[key]);
  };

  // jshint maxparams: 2
  exports.unsafeHasOwnProperty = function (prop, value) {
    return Object.prototype.hasOwnProperty.call(value, prop);
  };

  exports.unsafeHasProperty = function (prop, value) {
    return prop in value;
  };
})(PS["Data.Foreign.Index"] = PS["Data.Foreign.Index"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Foreign.Index"];
  var Prelude = PS["Prelude"];
  var Data_Either = PS["Data.Either"];
  var Data_Foreign = PS["Data.Foreign"];
  var Data_Function = PS["Data.Function"];
  var Data_Int = PS["Data.Int"];        
  var Index = function (errorAt, hasOwnProperty, hasProperty, ix) {
      this.errorAt = errorAt;
      this.hasOwnProperty = hasOwnProperty;
      this.hasProperty = hasProperty;
      this.ix = ix;
  };
  var unsafeReadProp = function (k) {
      return function (value) {
          return $foreign.unsafeReadPropImpl(new Data_Either.Left(new Data_Foreign.TypeMismatch("object", Data_Foreign.typeOf(value))), Prelude.pure(Data_Either.applicativeEither), k, value);
      };
  };
  var prop = unsafeReadProp;
  var ix = function (dict) {
      return dict.ix;
  };
  var $bang = function (dictIndex) {
      return ix(dictIndex);
  };                         
  var hasPropertyImpl = function (v) {
      return function (value) {
          if (Data_Foreign.isNull(value)) {
              return false;
          };
          if (Data_Foreign.isUndefined(value)) {
              return false;
          };
          if (Data_Foreign.typeOf(value) === "object" || Data_Foreign.typeOf(value) === "function") {
              return $foreign.unsafeHasProperty(v, value);
          };
          return false;
      };
  };
  var hasProperty = function (dict) {
      return dict.hasProperty;
  };
  var hasOwnPropertyImpl = function (v) {
      return function (value) {
          if (Data_Foreign.isNull(value)) {
              return false;
          };
          if (Data_Foreign.isUndefined(value)) {
              return false;
          };
          if (Data_Foreign.typeOf(value) === "object" || Data_Foreign.typeOf(value) === "function") {
              return $foreign.unsafeHasOwnProperty(v, value);
          };
          return false;
      };
  };                                                                                                                   
  var indexString = new Index(Data_Foreign.ErrorAtProperty.create, hasOwnPropertyImpl, hasPropertyImpl, Prelude.flip(prop));
  var hasOwnProperty = function (dict) {
      return dict.hasOwnProperty;
  };
  var errorAt = function (dict) {
      return dict.errorAt;
  };
  exports["Index"] = Index;
  exports["errorAt"] = errorAt;
  exports["hasOwnProperty"] = hasOwnProperty;
  exports["hasProperty"] = hasProperty;
  exports["!"] = $bang;
  exports["ix"] = ix;
  exports["prop"] = prop;
  exports["indexString"] = indexString;
})(PS["Data.Foreign.Index"] = PS["Data.Foreign.Index"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Array = PS["Data.Array"];
  var Data_Either = PS["Data.Either"];
  var Data_Foreign = PS["Data.Foreign"];
  var Data_Foreign_Index = PS["Data.Foreign.Index"];
  var Data_Foreign_Null = PS["Data.Foreign.Null"];
  var Data_Foreign_NullOrUndefined = PS["Data.Foreign.NullOrUndefined"];
  var Data_Foreign_Undefined = PS["Data.Foreign.Undefined"];
  var Data_Int = PS["Data.Int"];
  var Data_Traversable = PS["Data.Traversable"];        
  var IsForeign = function (read) {
      this.read = read;
  };                                                           
  var read = function (dict) {
      return dict.read;
  };
  var readWith = function (dictIsForeign) {
      return function (f) {
          return function (value) {
              return Data_Either.either(function ($8) {
                  return Data_Either.Left.create(f($8));
              })(Data_Either.Right.create)(read(dictIsForeign)(value));
          };
      };
  };
  var readProp = function (dictIsForeign) {
      return function (dictIndex) {
          return function (prop) {
              return function (value) {
                  return Prelude[">>="](Data_Either.bindEither)(Data_Foreign_Index["!"](dictIndex)(value)(prop))(readWith(dictIsForeign)(Data_Foreign_Index.errorAt(dictIndex)(prop)));
              };
          };
      };
  };                                                     
  var foreignIsForeign = new IsForeign(function (f) {
      return Prelude["return"](Data_Either.applicativeEither)(f);
  });
  exports["IsForeign"] = IsForeign;
  exports["readProp"] = readProp;
  exports["readWith"] = readWith;
  exports["read"] = read;
  exports["foreignIsForeign"] = foreignIsForeign;
})(PS["Data.Foreign.Class"] = PS["Data.Foreign.Class"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];        
  var $less$dollar = function (dictFunctor) {
      return function (x) {
          return function (f) {
              return Prelude["<$>"](dictFunctor)(Prelude["const"](x))(f);
          };
      };
  };
  var $dollar$greater = function (dictFunctor) {
      return function (f) {
          return function (x) {
              return Prelude["<$>"](dictFunctor)(Prelude["const"](x))(f);
          };
      };
  };
  exports["$>"] = $dollar$greater;
  exports["<$"] = $less$dollar;
})(PS["Data.Functor"] = PS["Data.Functor"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.Generic


  //------------------------------------------------------------------------------
  // Zipping ---------------------------------------------------------------------
  //------------------------------------------------------------------------------

  exports.zipAll = function(f) {
      return function(xs) {
          return function(ys) {
              var l = xs.length < ys.length ? xs.length : ys.length;
              for (var i = 0; i < l; i++) {
                  if (!f(xs[i])(ys[i])) {
                      return false;
                  }
              }
              return true;
          };
      };
  };
})(PS["Data.Generic"] = PS["Data.Generic"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $$Proxy = (function () {
      function Proxy() {

      };
      Proxy.value = new Proxy();
      return Proxy;
  })();
  exports["Proxy"] = $$Proxy;
})(PS["Type.Proxy"] = PS["Type.Proxy"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.Generic"];
  var Prelude = PS["Prelude"];
  var Data_Either = PS["Data.Either"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Tuple = PS["Data.Tuple"];
  var Data_Traversable = PS["Data.Traversable"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Array = PS["Data.Array"];
  var Data_String = PS["Data.String"];
  var Type_Proxy = PS["Type.Proxy"];
  var Data_Monoid = PS["Data.Monoid"];        
  var SProd = (function () {
      function SProd(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      SProd.create = function (value0) {
          return function (value1) {
              return new SProd(value0, value1);
          };
      };
      return SProd;
  })();
  var SRecord = (function () {
      function SRecord(value0) {
          this.value0 = value0;
      };
      SRecord.create = function (value0) {
          return new SRecord(value0);
      };
      return SRecord;
  })();
  var SNumber = (function () {
      function SNumber(value0) {
          this.value0 = value0;
      };
      SNumber.create = function (value0) {
          return new SNumber(value0);
      };
      return SNumber;
  })();
  var SBoolean = (function () {
      function SBoolean(value0) {
          this.value0 = value0;
      };
      SBoolean.create = function (value0) {
          return new SBoolean(value0);
      };
      return SBoolean;
  })();
  var SInt = (function () {
      function SInt(value0) {
          this.value0 = value0;
      };
      SInt.create = function (value0) {
          return new SInt(value0);
      };
      return SInt;
  })();
  var SString = (function () {
      function SString(value0) {
          this.value0 = value0;
      };
      SString.create = function (value0) {
          return new SString(value0);
      };
      return SString;
  })();
  var SChar = (function () {
      function SChar(value0) {
          this.value0 = value0;
      };
      SChar.create = function (value0) {
          return new SChar(value0);
      };
      return SChar;
  })();
  var SArray = (function () {
      function SArray(value0) {
          this.value0 = value0;
      };
      SArray.create = function (value0) {
          return new SArray(value0);
      };
      return SArray;
  })();
  var SigProd = (function () {
      function SigProd(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      SigProd.create = function (value0) {
          return function (value1) {
              return new SigProd(value0, value1);
          };
      };
      return SigProd;
  })();
  var SigRecord = (function () {
      function SigRecord(value0) {
          this.value0 = value0;
      };
      SigRecord.create = function (value0) {
          return new SigRecord(value0);
      };
      return SigRecord;
  })();
  var SigNumber = (function () {
      function SigNumber() {

      };
      SigNumber.value = new SigNumber();
      return SigNumber;
  })();
  var SigBoolean = (function () {
      function SigBoolean() {

      };
      SigBoolean.value = new SigBoolean();
      return SigBoolean;
  })();
  var SigInt = (function () {
      function SigInt() {

      };
      SigInt.value = new SigInt();
      return SigInt;
  })();
  var SigString = (function () {
      function SigString() {

      };
      SigString.value = new SigString();
      return SigString;
  })();
  var SigChar = (function () {
      function SigChar() {

      };
      SigChar.value = new SigChar();
      return SigChar;
  })();
  var SigArray = (function () {
      function SigArray(value0) {
          this.value0 = value0;
      };
      SigArray.create = function (value0) {
          return new SigArray(value0);
      };
      return SigArray;
  })();
  var Generic = function (fromSpine, toSignature, toSpine) {
      this.fromSpine = fromSpine;
      this.toSignature = toSignature;
      this.toSpine = toSpine;
  };
  var toSpine = function (dict) {
      return dict.toSpine;
  };
  var toSignature = function (dict) {
      return dict.toSignature;
  };
  var genericString = new Generic(function (v) {
      if (v instanceof SString) {
          return new Data_Maybe.Just(v.value0);
      };
      return Data_Maybe.Nothing.value;
  }, function (v) {
      return SigString.value;
  }, function (x) {
      return new SString(x);
  });
  var genericNumber = new Generic(function (v) {
      if (v instanceof SNumber) {
          return new Data_Maybe.Just(v.value0);
      };
      return Data_Maybe.Nothing.value;
  }, function (v) {
      return SigNumber.value;
  }, function (x) {
      return new SNumber(x);
  });
  var genericInt = new Generic(function (v) {
      if (v instanceof SInt) {
          return new Data_Maybe.Just(v.value0);
      };
      return Data_Maybe.Nothing.value;
  }, function (v) {
      return SigInt.value;
  }, function (x) {
      return new SInt(x);
  });
  var genericChar = new Generic(function (v) {
      if (v instanceof SChar) {
          return new Data_Maybe.Just(v.value0);
      };
      return Data_Maybe.Nothing.value;
  }, function (v) {
      return SigChar.value;
  }, function (x) {
      return new SChar(x);
  });
  var genericBool = new Generic(function (v) {
      if (v instanceof SBoolean) {
          return new Data_Maybe.Just(v.value0);
      };
      return Data_Maybe.Nothing.value;
  }, function (v) {
      return SigBoolean.value;
  }, function (b) {
      return new SBoolean(b);
  });
  var fromSpine = function (dict) {
      return dict.fromSpine;
  };                                                         
  var eqGeneric = new Prelude.Eq(function (v) {
      return function (v1) {
          if (v instanceof SProd && v1 instanceof SProd) {
              return v.value0 === v1.value0 && (Data_Array.length(v.value1) === Data_Array.length(v1.value1) && $foreign.zipAll(function (x) {
                  return function (y) {
                      return Prelude["=="](eqGeneric)(x(Prelude.unit))(y(Prelude.unit));
                  };
              })(v.value1)(v1.value1));
          };
          if (v instanceof SRecord && v1 instanceof SRecord) {
              var go = function (x) {
                  return function (y) {
                      return x.recLabel === y.recLabel && Prelude["=="](eqGeneric)(x.recValue(Prelude.unit))(y.recValue(Prelude.unit));
                  };
              };
              return Data_Array.length(v.value0) === Data_Array.length(v1.value0) && $foreign.zipAll(go)(v.value0)(v1.value0);
          };
          if (v instanceof SInt && v1 instanceof SInt) {
              return v.value0 === v1.value0;
          };
          if (v instanceof SNumber && v1 instanceof SNumber) {
              return v.value0 === v1.value0;
          };
          if (v instanceof SBoolean && v1 instanceof SBoolean) {
              return v.value0 === v1.value0;
          };
          if (v instanceof SChar && v1 instanceof SChar) {
              return v.value0 === v1.value0;
          };
          if (v instanceof SString && v1 instanceof SString) {
              return v.value0 === v1.value0;
          };
          if (v instanceof SArray && v1 instanceof SArray) {
              return Data_Array.length(v.value0) === Data_Array.length(v1.value0) && $foreign.zipAll(function (x) {
                  return function (y) {
                      return Prelude["=="](eqGeneric)(x(Prelude.unit))(y(Prelude.unit));
                  };
              })(v.value0)(v1.value0);
          };
          return false;
      };
  });
  var gEq = function (dictGeneric) {
      return function (x) {
          return function (y) {
              return Prelude["=="](eqGeneric)(toSpine(dictGeneric)(x))(toSpine(dictGeneric)(y));
          };
      };
  };
  var anyProxy = (Type_Proxy["Proxy"]).value;
  var genericArray = function (dictGeneric) {
      return new Generic(function (v) {
          if (v instanceof SArray) {
              return Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Maybe.applicativeMaybe)(function ($197) {
                  return fromSpine(dictGeneric)((function (v1) {
                      return v1(Prelude.unit);
                  })($197));
              })(v.value0);
          };
          return Data_Maybe.Nothing.value;
      }, function (x) {
          var lowerProxy = function (v) {
              return anyProxy;
          };
          return new SigArray(function (unit) {
              return toSignature(dictGeneric)(lowerProxy(x));
          });
      }, function (xs) {
          return new SArray(Prelude["<$>"](Prelude.functorArray)(function (x) {
              return function (y) {
                  return toSpine(dictGeneric)(x);
              };
          })(xs));
      });
  };
  var genericMaybe = function (dictGeneric) {
      return new Generic(function (v) {
          if (v instanceof SProd && (v.value0 === "Data.Maybe.Just" && v.value1.length === 1)) {
              return Prelude["<$>"](Data_Maybe.functorMaybe)(Data_Maybe.Just.create)(fromSpine(dictGeneric)(v.value1[0](Prelude.unit)));
          };
          if (v instanceof SProd && (v.value0 === "Data.Maybe.Nothing" && v.value1.length === 0)) {
              return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Maybe.Nothing.value);
          };
          return Data_Maybe.Nothing.value;
      }, function (x) {
          var mbProxy = function (v) {
              return anyProxy;
          };
          return new SigProd("Data.Maybe.Maybe", [ {
              sigConstructor: "Data.Maybe.Just", 
              sigValues: [ function (u) {
                  return toSignature(dictGeneric)(mbProxy(x));
              } ]
          }, {
              sigConstructor: "Data.Maybe.Nothing", 
              sigValues: [  ]
          } ]);
      }, function (v) {
          if (v instanceof Data_Maybe.Just) {
              return new SProd("Data.Maybe.Just", [ function (u) {
                  return toSpine(dictGeneric)(v.value0);
              } ]);
          };
          if (v instanceof Data_Maybe.Nothing) {
              return new SProd("Data.Maybe.Nothing", [  ]);
          };
          throw new Error("Failed pattern match at Data.Generic line 198, column 7 - line 199, column 7: " + [ v.constructor.name ]);
      });
  };
  exports["SigProd"] = SigProd;
  exports["SigRecord"] = SigRecord;
  exports["SigNumber"] = SigNumber;
  exports["SigBoolean"] = SigBoolean;
  exports["SigInt"] = SigInt;
  exports["SigString"] = SigString;
  exports["SigChar"] = SigChar;
  exports["SigArray"] = SigArray;
  exports["SProd"] = SProd;
  exports["SRecord"] = SRecord;
  exports["SNumber"] = SNumber;
  exports["SBoolean"] = SBoolean;
  exports["SInt"] = SInt;
  exports["SString"] = SString;
  exports["SChar"] = SChar;
  exports["SArray"] = SArray;
  exports["Generic"] = Generic;
  exports["gEq"] = gEq;
  exports["fromSpine"] = fromSpine;
  exports["toSignature"] = toSignature;
  exports["toSpine"] = toSpine;
  exports["genericNumber"] = genericNumber;
  exports["genericInt"] = genericInt;
  exports["genericString"] = genericString;
  exports["genericChar"] = genericChar;
  exports["genericBool"] = genericBool;
  exports["genericArray"] = genericArray;
  exports["genericMaybe"] = genericMaybe;
  exports["eqGeneric"] = eqGeneric;
})(PS["Data.Generic"] = PS["Data.Generic"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Tuple = PS["Data.Tuple"];
  var Data_Array_ST = PS["Data.Array.ST"];
  var Data_Traversable = PS["Data.Traversable"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  var Control_Monad_ST = PS["Control.Monad.ST"];        
  var Unfoldable = function (unfoldr) {
      this.unfoldr = unfoldr;
  };
  var unfoldr = function (dict) {
      return dict.unfoldr;
  };
  var unfoldableArray = new Unfoldable(function (f) {
      return function (b) {
          return Control_Monad_Eff.runPure(Data_Array_ST.runSTArray(function __do() {
              var v = Data_Array_ST.emptySTArray();
              var v1 = Control_Monad_ST.newSTRef(b)();
              (function () {
                  while (!(function __do() {
                      var v2 = Control_Monad_ST.readSTRef(v1)();
                      var $12 = f(v2);
                      if ($12 instanceof Data_Maybe.Nothing) {
                          return true;
                      };
                      if ($12 instanceof Data_Maybe.Just) {
                          Data_Array_ST.pushSTArray(v)($12.value0.value0)();
                          Control_Monad_ST.writeSTRef(v1)($12.value0.value1)();
                          return false;
                      };
                      throw new Error("Failed pattern match at Data.Unfoldable line 35, column 7 - line 41, column 5: " + [ $12.constructor.name ]);
                  })()) {

                  };
                  return {};
              })();
              return v;
          }));
      };
  });
  exports["Unfoldable"] = Unfoldable;
  exports["unfoldr"] = unfoldr;
  exports["unfoldableArray"] = unfoldableArray;
})(PS["Data.Unfoldable"] = PS["Data.Unfoldable"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Alternative = PS["Control.Alternative"];
  var Control_Lazy = PS["Control.Lazy"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_Plus = PS["Control.Plus"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Traversable = PS["Data.Traversable"];
  var Data_Tuple = PS["Data.Tuple"];
  var Data_Unfoldable = PS["Data.Unfoldable"];        
  var Nil = (function () {
      function Nil() {

      };
      Nil.value = new Nil();
      return Nil;
  })();
  var Cons = (function () {
      function Cons(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Cons.create = function (value0) {
          return function (value1) {
              return new Cons(value0, value1);
          };
      };
      return Cons;
  })();
  var $colon = Cons.create;
  var uncons = function (v) {
      if (v instanceof Nil) {
          return Data_Maybe.Nothing.value;
      };
      if (v instanceof Cons) {
          return new Data_Maybe.Just({
              head: v.value0, 
              tail: v.value1
          });
      };
      throw new Error("Failed pattern match at Data.List line 273, column 1 - line 274, column 1: " + [ v.constructor.name ]);
  };
  var toUnfoldable = function (dictUnfoldable) {
      return Data_Unfoldable.unfoldr(dictUnfoldable)(function (xs) {
          return Prelude["<$>"](Data_Maybe.functorMaybe)(function (rec) {
              return new Data_Tuple.Tuple(rec.head, rec.tail);
          })(uncons(xs));
      });
  };
  var tail = function (v) {
      if (v instanceof Nil) {
          return Data_Maybe.Nothing.value;
      };
      if (v instanceof Cons) {
          return new Data_Maybe.Just(v.value1);
      };
      throw new Error("Failed pattern match at Data.List line 254, column 1 - line 255, column 1: " + [ v.constructor.name ]);
  };
  var span = function (v) {
      return function (v1) {
          if (v1 instanceof Cons && v(v1.value0)) {
              var $134 = span(v)(v1.value1);
              return {
                  init: new Cons(v1.value0, $134.init), 
                  rest: $134.rest
              };
          };
          return {
              init: Nil.value, 
              rest: v1
          };
      };
  };
  var singleton = function (a) {
      return new Cons(a, Nil.value);
  };
  var sortBy = function (cmp) {
      var merge = function (v) {
          return function (v1) {
              if (v instanceof Cons && v1 instanceof Cons) {
                  if (Prelude["=="](Prelude.eqOrdering)(cmp(v.value0)(v1.value0))(Prelude.GT.value)) {
                      return new Cons(v1.value0, merge(v)(v1.value1));
                  };
                  if (Prelude.otherwise) {
                      return new Cons(v.value0, merge(v.value1)(v1));
                  };
              };
              if (v instanceof Nil) {
                  return v1;
              };
              if (v1 instanceof Nil) {
                  return v;
              };
              throw new Error("Failed pattern match at Data.List line 475, column 3 - line 478, column 3: " + [ v.constructor.name, v1.constructor.name ]);
          };
      };
      var mergePairs = function (v) {
          if (v instanceof Cons && v.value1 instanceof Cons) {
              return new Cons(merge(v.value0)(v.value1.value0), mergePairs(v.value1.value1));
          };
          return v;
      };
      var mergeAll = function (__copy_v) {
          var v = __copy_v;
          tco: while (true) {
              if (v instanceof Cons && v.value1 instanceof Nil) {
                  return v.value0;
              };
              var __tco_v = mergePairs(v);
              v = __tco_v;
              continue tco;
          };
      };
      var sequences = function (v) {
          if (v instanceof Cons && v.value1 instanceof Cons) {
              if (Prelude["=="](Prelude.eqOrdering)(cmp(v.value0)(v.value1.value0))(Prelude.GT.value)) {
                  return descending(v.value1.value0)(singleton(v.value0))(v.value1.value1);
              };
              if (Prelude.otherwise) {
                  return ascending(v.value1.value0)(Cons.create(v.value0))(v.value1.value1);
              };
          };
          return singleton(v);
      };
      var descending = function (__copy_a) {
          return function (__copy_as) {
              return function (__copy_v) {
                  var a = __copy_a;
                  var as = __copy_as;
                  var v = __copy_v;
                  tco: while (true) {
                      if (v instanceof Cons && Prelude["=="](Prelude.eqOrdering)(cmp(a)(v.value0))(Prelude.GT.value)) {
                          var __tco_a = v.value0;
                          var __tco_as = new Cons(a, as);
                          var __tco_v = v.value1;
                          a = __tco_a;
                          as = __tco_as;
                          v = __tco_v;
                          continue tco;
                      };
                      return new Cons(new Cons(a, as), sequences(v));
                  };
              };
          };
      };
      var ascending = function (a) {
          return function (as) {
              return function (v) {
                  if (v instanceof Cons && Prelude["/="](Prelude.eqOrdering)(cmp(a)(v.value0))(Prelude.GT.value)) {
                      return ascending(v.value0)(function (ys) {
                          return as(new Cons(a, ys));
                      })(v.value1);
                  };
                  return new Cons(as(singleton(a)), sequences(v));
              };
          };
      };
      return function ($372) {
          return mergeAll(sequences($372));
      };
  };
  var showList = function (dictShow) {
      return new Prelude.Show(function (v) {
          if (v instanceof Nil) {
              return "Nil";
          };
          if (v instanceof Cons) {
              return "Cons (" + (Prelude.show(dictShow)(v.value0) + (") (" + (Prelude.show(showList(dictShow))(v.value1) + ")")));
          };
          throw new Error("Failed pattern match at Data.List line 727, column 3 - line 728, column 3: " + [ v.constructor.name ]);
      });
  };
  var semigroupList = new Prelude.Semigroup(function (v) {
      return function (ys) {
          if (v instanceof Nil) {
              return ys;
          };
          if (v instanceof Cons) {
              return new Cons(v.value0, Prelude["<>"](semigroupList)(v.value1)(ys));
          };
          throw new Error("Failed pattern match at Data.List line 751, column 3 - line 752, column 3: " + [ v.constructor.name, ys.constructor.name ]);
      };
  });
  var reverse = (function () {
      var go = function (__copy_acc) {
          return function (__copy_v) {
              var acc = __copy_acc;
              var v = __copy_v;
              tco: while (true) {
                  if (v instanceof Nil) {
                      return acc;
                  };
                  if (v instanceof Cons) {
                      var __tco_acc = new Cons(v.value0, acc);
                      var __tco_v = v.value1;
                      acc = __tco_acc;
                      v = __tco_v;
                      continue tco;
                  };
                  throw new Error("Failed pattern match at Data.List line 371, column 1 - line 379, column 1: " + [ acc.constructor.name, v.constructor.name ]);
              };
          };
      };
      return go(Nil.value);
  })();
  var monoidList = new Data_Monoid.Monoid(function () {
      return semigroupList;
  }, Nil.value);
  var mapMaybe = function (f) {
      var go = function (__copy_acc) {
          return function (__copy_v) {
              var acc = __copy_acc;
              var v = __copy_v;
              tco: while (true) {
                  if (v instanceof Nil) {
                      return reverse(acc);
                  };
                  if (v instanceof Cons) {
                      var $215 = f(v.value0);
                      if ($215 instanceof Data_Maybe.Nothing) {
                          var __tco_acc = acc;
                          var __tco_v = v.value1;
                          acc = __tco_acc;
                          v = __tco_v;
                          continue tco;
                      };
                      if ($215 instanceof Data_Maybe.Just) {
                          var __tco_acc = new Cons($215.value0, acc);
                          var __tco_v = v.value1;
                          acc = __tco_acc;
                          v = __tco_v;
                          continue tco;
                      };
                      throw new Error("Failed pattern match at Data.List line 427, column 5 - line 433, column 1: " + [ $215.constructor.name ]);
                  };
                  throw new Error("Failed pattern match at Data.List line 423, column 1 - line 433, column 1: " + [ acc.constructor.name, v.constructor.name ]);
              };
          };
      };
      return go(Nil.value);
  };
  var some = function (dictAlternative) {
      return function (dictLazy) {
          return function (v) {
              return Prelude["<*>"]((dictAlternative["__superclass_Prelude.Applicative_0"]())["__superclass_Prelude.Apply_0"]())(Prelude["<$>"](((dictAlternative["__superclass_Control.Plus.Plus_1"]())["__superclass_Control.Alt.Alt_0"]())["__superclass_Prelude.Functor_0"]())(Cons.create)(v))(Control_Lazy.defer(dictLazy)(function (v1) {
                  return many(dictAlternative)(dictLazy)(v);
              }));
          };
      };
  };
  var many = function (dictAlternative) {
      return function (dictLazy) {
          return function (v) {
              return Control_Alt["<|>"]((dictAlternative["__superclass_Control.Plus.Plus_1"]())["__superclass_Control.Alt.Alt_0"]())(some(dictAlternative)(dictLazy)(v))(Prelude.pure(dictAlternative["__superclass_Prelude.Applicative_0"]())(Nil.value));
          };
      };
  };
  var last = function (__copy_v) {
      var v = __copy_v;
      tco: while (true) {
          if (v instanceof Cons && v.value1 instanceof Nil) {
              return new Data_Maybe.Just(v.value0);
          };
          if (v instanceof Cons) {
              var __tco_v = v.value1;
              v = __tco_v;
              continue tco;
          };
          return Data_Maybe.Nothing.value;
      };
  };
  var init = function (v) {
      if (v instanceof Nil) {
          return Data_Maybe.Nothing.value;
      };
      var go = function (__copy_v1) {
          return function (__copy_acc) {
              var v1 = __copy_v1;
              var acc = __copy_acc;
              tco: while (true) {
                  if (v1 instanceof Cons && v1.value1 instanceof Nil) {
                      return acc;
                  };
                  if (v1 instanceof Cons) {
                      var __tco_v1 = v1.value1;
                      var __tco_acc = new Cons(v1.value0, acc);
                      v1 = __tco_v1;
                      acc = __tco_acc;
                      continue tco;
                  };
                  return acc;
              };
          };
      };
      return Data_Maybe.Just.create(reverse(go(v)(Nil.value)));
  };                     
  var head = function (v) {
      if (v instanceof Nil) {
          return Data_Maybe.Nothing.value;
      };
      if (v instanceof Cons) {
          return new Data_Maybe.Just(v.value0);
      };
      throw new Error("Failed pattern match at Data.List line 239, column 1 - line 240, column 1: " + [ v.constructor.name ]);
  };
  var groupBy = function (v) {
      return function (v1) {
          if (v1 instanceof Nil) {
              return Nil.value;
          };
          if (v1 instanceof Cons) {
              var $261 = span(v(v1.value0))(v1.value1);
              return new Cons(new Cons(v1.value0, $261.init), groupBy(v)($261.rest));
          };
          throw new Error("Failed pattern match at Data.List line 567, column 1 - line 568, column 1: " + [ v.constructor.name, v1.constructor.name ]);
      };
  };
  var functorList = new Prelude.Functor(function (f) {
      return function (lst) {
          var go = function (__copy_v) {
              return function (__copy_acc) {
                  var v = __copy_v;
                  var acc = __copy_acc;
                  tco: while (true) {
                      if (v instanceof Nil) {
                          return acc;
                      };
                      if (v instanceof Cons) {
                          var __tco_v = v.value1;
                          var __tco_acc = new Cons(f(v.value0), acc);
                          v = __tco_v;
                          acc = __tco_acc;
                          continue tco;
                      };
                      throw new Error("Failed pattern match at Data.List line 758, column 3 - line 764, column 1: " + [ v.constructor.name, acc.constructor.name ]);
                  };
              };
          };
          return reverse(go(lst)(Nil.value));
      };
  });
  var fromList = function (dictUnfoldable) {
      return toUnfoldable(dictUnfoldable);
  };
  var fromFoldable = function (dictFoldable) {
      return Data_Foldable.foldr(dictFoldable)(Cons.create)(Nil.value);
  };
  var toList = function (dictFoldable) {
      return fromFoldable(dictFoldable);
  };
  var foldableList = new Data_Foldable.Foldable(function (dictMonoid) {
      return function (f) {
          return Data_Foldable.foldl(foldableList)(function (acc) {
              return function ($374) {
                  return Prelude.append(dictMonoid["__superclass_Prelude.Semigroup_0"]())(acc)(f($374));
              };
          })(Data_Monoid.mempty(dictMonoid));
      };
  }, (function () {
      var go = function (__copy_v) {
          return function (__copy_b) {
              return function (__copy_v1) {
                  var v = __copy_v;
                  var b = __copy_b;
                  var v1 = __copy_v1;
                  tco: while (true) {
                      if (v1 instanceof Nil) {
                          return b;
                      };
                      if (v1 instanceof Cons) {
                          var __tco_v = v;
                          var __tco_b = v(b)(v1.value0);
                          var __tco_v1 = v1.value1;
                          v = __tco_v;
                          b = __tco_b;
                          v1 = __tco_v1;
                          continue tco;
                      };
                      throw new Error("Failed pattern match at Data.List line 767, column 3 - line 771, column 3: " + [ v.constructor.name, b.constructor.name, v1.constructor.name ]);
                  };
              };
          };
      };
      return go;
  })(), function (v) {
      return function (b) {
          return function (v1) {
              if (v1 instanceof Nil) {
                  return b;
              };
              if (v1 instanceof Cons) {
                  return v(v1.value0)(Data_Foldable.foldr(foldableList)(v)(b)(v1.value1));
              };
              throw new Error("Failed pattern match at Data.List line 765, column 3 - line 766, column 3: " + [ v.constructor.name, b.constructor.name, v1.constructor.name ]);
          };
      };
  });
  var length = Data_Foldable.foldl(foldableList)(function (acc) {
      return function (v) {
          return acc + 1 | 0;
      };
  })(0);
  var traversableList = new Data_Traversable.Traversable(function () {
      return foldableList;
  }, function () {
      return functorList;
  }, function (dictApplicative) {
      return function (v) {
          if (v instanceof Nil) {
              return Prelude.pure(dictApplicative)(Nil.value);
          };
          if (v instanceof Cons) {
              return Prelude["<*>"](dictApplicative["__superclass_Prelude.Apply_0"]())(Prelude["<$>"]((dictApplicative["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]())(Cons.create)(v.value0))(Data_Traversable.sequence(traversableList)(dictApplicative)(v.value1));
          };
          throw new Error("Failed pattern match at Data.List line 784, column 3 - line 785, column 3: " + [ v.constructor.name ]);
      };
  }, function (dictApplicative) {
      return function (v) {
          return function (v1) {
              if (v1 instanceof Nil) {
                  return Prelude.pure(dictApplicative)(Nil.value);
              };
              if (v1 instanceof Cons) {
                  return Prelude["<*>"](dictApplicative["__superclass_Prelude.Apply_0"]())(Prelude["<$>"]((dictApplicative["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]())(Cons.create)(v(v1.value0)))(Data_Traversable.traverse(traversableList)(dictApplicative)(v)(v1.value1));
              };
              throw new Error("Failed pattern match at Data.List line 782, column 3 - line 783, column 3: " + [ v.constructor.name, v1.constructor.name ]);
          };
      };
  });                                            
  var foldM = function (dictMonad) {
      return function (v) {
          return function (a) {
              return function (v1) {
                  if (v1 instanceof Nil) {
                      return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())(a);
                  };
                  if (v1 instanceof Cons) {
                      return Prelude[">>="](dictMonad["__superclass_Prelude.Bind_1"]())(v(a)(v1.value0))(function (a$prime) {
                          return foldM(dictMonad)(v)(a$prime)(v1.value1);
                      });
                  };
                  throw new Error("Failed pattern match at Data.List line 705, column 1 - line 706, column 1: " + [ v.constructor.name, a.constructor.name, v1.constructor.name ]);
              };
          };
      };
  };
  var findIndex = function (fn) {
      var go = function (__copy_v) {
          return function (__copy_v1) {
              var v = __copy_v;
              var v1 = __copy_v1;
              tco: while (true) {
                  if (v1 instanceof Cons) {
                      if (fn(v1.value0)) {
                          return new Data_Maybe.Just(v);
                      };
                      if (Prelude.otherwise) {
                          var __tco_v = v + 1 | 0;
                          var __tco_v1 = v1.value1;
                          v = __tco_v;
                          v1 = __tco_v1;
                          continue tco;
                      };
                  };
                  if (v1 instanceof Nil) {
                      return Data_Maybe.Nothing.value;
                  };
                  throw new Error("Failed pattern match at Data.List line 307, column 3 - line 309, column 3: " + [ v.constructor.name, v1.constructor.name ]);
              };
          };
      };
      return go(0);
  };
  var filter = function (p) {
      var go = function (__copy_acc) {
          return function (__copy_v) {
              var acc = __copy_acc;
              var v = __copy_v;
              tco: while (true) {
                  if (v instanceof Nil) {
                      return reverse(acc);
                  };
                  if (v instanceof Cons) {
                      if (p(v.value0)) {
                          var __tco_acc = new Cons(v.value0, acc);
                          var __tco_v = v.value1;
                          acc = __tco_acc;
                          v = __tco_v;
                          continue tco;
                      };
                      if (Prelude.otherwise) {
                          var __tco_acc = acc;
                          var __tco_v = v.value1;
                          acc = __tco_acc;
                          v = __tco_v;
                          continue tco;
                      };
                  };
                  throw new Error("Failed pattern match at Data.List line 394, column 1 - line 409, column 1: " + [ acc.constructor.name, v.constructor.name ]);
              };
          };
      };
      return go(Nil.value);
  };
  var eqList = function (dictEq) {
      return new Prelude.Eq(function (xs) {
          return function (ys) {
              var go = function (__copy_v) {
                  return function (__copy_v1) {
                      return function (__copy_v2) {
                          var v = __copy_v;
                          var v1 = __copy_v1;
                          var v2 = __copy_v2;
                          tco: while (true) {
                              if (!v2) {
                                  return false;
                              };
                              if (v instanceof Nil && v1 instanceof Nil) {
                                  return v2;
                              };
                              if (v instanceof Cons && v1 instanceof Cons) {
                                  var __tco_v = v.value1;
                                  var __tco_v1 = v1.value1;
                                  var __tco_v2 = v2 && Prelude["=="](dictEq)(v1.value0)(v.value0);
                                  v = __tco_v;
                                  v1 = __tco_v1;
                                  v2 = __tco_v2;
                                  continue tco;
                              };
                              return false;
                          };
                      };
                  };
              };
              return go(xs)(ys)(true);
          };
      });
  };
  var concatMap = function (v) {
      return function (v1) {
          if (v1 instanceof Nil) {
              return Nil.value;
          };
          if (v1 instanceof Cons) {
              return Prelude["<>"](semigroupList)(v(v1.value0))(concatMap(v)(v1.value1));
          };
          throw new Error("Failed pattern match at Data.List line 387, column 1 - line 388, column 1: " + [ v.constructor.name, v1.constructor.name ]);
      };
  };
  var catMaybes = mapMaybe(Prelude.id(Prelude.categoryFn));
  var applyList = new Prelude.Apply(function () {
      return functorList;
  }, function (v) {
      return function (v1) {
          if (v instanceof Nil) {
              return Nil.value;
          };
          if (v instanceof Cons) {
              return Prelude["<>"](semigroupList)(Prelude["<$>"](functorList)(v.value0)(v1))(Prelude["<*>"](applyList)(v.value1)(v1));
          };
          throw new Error("Failed pattern match at Data.List line 788, column 3 - line 789, column 3: " + [ v.constructor.name, v1.constructor.name ]);
      };
  });
  var bindList = new Prelude.Bind(function () {
      return applyList;
  }, Prelude.flip(concatMap));
  var concat = function (v) {
      return Prelude[">>="](bindList)(v)(Prelude.id(Prelude.categoryFn));
  };
  var applicativeList = new Prelude.Applicative(function () {
      return applyList;
  }, function (a) {
      return new Cons(a, Nil.value);
  });
  var monadList = new Prelude.Monad(function () {
      return applicativeList;
  }, function () {
      return bindList;
  });
  var alterAt = function (v) {
      return function (v1) {
          return function (v2) {
              if (v === 0 && v2 instanceof Cons) {
                  return Data_Maybe.Just.create((function () {
                      var $366 = v1(v2.value0);
                      if ($366 instanceof Data_Maybe.Nothing) {
                          return v2.value1;
                      };
                      if ($366 instanceof Data_Maybe.Just) {
                          return new Cons($366.value0, v2.value1);
                      };
                      throw new Error("Failed pattern match at Data.List line 356, column 27 - line 360, column 1: " + [ $366.constructor.name ]);
                  })());
              };
              if (v2 instanceof Cons) {
                  return Prelude["<$>"](Data_Maybe.functorMaybe)(Cons.create(v2.value0))(alterAt(v - 1)(v1)(v2.value1));
              };
              return Data_Maybe.Nothing.value;
          };
      };
  };
  var modifyAt = function (n) {
      return function (f) {
          return alterAt(n)(function ($375) {
              return Data_Maybe.Just.create(f($375));
          });
      };
  };
  var altList = new Control_Alt.Alt(function () {
      return functorList;
  }, Prelude.append(semigroupList));
  var plusList = new Control_Plus.Plus(function () {
      return altList;
  }, Nil.value);
  var alternativeList = new Control_Alternative.Alternative(function () {
      return plusList;
  }, function () {
      return applicativeList;
  });
  var monadPlusList = new Control_MonadPlus.MonadPlus(function () {
      return alternativeList;
  }, function () {
      return monadList;
  });
  exports["Nil"] = Nil;
  exports["Cons"] = Cons;
  exports["fromList"] = fromList;
  exports["toList"] = toList;
  exports["foldM"] = foldM;
  exports["groupBy"] = groupBy;
  exports["span"] = span;
  exports["sortBy"] = sortBy;
  exports["catMaybes"] = catMaybes;
  exports["mapMaybe"] = mapMaybe;
  exports["filter"] = filter;
  exports["concatMap"] = concatMap;
  exports["concat"] = concat;
  exports["reverse"] = reverse;
  exports["alterAt"] = alterAt;
  exports["modifyAt"] = modifyAt;
  exports["findIndex"] = findIndex;
  exports["uncons"] = uncons;
  exports["init"] = init;
  exports["tail"] = tail;
  exports["last"] = last;
  exports["head"] = head;
  exports[":"] = $colon;
  exports["length"] = length;
  exports["many"] = many;
  exports["some"] = some;
  exports["singleton"] = singleton;
  exports["fromFoldable"] = fromFoldable;
  exports["toUnfoldable"] = toUnfoldable;
  exports["showList"] = showList;
  exports["eqList"] = eqList;
  exports["semigroupList"] = semigroupList;
  exports["monoidList"] = monoidList;
  exports["functorList"] = functorList;
  exports["foldableList"] = foldableList;
  exports["traversableList"] = traversableList;
  exports["applyList"] = applyList;
  exports["applicativeList"] = applicativeList;
  exports["bindList"] = bindList;
  exports["monadList"] = monadList;
  exports["altList"] = altList;
  exports["plusList"] = plusList;
  exports["alternativeList"] = alternativeList;
  exports["monadPlusList"] = monadPlusList;
})(PS["Data.List"] = PS["Data.List"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.List.Unsafe

  exports.unsafeThrow = function (msg) {
    throw new Error(msg);
  };
})(PS["Data.List.Unsafe"] = PS["Data.List.Unsafe"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.List.Unsafe"];
  var Prelude = PS["Prelude"];
  var Data_List = PS["Data.List"];        
  var tail = function (v) {
      if (v instanceof Data_List.Cons) {
          return v.value1;
      };
      if (v instanceof Data_List.Nil) {
          return $foreign.unsafeThrow("Data.List.Unsafe.tail called on empty list");
      };
      throw new Error("Failed pattern match at Data.List.Unsafe line 27, column 1 - line 28, column 1: " + [ v.constructor.name ]);
  };
  var head = function (v) {
      if (v instanceof Data_List.Cons) {
          return v.value0;
      };
      if (v instanceof Data_List.Nil) {
          return $foreign.unsafeThrow("Data.List.Unsafe.head called on empty list");
      };
      throw new Error("Failed pattern match at Data.List.Unsafe line 20, column 1 - line 21, column 1: " + [ v.constructor.name ]);
  };
  exports["tail"] = tail;
  exports["head"] = head;
})(PS["Data.List.Unsafe"] = PS["Data.List.Unsafe"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_List_1 = PS["Data.List"];
  var Data_List_1 = PS["Data.List"];
  var Data_Char_Unicode = PS["Data.Char.Unicode"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_String = PS["Data.String"];
  var unlines = (function () {
      var f = function (acc) {
          return function (a) {
              return acc + (a + "\n");
          };
      };
      return Data_Foldable.foldl(Data_List_1.foldableList)(f)("");
  })();
  var toCharList = function (s) {
      var $4 = Data_String.uncons(s);
      if ($4 instanceof Data_Maybe.Nothing) {
          return Data_List_1.Nil.value;
      };
      if ($4 instanceof Data_Maybe.Just) {
          return new Data_List_1.Cons($4.value0.head, toCharList($4.value0.tail));
      };
      throw new Error("Failed pattern match at Data.List.WordsLines line 75, column 5 - line 82, column 1: " + [ $4.constructor.name ]);
  };
  var fromCharList = Data_Foldable.foldl(Data_List_1.foldableList)(function (accum) {
      return function (a) {
          return accum + Data_String.singleton(a);
      };
  })("");
  var $$break = function (p) {
      return Data_List_1.span(function ($21) {
          return !p($21);
      });
  };
  var lines = (function () {
      var stripNewLine = function (s) {
          var $8 = Data_List_1.uncons(s);
          if ($8 instanceof Data_Maybe.Nothing) {
              return Data_List_1.Nil.value;
          };
          if ($8 instanceof Data_Maybe.Just && $8.value0.head === "\n") {
              return $8.value0.tail;
          };
          if ($8 instanceof Data_Maybe.Just) {
              return new Data_List_1.Cons($8.value0.head, $8.value0.tail);
          };
          throw new Error("Failed pattern match at Data.List.WordsLines line 62, column 9 - line 68, column 1: " + [ $8.constructor.name ]);
      };
      var go = function (s) {
          var $15 = Data_List_1.uncons(s);
          if ($15 instanceof Data_Maybe.Nothing) {
              return Data_List_1.Nil.value;
          };
          if ($15 instanceof Data_Maybe.Just) {
              var withBreaks = $$break(function (v) {
                  return v === "\n";
              })(s);
              return new Data_List_1.Cons(withBreaks.init, go(stripNewLine(withBreaks.rest)));
          };
          throw new Error("Failed pattern match at Data.List.WordsLines line 54, column 9 - line 60, column 5: " + [ $15.constructor.name ]);
      };
      return function ($22) {
          return Prelude.map(Data_List_1.functorList)(fromCharList)(go(toCharList($22)));
      };
  })();
  exports["fromCharList"] = fromCharList;
  exports["toCharList"] = toCharList;
  exports["lines"] = lines;
  exports["unlines"] = unlines;
})(PS["Data.List.WordsLines"] = PS["Data.List.WordsLines"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_List = PS["Data.List"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Maybe_Unsafe = PS["Data.Maybe.Unsafe"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Traversable = PS["Data.Traversable"];
  var Data_Tuple = PS["Data.Tuple"];        
  var Leaf = (function () {
      function Leaf() {

      };
      Leaf.value = new Leaf();
      return Leaf;
  })();
  var Two = (function () {
      function Two(value0, value1, value2, value3) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
          this.value3 = value3;
      };
      Two.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return function (value3) {
                      return new Two(value0, value1, value2, value3);
                  };
              };
          };
      };
      return Two;
  })();
  var Three = (function () {
      function Three(value0, value1, value2, value3, value4, value5, value6) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
          this.value3 = value3;
          this.value4 = value4;
          this.value5 = value5;
          this.value6 = value6;
      };
      Three.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return function (value3) {
                      return function (value4) {
                          return function (value5) {
                              return function (value6) {
                                  return new Three(value0, value1, value2, value3, value4, value5, value6);
                              };
                          };
                      };
                  };
              };
          };
      };
      return Three;
  })();
  var TwoLeft = (function () {
      function TwoLeft(value0, value1, value2) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
      };
      TwoLeft.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return new TwoLeft(value0, value1, value2);
              };
          };
      };
      return TwoLeft;
  })();
  var TwoRight = (function () {
      function TwoRight(value0, value1, value2) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
      };
      TwoRight.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return new TwoRight(value0, value1, value2);
              };
          };
      };
      return TwoRight;
  })();
  var ThreeLeft = (function () {
      function ThreeLeft(value0, value1, value2, value3, value4, value5) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
          this.value3 = value3;
          this.value4 = value4;
          this.value5 = value5;
      };
      ThreeLeft.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return function (value3) {
                      return function (value4) {
                          return function (value5) {
                              return new ThreeLeft(value0, value1, value2, value3, value4, value5);
                          };
                      };
                  };
              };
          };
      };
      return ThreeLeft;
  })();
  var ThreeMiddle = (function () {
      function ThreeMiddle(value0, value1, value2, value3, value4, value5) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
          this.value3 = value3;
          this.value4 = value4;
          this.value5 = value5;
      };
      ThreeMiddle.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return function (value3) {
                      return function (value4) {
                          return function (value5) {
                              return new ThreeMiddle(value0, value1, value2, value3, value4, value5);
                          };
                      };
                  };
              };
          };
      };
      return ThreeMiddle;
  })();
  var ThreeRight = (function () {
      function ThreeRight(value0, value1, value2, value3, value4, value5) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
          this.value3 = value3;
          this.value4 = value4;
          this.value5 = value5;
      };
      ThreeRight.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return function (value3) {
                      return function (value4) {
                          return function (value5) {
                              return new ThreeRight(value0, value1, value2, value3, value4, value5);
                          };
                      };
                  };
              };
          };
      };
      return ThreeRight;
  })();
  var KickUp = (function () {
      function KickUp(value0, value1, value2, value3) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
          this.value3 = value3;
      };
      KickUp.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return function (value3) {
                      return new KickUp(value0, value1, value2, value3);
                  };
              };
          };
      };
      return KickUp;
  })();
  var values = function (v) {
      if (v instanceof Leaf) {
          return Data_List.Nil.value;
      };
      if (v instanceof Two) {
          return Prelude["++"](Data_List.semigroupList)(values(v.value0))(Prelude["++"](Data_List.semigroupList)(Prelude.pure(Data_List.applicativeList)(v.value2))(values(v.value3)));
      };
      if (v instanceof Three) {
          return Prelude["++"](Data_List.semigroupList)(values(v.value0))(Prelude["++"](Data_List.semigroupList)(Prelude.pure(Data_List.applicativeList)(v.value2))(Prelude["++"](Data_List.semigroupList)(values(v.value3))(Prelude["++"](Data_List.semigroupList)(Prelude.pure(Data_List.applicativeList)(v.value5))(values(v.value6)))));
      };
      throw new Error("Failed pattern match at Data.Map line 311, column 1 - line 312, column 1: " + [ v.constructor.name ]);
  };
  var toList = function (v) {
      if (v instanceof Leaf) {
          return Data_List.Nil.value;
      };
      if (v instanceof Two) {
          return Prelude["++"](Data_List.semigroupList)(toList(v.value0))(Prelude["++"](Data_List.semigroupList)(Prelude.pure(Data_List.applicativeList)(new Data_Tuple.Tuple(v.value1, v.value2)))(toList(v.value3)));
      };
      if (v instanceof Three) {
          return Prelude["++"](Data_List.semigroupList)(toList(v.value0))(Prelude["++"](Data_List.semigroupList)(Prelude.pure(Data_List.applicativeList)(new Data_Tuple.Tuple(v.value1, v.value2)))(Prelude["++"](Data_List.semigroupList)(toList(v.value3))(Prelude["++"](Data_List.semigroupList)(Prelude.pure(Data_List.applicativeList)(new Data_Tuple.Tuple(v.value4, v.value5)))(toList(v.value6)))));
      };
      throw new Error("Failed pattern match at Data.Map line 290, column 1 - line 291, column 1: " + [ v.constructor.name ]);
  };
  var singleton = function (k) {
      return function (v) {
          return new Two(Leaf.value, k, v, Leaf.value);
      };
  };
  var lookup = function (__copy_dictOrd) {
      return function (__copy_k) {
          return function (__copy_tree) {
              var dictOrd = __copy_dictOrd;
              var k = __copy_k;
              var tree = __copy_tree;
              tco: while (true) {
                  var comp = Prelude.compare(dictOrd);
                  if (tree instanceof Leaf) {
                      return Data_Maybe.Nothing.value;
                  };
                  if (tree instanceof Two) {
                      var $91 = comp(k)(tree.value1);
                      if ($91 instanceof Prelude.EQ) {
                          return new Data_Maybe.Just(tree.value2);
                      };
                      if ($91 instanceof Prelude.LT) {
                          var __tco_dictOrd = dictOrd;
                          var __tco_k = k;
                          var __tco_tree = tree.value0;
                          dictOrd = __tco_dictOrd;
                          k = __tco_k;
                          tree = __tco_tree;
                          continue tco;
                      };
                      var __tco_dictOrd = dictOrd;
                      var __tco_k = k;
                      var __tco_tree = tree.value3;
                      dictOrd = __tco_dictOrd;
                      k = __tco_k;
                      tree = __tco_tree;
                      continue tco;
                  };
                  if (tree instanceof Three) {
                      var $96 = comp(k)(tree.value1);
                      if ($96 instanceof Prelude.EQ) {
                          return new Data_Maybe.Just(tree.value2);
                      };
                      var $97 = comp(k)(tree.value4);
                      if ($97 instanceof Prelude.EQ) {
                          return new Data_Maybe.Just(tree.value5);
                      };
                      if ($96 instanceof Prelude.LT) {
                          var __tco_dictOrd = dictOrd;
                          var __tco_k = k;
                          var __tco_tree = tree.value0;
                          dictOrd = __tco_dictOrd;
                          k = __tco_k;
                          tree = __tco_tree;
                          continue tco;
                      };
                      if ($97 instanceof Prelude.GT) {
                          var __tco_dictOrd = dictOrd;
                          var __tco_k = k;
                          var __tco_tree = tree.value6;
                          dictOrd = __tco_dictOrd;
                          k = __tco_k;
                          tree = __tco_tree;
                          continue tco;
                      };
                      var __tco_dictOrd = dictOrd;
                      var __tco_k = k;
                      var __tco_tree = tree.value3;
                      dictOrd = __tco_dictOrd;
                      k = __tco_k;
                      tree = __tco_tree;
                      continue tco;
                  };
                  throw new Error("Failed pattern match at Data.Map line 121, column 6 - line 143, column 1: " + [ tree.constructor.name ]);
              };
          };
      };
  }; 
  var fromZipper = function (__copy_dictOrd) {
      return function (__copy_v) {
          return function (__copy_tree) {
              var dictOrd = __copy_dictOrd;
              var v = __copy_v;
              var tree = __copy_tree;
              tco: while (true) {
                  if (v instanceof Data_List.Nil) {
                      return tree;
                  };
                  if (v instanceof Data_List.Cons) {
                      if (v.value0 instanceof TwoLeft) {
                          var __tco_dictOrd = dictOrd;
                          var __tco_v = v.value1;
                          var __tco_tree = new Two(tree, v.value0.value0, v.value0.value1, v.value0.value2);
                          dictOrd = __tco_dictOrd;
                          v = __tco_v;
                          tree = __tco_tree;
                          continue tco;
                      };
                      if (v.value0 instanceof TwoRight) {
                          var __tco_dictOrd = dictOrd;
                          var __tco_v = v.value1;
                          var __tco_tree = new Two(v.value0.value0, v.value0.value1, v.value0.value2, tree);
                          dictOrd = __tco_dictOrd;
                          v = __tco_v;
                          tree = __tco_tree;
                          continue tco;
                      };
                      if (v.value0 instanceof ThreeLeft) {
                          var __tco_dictOrd = dictOrd;
                          var __tco_v = v.value1;
                          var __tco_tree = new Three(tree, v.value0.value0, v.value0.value1, v.value0.value2, v.value0.value3, v.value0.value4, v.value0.value5);
                          dictOrd = __tco_dictOrd;
                          v = __tco_v;
                          tree = __tco_tree;
                          continue tco;
                      };
                      if (v.value0 instanceof ThreeMiddle) {
                          var __tco_dictOrd = dictOrd;
                          var __tco_v = v.value1;
                          var __tco_tree = new Three(v.value0.value0, v.value0.value1, v.value0.value2, tree, v.value0.value3, v.value0.value4, v.value0.value5);
                          dictOrd = __tco_dictOrd;
                          v = __tco_v;
                          tree = __tco_tree;
                          continue tco;
                      };
                      if (v.value0 instanceof ThreeRight) {
                          var __tco_dictOrd = dictOrd;
                          var __tco_v = v.value1;
                          var __tco_tree = new Three(v.value0.value0, v.value0.value1, v.value0.value2, v.value0.value3, v.value0.value4, v.value0.value5, tree);
                          dictOrd = __tco_dictOrd;
                          v = __tco_v;
                          tree = __tco_tree;
                          continue tco;
                      };
                      throw new Error("Failed pattern match at Data.Map line 156, column 3 - line 163, column 1: " + [ v.value0.constructor.name ]);
                  };
                  throw new Error("Failed pattern match at Data.Map line 154, column 1 - line 155, column 1: " + [ v.constructor.name, tree.constructor.name ]);
              };
          };
      };
  };
  var insert = function (dictOrd) {
      var up = function (__copy_v) {
          return function (__copy_v1) {
              var v = __copy_v;
              var v1 = __copy_v1;
              tco: while (true) {
                  if (v instanceof Data_List.Nil) {
                      return new Two(v1.value0, v1.value1, v1.value2, v1.value3);
                  };
                  if (v instanceof Data_List.Cons) {
                      if (v.value0 instanceof TwoLeft) {
                          return fromZipper(dictOrd)(v.value1)(new Three(v1.value0, v1.value1, v1.value2, v1.value3, v.value0.value0, v.value0.value1, v.value0.value2));
                      };
                      if (v.value0 instanceof TwoRight) {
                          return fromZipper(dictOrd)(v.value1)(new Three(v.value0.value0, v.value0.value1, v.value0.value2, v1.value0, v1.value1, v1.value2, v1.value3));
                      };
                      if (v.value0 instanceof ThreeLeft) {
                          var __tco_v = v.value1;
                          var __tco_v1 = new KickUp(new Two(v1.value0, v1.value1, v1.value2, v1.value3), v.value0.value0, v.value0.value1, new Two(v.value0.value2, v.value0.value3, v.value0.value4, v.value0.value5));
                          v = __tco_v;
                          v1 = __tco_v1;
                          continue tco;
                      };
                      if (v.value0 instanceof ThreeMiddle) {
                          var __tco_v = v.value1;
                          var __tco_v1 = new KickUp(new Two(v.value0.value0, v.value0.value1, v.value0.value2, v1.value0), v1.value1, v1.value2, new Two(v1.value3, v.value0.value3, v.value0.value4, v.value0.value5));
                          v = __tco_v;
                          v1 = __tco_v1;
                          continue tco;
                      };
                      if (v.value0 instanceof ThreeRight) {
                          var __tco_v = v.value1;
                          var __tco_v1 = new KickUp(new Two(v.value0.value0, v.value0.value1, v.value0.value2, v.value0.value3), v.value0.value4, v.value0.value5, new Two(v1.value0, v1.value1, v1.value2, v1.value3));
                          v = __tco_v;
                          v1 = __tco_v1;
                          continue tco;
                      };
                      throw new Error("Failed pattern match at Data.Map line 197, column 5 - line 205, column 1: " + [ v.value0.constructor.name ]);
                  };
                  throw new Error("Failed pattern match at Data.Map line 195, column 3 - line 196, column 3: " + [ v.constructor.name, v1.constructor.name ]);
              };
          };
      };
      var comp = Prelude.compare(dictOrd);
      var down = function (__copy_ctx) {
          return function (__copy_k) {
              return function (__copy_v) {
                  return function (__copy_v1) {
                      var ctx = __copy_ctx;
                      var k = __copy_k;
                      var v = __copy_v;
                      var v1 = __copy_v1;
                      tco: while (true) {
                          if (v1 instanceof Leaf) {
                              return up(ctx)(new KickUp(Leaf.value, k, v, Leaf.value));
                          };
                          if (v1 instanceof Two) {
                              var $203 = comp(k)(v1.value1);
                              if ($203 instanceof Prelude.EQ) {
                                  return fromZipper(dictOrd)(ctx)(new Two(v1.value0, k, v, v1.value3));
                              };
                              if ($203 instanceof Prelude.LT) {
                                  var __tco_ctx = new Data_List.Cons(new TwoLeft(v1.value1, v1.value2, v1.value3), ctx);
                                  var __tco_k = k;
                                  var __tco_v = v;
                                  var __tco_v1 = v1.value0;
                                  ctx = __tco_ctx;
                                  k = __tco_k;
                                  v = __tco_v;
                                  v1 = __tco_v1;
                                  continue tco;
                              };
                              var __tco_ctx = new Data_List.Cons(new TwoRight(v1.value0, v1.value1, v1.value2), ctx);
                              var __tco_k = k;
                              var __tco_v = v;
                              var __tco_v1 = v1.value3;
                              ctx = __tco_ctx;
                              k = __tco_k;
                              v = __tco_v;
                              v1 = __tco_v1;
                              continue tco;
                          };
                          if (v1 instanceof Three) {
                              var $208 = comp(k)(v1.value1);
                              if ($208 instanceof Prelude.EQ) {
                                  return fromZipper(dictOrd)(ctx)(new Three(v1.value0, k, v, v1.value3, v1.value4, v1.value5, v1.value6));
                              };
                              var $209 = comp(k)(v1.value4);
                              if ($209 instanceof Prelude.EQ) {
                                  return fromZipper(dictOrd)(ctx)(new Three(v1.value0, v1.value1, v1.value2, v1.value3, k, v, v1.value6));
                              };
                              if ($208 instanceof Prelude.LT) {
                                  var __tco_ctx = new Data_List.Cons(new ThreeLeft(v1.value1, v1.value2, v1.value3, v1.value4, v1.value5, v1.value6), ctx);
                                  var __tco_k = k;
                                  var __tco_v = v;
                                  var __tco_v1 = v1.value0;
                                  ctx = __tco_ctx;
                                  k = __tco_k;
                                  v = __tco_v;
                                  v1 = __tco_v1;
                                  continue tco;
                              };
                              if ($208 instanceof Prelude.GT) {
                                  if ($209 instanceof Prelude.LT) {
                                      var __tco_ctx = new Data_List.Cons(new ThreeMiddle(v1.value0, v1.value1, v1.value2, v1.value4, v1.value5, v1.value6), ctx);
                                      var __tco_k = k;
                                      var __tco_v = v;
                                      var __tco_v1 = v1.value3;
                                      ctx = __tco_ctx;
                                      k = __tco_k;
                                      v = __tco_v;
                                      v1 = __tco_v1;
                                      continue tco;
                                  };
                                  var __tco_ctx = new Data_List.Cons(new ThreeRight(v1.value0, v1.value1, v1.value2, v1.value3, v1.value4, v1.value5), ctx);
                                  var __tco_k = k;
                                  var __tco_v = v;
                                  var __tco_v1 = v1.value6;
                                  ctx = __tco_ctx;
                                  k = __tco_k;
                                  v = __tco_v;
                                  v1 = __tco_v1;
                                  continue tco;
                              };
                              var __tco_ctx = new Data_List.Cons(new ThreeRight(v1.value0, v1.value1, v1.value2, v1.value3, v1.value4, v1.value5), ctx);
                              var __tco_k = k;
                              var __tco_v = v;
                              var __tco_v1 = v1.value6;
                              ctx = __tco_ctx;
                              k = __tco_k;
                              v = __tco_v;
                              v1 = __tco_v1;
                              continue tco;
                          };
                          throw new Error("Failed pattern match at Data.Map line 173, column 3 - line 174, column 3: " + [ ctx.constructor.name, k.constructor.name, v.constructor.name, v1.constructor.name ]);
                      };
                  };
              };
          };
      };
      return down(Data_List.Nil.value);
  };
  var empty = Leaf.value;
  var $$delete = function (dictOrd) {
      var up = function (__copy_v) {
          return function (__copy_v1) {
              var v = __copy_v;
              var v1 = __copy_v1;
              tco: while (true) {
                  if (v instanceof Data_List.Nil) {
                      return v1;
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof TwoLeft && (v.value0.value2 instanceof Leaf && v1 instanceof Leaf))) {
                      return fromZipper(dictOrd)(v.value1)(new Two(Leaf.value, v.value0.value0, v.value0.value1, Leaf.value));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof TwoRight && (v.value0.value0 instanceof Leaf && v1 instanceof Leaf))) {
                      return fromZipper(dictOrd)(v.value1)(new Two(Leaf.value, v.value0.value1, v.value0.value2, Leaf.value));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof TwoLeft && v.value0.value2 instanceof Two)) {
                      var __tco_v = v.value1;
                      var __tco_v1 = new Three(v1, v.value0.value0, v.value0.value1, v.value0.value2.value0, v.value0.value2.value1, v.value0.value2.value2, v.value0.value2.value3);
                      v = __tco_v;
                      v1 = __tco_v1;
                      continue tco;
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof TwoRight && v.value0.value0 instanceof Two)) {
                      var __tco_v = v.value1;
                      var __tco_v1 = new Three(v.value0.value0.value0, v.value0.value0.value1, v.value0.value0.value2, v.value0.value0.value3, v.value0.value1, v.value0.value2, v1);
                      v = __tco_v;
                      v1 = __tco_v1;
                      continue tco;
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof TwoLeft && v.value0.value2 instanceof Three)) {
                      return fromZipper(dictOrd)(v.value1)(new Two(new Two(v1, v.value0.value0, v.value0.value1, v.value0.value2.value0), v.value0.value2.value1, v.value0.value2.value2, new Two(v.value0.value2.value3, v.value0.value2.value4, v.value0.value2.value5, v.value0.value2.value6)));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof TwoRight && v.value0.value0 instanceof Three)) {
                      return fromZipper(dictOrd)(v.value1)(new Two(new Two(v.value0.value0.value0, v.value0.value0.value1, v.value0.value0.value2, v.value0.value0.value3), v.value0.value0.value4, v.value0.value0.value5, new Two(v.value0.value0.value6, v.value0.value1, v.value0.value2, v1)));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeLeft && (v.value0.value2 instanceof Leaf && (v.value0.value5 instanceof Leaf && v1 instanceof Leaf)))) {
                      return fromZipper(dictOrd)(v.value1)(new Three(Leaf.value, v.value0.value0, v.value0.value1, Leaf.value, v.value0.value3, v.value0.value4, Leaf.value));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeMiddle && (v.value0.value0 instanceof Leaf && (v.value0.value5 instanceof Leaf && v1 instanceof Leaf)))) {
                      return fromZipper(dictOrd)(v.value1)(new Three(Leaf.value, v.value0.value1, v.value0.value2, Leaf.value, v.value0.value3, v.value0.value4, Leaf.value));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeRight && (v.value0.value0 instanceof Leaf && (v.value0.value3 instanceof Leaf && v1 instanceof Leaf)))) {
                      return fromZipper(dictOrd)(v.value1)(new Three(Leaf.value, v.value0.value1, v.value0.value2, Leaf.value, v.value0.value4, v.value0.value5, Leaf.value));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeLeft && v.value0.value2 instanceof Two)) {
                      return fromZipper(dictOrd)(v.value1)(new Two(new Three(v1, v.value0.value0, v.value0.value1, v.value0.value2.value0, v.value0.value2.value1, v.value0.value2.value2, v.value0.value2.value3), v.value0.value3, v.value0.value4, v.value0.value5));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeMiddle && v.value0.value0 instanceof Two)) {
                      return fromZipper(dictOrd)(v.value1)(new Two(new Three(v.value0.value0.value0, v.value0.value0.value1, v.value0.value0.value2, v.value0.value0.value3, v.value0.value1, v.value0.value2, v1), v.value0.value3, v.value0.value4, v.value0.value5));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeMiddle && v.value0.value5 instanceof Two)) {
                      return fromZipper(dictOrd)(v.value1)(new Two(v.value0.value0, v.value0.value1, v.value0.value2, new Three(v1, v.value0.value3, v.value0.value4, v.value0.value5.value0, v.value0.value5.value1, v.value0.value5.value2, v.value0.value5.value3)));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeRight && v.value0.value3 instanceof Two)) {
                      return fromZipper(dictOrd)(v.value1)(new Two(v.value0.value0, v.value0.value1, v.value0.value2, new Three(v.value0.value3.value0, v.value0.value3.value1, v.value0.value3.value2, v.value0.value3.value3, v.value0.value4, v.value0.value5, v1)));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeLeft && v.value0.value2 instanceof Three)) {
                      return fromZipper(dictOrd)(v.value1)(new Three(new Two(v1, v.value0.value0, v.value0.value1, v.value0.value2.value0), v.value0.value2.value1, v.value0.value2.value2, new Two(v.value0.value2.value3, v.value0.value2.value4, v.value0.value2.value5, v.value0.value2.value6), v.value0.value3, v.value0.value4, v.value0.value5));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeMiddle && v.value0.value0 instanceof Three)) {
                      return fromZipper(dictOrd)(v.value1)(new Three(new Two(v.value0.value0.value0, v.value0.value0.value1, v.value0.value0.value2, v.value0.value0.value3), v.value0.value0.value4, v.value0.value0.value5, new Two(v.value0.value0.value6, v.value0.value1, v.value0.value2, v1), v.value0.value3, v.value0.value4, v.value0.value5));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeMiddle && v.value0.value5 instanceof Three)) {
                      return fromZipper(dictOrd)(v.value1)(new Three(v.value0.value0, v.value0.value1, v.value0.value2, new Two(v1, v.value0.value3, v.value0.value4, v.value0.value5.value0), v.value0.value5.value1, v.value0.value5.value2, new Two(v.value0.value5.value3, v.value0.value5.value4, v.value0.value5.value5, v.value0.value5.value6)));
                  };
                  if (v instanceof Data_List.Cons && (v.value0 instanceof ThreeRight && v.value0.value3 instanceof Three)) {
                      return fromZipper(dictOrd)(v.value1)(new Three(v.value0.value0, v.value0.value1, v.value0.value2, new Two(v.value0.value3.value0, v.value0.value3.value1, v.value0.value3.value2, v.value0.value3.value3), v.value0.value3.value4, v.value0.value3.value5, new Two(v.value0.value3.value6, v.value0.value4, v.value0.value5, v1)));
                  };
                  return Data_Maybe_Unsafe.unsafeThrow("Impossible case in 'up'");
              };
          };
      };
      var removeMaxNode = function (__copy_v) {
          return function (__copy_v1) {
              var v = __copy_v;
              var v1 = __copy_v1;
              tco: while (true) {
                  if (v1 instanceof Two && (v1.value0 instanceof Leaf && v1.value3 instanceof Leaf)) {
                      return up(v)(Leaf.value);
                  };
                  if (v1 instanceof Two) {
                      var __tco_v = new Data_List.Cons(new TwoRight(v1.value0, v1.value1, v1.value2), v);
                      var __tco_v1 = v1.value3;
                      v = __tco_v;
                      v1 = __tco_v1;
                      continue tco;
                  };
                  if (v1 instanceof Three && (v1.value0 instanceof Leaf && (v1.value3 instanceof Leaf && v1.value6 instanceof Leaf))) {
                      return up(new Data_List.Cons(new TwoRight(Leaf.value, v1.value1, v1.value2), v))(Leaf.value);
                  };
                  if (v1 instanceof Three) {
                      var __tco_v = new Data_List.Cons(new ThreeRight(v1.value0, v1.value1, v1.value2, v1.value3, v1.value4, v1.value5), v);
                      var __tco_v1 = v1.value6;
                      v = __tco_v;
                      v1 = __tco_v1;
                      continue tco;
                  };
                  if (v1 instanceof Leaf) {
                      return Data_Maybe_Unsafe.unsafeThrow("Impossible case in 'removeMaxNode'");
                  };
                  throw new Error("Failed pattern match at Data.Map line 259, column 3 - line 260, column 3: " + [ v.constructor.name, v1.constructor.name ]);
              };
          };
      };
      var maxNode = function (__copy_v) {
          var v = __copy_v;
          tco: while (true) {
              if (v instanceof Two && v.value3 instanceof Leaf) {
                  return {
                      key: v.value1, 
                      value: v.value2
                  };
              };
              if (v instanceof Two) {
                  var __tco_v = v.value3;
                  v = __tco_v;
                  continue tco;
              };
              if (v instanceof Three && v.value6 instanceof Leaf) {
                  return {
                      key: v.value4, 
                      value: v.value5
                  };
              };
              if (v instanceof Three) {
                  var __tco_v = v.value6;
                  v = __tco_v;
                  continue tco;
              };
              if (v instanceof Leaf) {
                  return Data_Maybe_Unsafe.unsafeThrow("Impossible case in 'maxNode'");
              };
              throw new Error("Failed pattern match at Data.Map line 251, column 3 - line 252, column 3: " + [ v.constructor.name ]);
          };
      };
      var down = function (__copy_ctx) {
          return function (__copy_v) {
              return function (__copy_v1) {
                  var ctx = __copy_ctx;
                  var v = __copy_v;
                  var v1 = __copy_v1;
                  tco: while (true) {
                      if (v1 instanceof Leaf) {
                          return fromZipper(dictOrd)(ctx)(Leaf.value);
                      };
                      if (v1 instanceof Two && (v1.value0 instanceof Leaf && (v1.value3 instanceof Leaf && Prelude["=="](dictOrd["__superclass_Prelude.Eq_0"]())(v)(v1.value1)))) {
                          return up(ctx)(Leaf.value);
                      };
                      if (v1 instanceof Two) {
                          if (Prelude["=="](dictOrd["__superclass_Prelude.Eq_0"]())(v)(v1.value1)) {
                              var max = maxNode(v1.value0);
                              return removeMaxNode(new Data_List.Cons(new TwoLeft(max.key, max.value, v1.value3), ctx))(v1.value0);
                          };
                          if (Prelude["<"](dictOrd)(v)(v1.value1)) {
                              var __tco_ctx = new Data_List.Cons(new TwoLeft(v1.value1, v1.value2, v1.value3), ctx);
                              var __tco_v = v;
                              var __tco_v1 = v1.value0;
                              ctx = __tco_ctx;
                              v = __tco_v;
                              v1 = __tco_v1;
                              continue tco;
                          };
                          if (Prelude.otherwise) {
                              var __tco_ctx = new Data_List.Cons(new TwoRight(v1.value0, v1.value1, v1.value2), ctx);
                              var __tco_v = v;
                              var __tco_v1 = v1.value3;
                              ctx = __tco_ctx;
                              v = __tco_v;
                              v1 = __tco_v1;
                              continue tco;
                          };
                      };
                      if (v1 instanceof Three && (v1.value0 instanceof Leaf && (v1.value3 instanceof Leaf && v1.value6 instanceof Leaf))) {
                          if (Prelude["=="](dictOrd["__superclass_Prelude.Eq_0"]())(v)(v1.value1)) {
                              return fromZipper(dictOrd)(ctx)(new Two(Leaf.value, v1.value4, v1.value5, Leaf.value));
                          };
                          if (Prelude["=="](dictOrd["__superclass_Prelude.Eq_0"]())(v)(v1.value4)) {
                              return fromZipper(dictOrd)(ctx)(new Two(Leaf.value, v1.value1, v1.value2, Leaf.value));
                          };
                      };
                      if (v1 instanceof Three) {
                          if (Prelude["=="](dictOrd["__superclass_Prelude.Eq_0"]())(v)(v1.value1)) {
                              var max = maxNode(v1.value0);
                              return removeMaxNode(new Data_List.Cons(new ThreeLeft(max.key, max.value, v1.value3, v1.value4, v1.value5, v1.value6), ctx))(v1.value0);
                          };
                          if (Prelude["=="](dictOrd["__superclass_Prelude.Eq_0"]())(v)(v1.value4)) {
                              var max = maxNode(v1.value3);
                              return removeMaxNode(new Data_List.Cons(new ThreeMiddle(v1.value0, v1.value1, v1.value2, max.key, max.value, v1.value6), ctx))(v1.value3);
                          };
                          if (Prelude["<"](dictOrd)(v)(v1.value1)) {
                              var __tco_ctx = new Data_List.Cons(new ThreeLeft(v1.value1, v1.value2, v1.value3, v1.value4, v1.value5, v1.value6), ctx);
                              var __tco_v = v;
                              var __tco_v1 = v1.value0;
                              ctx = __tco_ctx;
                              v = __tco_v;
                              v1 = __tco_v1;
                              continue tco;
                          };
                          if (Prelude["<"](dictOrd)(v1.value1)(v) && Prelude["<"](dictOrd)(v)(v1.value4)) {
                              var __tco_ctx = new Data_List.Cons(new ThreeMiddle(v1.value0, v1.value1, v1.value2, v1.value4, v1.value5, v1.value6), ctx);
                              var __tco_v = v;
                              var __tco_v1 = v1.value3;
                              ctx = __tco_ctx;
                              v = __tco_v;
                              v1 = __tco_v1;
                              continue tco;
                          };
                          if (Prelude.otherwise) {
                              var __tco_ctx = new Data_List.Cons(new ThreeRight(v1.value0, v1.value1, v1.value2, v1.value3, v1.value4, v1.value5), ctx);
                              var __tco_v = v;
                              var __tco_v1 = v1.value6;
                              ctx = __tco_ctx;
                              v = __tco_v;
                              v1 = __tco_v1;
                              continue tco;
                          };
                      };
                      throw new Error("Failed pattern match at Data.Map line 209, column 3 - line 210, column 3: " + [ ctx.constructor.name, v.constructor.name, v1.constructor.name ]);
                  };
              };
          };
      };
      return down(Data_List.Nil.value);
  };
  var alter = function (dictOrd) {
      return function (f) {
          return function (k) {
              return function (m) {
                  var $492 = f(lookup(dictOrd)(k)(m));
                  if ($492 instanceof Data_Maybe.Nothing) {
                      return $$delete(dictOrd)(k)(m);
                  };
                  if ($492 instanceof Data_Maybe.Just) {
                      return insert(dictOrd)(k)($492.value0)(m);
                  };
                  throw new Error("Failed pattern match at Data.Map line 268, column 15 - line 273, column 1: " + [ $492.constructor.name ]);
              };
          };
      };
  };
  var fromFoldableWith = function (dictOrd) {
      return function (dictFoldable) {
          return function (f) {
              var combine = function (v) {
                  return function (v1) {
                      if (v1 instanceof Data_Maybe.Just) {
                          return Data_Maybe.Just.create(f(v)(v1.value0));
                      };
                      if (v1 instanceof Data_Maybe.Nothing) {
                          return new Data_Maybe.Just(v);
                      };
                      throw new Error("Failed pattern match at Data.Map line 285, column 3 - line 286, column 3: " + [ v.constructor.name, v1.constructor.name ]);
                  };
              };
              return Data_Foldable.foldl(dictFoldable)(function (m) {
                  return function (v) {
                      return alter(dictOrd)(combine(v.value1))(v.value0)(m);
                  };
              })(empty);
          };
      };
  };
  var unionWith = function (dictOrd) {
      return function (f) {
          return function (m1) {
              return function (m2) {
                  var go = function (m) {
                      return function (v) {
                          return alter(dictOrd)(function ($505) {
                              return Data_Maybe.Just.create(Data_Maybe.maybe(v.value1)(f(v.value1))($505));
                          })(v.value0)(m);
                      };
                  };
                  return Data_Foldable.foldl(Data_List.foldableList)(go)(m2)(toList(m1));
              };
          };
      };
  };
  exports["unionWith"] = unionWith;
  exports["values"] = values;
  exports["alter"] = alter;
  exports["toList"] = toList;
  exports["fromFoldableWith"] = fromFoldableWith;
  exports["lookup"] = lookup;
  exports["insert"] = insert;
  exports["singleton"] = singleton;
  exports["empty"] = empty;
})(PS["Data.Map"] = PS["Data.Map"] || {});
(function(exports) {
  /* global exports */
  "use strict";      

  exports.runST = function (f) {
    return f;
  };

  // jshint maxparams: 2
  exports._fmapStrMap = function (m0, f) {
    var m = {};
    for (var k in m0) {
      if (m0.hasOwnProperty(k)) {
        m[k] = f(m0[k]);
      }
    }
    return m;
  };

  // jshint maxparams: 4
  exports._lookup = function (no, yes, k, m) {
    return k in m ? yes(m[k]) : no;
  };

  function _collect (f) {
    return function (m) {
      var r = [];
      for (var k in m) {
        if (m.hasOwnProperty(k)) {
          r.push(f(k)(m[k]));
        }
      }
      return r;
    };
  }
})(PS["Data.StrMap"] = PS["Data.StrMap"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Data.StrMap.ST

  exports["new"] = function () {
    return {};
  };

  exports.poke = function (m) {
    return function (k) {
      return function (v) {
        return function () {
          m[k] = v;
          return m;
        };
      };
    };
  };
})(PS["Data.StrMap.ST"] = PS["Data.StrMap.ST"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.StrMap.ST"];
  var Prelude = PS["Prelude"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  var Control_Monad_ST = PS["Control.Monad.ST"];
  var Data_Maybe = PS["Data.Maybe"];
  exports["poke"] = $foreign.poke;
  exports["new"] = $foreign["new"];
})(PS["Data.StrMap.ST"] = PS["Data.StrMap.ST"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.StrMap"];
  var Prelude = PS["Prelude"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Function = PS["Data.Function"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Traversable = PS["Data.Traversable"];
  var Data_Tuple = PS["Data.Tuple"];
  var Data_List = PS["Data.List"];
  var Control_Monad_ST = PS["Control.Monad.ST"];
  var Data_StrMap_ST = PS["Data.StrMap.ST"];
  var pureST = function (f) {
      return Control_Monad_Eff.runPure($foreign.runST(f));
  };
  var member = Data_Function.runFn4($foreign._lookup)(false)(Prelude["const"](true));
  var lookup = Data_Function.runFn4($foreign._lookup)(Data_Maybe.Nothing.value)(Data_Maybe.Just.create);
  var functorStrMap = new Prelude.Functor(function (f) {
      return function (m) {
          return $foreign._fmapStrMap(m, f);
      };
  });                                                         
  var fromFoldable = function (dictFoldable) {
      return function (l) {
          return pureST(function __do() {
              var v = Data_StrMap_ST["new"]();
              Data_Foldable.for_(Control_Monad_Eff.applicativeEff)(dictFoldable)(l)(function (v1) {
                  return Data_StrMap_ST.poke(v)(v1.value0)(v1.value1);
              })();
              return v;
          });
      };
  };
  exports["member"] = member;
  exports["fromFoldable"] = fromFoldable;
  exports["lookup"] = lookup;
  exports["functorStrMap"] = functorStrMap;
})(PS["Data.StrMap"] = PS["Data.StrMap"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_String = PS["Data.String"];
  var Data_Function = PS["Data.Function"];
  var upperCaseEq = Data_Function.on(Prelude.eq(Prelude.eqString))(Data_String.toUpper);
  var startsWith = function (needle) {
      return function (haystack) {
          return Data_Maybe.maybe(false)(Prelude.id(Prelude.categoryFn))(Prelude.bind(Data_Maybe.bindMaybe)(Data_String.indexOf(needle)(haystack))(function (v) {
              return Prelude["return"](Data_Maybe.applicativeMaybe)(v === 0);
          }));
      };
  };
  var endsWith = function (needle) {
      return function (haystack) {
          return Data_Maybe.maybe(false)(Prelude.id(Prelude.categoryFn))(Prelude.bind(Data_Maybe.bindMaybe)(Data_String.lastIndexOf(needle)(haystack))(function (v) {
              return Prelude["return"](Data_Maybe.applicativeMaybe)(v === Data_String.length(haystack) - Data_String.length(needle));
          }));
      };
  };
  exports["startsWith"] = startsWith;
  exports["endsWith"] = endsWith;
  exports["upperCaseEq"] = upperCaseEq;
})(PS["Data.String.Ext"] = PS["Data.String.Ext"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  exports["regex'"] = function (s1) {
    return function (s2) {
      return new RegExp(s1, s2);
    };
  };

  exports.test = function (r) {
    return function (s) {
      return r.test(s);
    };
  };

  exports._match = function (just) {
    return function (nothing) {
      return function (r) {
        return function (s) {
          var m = s.match(r);
          if (m == null) {
            return nothing;
          } else {
            var list = [];
            for (var i = 0; i < m.length; i++) {
              list.push(m[i] == null ? nothing : just(m[i]));
            }
            return just(list);
          }
        };
      };
    };
  };

  exports.replace = function (r) {
    return function (s1) {
      return function (s2) {
        return s2.replace(r, s1);
      };
    };
  };

  exports["replace'"] = function (r) {
    return function (f) {
      return function (s2) {
        return s2.replace(r, function (match) {
          return f(match)(Array.prototype.splice.call(arguments, 1, arguments.length - 3));
        });
      };
    };
  };
})(PS["Data.String.Regex"] = PS["Data.String.Regex"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Data.String.Regex"];
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_String = PS["Data.String"];                                            
  var renderFlags = function (f) {
      return (function () {
          if (f.global) {
              return "g";
          };
          if (!f.global) {
              return "";
          };
          throw new Error("Failed pattern match at Data.String.Regex line 65, column 4 - line 65, column 32: " + [ f.global.constructor.name ]);
      })() + ((function () {
          if (f.ignoreCase) {
              return "i";
          };
          if (!f.ignoreCase) {
              return "";
          };
          throw new Error("Failed pattern match at Data.String.Regex line 66, column 4 - line 66, column 36: " + [ f.ignoreCase.constructor.name ]);
      })() + ((function () {
          if (f.multiline) {
              return "m";
          };
          if (!f.multiline) {
              return "";
          };
          throw new Error("Failed pattern match at Data.String.Regex line 67, column 4 - line 67, column 35: " + [ f.multiline.constructor.name ]);
      })() + ((function () {
          if (f.sticky) {
              return "y";
          };
          if (!f.sticky) {
              return "";
          };
          throw new Error("Failed pattern match at Data.String.Regex line 68, column 4 - line 68, column 32: " + [ f.sticky.constructor.name ]);
      })() + (function () {
          if (f.unicode) {
              return "u";
          };
          if (!f.unicode) {
              return "";
          };
          throw new Error("Failed pattern match at Data.String.Regex line 69, column 4 - line 69, column 33: " + [ f.unicode.constructor.name ]);
      })())));
  };
  var regex = function (s) {
      return function (f) {
          return $foreign["regex'"](s)(renderFlags(f));
      };
  };
  var parseFlags = function (s) {
      return {
          global: Data_String.contains("g")(s), 
          ignoreCase: Data_String.contains("i")(s), 
          multiline: Data_String.contains("m")(s), 
          sticky: Data_String.contains("y")(s), 
          unicode: Data_String.contains("u")(s)
      };
  };
  var noFlags = {
      global: false, 
      ignoreCase: false, 
      multiline: false, 
      sticky: false, 
      unicode: false
  };
  var match = $foreign._match(Data_Maybe.Just.create)(Data_Maybe.Nothing.value);
  exports["noFlags"] = noFlags;
  exports["match"] = match;
  exports["parseFlags"] = parseFlags;
  exports["renderFlags"] = renderFlags;
  exports["regex"] = regex;
  exports["replace'"] = $foreign["replace'"];
  exports["test"] = $foreign.test;
})(PS["Data.String.Regex"] = PS["Data.String.Regex"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Tuple = PS["Data.Tuple"];
  var tuple3 = function (a) {
      return function (b) {
          return function (c) {
              return new Data_Tuple.Tuple(new Data_Tuple.Tuple(a, b), c);
          };
      };
  };
  exports["tuple3"] = tuple3;
})(PS["Data.Tuple.Nested"] = PS["Data.Tuple.Nested"] || {});
(function(exports) {
  /* global exports, console */
  "use strict";

  // module Debug.Trace

  exports.traceAny = function (x) {
    return function (k) {
      console.log(x);
      return k({});
    };
  };
})(PS["Debug.Trace"] = PS["Debug.Trace"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Debug.Trace"];
  var Prelude = PS["Prelude"];
  var traceAnyA = function (dictApplicative) {
      return function (s) {
          return $foreign.traceAny(s)(function (v) {
              return Prelude.pure(dictApplicative)(Prelude.unit);
          });
      };
  };
  var traceA = function (dictApplicative) {
      return traceAnyA(dictApplicative);
  };
  exports["traceA"] = traceA;
  exports["traceAnyA"] = traceAnyA;
})(PS["Debug.Trace"] = PS["Debug.Trace"] || {});
(function(exports) {
    "use strict";
  // module Node.Process

  /* global exports */
  /* global process */

  exports.process = process;

  exports.exit = function(code) {
      return function() {
          process.exit(code);
      };
  };
})(PS["Node.Process"] = PS["Node.Process"] || {});
(function(exports) {
    "use strict";

  // module Unsafe.Coerce

  exports.unsafeCoerce = function(x) { return x; }
})(PS["Unsafe.Coerce"] = PS["Unsafe.Coerce"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Unsafe.Coerce"];
  exports["unsafeCoerce"] = $foreign.unsafeCoerce;
})(PS["Unsafe.Coerce"] = PS["Unsafe.Coerce"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Node.Process"];
  var Prelude = PS["Prelude"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  var Control_Monad_Eff_Console = PS["Control.Monad.Eff.Console"];
  var Control_Monad_Eff_Exception = PS["Control.Monad.Eff.Exception"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Maybe_Unsafe = PS["Data.Maybe.Unsafe"];
  var Data_StrMap_1 = PS["Data.StrMap"];
  var Data_StrMap_1 = PS["Data.StrMap"];
  var Data_Posix = PS["Data.Posix"];
  var Data_Posix_Signal_1 = PS["Data.Posix.Signal"];
  var Data_Posix_Signal_1 = PS["Data.Posix.Signal"];
  var Node_Stream = PS["Node.Stream"];
  var Unsafe_Coerce = PS["Unsafe.Coerce"];
  var Node_Platform_1 = PS["Node.Platform"];
  var Node_Platform_1 = PS["Node.Platform"];
  var mkEff = Unsafe_Coerce.unsafeCoerce;
  var getEnv = mkEff(function (v) {
      return $foreign.process.env;
  });                            
  var argv = mkEff(function (v) {
      return $foreign.process.argv;
  });
  exports["getEnv"] = getEnv;
  exports["argv"] = argv;
  exports["exit"] = $foreign.exit;
})(PS["Node.Process"] = PS["Node.Process"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Array = PS["Data.Array"];
  var Data_String_1 = PS["Data.String"];
  var Data_String_1 = PS["Data.String"];
  var Data_Maybe = PS["Data.Maybe"];        
  var dedent = function (txt) {
      var nonEmpty = function ($3) {
          return (function (v) {
              return v !== 0;
          })(Data_String_1.length(Data_String_1.trim($3)));
      };
      var lines = Data_String_1.split("\n")(txt);
      var isWhitespace = function (v) {
          if (v === " ") {
              return true;
          };
          if (v === "\n") {
              return true;
          };
          if (v === "\t") {
              return true;
          };
          return false;
      };
      var countLeading = function (line) {
          return Data_Array.length(Data_Array.takeWhile(isWhitespace)(Data_String_1.toCharArray(line)));
      };
      var shortestLeading = Data_Maybe.maybe(0)(Prelude.id(Prelude.categoryFn))(Data_Array.head(Data_Array.sort(Prelude.ordInt)(Prelude["<$>"](Prelude.functorArray)(countLeading)(Data_Array.filter(nonEmpty)(lines)))));
      return Data_String_1.joinWith("\n")(Prelude["<$>"](Prelude.functorArray)(Data_String_1.drop(shortestLeading))(lines));
  };
  exports["dedent"] = dedent;
})(PS["Text.Wrap"] = PS["Text.Wrap"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_String = PS["Data.String"];
  var Data_Foldable = PS["Data.Foldable"];        
  var Position = (function () {
      function Position(value0) {
          this.value0 = value0;
      };
      Position.create = function (value0) {
          return new Position(value0);
      };
      return Position;
  })();
  var updatePosString = function (pos) {
      return function (str) {
          var updatePosChar = function (v) {
              return function (c) {
                  if (c === "\n") {
                      return new Position({
                          line: v.value0.line + 1 | 0, 
                          column: 1
                      });
                  };
                  if (c === "\r") {
                      return new Position({
                          line: v.value0.line + 1 | 0, 
                          column: 1
                      });
                  };
                  if (c === "\t") {
                      return new Position({
                          line: v.value0.line, 
                          column: (v.value0.column + 8 | 0) - (v.value0.column - 1) % 8
                      });
                  };
                  return new Position({
                      line: v.value0.line, 
                      column: v.value0.column + 1 | 0
                  });
              };
          };
          return Data_Foldable.foldl(Data_Foldable.foldableArray)(updatePosChar)(pos)(Data_String.split("")(str));
      };
  };
  var showPosition = new Prelude.Show(function (v) {
      return "Position { line: " + (Prelude.show(Prelude.showInt)(v.value0.line) + (", column: " + (Prelude.show(Prelude.showInt)(v.value0.column) + " }")));
  });
  var initialPos = new Position({
      line: 1, 
      column: 1
  });
  exports["Position"] = Position;
  exports["updatePosString"] = updatePosString;
  exports["initialPos"] = initialPos;
  exports["showPosition"] = showPosition;
})(PS["Text.Parsing.Parser.Pos"] = PS["Text.Parsing.Parser.Pos"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Either = PS["Data.Either"];
  var Data_Identity = PS["Data.Identity"];
  var Data_Tuple = PS["Data.Tuple"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Alternative = PS["Control.Alternative"];
  var Control_Lazy = PS["Control.Lazy"];
  var Control_Monad_State_Class = PS["Control.Monad.State.Class"];
  var Control_Monad_Trans = PS["Control.Monad.Trans"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_Plus = PS["Control.Plus"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];        
  var ParseError = (function () {
      function ParseError(value0) {
          this.value0 = value0;
      };
      ParseError.create = function (value0) {
          return new ParseError(value0);
      };
      return ParseError;
  })();
  var PState = (function () {
      function PState(value0) {
          this.value0 = value0;
      };
      PState.create = function (value0) {
          return new PState(value0);
      };
      return PState;
  })();
  var ParserT = function (x) {
      return x;
  };
  var unParserT = function (v) {
      return v;
  }; 
  var runParserT = function (dictMonad) {
      return function (s) {
          return function (p) {
              return Prelude.bind(dictMonad["__superclass_Prelude.Bind_1"]())(unParserT(p)(s))(function (v) {
                  return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())(v.result);
              });
          };
      };
  };
  var runParser = function (s) {
      return function ($54) {
          return Data_Identity.runIdentity(runParserT(Data_Identity.monadIdentity)(new PState({
              input: s, 
              position: Text_Parsing_Parser_Pos.initialPos
          }))($54));
      };
  };
  var parseFailed = function (s) {
      return function (pos) {
          return function (message) {
              return {
                  input: s, 
                  consumed: false, 
                  result: new Data_Either.Left(new ParseError({
                      message: message, 
                      position: pos
                  })), 
                  position: pos
              };
          };
      };
  };
  var monadTransParserT = new Control_Monad_Trans.MonadTrans(function (dictMonad) {
      return function (m) {
          return ParserT(function (v) {
              return Prelude["<$>"](((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]())(function (a) {
                  return {
                      input: v.value0.input, 
                      consumed: false, 
                      result: new Data_Either.Right(a), 
                      position: v.value0.position
                  };
              })(m);
          });
      };
  });
  var lazyParserT = new Control_Lazy.Lazy(function (f) {
      return ParserT(function (s) {
          return unParserT(f(Prelude.unit))(s);
      });
  });
  var functorParserT = function (dictFunctor) {
      return new Prelude.Functor(function (f) {
          return function (p) {
              var f$prime = function (o) {
                  return {
                      input: o.input, 
                      result: Prelude["<$>"](Data_Either.functorEither)(f)(o.result), 
                      consumed: o.consumed, 
                      position: o.position
                  };
              };
              return ParserT(function (s) {
                  return Prelude["<$>"](dictFunctor)(f$prime)(unParserT(p)(s));
              });
          };
      });
  };
  var fail = function (dictMonad) {
      return function (message) {
          return ParserT(function (v) {
              return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())(parseFailed(v.value0.input)(v.value0.position)(message));
          });
      };
  };
  var monadParserT = function (dictMonad) {
      return new Prelude.Monad(function () {
          return applicativeParserT(dictMonad);
      }, function () {
          return bindParserT(dictMonad);
      });
  };
  var bindParserT = function (dictMonad) {
      return new Prelude.Bind(function () {
          return applyParserT(dictMonad);
      }, function (p) {
          return function (f) {
              var updateConsumedFlag = function (c) {
                  return function (o) {
                      return {
                          input: o.input, 
                          consumed: c || o.consumed, 
                          result: o.result, 
                          position: o.position
                      };
                  };
              };
              return ParserT(function (s) {
                  return Prelude[">>="](dictMonad["__superclass_Prelude.Bind_1"]())(unParserT(p)(s))(function (o) {
                      if (o.result instanceof Data_Either.Left) {
                          return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())({
                              input: o.input, 
                              result: new Data_Either.Left(o.result.value0), 
                              consumed: o.consumed, 
                              position: o.position
                          });
                      };
                      if (o.result instanceof Data_Either.Right) {
                          return Prelude["<$>"](((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]())(updateConsumedFlag(o.consumed))(unParserT(f(o.result.value0))(new PState({
                              input: o.input, 
                              position: o.position
                          })));
                      };
                      throw new Error("Failed pattern match at Text.Parsing.Parser line 80, column 5 - line 83, column 5: " + [ o.result.constructor.name ]);
                  });
              });
          };
      });
  };
  var applyParserT = function (dictMonad) {
      return new Prelude.Apply(function () {
          return functorParserT(((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]());
      }, Prelude.ap(monadParserT(dictMonad)));
  };
  var applicativeParserT = function (dictMonad) {
      return new Prelude.Applicative(function () {
          return applyParserT(dictMonad);
      }, function (a) {
          return ParserT(function (v) {
              return Prelude.pure(dictMonad["__superclass_Prelude.Applicative_0"]())({
                  input: v.value0.input, 
                  result: new Data_Either.Right(a), 
                  consumed: false, 
                  position: v.value0.position
              });
          });
      });
  };
  var altParserT = function (dictMonad) {
      return new Control_Alt.Alt(function () {
          return functorParserT(((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]());
      }, function (p1) {
          return function (p2) {
              return ParserT(function (s) {
                  return Prelude[">>="](dictMonad["__superclass_Prelude.Bind_1"]())(unParserT(p1)(s))(function (o) {
                      if (o.result instanceof Data_Either.Left && !o.consumed) {
                          return unParserT(p2)(s);
                      };
                      return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())(o);
                  });
              });
          };
      });
  };
  var plusParserT = function (dictMonad) {
      return new Control_Plus.Plus(function () {
          return altParserT(dictMonad);
      }, fail(dictMonad)("No alternative"));
  };
  var alternativeParserT = function (dictMonad) {
      return new Control_Alternative.Alternative(function () {
          return plusParserT(dictMonad);
      }, function () {
          return applicativeParserT(dictMonad);
      });
  };
  var monadPlusParserT = function (dictMonad) {
      return new Control_MonadPlus.MonadPlus(function () {
          return alternativeParserT(dictMonad);
      }, function () {
          return monadParserT(dictMonad);
      });
  };
  exports["ParserT"] = ParserT;
  exports["PState"] = PState;
  exports["ParseError"] = ParseError;
  exports["parseFailed"] = parseFailed;
  exports["fail"] = fail;
  exports["runParser"] = runParser;
  exports["runParserT"] = runParserT;
  exports["unParserT"] = unParserT;
  exports["functorParserT"] = functorParserT;
  exports["applyParserT"] = applyParserT;
  exports["applicativeParserT"] = applicativeParserT;
  exports["altParserT"] = altParserT;
  exports["plusParserT"] = plusParserT;
  exports["alternativeParserT"] = alternativeParserT;
  exports["bindParserT"] = bindParserT;
  exports["monadParserT"] = monadParserT;
  exports["monadPlusParserT"] = monadPlusParserT;
  exports["monadTransParserT"] = monadTransParserT;
  exports["lazyParserT"] = lazyParserT;
})(PS["Text.Parsing.Parser"] = PS["Text.Parsing.Parser"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Either = PS["Data.Either"];
  var Data_List = PS["Data.List"];
  var Data_Foldable = PS["Data.Foldable"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Plus = PS["Control.Plus"];
  var Control_Apply = PS["Control.Apply"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];        
  var $less$qmark$greater = function (dictMonad) {
      return function (p) {
          return function (msg) {
              return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(dictMonad))(p)(Text_Parsing_Parser.fail(dictMonad)("Expected " + msg));
          };
      };
  };
  var $less$qmark$qmark$greater = function (dictMonad) {
      return Prelude.flip($less$qmark$greater(dictMonad));
  };
  var $$try = function (dictFunctor) {
      return function (p) {
          var try$prime = function (v) {
              return function (v1) {
                  return function (v2) {
                      if (v2.result instanceof Data_Either.Left) {
                          return {
                              input: v, 
                              result: v2.result, 
                              consumed: false, 
                              position: v1
                          };
                      };
                      return v2;
                  };
              };
          };
          return Text_Parsing_Parser.ParserT(function (v) {
              return Prelude["<$>"](dictFunctor)(try$prime(v.value0.input)(v.value0.position))(Text_Parsing_Parser.unParserT(p)(new Text_Parsing_Parser.PState({
                  input: v.value0.input, 
                  position: v.value0.position
              })));
          });
      };
  };
  var sepBy1 = function (dictMonad) {
      return function (p) {
          return function (sep) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(p)(function (v) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(Data_List.many(Text_Parsing_Parser.alternativeParserT(dictMonad))(Text_Parsing_Parser.lazyParserT)(Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(sep)(function () {
                      return p;
                  })))(function (v1) {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(Data_List[":"](v)(v1));
                  });
              });
          };
      };
  };
  var optional = function (dictMonad) {
      return function (p) {
          return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(dictMonad))(Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(p)(function () {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(Prelude.unit);
          }))(Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(Prelude.unit));
      };
  };
  var option = function (dictMonad) {
      return function (a) {
          return function (p) {
              return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(dictMonad))(p)(Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(a));
          };
      };
  };
  var optionMaybe = function (dictMonad) {
      return function (p) {
          return option(dictMonad)(Data_Maybe.Nothing.value)(Prelude["<$>"](Text_Parsing_Parser.functorParserT(((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]()))(Data_Maybe.Just.create)(p));
      };
  };
  var notFollowedBy = function (dictMonad) {
      return function (p) {
          return $$try(((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]())(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(dictMonad))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(dictMonad))($$try(((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]())(p))(Text_Parsing_Parser.fail(dictMonad)("Negated parser succeeded")))(Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(Prelude.unit)));
      };
  };
  var manyTill = function (dictMonad) {
      return function (p) {
          return function (end) {
              var scan = Control_Alt["<|>"](Text_Parsing_Parser.altParserT(dictMonad))(Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(end)(function () {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(Data_List.Nil.value);
              }))(Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(p)(function (v) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(scan)(function (v1) {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(Data_List[":"](v)(v1));
                  });
              }));
              return scan;
          };
      };
  };
  var lookAhead = function (dictMonad) {
      return function (v) {
          return function (v1) {
              return Prelude.bind(dictMonad["__superclass_Prelude.Bind_1"]())(v(new Text_Parsing_Parser.PState({
                  input: v1.value0.input, 
                  position: v1.value0.position
              })))(function (v2) {
                  return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())((function () {
                      var $75 = {};
                      for (var $76 in v2) {
                          if (v2.hasOwnProperty($76)) {
                              $75[$76] = v2[$76];
                          };
                      };
                      $75.input = v1.value0.input;
                      $75.consumed = false;
                      $75.position = v1.value0.position;
                      return $75;
                  })());
              });
          };
      };
  };
  var choice = function (dictFoldable) {
      return function (dictMonad) {
          return Data_Foldable.foldl(dictFoldable)(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(dictMonad)))(Control_Plus.empty(Text_Parsing_Parser.plusParserT(dictMonad)));
      };
  };
  var between = function (dictMonad) {
      return function (open) {
          return function (close) {
              return function (p) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(open)(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(p)(function (v) {
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(close)(function () {
                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(v);
                          });
                      });
                  });
              };
          };
      };
  };
  exports["manyTill"] = manyTill;
  exports["notFollowedBy"] = notFollowedBy;
  exports["lookAhead"] = lookAhead;
  exports["choice"] = choice;
  exports["sepBy1"] = sepBy1;
  exports["try"] = $$try;
  exports["optionMaybe"] = optionMaybe;
  exports["optional"] = optional;
  exports["option"] = option;
  exports["between"] = between;
  exports["<??>"] = $less$qmark$qmark$greater;
  exports["<?>"] = $less$qmark$greater;
})(PS["Text.Parsing.Parser.Combinators"] = PS["Text.Parsing.Parser.Combinators"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_String = PS["Data.String"];
  var Data_Either = PS["Data.Either"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Char = PS["Data.Char"];
  var Data_Array = PS["Data.Array"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Combinators = PS["Text.Parsing.Parser.Combinators"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];        
  var string = function (dictMonad) {
      return function (str) {
          return Text_Parsing_Parser.ParserT(function (v) {
              return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())((function () {
                  var $16 = Data_String.indexOf(str)(v.value0.input);
                  if ($16 instanceof Data_Maybe.Just && $16.value0 === 0) {
                      return {
                          consumed: true, 
                          input: Data_String.drop(Data_String.length(str))(v.value0.input), 
                          result: new Data_Either.Right(str), 
                          position: Text_Parsing_Parser_Pos.updatePosString(v.value0.position)(str)
                      };
                  };
                  return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("Expected " + str);
              })());
          });
      };
  };
  var eof = function (dictMonad) {
      return Text_Parsing_Parser.ParserT(function (v) {
          return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())((function () {
              if (v.value0.input === "") {
                  return {
                      consumed: false, 
                      input: v.value0.input, 
                      result: new Data_Either.Right(Prelude.unit), 
                      position: v.value0.position
                  };
              };
              return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("Expected EOF");
          })());
      });
  };
  var anyChar = function (dictMonad) {
      return Text_Parsing_Parser.ParserT(function (v) {
          return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())((function () {
              var $27 = Data_String.charAt(0)(v.value0.input);
              if ($27 instanceof Data_Maybe.Nothing) {
                  return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("Unexpected EOF");
              };
              if ($27 instanceof Data_Maybe.Just) {
                  return {
                      consumed: true, 
                      input: Data_String.drop(1)(v.value0.input), 
                      result: new Data_Either.Right($27.value0), 
                      position: Text_Parsing_Parser_Pos.updatePosString(v.value0.position)(Data_Char.toString($27.value0))
                  };
              };
              throw new Error("Failed pattern match at Text.Parsing.Parser.String line 35, column 3 - line 40, column 1: " + [ $27.constructor.name ]);
          })());
      });
  };
  var satisfy = function (dictMonad) {
      return function (f) {
          return Text_Parsing_Parser_Combinators["try"](((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]())(Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(anyChar(dictMonad))(function (v) {
              var $33 = f(v);
              if ($33) {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(v);
              };
              if (!$33) {
                  return Text_Parsing_Parser.fail(dictMonad)("Character '" + (Data_String.fromChar(v) + "' did not satisfy predicate"));
              };
              throw new Error("Failed pattern match at Text.Parsing.Parser.String line 43, column 3 - line 47, column 1: " + [ $33.constructor.name ]);
          }));
      };
  };
  var $$char = function (dictMonad) {
      return function (c) {
          return satisfy(dictMonad)(function (v) {
              return v === c;
          });
      };
  };
  var noneOf = function (dictMonad) {
      return function (ss) {
          return satisfy(dictMonad)(Prelude.flip(Data_Foldable.notElem(Data_Foldable.foldableArray)(Prelude.eqChar))(ss));
      };
  };
  var oneOf = function (dictMonad) {
      return function (ss) {
          return satisfy(dictMonad)(Prelude.flip(Data_Foldable.elem(Data_Foldable.foldableArray)(Prelude.eqChar))(ss));
      };
  };
  var whiteSpace = function (dictMonad) {
      return Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(Data_Array.many(Text_Parsing_Parser.alternativeParserT(dictMonad))(Text_Parsing_Parser.lazyParserT)(satisfy(dictMonad)(function (c) {
          return c === "\n" || (c === "\r" || (c === " " || c === "\t"));
      })))(function (v) {
          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(Data_String.fromCharArray(v));
      });
  };
  var skipSpaces = function (dictMonad) {
      return Prelude.bind(Text_Parsing_Parser.bindParserT(dictMonad))(whiteSpace(dictMonad))(function () {
          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(dictMonad))(Prelude.unit);
      });
  };
  exports["noneOf"] = noneOf;
  exports["oneOf"] = oneOf;
  exports["skipSpaces"] = skipSpaces;
  exports["whiteSpace"] = whiteSpace;
  exports["char"] = $$char;
  exports["satisfy"] = satisfy;
  exports["anyChar"] = anyChar;
  exports["string"] = string;
  exports["eof"] = eof;
})(PS["Text.Parsing.Parser.String"] = PS["Text.Parsing.Parser.String"] || {});
(function(exports) {
  /* globals exports */
  "use strict";     

  exports.isNaN = isNaN;

  exports.readFloat = parseFloat;
})(PS["Global"] = PS["Global"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Global"];
  exports["readFloat"] = $foreign.readFloat;
  exports["isNaN"] = $foreign["isNaN"];
})(PS["Global"] = PS["Global"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Unsafe_Coerce = PS["Unsafe.Coerce"];
  var Control_Apply_1 = PS["Control.Apply"];
  var Data_Generic = PS["Data.Generic"];
  var Data_Either = PS["Data.Either"];
  var Data_List = PS["Data.List"];
  var Control_Apply_1 = PS["Control.Apply"];
  var Control_Alt = PS["Control.Alt"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Combinators = PS["Text.Parsing.Parser.Combinators"];
  var Text_Parsing_Parser_String = PS["Text.Parsing.Parser.String"];
  var Data_Array = PS["Data.Array"];
  var Data_String_1 = PS["Data.String"];
  var Data_String_1 = PS["Data.String"];
  var Global = PS["Global"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Identity = PS["Data.Identity"];
  var Data_Unfoldable = PS["Data.Unfoldable"];
  var Data_Foldable = PS["Data.Foldable"];        
  var StringValue = (function () {
      function StringValue(value0) {
          this.value0 = value0;
      };
      StringValue.create = function (value0) {
          return new StringValue(value0);
      };
      return StringValue;
  })();
  var BoolValue = (function () {
      function BoolValue(value0) {
          this.value0 = value0;
      };
      BoolValue.create = function (value0) {
          return new BoolValue(value0);
      };
      return BoolValue;
  })();
  var ArrayValue = (function () {
      function ArrayValue(value0) {
          this.value0 = value0;
      };
      ArrayValue.create = function (value0) {
          return new ArrayValue(value0);
      };
      return ArrayValue;
  })();
  var IntValue = (function () {
      function IntValue(value0) {
          this.value0 = value0;
      };
      IntValue.create = function (value0) {
          return new IntValue(value0);
      };
      return IntValue;
  })();
  var FloatValue = (function () {
      function FloatValue(value0) {
          this.value0 = value0;
      };
      FloatValue.create = function (value0) {
          return new FloatValue(value0);
      };
      return FloatValue;
  })();
  var showValue = new Prelude.Show(function (v) {
      if (v instanceof StringValue) {
          return "StringValue " + v.value0;
      };
      if (v instanceof BoolValue) {
          return "BoolValue " + Prelude.show(Prelude.showBoolean)(v.value0);
      };
      if (v instanceof ArrayValue) {
          return "ArrayValue " + Prelude.show(Prelude.showArray(Prelude.showString))(Prelude["<$>"](Prelude.functorArray)(Prelude.show(showValue))(v.value0));
      };
      if (v instanceof IntValue) {
          return "IntValue " + Prelude.show(Prelude.showInt)(v.value0);
      };
      if (v instanceof FloatValue) {
          return "FloatValue " + Prelude.show(Prelude.showNumber)(v.value0);
      };
      throw new Error("Failed pattern match at Language.Docopt.Value line 37, column 3 - line 38, column 3: " + [ v.constructor.name ]);
  });
  var prettyPrintValue = function (v) {
      if (v instanceof StringValue) {
          return v.value0;
      };
      if (v instanceof BoolValue) {
          return Prelude.show(Prelude.showBoolean)(v.value0);
      };
      if (v instanceof ArrayValue) {
          return Prelude.show(Prelude.showArray(Prelude.showString))(Prelude["<$>"](Prelude.functorArray)(prettyPrintValue)(v.value0));
      };
      if (v instanceof IntValue) {
          return Prelude.show(Prelude.showInt)(v.value0);
      };
      if (v instanceof FloatValue) {
          return Prelude.show(Prelude.showNumber)(v.value0);
      };
      throw new Error("Failed pattern match at Language.Docopt.Value line 76, column 1 - line 77, column 1: " + [ v.constructor.name ]);
  };
  var parse = function (s) {
      return function (split) {
          var white = Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(" "))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("\n"));
          var quoted = Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(StringValue.create)(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(function ($100) {
              return Data_String_1.fromCharArray(Data_List.fromList(Data_Unfoldable.unfoldableArray)($100));
          })(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)([ Text_Parsing_Parser_Combinators.between(Data_Identity.monadIdentity)(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("\""))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("\""))(Data_List.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ "\"" ]))), Text_Parsing_Parser_Combinators.between(Data_Identity.monadIdentity)(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("'"))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("'"))(Data_List.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ "'" ]))) ])));
          var number = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_String_1.fromCharArray)(Data_Array.some(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ ",", " ", "\n" ]))))(function (v) {
              var n = Global.readFloat(v);
              var $38 = Global["isNaN"](n);
              if ($38) {
                  return Text_Parsing_Parser.fail(Data_Identity.monadIdentity)("NaN");
              };
              if (!$38) {
                  var $39 = Data_String_1.contains(".")(v);
                  if ($39) {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new FloatValue(n));
                  };
                  if (!$39) {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new IntValue(Unsafe_Coerce.unsafeCoerce(n)));
                  };
                  throw new Error("Failed pattern match at Language.Docopt.Value line 128, column 23 - line 133, column 5: " + [ $39.constructor.name ]);
              };
              throw new Error("Failed pattern match at Language.Docopt.Value line 127, column 7 - line 133, column 5: " + [ $38.constructor.name ]);
          });
          var bool = (function () {
              var true$prime = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(function ($101) {
                  return Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)($101));
              })([ "true", "True", "TRUE" ])))(function () {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new BoolValue(true));
              });
              var false$prime = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(function ($102) {
                  return Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)($102));
              })([ "false", "False", "FALSE" ])))(function () {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new BoolValue(false));
              });
              return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Data_Identity.monadIdentity))(true$prime)(false$prime);
          })();
          var value = Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ bool, number, quoted ]));
          var inner = Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(value))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(StringValue.create)(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(function ($103) {
              return Data_String_1.fromCharArray(Data_List.fromList(Data_Unfoldable.unfoldableArray)($103));
          })(Data_List.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ ",", " ", "\n" ]))))));
          var values = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.sepBy1(Data_Identity.monadIdentity)(inner)(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)([ Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Control_Apply_1["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply_1["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(white))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(",")))(Data_List.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(white))), Data_List.some(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(white) ])))(function (v) {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))((function () {
                  if (v instanceof Data_List.Cons && v.value1 instanceof Data_List.Nil) {
                      return v.value0;
                  };
                  return new ArrayValue(Data_List.fromList(Data_Unfoldable.unfoldableArray)(v));
              })());
          });
          return Text_Parsing_Parser.runParser(s)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))((function () {
              if (split) {
                  return values;
              };
              if (!split) {
                  return value;
              };
              throw new Error("Failed pattern match at Language.Docopt.Value line 99, column 24 - line 101, column 19: " + [ split.constructor.name ]);
          })())(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity))(function () {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(v);
              });
          }));
      };
  };
  var read = function (s) {
      return function (split) {
          return Data_Either.either(Prelude["const"](new StringValue(s)))(Prelude.id(Prelude.categoryFn))(parse(s)(split));
      };
  };
  var isBoolValue = function (v) {
      if (v instanceof BoolValue) {
          return true;
      };
      return false;
  };
  var isArrayValue = function (v) {
      if (v instanceof ArrayValue) {
          return true;
      };
      return false;
  };
  var genericValue = new Data_Generic.Generic(function (v) {
      if (v instanceof Data_Generic.SProd && (v.value0 === "Language.Docopt.Value.StringValue" && v.value1.length === 1)) {
          return Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(StringValue.create))(Data_Generic.fromSpine(Data_Generic.genericString)(v.value1[0](Prelude.unit)));
      };
      if (v instanceof Data_Generic.SProd && (v.value0 === "Language.Docopt.Value.BoolValue" && v.value1.length === 1)) {
          return Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(BoolValue.create))(Data_Generic.fromSpine(Data_Generic.genericBool)(v.value1[0](Prelude.unit)));
      };
      if (v instanceof Data_Generic.SProd && (v.value0 === "Language.Docopt.Value.ArrayValue" && v.value1.length === 1)) {
          return Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(ArrayValue.create))(Data_Generic.fromSpine(Data_Generic.genericArray(genericValue))(v.value1[0](Prelude.unit)));
      };
      if (v instanceof Data_Generic.SProd && (v.value0 === "Language.Docopt.Value.IntValue" && v.value1.length === 1)) {
          return Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(IntValue.create))(Data_Generic.fromSpine(Data_Generic.genericInt)(v.value1[0](Prelude.unit)));
      };
      if (v instanceof Data_Generic.SProd && (v.value0 === "Language.Docopt.Value.FloatValue" && v.value1.length === 1)) {
          return Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(FloatValue.create))(Data_Generic.fromSpine(Data_Generic.genericNumber)(v.value1[0](Prelude.unit)));
      };
      return Data_Maybe.Nothing.value;
  }, function ($dollarq) {
      return new Data_Generic.SigProd("Language.Docopt.Value.Value", [ {
          sigConstructor: "Language.Docopt.Value.StringValue", 
          sigValues: [ function ($dollarq1) {
              return Data_Generic.toSignature(Data_Generic.genericString)(Data_Generic.anyProxy);
          } ]
      }, {
          sigConstructor: "Language.Docopt.Value.BoolValue", 
          sigValues: [ function ($dollarq1) {
              return Data_Generic.toSignature(Data_Generic.genericBool)(Data_Generic.anyProxy);
          } ]
      }, {
          sigConstructor: "Language.Docopt.Value.ArrayValue", 
          sigValues: [ function ($dollarq1) {
              return Data_Generic.toSignature(Data_Generic.genericArray(genericValue))(Data_Generic.anyProxy);
          } ]
      }, {
          sigConstructor: "Language.Docopt.Value.IntValue", 
          sigValues: [ function ($dollarq1) {
              return Data_Generic.toSignature(Data_Generic.genericInt)(Data_Generic.anyProxy);
          } ]
      }, {
          sigConstructor: "Language.Docopt.Value.FloatValue", 
          sigValues: [ function ($dollarq1) {
              return Data_Generic.toSignature(Data_Generic.genericNumber)(Data_Generic.anyProxy);
          } ]
      } ]);
  }, function (v) {
      if (v instanceof StringValue) {
          return new Data_Generic.SProd("Language.Docopt.Value.StringValue", [ function ($dollarq) {
              return Data_Generic.toSpine(Data_Generic.genericString)(v.value0);
          } ]);
      };
      if (v instanceof BoolValue) {
          return new Data_Generic.SProd("Language.Docopt.Value.BoolValue", [ function ($dollarq) {
              return Data_Generic.toSpine(Data_Generic.genericBool)(v.value0);
          } ]);
      };
      if (v instanceof ArrayValue) {
          return new Data_Generic.SProd("Language.Docopt.Value.ArrayValue", [ function ($dollarq) {
              return Data_Generic.toSpine(Data_Generic.genericArray(genericValue))(v.value0);
          } ]);
      };
      if (v instanceof IntValue) {
          return new Data_Generic.SProd("Language.Docopt.Value.IntValue", [ function ($dollarq) {
              return Data_Generic.toSpine(Data_Generic.genericInt)(v.value0);
          } ]);
      };
      if (v instanceof FloatValue) {
          return new Data_Generic.SProd("Language.Docopt.Value.FloatValue", [ function ($dollarq) {
              return Data_Generic.toSpine(Data_Generic.genericNumber)(v.value0);
          } ]);
      };
      throw new Error("Failed pattern match: " + [ v.constructor.name ]);
  });
  exports["StringValue"] = StringValue;
  exports["BoolValue"] = BoolValue;
  exports["ArrayValue"] = ArrayValue;
  exports["IntValue"] = IntValue;
  exports["FloatValue"] = FloatValue;
  exports["prettyPrintValue"] = prettyPrintValue;
  exports["isArrayValue"] = isArrayValue;
  exports["isBoolValue"] = isBoolValue;
  exports["parse"] = parse;
  exports["read"] = read;
  exports["genericValue"] = genericValue;
  exports["showValue"] = showValue;
})(PS["Language.Docopt.Value"] = PS["Language.Docopt.Value"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_String = PS["Data.String"];
  var Control_Apply = PS["Control.Apply"];
  var Data_Generic = PS["Data.Generic"];
  var Language_Docopt_Value = PS["Language.Docopt.Value"];        
  var Argument = function (x) {
      return x;
  };
  var Option = function (x) {
      return x;
  };
  var runOption = function (v) {
      return v;
  };
  var runArgument = function (v) {
      return v;
  };
  var prettyPrintOptionNaked = function (v) {
      var $$short = Data_Maybe.maybe("")(function (f) {
          return "-" + Data_String.fromChar(f);
      })(v.flag);
      var rep = (function () {
          if (v.repeatable) {
              return "...";
          };
          if (!v.repeatable) {
              return "";
          };
          throw new Error("Failed pattern match at Language.Docopt.Option line 134, column 12 - line 135, column 5: " + [ v.repeatable.constructor.name ]);
      })();
      var $$long = Data_Maybe.maybe("")(Prelude["const"]("|"))(Control_Apply["*>"](Data_Maybe.applyMaybe)(v.flag)(v.name)) + Data_Maybe.maybe("")(function (v1) {
          return "--" + v1;
      })(v.name);
      var arg$prime = Prelude.flip(Data_Maybe.maybe(""))(v.arg)(function (v1) {
          return "=" + v1.name;
      });
      return $$short + ($$long + (arg$prime + rep));
  };
  var prettyPrintOption = function (v) {
      var $$short = Data_Maybe.maybe("")(function (f) {
          return "-" + Data_String.fromChar(f);
      })(v.flag);
      var rep = (function () {
          if (v.repeatable) {
              return "...";
          };
          if (!v.repeatable) {
              return "";
          };
          throw new Error("Failed pattern match at Language.Docopt.Option line 117, column 12 - line 118, column 5: " + [ v.repeatable.constructor.name ]);
      })();
      var $$long = Data_Maybe.maybe("")(Prelude["const"](", "))(Control_Apply["*>"](Data_Maybe.applyMaybe)(v.flag)(v.name)) + Data_Maybe.maybe("")(function (v1) {
          return "--" + v1;
      })(v.name);
      var env = Prelude.flip(Data_Maybe.maybe(""))(v.env)(function (k) {
          return " [env: " + (k + "]");
      });
      var $$default = Prelude.flip(Data_Maybe.maybe(""))(v.arg)(function (v1) {
          return Prelude.flip(Data_Maybe.maybe(""))(v1["default"])(function (v2) {
              return " [default: " + (Language_Docopt_Value.prettyPrintValue(v2) + "]");
          });
      });
      var arg$prime = Prelude.flip(Data_Maybe.maybe(""))(v.arg)(function (v1) {
          return (function () {
              if (v1.optional) {
                  return "[";
              };
              if (!v1.optional) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Option line 119, column 18 - line 119, column 46: " + [ v1.optional.constructor.name ]);
          })() + ("=" + (v1.name + (function () {
              if (v1.optional) {
                  return "]";
              };
              if (!v1.optional) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Option line 121, column 23 - line 121, column 51: " + [ v1.optional.constructor.name ]);
          })()));
      });
      return $$short + ($$long + (arg$prime + (rep + ($$default + env))));
  };
  var isRepeatable = function (v) {
      return v.repeatable;
  };
  var isFlag = function (v) {
      if (v.arg instanceof Data_Maybe.Just && (v.arg.value0["default"] instanceof Data_Maybe.Just && (v.arg.value0["default"]).value0 instanceof Language_Docopt_Value.BoolValue)) {
          return true;
      };
      if (v.arg instanceof Data_Maybe.Nothing) {
          return true;
      };
      return false;
  };
  var hasDefault = function (v) {
      if (v.arg instanceof Data_Maybe.Just && v.arg.value0["default"] instanceof Data_Maybe.Just) {
          return true;
      };
      return false;
  };
  var genericArgument = new Data_Generic.Generic(function (v) {
      if (v instanceof Data_Generic.SProd && (v.value0 === "Language.Docopt.Option.Argument" && v.value1.length === 1)) {
          return Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(Argument))((function (r) {
              if (r instanceof Data_Generic.SRecord && r.value0.length === 3) {
                  return Prelude.apply(Data_Maybe.applyMaybe)(Prelude.apply(Data_Maybe.applyMaybe)(Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(function (default1) {
                      return function (name1) {
                          return function (optional1) {
                              return {
                                  "default": default1, 
                                  name: name1, 
                                  optional: optional1
                              };
                          };
                      };
                  }))(Data_Generic.fromSpine(Data_Generic.genericMaybe(Language_Docopt_Value.genericValue))((r.value0[0]).recValue(Prelude.unit))))(Data_Generic.fromSpine(Data_Generic.genericString)((r.value0[1]).recValue(Prelude.unit))))(Data_Generic.fromSpine(Data_Generic.genericBool)((r.value0[2]).recValue(Prelude.unit)));
              };
              return Data_Maybe.Nothing.value;
          })(v.value1[0](Prelude.unit)));
      };
      return Data_Maybe.Nothing.value;
  }, function ($dollarq) {
      return new Data_Generic.SigProd("Language.Docopt.Option.Argument", [ {
          sigConstructor: "Language.Docopt.Option.Argument", 
          sigValues: [ function ($dollarq1) {
              return new Data_Generic.SigRecord([ {
                  recLabel: "default", 
                  recValue: function ($dollarq2) {
                      return Data_Generic.toSignature(Data_Generic.genericMaybe(Language_Docopt_Value.genericValue))(Data_Generic.anyProxy);
                  }
              }, {
                  recLabel: "name", 
                  recValue: function ($dollarq2) {
                      return Data_Generic.toSignature(Data_Generic.genericString)(Data_Generic.anyProxy);
                  }
              }, {
                  recLabel: "optional", 
                  recValue: function ($dollarq2) {
                      return Data_Generic.toSignature(Data_Generic.genericBool)(Data_Generic.anyProxy);
                  }
              } ]);
          } ]
      } ]);
  }, function (v) {
      return new Data_Generic.SProd("Language.Docopt.Option.Argument", [ function ($dollarq) {
          return new Data_Generic.SRecord([ {
              recLabel: "default", 
              recValue: function ($dollarq1) {
                  return Data_Generic.toSpine(Data_Generic.genericMaybe(Language_Docopt_Value.genericValue))(v["default"]);
              }
          }, {
              recLabel: "name", 
              recValue: function ($dollarq1) {
                  return Data_Generic.toSpine(Data_Generic.genericString)(v.name);
              }
          }, {
              recLabel: "optional", 
              recValue: function ($dollarq1) {
                  return Data_Generic.toSpine(Data_Generic.genericBool)(v.optional);
              }
          } ]);
      } ]);
  });
  var genericOption = new Data_Generic.Generic(function (v) {
      if (v instanceof Data_Generic.SProd && (v.value0 === "Language.Docopt.Option.Option" && v.value1.length === 1)) {
          return Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(Option))((function (r) {
              if (r instanceof Data_Generic.SRecord && r.value0.length === 5) {
                  return Prelude.apply(Data_Maybe.applyMaybe)(Prelude.apply(Data_Maybe.applyMaybe)(Prelude.apply(Data_Maybe.applyMaybe)(Prelude.apply(Data_Maybe.applyMaybe)(Prelude.apply(Data_Maybe.applyMaybe)(new Data_Maybe.Just(function (arg1) {
                      return function (env1) {
                          return function (flag1) {
                              return function (name1) {
                                  return function (repeatable1) {
                                      return {
                                          arg: arg1, 
                                          env: env1, 
                                          flag: flag1, 
                                          name: name1, 
                                          repeatable: repeatable1
                                      };
                                  };
                              };
                          };
                      };
                  }))(Data_Generic.fromSpine(Data_Generic.genericMaybe(genericArgument))((r.value0[0]).recValue(Prelude.unit))))(Data_Generic.fromSpine(Data_Generic.genericMaybe(Data_Generic.genericString))((r.value0[1]).recValue(Prelude.unit))))(Data_Generic.fromSpine(Data_Generic.genericMaybe(Data_Generic.genericChar))((r.value0[2]).recValue(Prelude.unit))))(Data_Generic.fromSpine(Data_Generic.genericMaybe(Data_Generic.genericString))((r.value0[3]).recValue(Prelude.unit))))(Data_Generic.fromSpine(Data_Generic.genericBool)((r.value0[4]).recValue(Prelude.unit)));
              };
              return Data_Maybe.Nothing.value;
          })(v.value1[0](Prelude.unit)));
      };
      return Data_Maybe.Nothing.value;
  }, function ($dollarq) {
      return new Data_Generic.SigProd("Language.Docopt.Option.Option", [ {
          sigConstructor: "Language.Docopt.Option.Option", 
          sigValues: [ function ($dollarq1) {
              return new Data_Generic.SigRecord([ {
                  recLabel: "arg", 
                  recValue: function ($dollarq2) {
                      return Data_Generic.toSignature(Data_Generic.genericMaybe(genericArgument))(Data_Generic.anyProxy);
                  }
              }, {
                  recLabel: "env", 
                  recValue: function ($dollarq2) {
                      return Data_Generic.toSignature(Data_Generic.genericMaybe(Data_Generic.genericString))(Data_Generic.anyProxy);
                  }
              }, {
                  recLabel: "flag", 
                  recValue: function ($dollarq2) {
                      return Data_Generic.toSignature(Data_Generic.genericMaybe(Data_Generic.genericChar))(Data_Generic.anyProxy);
                  }
              }, {
                  recLabel: "name", 
                  recValue: function ($dollarq2) {
                      return Data_Generic.toSignature(Data_Generic.genericMaybe(Data_Generic.genericString))(Data_Generic.anyProxy);
                  }
              }, {
                  recLabel: "repeatable", 
                  recValue: function ($dollarq2) {
                      return Data_Generic.toSignature(Data_Generic.genericBool)(Data_Generic.anyProxy);
                  }
              } ]);
          } ]
      } ]);
  }, function (v) {
      return new Data_Generic.SProd("Language.Docopt.Option.Option", [ function ($dollarq) {
          return new Data_Generic.SRecord([ {
              recLabel: "arg", 
              recValue: function ($dollarq1) {
                  return Data_Generic.toSpine(Data_Generic.genericMaybe(genericArgument))(v.arg);
              }
          }, {
              recLabel: "env", 
              recValue: function ($dollarq1) {
                  return Data_Generic.toSpine(Data_Generic.genericMaybe(Data_Generic.genericString))(v.env);
              }
          }, {
              recLabel: "flag", 
              recValue: function ($dollarq1) {
                  return Data_Generic.toSpine(Data_Generic.genericMaybe(Data_Generic.genericChar))(v.flag);
              }
          }, {
              recLabel: "name", 
              recValue: function ($dollarq1) {
                  return Data_Generic.toSpine(Data_Generic.genericMaybe(Data_Generic.genericString))(v.name);
              }
          }, {
              recLabel: "repeatable", 
              recValue: function ($dollarq1) {
                  return Data_Generic.toSpine(Data_Generic.genericBool)(v.repeatable);
              }
          } ]);
      } ]);
  });                                                                      
  var eqOption = new Prelude.Eq(Data_Generic.gEq(genericOption));
  exports["Option"] = Option;
  exports["Argument"] = Argument;
  exports["prettyPrintOptionNaked"] = prettyPrintOptionNaked;
  exports["prettyPrintOption"] = prettyPrintOption;
  exports["isFlag"] = isFlag;
  exports["hasDefault"] = hasDefault;
  exports["isRepeatable"] = isRepeatable;
  exports["runArgument"] = runArgument;
  exports["runOption"] = runOption;
  exports["genericOption"] = genericOption;
  exports["genericArgument"] = genericArgument;
  exports["eqOption"] = eqOption;
})(PS["Language.Docopt.Option"] = PS["Language.Docopt.Option"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_StrMap_1 = PS["Data.StrMap"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_StrMap_1 = PS["Data.StrMap"];
  var Data_Tuple = PS["Data.Tuple"];        
  var member = Data_StrMap_1.member;
  var lookup = Data_StrMap_1.lookup;
  exports["lookup"] = lookup;
  exports["member"] = member;
})(PS["Language.Docopt.Env"] = PS["Language.Docopt.Env"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_List = PS["Data.List"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Function = PS["Data.Function"];
  var Data_String_Ext = PS["Data.String.Ext"];
  var Data_String = PS["Data.String"];
  var Language_Docopt_Option = PS["Language.Docopt.Option"];
  var Language_Docopt_Env_1 = PS["Language.Docopt.Env"];
  var Language_Docopt_Env_1 = PS["Language.Docopt.Env"];
  var Data_Monoid = PS["Data.Monoid"];        
  var Command = (function () {
      function Command(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Command.create = function (value0) {
          return function (value1) {
              return new Command(value0, value1);
          };
      };
      return Command;
  })();
  var Positional = (function () {
      function Positional(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Positional.create = function (value0) {
          return function (value1) {
              return new Positional(value0, value1);
          };
      };
      return Positional;
  })();
  var Option = (function () {
      function Option(value0) {
          this.value0 = value0;
      };
      Option.create = function (value0) {
          return new Option(value0);
      };
      return Option;
  })();
  var Group = (function () {
      function Group(value0, value1, value2) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
      };
      Group.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return new Group(value0, value1, value2);
              };
          };
      };
      return Group;
  })();
  var EOA = (function () {
      function EOA() {

      };
      EOA.value = new EOA();
      return EOA;
  })();
  var Stdin = (function () {
      function Stdin() {

      };
      Stdin.value = new Stdin();
      return Stdin;
  })();
  var Branch = function (x) {
      return x;
  }; 
  var setRequired = function (v) {
      return function (v1) {
          if (v instanceof Group) {
              return new Group(!v1, v.value1, v.value2);
          };
          return v;
      };
  };
  var setRepeatableOr = function (v) {
      return function (v1) {
          if (v instanceof Option) {
              return Option.create(Language_Docopt_Option.Option((function () {
                  var $46 = {};
                  for (var $47 in v.value0) {
                      if (v.value0.hasOwnProperty($47)) {
                          $46[$47] = v.value0[$47];
                      };
                  };
                  $46.repeatable = v.value0.repeatable || v1;
                  return $46;
              })()));
          };
          if (v instanceof Positional) {
              return new Positional(v.value0, v.value1 || v1);
          };
          if (v instanceof Command) {
              return new Command(v.value0, v.value1 || v1);
          };
          return v;
      };
  };
  var setRepeatable = function (v) {
      return function (v1) {
          if (v instanceof Option) {
              return Option.create(Language_Docopt_Option.Option((function () {
                  var $55 = {};
                  for (var $56 in v.value0) {
                      if (v.value0.hasOwnProperty($56)) {
                          $55[$56] = v.value0[$56];
                      };
                  };
                  $55.repeatable = v1;
                  return $55;
              })()));
          };
          if (v instanceof Positional) {
              return new Positional(v.value0, v1);
          };
          if (v instanceof Command) {
              return new Command(v.value0, v1);
          };
          return v;
      };
  };
  var runBranch = function (v) {
      return v;
  };
  var prettyPrintBranchNaked = function (v) {
      return Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(" ")(Prelude["<$>"](Data_List.functorList)(prettyPrintArgNaked)(v));
  };
  var prettyPrintArgNaked = function (v) {
      if (v instanceof Stdin) {
          return "-";
      };
      if (v instanceof EOA) {
          return "-- ARGS...";
      };
      if (v instanceof Command) {
          return v.value0 + (function () {
              if (v.value1) {
                  return "...";
              };
              if (!v.value1) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 110, column 52 - line 110, column 75: " + [ v.value1.constructor.name ]);
          })();
      };
      if (v instanceof Positional) {
          return v.value0 + (function () {
              if (v.value1) {
                  return "...";
              };
              if (!v.value1) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 111, column 52 - line 111, column 75: " + [ v.value1.constructor.name ]);
          })();
      };
      if (v instanceof Option) {
          return Language_Docopt_Option.prettyPrintOptionNaked(v.value0);
      };
      if (v instanceof Group) {
          var repetition = (function () {
              if (v.value2) {
                  return "...";
              };
              if (!v.value2) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 116, column 18 - line 118, column 1: " + [ v.value2.constructor.name ]);
          })();
          var inner = Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(" | ")(Prelude["<$>"](Data_List.functorList)(prettyPrintBranchNaked)(v.value1));
          return inner + repetition;
      };
      throw new Error("Failed pattern match at Language.Docopt.Argument line 108, column 1 - line 109, column 1: " + [ v.constructor.name ]);
  };
  var prettyPrintBranch = function (v) {
      return Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(" ")(Prelude["<$>"](Data_List.functorList)(prettyPrintArg)(v));
  };
  var prettyPrintArg = function (v) {
      if (v instanceof Stdin) {
          return "-";
      };
      if (v instanceof EOA) {
          return "--";
      };
      if (v instanceof Command) {
          return v.value0 + (function () {
              if (v.value1) {
                  return "...";
              };
              if (!v.value1) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 92, column 44 - line 92, column 67: " + [ v.value1.constructor.name ]);
          })();
      };
      if (v instanceof Positional) {
          var name = (function () {
              var $81 = Data_String.toUpper(v.value0) === v.value0;
              if ($81) {
                  return v.value0;
              };
              if (!$81) {
                  return "<" + (v.value0 + ">");
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 95, column 12 - line 96, column 1: " + [ $81.constructor.name ]);
          })();
          return name + (function () {
              if (v.value1) {
                  return "...";
              };
              if (!v.value1) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 93, column 44 - line 93, column 67: " + [ v.value1.constructor.name ]);
          })();
      };
      if (v instanceof Option) {
          return Language_Docopt_Option.prettyPrintOption(v.value0);
      };
      if (v instanceof Group) {
          var repetition = (function () {
              if (v.value2) {
                  return "...";
              };
              if (!v.value2) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 102, column 18 - line 104, column 1: " + [ v.value2.constructor.name ]);
          })();
          var open = (function () {
              if (v.value0) {
                  return "[";
              };
              if (!v.value0) {
                  return "(";
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 99, column 18 - line 100, column 5: " + [ v.value0.constructor.name ]);
          })();
          var inner = Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(" | ")(Prelude["<$>"](Data_List.functorList)(prettyPrintBranch)(v.value1));
          var close = (function () {
              if (v.value0) {
                  return "]";
              };
              if (!v.value0) {
                  return ")";
              };
              throw new Error("Failed pattern match at Language.Docopt.Argument line 100, column 18 - line 101, column 5: " + [ v.value0.constructor.name ]);
          })();
          return open + (inner + (close + repetition));
      };
      throw new Error("Failed pattern match at Language.Docopt.Argument line 90, column 1 - line 91, column 1: " + [ v.constructor.name ]);
  };
  var isRepeatable = function (v) {
      if (v instanceof Option) {
          return Language_Docopt_Option.isRepeatable(v.value0);
      };
      if (v instanceof Positional) {
          return v.value1;
      };
      if (v instanceof Command) {
          return v.value1;
      };
      return false;
  };
  var isFree = function (v) {
      if (v instanceof Option) {
          return true;
      };
      if (v instanceof Group) {
          return Data_Foldable.all(Data_List.foldableList)(Prelude.booleanAlgebraBoolean)(function ($139) {
              return Data_Foldable.all(Data_List.foldableList)(Prelude.booleanAlgebraBoolean)(isFree)(runBranch($139));
          })(v.value1);
      };
      return false;
  };
  var isFlag = function (v) {
      if (v instanceof Option) {
          return Language_Docopt_Option.isFlag(v.value0);
      };
      return false;
  };
  var isCommand = function (v) {
      if (v instanceof Command) {
          return true;
      };
      return false;
  };
  var hasDefault = function (v) {
      if (v instanceof Option) {
          return Language_Docopt_Option.hasDefault(v.value0);
      };
      return false;
  };
  var getEnvKey = function (v) {
      if (v instanceof Option) {
          return v.value0.env;
      };
      return Data_Maybe.Nothing.value;
  };
  var hasEnvBacking = function (p) {
      return function (env) {
          return Data_Maybe.maybe(false)(Prelude.id(Prelude.categoryFn))(Prelude["<$>"](Data_Maybe.functorMaybe)(Prelude.flip(Language_Docopt_Env_1.member)(env))(getEnvKey(p)));
      };
  };
  var getArgument = function (v) {
      if (v instanceof Option) {
          return v.value0.arg;
      };
      return Data_Maybe.Nothing.value;
  };
  var eqBranch = new Prelude.Eq(function (v) {
      return function (v1) {
          return Prelude["=="](Data_List.eqList(eqArgument))(v)(v1);
      };
  });
  var eqArgument = new Prelude.Eq(function (v) {
      return function (v1) {
          if (v instanceof EOA && v1 instanceof EOA) {
              return true;
          };
          if (v instanceof Stdin && v1 instanceof Stdin) {
              return true;
          };
          if (v instanceof Command && v1 instanceof Command) {
              return v.value0 === v1.value0 && v.value1 === v1.value1;
          };
          if (v instanceof Positional && v1 instanceof Positional) {
              return Data_String_Ext.upperCaseEq(v.value0)(v1.value0) && v.value1 === v1.value1;
          };
          if (v instanceof Group && v1 instanceof Group) {
              return v.value0 === v1.value0 && (Prelude["=="](Data_List.eqList(eqBranch))(v.value1)(v1.value1) && v.value2 === v1.value2);
          };
          if (v instanceof Option && v1 instanceof Option) {
              return Prelude["=="](Language_Docopt_Option.eqOption)(v.value0)(v1.value0);
          };
          return false;
      };
  });
  exports["Branch"] = Branch;
  exports["Command"] = Command;
  exports["Positional"] = Positional;
  exports["Option"] = Option;
  exports["Group"] = Group;
  exports["EOA"] = EOA;
  exports["Stdin"] = Stdin;
  exports["isFree"] = isFree;
  exports["isCommand"] = isCommand;
  exports["isFlag"] = isFlag;
  exports["getArgument"] = getArgument;
  exports["hasEnvBacking"] = hasEnvBacking;
  exports["getEnvKey"] = getEnvKey;
  exports["hasDefault"] = hasDefault;
  exports["setRepeatableOr"] = setRepeatableOr;
  exports["setRequired"] = setRequired;
  exports["setRepeatable"] = setRepeatable;
  exports["isRepeatable"] = isRepeatable;
  exports["runBranch"] = runBranch;
  exports["prettyPrintArgNaked"] = prettyPrintArgNaked;
  exports["prettyPrintArg"] = prettyPrintArg;
  exports["prettyPrintBranch"] = prettyPrintBranch;
  exports["eqBranch"] = eqBranch;
  exports["eqArgument"] = eqArgument;
})(PS["Language.Docopt.Argument"] = PS["Language.Docopt.Argument"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_List = PS["Data.List"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Foldable = PS["Data.Foldable"];
  var Language_Docopt_Argument = PS["Language.Docopt.Argument"];        
  var Usage = function (x) {
      return x;
  }; 
  var runUsage = function (v) {
      return v;
  };
  exports["Usage"] = Usage;
  exports["runUsage"] = runUsage;
})(PS["Language.Docopt.Usage"] = PS["Language.Docopt.Usage"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_List = PS["Data.List"];
  var Data_Generic = PS["Data.Generic"];
  var Text_Wrap = PS["Text.Wrap"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Data_Maybe = PS["Data.Maybe"];        
  var SolveError = function (x) {
      return x;
  };
  var DocoptScanError = (function () {
      function DocoptScanError(value0) {
          this.value0 = value0;
      };
      DocoptScanError.create = function (value0) {
          return new DocoptScanError(value0);
      };
      return DocoptScanError;
  })();
  var DocoptUsageParseError = (function () {
      function DocoptUsageParseError(value0) {
          this.value0 = value0;
      };
      DocoptUsageParseError.create = function (value0) {
          return new DocoptUsageParseError(value0);
      };
      return DocoptUsageParseError;
  })();
  var DocoptDescParseError = (function () {
      function DocoptDescParseError(value0) {
          this.value0 = value0;
      };
      DocoptDescParseError.create = function (value0) {
          return new DocoptDescParseError(value0);
      };
      return DocoptDescParseError;
  })();
  var DocoptUserParseError = (function () {
      function DocoptUserParseError(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      DocoptUserParseError.create = function (value0) {
          return function (value1) {
              return new DocoptUserParseError(value0, value1);
          };
      };
      return DocoptUserParseError;
  })();
  var DocoptSolveError = (function () {
      function DocoptSolveError(value0) {
          this.value0 = value0;
      };
      DocoptSolveError.create = function (value0) {
          return new DocoptSolveError(value0);
      };
      return DocoptSolveError;
  })();
  var unParseError = function (v) {
      return v.value0;
  }; 
  var developerErrorMessage = Text_Wrap.dedent("\n  This is likely an error with the program itself and not your fault.\n  Please raise this with the program's author.\n");
  var prettyPrintDocoptError = function (v) {
      if (v instanceof DocoptScanError) {
          return "Failed to disect docopt text:\n" + ((unParseError(v.value0)).message + ("\n" + developerErrorMessage));
      };
      if (v instanceof DocoptUsageParseError) {
          return "Failed to parse the formal usage specification:\n" + ((unParseError(v.value0)).message + ("\n" + developerErrorMessage));
      };
      if (v instanceof DocoptDescParseError) {
          return "Failed to parse the option descriptions:\n" + ((unParseError(v.value0)).message + ("\n" + developerErrorMessage));
      };
      if (v instanceof DocoptSolveError) {
          return "Incoherent specification:\n" + (v.value0 + ("\n" + developerErrorMessage));
      };
      if (v instanceof DocoptUserParseError) {
          return v.value1.value0.message;
      };
      throw new Error("Failed pattern match at Language.Docopt.Errors line 54, column 1 - line 59, column 1: " + [ v.constructor.name ]);
  };
  exports["DocoptScanError"] = DocoptScanError;
  exports["DocoptUsageParseError"] = DocoptUsageParseError;
  exports["DocoptDescParseError"] = DocoptDescParseError;
  exports["DocoptUserParseError"] = DocoptUserParseError;
  exports["DocoptSolveError"] = DocoptSolveError;
  exports["SolveError"] = SolveError;
  exports["prettyPrintDocoptError"] = prettyPrintDocoptError;
  exports["developerErrorMessage"] = developerErrorMessage;
  exports["unParseError"] = unParseError;
})(PS["Language.Docopt.Errors"] = PS["Language.Docopt.Errors"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_List = PS["Data.List"];
  var Data_String = PS["Data.String"];
  var Data_Array = PS["Data.Array"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Language_Docopt_Value = PS["Language.Docopt.Value"];
  var Data_Monoid = PS["Data.Monoid"];        
  var LOpt = (function () {
      function LOpt(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      LOpt.create = function (value0) {
          return function (value1) {
              return new LOpt(value0, value1);
          };
      };
      return LOpt;
  })();
  var SOpt = (function () {
      function SOpt(value0, value1, value2) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
      };
      SOpt.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return new SOpt(value0, value1, value2);
              };
          };
      };
      return SOpt;
  })();
  var EOA = (function () {
      function EOA(value0) {
          this.value0 = value0;
      };
      EOA.create = function (value0) {
          return new EOA(value0);
      };
      return EOA;
  })();
  var Stdin = (function () {
      function Stdin() {

      };
      Stdin.value = new Stdin();
      return Stdin;
  })();
  var Lit = (function () {
      function Lit(value0) {
          this.value0 = value0;
      };
      Lit.create = function (value0) {
          return new Lit(value0);
      };
      return Lit;
  })();
  var PositionedToken = (function () {
      function PositionedToken(value0) {
          this.value0 = value0;
      };
      PositionedToken.create = function (value0) {
          return new PositionedToken(value0);
      };
      return PositionedToken;
  })();
  var unPositionedToken = function (v) {
      return v.value0;
  };
  var showToken = new Prelude.Show(function (v) {
      if (v instanceof LOpt) {
          return "LOpt " + (Prelude.show(Prelude.showString)(v.value0) + (" " + Prelude.show(Data_Maybe.showMaybe(Prelude.showString))(v.value1)));
      };
      if (v instanceof SOpt) {
          return "SOpt " + (Prelude.show(Prelude.showChar)(v.value0) + (" " + (Prelude.show(Prelude.showArray(Prelude.showChar))(v.value1) + (" " + Prelude.show(Data_Maybe.showMaybe(Prelude.showString))(v.value2)))));
      };
      if (v instanceof Lit) {
          return "Lit " + Prelude.show(Prelude.showString)(v.value0);
      };
      if (v instanceof EOA) {
          return "EOA " + Prelude.show(Data_List.showList(Language_Docopt_Value.showValue))(v.value0);
      };
      if (v instanceof Stdin) {
          return "Stdin";
      };
      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Token line 26, column 3 - line 27, column 3: " + [ v.constructor.name ]);
  });
  var showPositionedToken = new Prelude.Show(function (v) {
      return Prelude.show(showToken)(v.value0.token) + (" at " + Prelude.show(Text_Parsing_Parser_Pos.showPosition)(v.value0.sourcePos));
  });
  var prettyPrintToken = function (v) {
      if (v instanceof Stdin) {
          return "-";
      };
      if (v instanceof EOA) {
          return "-- " + Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(" ")(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Value.prettyPrintValue)(v.value0));
      };
      if (v instanceof Lit) {
          return Prelude.show(Prelude.showString)(v.value0);
      };
      if (v instanceof LOpt) {
          var arg = Data_Maybe.maybe("")(function (v1) {
              return "=" + v1;
          })(v.value1);
          return "--" + (v.value0 + arg);
      };
      if (v instanceof SOpt) {
          var arg = Data_Maybe.maybe("")(function (v1) {
              return "=" + v1;
          })(v.value2);
          return "-" + (Data_String.fromCharArray(Data_Array.cons(v.value0)(v.value1)) + arg);
      };
      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Token line 33, column 1 - line 34, column 1: " + [ v.constructor.name ]);
  };
  var getSource = function ($29) {
      return (function (v) {
          return v.source;
      })(unPositionedToken($29));
  };
  exports["PositionedToken"] = PositionedToken;
  exports["LOpt"] = LOpt;
  exports["SOpt"] = SOpt;
  exports["EOA"] = EOA;
  exports["Stdin"] = Stdin;
  exports["Lit"] = Lit;
  exports["unPositionedToken"] = unPositionedToken;
  exports["prettyPrintToken"] = prettyPrintToken;
  exports["getSource"] = getSource;
  exports["showToken"] = showToken;
  exports["showPositionedToken"] = showPositionedToken;
})(PS["Language.Docopt.ParserGen.Token"] = PS["Language.Docopt.ParserGen.Token"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Alt = PS["Control.Alt"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Text_Parsing_Parser_String = PS["Text.Parsing.Parser.String"];
  var Data_String_Regex = PS["Data.String.Regex"];
  var Data_Array = PS["Data.Array"];
  var Data_Char = PS["Data.Char"];
  var Data_String = PS["Data.String"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Either = PS["Data.Either"];
  var Debug_Trace = PS["Debug.Trace"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var string$prime = function (dictMonad) {
      return function (s) {
          var step = function (acc) {
              return function (x) {
                  return Prelude["<$>"](Text_Parsing_Parser.functorParserT(((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]()))(function ($49) {
                      return (function (v) {
                          return Prelude["++"](Prelude.semigroupArray)(acc)(v);
                      })(Data_Array.singleton($49));
                  })(Text_Parsing_Parser_String.satisfy(dictMonad)(function (c) {
                      return Data_Char.toLower(c) === Data_Char.toLower(x);
                  }));
              };
          };
          return Prelude["<$>"](Text_Parsing_Parser.functorParserT(((dictMonad["__superclass_Prelude.Bind_1"]())["__superclass_Prelude.Apply_0"]())["__superclass_Prelude.Functor_0"]()))(Data_String.fromCharArray)(Data_Array.foldM(Text_Parsing_Parser.monadParserT(dictMonad))(step)([  ])(Data_String.toCharArray(s)));
      };
  };
  var space = function (dictMonad) {
      return Text_Parsing_Parser_String["char"](dictMonad)(" ");
  };
  var regex = function (dictMonad) {
      return function (s) {
          return Text_Parsing_Parser_String.satisfy(dictMonad)(function (c) {
              return Data_String_Regex.test(Data_String_Regex.regex(s)(Data_String_Regex.noFlags))(Data_Char.toString(c));
          });
      };
  };
  var upperAlpha = function (dictMonad) {
      return regex(dictMonad)("[A-Z]");
  };
  var lowerAlphaNum = function (dictMonad) {
      return regex(dictMonad)("[0-9a-z]");
  };
  var lowerAlpha = function (dictMonad) {
      return regex(dictMonad)("[a-z]");
  };
  var getPosition = function (dictMonad) {
      return Text_Parsing_Parser.ParserT(function (v) {
          return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())({
              input: v.value0.input, 
              result: new Data_Either.Right(v.value0.position), 
              consumed: false, 
              position: v.value0.position
          });
      });
  };
  var getInput = function (dictMonad) {
      return function (dictShow) {
          return Text_Parsing_Parser.ParserT(function (v) {
              return Prelude["return"](dictMonad["__superclass_Prelude.Applicative_0"]())({
                  input: v.value0.input, 
                  result: new Data_Either.Right(v.value0.input), 
                  consumed: false, 
                  position: v.value0.position
              });
          });
      };
  };
  var digit = function (dictMonad) {
      return regex(dictMonad)("[0-9]");
  };
  var alpha = function (dictMonad) {
      return regex(dictMonad)("[a-zA-Z]");
  };
  var alphaNum = function (dictMonad) {
      return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(dictMonad))(alpha(dictMonad))(digit(dictMonad));
  };
  exports["string'"] = string$prime;
  exports["space"] = space;
  exports["alphaNum"] = alphaNum;
  exports["lowerAlphaNum"] = lowerAlphaNum;
  exports["lowerAlpha"] = lowerAlpha;
  exports["upperAlpha"] = upperAlpha;
  exports["alpha"] = alpha;
  exports["digit"] = digit;
  exports["regex"] = regex;
  exports["getInput"] = getInput;
  exports["getPosition"] = getPosition;
})(PS["Language.Docopt.Parser.Base"] = PS["Language.Docopt.Parser.Base"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Plus = PS["Control.Plus"];
  var Control_Bind = PS["Control.Bind"];
  var Debug_Trace = PS["Debug.Trace"];
  var Control_Apply = PS["Control.Apply"];
  var Data_Function = PS["Data.Function"];
  var Data_Either = PS["Data.Either"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_List = PS["Data.List"];
  var Control_Alt = PS["Control.Alt"];
  var Data_Traversable = PS["Data.Traversable"];
  var Control_Lazy = PS["Control.Lazy"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_String_1 = PS["Data.String"];
  var Data_String_1 = PS["Data.String"];
  var Data_List_Unsafe = PS["Data.List.Unsafe"];
  var Data_Array = PS["Data.Array"];
  var Data_Array_Unsafe = PS["Data.Array.Unsafe"];
  var Data_Monoid = PS["Data.Monoid"];
  var Data_Tuple = PS["Data.Tuple"];
  var Control_Monad_Reader = PS["Control.Monad.Reader"];
  var Control_Monad_Reader_Trans = PS["Control.Monad.Reader.Trans"];
  var Control_Monad_State_1 = PS["Control.Monad.State"];
  var Control_Monad_State_1 = PS["Control.Monad.State"];
  var Data_StrMap = PS["Data.StrMap"];
  var Control_Monad_Trans = PS["Control.Monad.Trans"];
  var Control_MonadPlus_Partial = PS["Control.MonadPlus.Partial"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Combinators = PS["Text.Parsing.Parser.Combinators"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Language_Docopt_Value_1 = PS["Language.Docopt.Value"];
  var Language_Docopt_Argument = PS["Language.Docopt.Argument"];
  var Language_Docopt_Usage = PS["Language.Docopt.Usage"];
  var Language_Docopt_Env = PS["Language.Docopt.Env"];
  var Language_Docopt_Option = PS["Language.Docopt.Option"];
  var Language_Docopt_Value_1 = PS["Language.Docopt.Value"];
  var Language_Docopt_Parser_Base = PS["Language.Docopt.Parser.Base"];
  var Language_Docopt_ParserGen_Token_1 = PS["Language.Docopt.ParserGen.Token"];
  var Language_Docopt_ParserGen_Token_1 = PS["Language.Docopt.ParserGen.Token"];
  var Language_Docopt_ParserGen_ValueMapping = PS["Language.Docopt.ParserGen.ValueMapping"];
  var Data_String_Ext = PS["Data.String.Ext"];
  var Control_Monad_State_Trans = PS["Control.Monad.State.Trans"];
  var Data_Identity = PS["Data.Identity"];
  var Data_Unfoldable = PS["Data.Unfoldable"];
  var Control_Monad_State_Class = PS["Control.Monad.State.Class"];
  var Control_Monad_Reader_Class = PS["Control.Monad.Reader.Class"];        
  var ScoredResult = function (x) {
      return x;
  };
  var OptParse = (function () {
      function OptParse(value0, value1, value2) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
      };
      OptParse.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return new OptParse(value0, value1, value2);
              };
          };
      };
      return OptParse;
  })();
  var Free = (function () {
      function Free(value0) {
          this.value0 = value0;
      };
      Free.create = function (value0) {
          return new Free(value0);
      };
      return Free;
  })();
  var Pending = (function () {
      function Pending(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Pending.create = function (value0) {
          return function (value1) {
              return new Pending(value0, value1);
          };
      };
      return Pending;
  })();
  var unScoredResult = function (v) {
      return v;
  };
  var unParseError = function (v) {
      return v.value0;
  };
  var token = function (test) {
      return Text_Parsing_Parser.ParserT(function (v) {
          return Prelude["return"](Control_Monad_Reader_Trans.applicativeReaderT(Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity)))((function () {
              if (v.value0.input instanceof Data_List.Cons) {
                  var $102 = test(v.value0.input.value0.value0.token);
                  if ($102 instanceof Data_Maybe.Just) {
                      var nextpos = (function () {
                          if (v.value0.input.value1 instanceof Data_List.Cons) {
                              return v.value0.input.value1.value0.value0.sourcePos;
                          };
                          if (v.value0.input.value1 instanceof Data_List.Nil) {
                              return v.value0.position;
                          };
                          throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 120, column 15 - line 123, column 11: " + [ v.value0.input.value1.constructor.name ]);
                      })();
                      return {
                          consumed: true, 
                          input: v.value0.input.value1, 
                          result: new Data_Either.Right($102.value0), 
                          position: nextpos
                      };
                  };
                  if ($102 instanceof Data_Maybe.Nothing) {
                      return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("a better error message!");
                  };
                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 117, column 7 - line 130, column 5: " + [ $102.constructor.name ]);
              };
              return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("Expected token, met EOF");
          })());
      });
  };
  var stdin = (function () {
      var go = function (v) {
          if (v instanceof Language_Docopt_ParserGen_Token_1.Stdin) {
              return new Data_Maybe.Just(new Language_Docopt_Value_1.BoolValue(true));
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(token(go))("stdin flag");
  })();
  var shortOption = function (f) {
      return function (a) {
          var isFlag = Data_Maybe.isNothing(a);
          var go = function (v) {
              return function (v1) {
                  if (v instanceof Language_Docopt_ParserGen_Token_1.SOpt && (v.value0 === f && (!isFlag && Data_Array.length(v.value1) === 0))) {
                      if (v.value2 instanceof Data_Maybe.Just) {
                          return Prelude["return"](Data_Either.applicativeEither)(new OptParse(new Language_Docopt_Value_1.StringValue(v.value2.value0), Data_Maybe.Nothing.value, false));
                      };
                      return Prelude["return"](Data_Either.applicativeEither)((function () {
                          if (v1 instanceof Data_Maybe.Just && v1.value0 instanceof Language_Docopt_ParserGen_Token_1.Lit) {
                              return new OptParse(Language_Docopt_Value_1.read(v1.value0.value0)(false), Data_Maybe.Nothing.value, true);
                          };
                          return new OptParse(new Language_Docopt_Value_1.BoolValue(true), Data_Maybe.Nothing.value, false);
                      })());
                  };
                  if (v instanceof Language_Docopt_ParserGen_Token_1.SOpt && (v.value0 === f && (!isFlag && Data_Array.length(v.value1) > 0))) {
                      var a1 = Data_String_1.fromCharArray(v.value1) + Data_Maybe.maybe("")(function (v3) {
                          return "=" + v3;
                      })(v.value2);
                      return Prelude["return"](Data_Either.applicativeEither)(new OptParse(Language_Docopt_Value_1.read(a1)(false), Data_Maybe.Nothing.value, false));
                  };
                  if (v instanceof Language_Docopt_ParserGen_Token_1.SOpt && (v.value0 === f && (isFlag && Data_Array.length(v.value1) > 0))) {
                      return Prelude["return"](Data_Either.applicativeEither)(new OptParse(new Language_Docopt_Value_1.BoolValue(true), Data_Maybe.Just.create(new Language_Docopt_ParserGen_Token_1.SOpt(Data_Array_Unsafe.head(v.value1), Data_Array_Unsafe.tail(v.value1), v.value2)), false));
                  };
                  if (v instanceof Language_Docopt_ParserGen_Token_1.SOpt && (v.value0 === f && (isFlag && Data_Array.length(v.value1) === 0))) {
                      if (v.value2 instanceof Data_Maybe.Just) {
                          return new Data_Either.Left("Option takes no argument");
                      };
                      if (v.value2 instanceof Data_Maybe.Nothing) {
                          return Prelude["return"](Data_Either.applicativeEither)(new OptParse(new Language_Docopt_Value_1.BoolValue(true), Data_Maybe.Nothing.value, false));
                      };
                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 280, column 9 - line 286, column 5: " + [ v.value2.constructor.name ]);
                  };
                  return Data_Either.Left.create("Invalid token" + (Prelude.show(Language_Docopt_ParserGen_Token_1.showToken)(v) + (" (input: " + (Prelude.show(Data_Maybe.showMaybe(Language_Docopt_ParserGen_Token_1.showToken))(v1) + ")"))));
              };
          };
          return Text_Parsing_Parser.ParserT(function (v) {
              return Prelude["return"](Control_Monad_Reader_Trans.applicativeReaderT(Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity)))((function () {
                  if (v.value0.input instanceof Data_List.Cons) {
                      var $143 = go(v.value0.input.value0.value0.token)(Prelude["<$>"](Data_Maybe.functorMaybe)(function ($358) {
                          return (function (v1) {
                              return v1.token;
                          })(Language_Docopt_ParserGen_Token_1.unPositionedToken($358));
                      })(Data_List.head(v.value0.input.value1)));
                      if ($143 instanceof Data_Either.Left) {
                          return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)($143.value0);
                      };
                      if ($143 instanceof Data_Either.Right) {
                          return {
                              consumed: Data_Maybe.maybe(true)(Prelude["const"](false))($143.value0.value1), 
                              input: (function () {
                                  var rest = (function () {
                                      if ($143.value0.value2) {
                                          return Data_List_Unsafe.tail(v.value0.input.value1);
                                      };
                                      if (!$143.value0.value2) {
                                          return v.value0.input.value1;
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 234, column 36 - line 235, column 24: " + [ $143.value0.value2.constructor.name ]);
                                  })();
                                  var pushed = Data_Maybe.maybe(Control_Plus.empty(Data_List.plusList))(function (v$prime) {
                                      return Data_List.singleton(new Language_Docopt_ParserGen_Token_1.PositionedToken({
                                          token: v$prime, 
                                          sourcePos: v.value0.position, 
                                          source: v.value0.input.value0.value0.source
                                      }));
                                  })($143.value0.value1);
                                  return Prelude["++"](Data_List.semigroupList)(pushed)(rest);
                              })(), 
                              result: new Data_Either.Right($143.value0.value0), 
                              position: Data_Maybe.maybe(v.value0.position)(function ($359) {
                                  return (function (v2) {
                                      return v2.sourcePos;
                                  })(Language_Docopt_ParserGen_Token_1.unPositionedToken($359));
                              })(Data_List.head(v.value0.input.value1))
                          };
                      };
                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 222, column 7 - line 241, column 5: " + [ $143.constructor.name ]);
                  };
                  return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("Expected token, met EOF");
              })());
          });
      };
  };
  var semigroupScoredResult = function (dictSemigroup) {
      return new Prelude.Semigroup(function (v) {
          return function (v1) {
              return {
                  score: v.score + v1.score | 0, 
                  result: Prelude["++"](dictSemigroup)(v.result)(v1.result)
              };
          };
      });
  };
  var score = function (score1) {
      return function (result) {
          return {
              score: score1, 
              result: result
          };
      };
  };
  var rmapScoreResult = function (f) {
      return function (v) {
          return ScoredResult((function () {
              var $162 = {};
              for (var $163 in v) {
                  if (v.hasOwnProperty($163)) {
                      $162[$163] = v[$163];
                  };
              };
              $162.result = f(v.result);
              return $162;
          })());
      };
  };
  var positional = function (n) {
      var go = function (v) {
          if (v instanceof Language_Docopt_ParserGen_Token_1.Lit) {
              return new Data_Maybe.Just(Language_Docopt_Value_1.read(v.value0)(false));
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(token(go))("positional argument " + Prelude.show(Prelude.showString)(n));
  };
  var monoidScoredResult = function (dictMonoid) {
      return new Data_Monoid.Monoid(function () {
          return semigroupScoredResult(dictMonoid["__superclass_Prelude.Semigroup_0"]());
      }, {
          score: 0, 
          result: Data_Monoid.mempty(dictMonoid)
      });
  };
  var longOption = function (n) {
      return function (a) {
          var isFlag = Data_Maybe.isNothing(a);
          var go = function (v) {
              return function (v1) {
                  if (v instanceof Language_Docopt_ParserGen_Token_1.LOpt && (!isFlag && v.value0 === n)) {
                      if (v.value1 instanceof Data_Maybe.Just) {
                          return Prelude["return"](Data_Either.applicativeEither)(new OptParse(Language_Docopt_Value_1.read(v.value1.value0)(false), Data_Maybe.Nothing.value, false));
                      };
                      return Prelude["return"](Data_Either.applicativeEither)((function () {
                          if (v1 instanceof Data_Maybe.Just && v1.value0 instanceof Language_Docopt_ParserGen_Token_1.Lit) {
                              return new OptParse(Language_Docopt_Value_1.read(v1.value0.value0)(false), Data_Maybe.Nothing.value, true);
                          };
                          return new OptParse(new Language_Docopt_Value_1.BoolValue(true), Data_Maybe.Nothing.value, false);
                      })());
                  };
                  if (v instanceof Language_Docopt_ParserGen_Token_1.LOpt && (isFlag && v.value0 === n)) {
                      if (v.value1 instanceof Data_Maybe.Just) {
                          return new Data_Either.Left("Option takes no argument");
                      };
                      if (v.value1 instanceof Data_Maybe.Nothing) {
                          return Prelude["return"](Data_Either.applicativeEither)(new OptParse(new Language_Docopt_Value_1.BoolValue(true), Data_Maybe.Nothing.value, false));
                      };
                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 204, column 9 - line 211, column 5: " + [ v.value1.constructor.name ]);
                  };
                  if (v instanceof Language_Docopt_ParserGen_Token_1.LOpt && (v.value1 instanceof Data_Maybe.Nothing && !isFlag)) {
                      var $180 = Data_String_1.stripPrefix(n)(v.value0);
                      if ($180 instanceof Data_Maybe.Just) {
                          return Prelude["return"](Data_Either.applicativeEither)(new OptParse(Language_Docopt_Value_1.read($180.value0)(false), Data_Maybe.Nothing.value, false));
                      };
                      return new Data_Either.Left("Invalid substring");
                  };
                  return Data_Either.Left.create("Invalid token" + (Prelude.show(Language_Docopt_ParserGen_Token_1.showToken)(v) + (" (input: " + (Prelude.show(Data_Maybe.showMaybe(Language_Docopt_ParserGen_Token_1.showToken))(v1) + ")"))));
              };
          };
          return Text_Parsing_Parser.ParserT(function (v) {
              return Prelude["return"](Control_Monad_Reader_Trans.applicativeReaderT(Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity)))((function () {
                  if (v.value0.input instanceof Data_List.Cons) {
                      var $186 = go(v.value0.input.value0.value0.token)(Prelude["<$>"](Data_Maybe.functorMaybe)(function ($360) {
                          return (function (v1) {
                              return v1.token;
                          })(Language_Docopt_ParserGen_Token_1.unPositionedToken($360));
                      })(Data_List.head(v.value0.input.value1)));
                      if ($186 instanceof Data_Either.Left) {
                          return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.input.value0.value0.sourcePos)($186.value0);
                      };
                      if ($186 instanceof Data_Either.Right) {
                          return {
                              consumed: Data_Maybe.maybe(true)(Prelude["const"](false))($186.value0.value1), 
                              input: (function () {
                                  var rest = (function () {
                                      if ($186.value0.value2) {
                                          return Data_List_Unsafe.tail(v.value0.input.value1);
                                      };
                                      if (!$186.value0.value2) {
                                          return v.value0.input.value1;
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 179, column 36 - line 180, column 24: " + [ $186.value0.value2.constructor.name ]);
                                  })();
                                  var pushed = Data_Maybe.maybe(Control_Plus.empty(Data_List.plusList))(function (v$prime) {
                                      return Data_List.singleton(new Language_Docopt_ParserGen_Token_1.PositionedToken({
                                          token: v$prime, 
                                          sourcePos: v.value0.position, 
                                          source: v.value0.input.value0.value0.source
                                      }));
                                  })($186.value0.value1);
                                  return Prelude["++"](Data_List.semigroupList)(pushed)(rest);
                              })(), 
                              result: new Data_Either.Right($186.value0.value0), 
                              position: Data_Maybe.maybe(v.value0.position)(function ($361) {
                                  return (function (v2) {
                                      return v2.sourcePos;
                                  })(Language_Docopt_ParserGen_Token_1.unPositionedToken($361));
                              })(Data_List.head(v.value0.input.value1))
                          };
                      };
                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 167, column 7 - line 186, column 5: " + [ $186.constructor.name ]);
                  };
                  return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("Expected token, met EOF");
              })());
          });
      };
  };  
  var eof = Text_Parsing_Parser.ParserT(function (v) {
      return Prelude["return"](Control_Monad_Reader_Trans.applicativeReaderT(Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity)))((function () {
          if (v.value0.input instanceof Data_List.Nil) {
              return {
                  consumed: false, 
                  input: v.value0.input, 
                  result: new Data_Either.Right(Prelude.unit), 
                  position: v.value0.position
              };
          };
          if (v.value0.input instanceof Data_List.Cons) {
              return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)((function () {
                  if (v.value0.input.value0.value0.token instanceof Language_Docopt_ParserGen_Token_1.LOpt) {
                      return "Unmatched option: " + v.value0.input.value0.value0.source;
                  };
                  if (v.value0.input.value0.value0.token instanceof Language_Docopt_ParserGen_Token_1.SOpt) {
                      return "Unmatched option: " + v.value0.input.value0.value0.source;
                  };
                  if (v.value0.input.value0.value0.token instanceof Language_Docopt_ParserGen_Token_1.EOA) {
                      return "Unmatched option: --";
                  };
                  if (v.value0.input.value0.value0.token instanceof Language_Docopt_ParserGen_Token_1.Stdin) {
                      return "Unmatched option: -";
                  };
                  if (v.value0.input.value0.value0.token instanceof Language_Docopt_ParserGen_Token_1.Lit) {
                      return "Unmatched command: " + v.value0.input.value0.value0.source;
                  };
                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 293, column 7 - line 303, column 1: " + [ v.value0.input.value0.value0.token.constructor.name ]);
              })());
          };
          throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 290, column 3 - line 303, column 1: " + [ v.value0.input.constructor.name ]);
      })());
  });
  var eoa = (function () {
      var go = function (v) {
          if (v instanceof Language_Docopt_ParserGen_Token_1.EOA) {
              return new Data_Maybe.Just(new Language_Docopt_Value_1.ArrayValue(Data_List.fromList(Data_Unfoldable.unfoldableArray)(v.value0)));
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(token(go))("--");
  })();
  var debug = false;
  var command = function (n) {
      var go = function (v) {
          if (v instanceof Language_Docopt_ParserGen_Token_1.Lit && v.value0 === n) {
              return new Data_Maybe.Just(new Language_Docopt_Value_1.BoolValue(true));
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(token(go))("command " + Prelude.show(Prelude.showString)(n));
  };
  var genBranchesParser = function (xs) {
      return function (term) {
          return function (optsFirst) {
              return function (canSkip) {
                  var fixMessage = function (m) {
                      return m;
                  };
                  var collect = function (s) {
                      return function (ps) {
                          return Prelude.flip(Data_Traversable.traverse(Data_List.traversableList)(Control_Monad_Reader_Trans.applicativeReaderT(Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity))))(ps)(function (p) {
                              return Prelude[">>="](Control_Monad_Reader_Trans.bindReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser.unParserT(p)(s))(function (o) {
                                  return Prelude.bind(Control_Monad_Reader_Trans.bindReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Control_Monad_Reader_Trans.monadTransReaderT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.get(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v) {
                                      return Prelude["return"](Control_Monad_Reader_Trans.applicativeReaderT(Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity)))(Data_Either.either(function (e) {
                                          return new Data_Either.Left({
                                              input: o.input, 
                                              consumed: o.consumed, 
                                              position: o.position, 
                                              result: {
                                                  error: e, 
                                                  depth: v
                                              }
                                          });
                                      })(function (r) {
                                          return new Data_Either.Right({
                                              input: o.input, 
                                              consumed: o.consumed, 
                                              position: o.position, 
                                              result: {
                                                  value: r, 
                                                  depth: v
                                              }
                                          });
                                      })(o.result));
                                  });
                              });
                          });
                      };
                  };
                  return function (v) {
                      return Prelude.bind(Control_Monad_Reader_Trans.bindReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Reader_Class.ask(Control_Monad_Reader_Trans.monadReaderReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(function (v1) {
                          var ps = Prelude["<#>"](Data_List.functorList)(xs)(function (x) {
                              return Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(rmapScoreResult(Data_Tuple.Tuple.create(x)))(genBranchParser(x)(optsFirst)(canSkip)))((function () {
                                  if (term) {
                                      return eof;
                                  };
                                  if (!term) {
                                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude.unit);
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 324, column 25 - line 327, column 7: " + [ term.constructor.name ]);
                              })());
                          });
                          var rs = Control_Monad_State_1.evalState(Control_Monad_Reader_Trans.runReaderT(collect(v)(ps))(v1))(0);
                          var rs$prime = Data_List.reverse(rs);
                          var winner = Control_Bind["=<<"](Data_Maybe.bindMaybe)(Data_Foldable.maximumBy(Data_List.foldableList)(Data_Function.on(Prelude.compare(Prelude.ordInt))(function ($364) {
                              return (function (v2) {
                                  return v2.score;
                              })(unScoredResult((function (v2) {
                                  return v2.value;
                              })((function (v2) {
                                  return v2.result;
                              })($364))));
                          })))(Data_List.last(Data_List.groupBy(Data_Function.on(Prelude.eq(Prelude.eqInt))(function ($365) {
                              return (function (v2) {
                                  return v2.depth;
                              })((function (v2) {
                                  return v2.result;
                              })($365));
                          }))(Data_List.sortBy(Data_Function.on(Prelude.compare(Prelude.ordInt))(function ($366) {
                              return (function (v2) {
                                  return v2.depth;
                              })((function (v2) {
                                  return v2.result;
                              })($366));
                          }))(Control_MonadPlus_Partial.mrights(Data_List.monadPlusList)(rs$prime)))));
                          var losers = Data_List.last(Data_List.groupBy(Data_Function.on(Prelude.eq(Prelude.eqInt))(function ($367) {
                              return (function (v2) {
                                  return v2.depth;
                              })((function (v2) {
                                  return v2.result;
                              })($367));
                          }))(Data_List.sortBy(Data_Function.on(Prelude.compare(Prelude.ordInt))(function ($368) {
                              return (function (v2) {
                                  return v2.depth;
                              })((function (v2) {
                                  return v2.result;
                              })($368));
                          }))(Control_MonadPlus_Partial.mlefts(Data_List.monadPlusList)(rs))));
                          return Prelude["return"](Control_Monad_Reader_Trans.applicativeReaderT(Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity)))(Data_Maybe["maybe'"](function (v2) {
                              return Data_Maybe.fromMaybe(Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("The impossible happened. Failure without error"))(Prelude.bind(Data_Maybe.bindMaybe)(losers)(function (v3) {
                                  var es$prime = (function () {
                                      var $230 = Data_List.length(v3) > 1;
                                      if ($230) {
                                          return Prelude.flip(Data_List.filter)(v3)(function (e) {
                                              var msg = (function (v4) {
                                                  return v4.message;
                                              })(unParseError(e.result.error));
                                              return !Data_String_Ext.startsWith("Expected")(msg);
                                          });
                                      };
                                      if (!$230) {
                                          return v3;
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 360, column 21 - line 365, column 13: " + [ $230.constructor.name ]);
                                  })();
                                  return Control_Alt["<|>"](Data_Maybe.altMaybe)(Prelude.bind(Data_Maybe.bindMaybe)(Data_List.last(es$prime))(function (v4) {
                                      return Prelude["return"](Data_Maybe.applicativeMaybe)((function () {
                                          var $232 = {};
                                          for (var $233 in v4) {
                                              if (v4.hasOwnProperty($233)) {
                                                  $232[$233] = v4[$233];
                                              };
                                          };
                                          $232.result = Data_Either.Left.create(v4.result.error);
                                          return $232;
                                      })());
                                  }))(Prelude["return"](Data_Maybe.applicativeMaybe)(Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("")));
                              }));
                          })(function (r) {
                              var $234 = {};
                              for (var $235 in r) {
                                  if (r.hasOwnProperty($235)) {
                                      $234[$235] = r[$235];
                                  };
                              };
                              $234.result = new Data_Either.Right(r.result.value);
                              return $234;
                          })(winner));
                      });
                  };
              };
          };
      };
  };
  var genBranchParser = function (v) {
      return function (optsFirst) {
          return function (canSkip) {
              var terminate = function (arg) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Language_Docopt_Parser_Base.getInput(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_List.showList(Language_Docopt_ParserGen_Token_1.showPositionedToken)))(function (v1) {
                      var rest = Prelude["<$>"](Data_List.functorList)(Data_Tuple.Tuple.create(arg))(Prelude["<$>"](Data_List.functorList)(function ($369) {
                          return Language_Docopt_Value_1.StringValue.create(Language_Docopt_ParserGen_Token_1.getSource($369));
                      })(v1));
                      return function (v2) {
                          return Prelude["return"](Control_Monad_Reader_Trans.applicativeReaderT(Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity)))({
                              consumed: true, 
                              input: Data_List.Nil.value, 
                              result: Prelude["return"](Data_Either.applicativeEither)({
                                  score: 1, 
                                  result: rest
                              }), 
                              position: v2.value0.position
                          });
                      };
                  });
              };
              var butGot = function (v1) {
                  if (v1 instanceof Data_List.Cons) {
                      return ", but got " + v1.value0.value0.source;
                  };
                  if (v1 instanceof Data_List.Nil) {
                      return "";
                  };
                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 677, column 5 - line 678, column 5: " + [ v1.constructor.name ]);
              };
              var genParser = function (v1) {
                  return function (v2) {
                      if (v1 instanceof Language_Docopt_Argument.Command) {
                          var go = Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(Data_Tuple.Tuple.create(v1))(command(v1.value0));
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Language_Docopt_Parser_Base.getInput(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_List.showList(Language_Docopt_ParserGen_Token_1.showPositionedToken)))(function (v3) {
                              return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(score(0))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))((function () {
                                  if (v1.value1) {
                                      return Data_List.some(Text_Parsing_Parser.alternativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Text_Parsing_Parser.lazyParserT)(go);
                                  };
                                  if (!v1.value1) {
                                      return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(Data_List.singleton)(go);
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 580, column 9 - line 581, column 9: " + [ v1.value1.constructor.name ]);
                              })())(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.modify(Control_Monad_Reader_Trans.monadStateReaderT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity)))(function (v4) {
                                  return 1 + v4 | 0;
                              })))))(Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("Expected " + (Language_Docopt_Argument.prettyPrintArg(v1) + butGot(v3))));
                          });
                      };
                      if (v1 instanceof Language_Docopt_Argument.EOA) {
                          return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(function ($370) {
                              return score(0)(Data_List.singleton(Data_Tuple.Tuple.create(v1)($370)));
                          })(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(eoa)(Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(new Language_Docopt_Value_1.ArrayValue([  ]))))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.modify(Control_Monad_Reader_Trans.monadStateReaderT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity)))(function (v3) {
                              return 1 + v3 | 0;
                          })))))(Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("Expected \"--\""));
                      };
                      if (v1 instanceof Language_Docopt_Argument.Stdin) {
                          return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(function ($371) {
                              return score(0)(Data_List.singleton(Data_Tuple.Tuple.create(v1)($371)));
                          })(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(stdin)(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.modify(Control_Monad_Reader_Trans.monadStateReaderT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity)))(function (v3) {
                              return 1 + v3 | 0;
                          })))))(Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("Expected \"-\""));
                      };
                      if (v1 instanceof Language_Docopt_Argument.Positional && (v1.value1 && optsFirst)) {
                          return terminate(v1);
                      };
                      if (v1 instanceof Language_Docopt_Argument.Positional) {
                          var go = Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(Data_Tuple.Tuple.create(v1))(positional(v1.value0));
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Language_Docopt_Parser_Base.getInput(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_List.showList(Language_Docopt_ParserGen_Token_1.showPositionedToken)))(function (v3) {
                              return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(score(0))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))((function () {
                                  if (v1.value1) {
                                      return Data_List.some(Text_Parsing_Parser.alternativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Text_Parsing_Parser.lazyParserT)(go);
                                  };
                                  if (!v1.value1) {
                                      return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(Data_List.singleton)(go);
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 607, column 9 - line 608, column 9: " + [ v1.value1.constructor.name ]);
                              })())(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.modify(Control_Monad_Reader_Trans.monadStateReaderT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity)))(function (v4) {
                                  return 1 + v4 | 0;
                              })))))(Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("Expected " + (Language_Docopt_Argument.prettyPrintArg(v1) + butGot(v3))));
                          });
                      };
                      if (v1 instanceof Language_Docopt_Argument.Group && (optsFirst && (Data_List.length(v1.value1) === 1 && Data_Foldable.all(Data_List.foldableList)(Prelude.booleanAlgebraBoolean)(function (v3) {
                          if (v3 instanceof Data_List.Cons && (v3.value0 instanceof Language_Docopt_Argument.Positional && v3.value1 instanceof Data_List.Nil)) {
                              return v3.value0.value1 || v1.value2;
                          };
                          return false;
                      })(v1.value1)))) {
                          return terminate(Data_List_Unsafe.head(Language_Docopt_Argument.runBranch(Data_List_Unsafe.head(v1.value1))));
                      };
                      if (v1 instanceof Language_Docopt_Argument.Option) {
                          var mkSoptParser = function (v3) {
                              return function (v4) {
                                  if (v3 instanceof Data_Maybe.Just) {
                                      return shortOption(v3.value0)(v4);
                                  };
                                  if (v3 instanceof Data_Maybe.Nothing) {
                                      return Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("flag");
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 628, column 11 - line 642, column 11: " + [ v3.constructor.name, v4.constructor.name ]);
                              };
                          };
                          var mkLoptParser = function (v3) {
                              return function (v4) {
                                  if (v3 instanceof Data_Maybe.Just) {
                                      return longOption(v3.value0)(v4);
                                  };
                                  if (v3 instanceof Data_Maybe.Nothing) {
                                      return Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("long name");
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 577, column 5 - line 586, column 5: " + [ v3.constructor.name, v4.constructor.name ]);
                              };
                          };
                          var isAnySopt = function (v3) {
                              if (v3 instanceof Language_Docopt_ParserGen_Token_1.SOpt) {
                                  return Prelude["return"](Data_Maybe.applicativeMaybe)(true);
                              };
                              return Prelude["return"](Data_Maybe.applicativeMaybe)(false);
                          };
                          var isAnyLopt = function (v3) {
                              if (v3 instanceof Language_Docopt_ParserGen_Token_1.LOpt) {
                                  return Prelude["return"](Data_Maybe.applicativeMaybe)(true);
                              };
                              return Prelude["return"](Data_Maybe.applicativeMaybe)(false);
                          };
                          var go = Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Text_Parsing_Parser_Combinators.option(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(false)(Text_Parsing_Parser_Combinators.lookAhead(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators["try"](Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(token(isAnyLopt)))))(function (v3) {
                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Text_Parsing_Parser_Combinators.option(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(false)(Text_Parsing_Parser_Combinators.lookAhead(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators["try"](Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(token(isAnySopt)))))(function (v4) {
                                  if (v3) {
                                      return Text_Parsing_Parser_Combinators["try"](Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(Data_Tuple.Tuple.create(v1))(mkLoptParser(v1.value0.name)(v1.value0.arg)));
                                  };
                                  if (!v3) {
                                      if (v4) {
                                          return Text_Parsing_Parser_Combinators["try"](Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(Data_Tuple.Tuple.create(v1))(mkSoptParser(v1.value0.flag)(v1.value0.arg)));
                                      };
                                      if (!v4) {
                                          return Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("long or short option");
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 638, column 21 - line 642, column 11: " + [ v4.constructor.name ]);
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 636, column 13 - line 642, column 11: " + [ v3.constructor.name ]);
                              });
                          });
                          return Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(score(0))((function () {
                              if (v1.value0.repeatable) {
                                  return Data_List.some(Text_Parsing_Parser.alternativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Text_Parsing_Parser.lazyParserT)(go);
                              };
                              if (!v1.value0.repeatable) {
                                  return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(Data_List.singleton)(go);
                              };
                              throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 624, column 9 - line 625, column 7: " + [ v1.value0.repeatable.constructor.name ]);
                          })()))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.modify(Control_Monad_Reader_Trans.monadStateReaderT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity)))(function (v3) {
                              return 1 + v3 | 0;
                          })));
                      };
                      if (v1 instanceof Language_Docopt_Argument.Group) {
                          var step = Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(rmapScoreResult(Data_Tuple.snd))(genBranchesParser(v1.value1)(false)(optsFirst)(!Language_Docopt_Argument.isFree(v1) || v2));
                          var go = (function () {
                              if (Data_List.length(v1.value1) === 0) {
                                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Data_Monoid.mempty(monoidScoredResult(Data_List.monoidList)));
                              };
                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(step)(function (v3) {
                                  var $292 = v1.value2 && Data_List.length((function (v4) {
                                      return v4.result;
                                  })(unScoredResult(v3))) > 0;
                                  if ($292) {
                                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(step)(Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Data_Monoid.mempty(monoidScoredResult(Data_List.monoidList)))))(function (v4) {
                                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["++"](semigroupScoredResult(Data_List.semigroupList))(v3)(v4));
                                      });
                                  };
                                  if (!$292) {
                                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(v3);
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 663, column 11 - line 669, column 9: " + [ $292.constructor.name ]);
                              });
                          })();
                          var mod = (function () {
                              if (v1.value0) {
                                  return function ($372) {
                                      return Text_Parsing_Parser_Combinators.option(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Monoid.mempty(monoidScoredResult(Data_List.monoidList)))(Text_Parsing_Parser_Combinators["try"](Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))($372));
                                  };
                              };
                              if (!v1.value0) {
                                  return function (p) {
                                      return p;
                                  };
                              };
                              throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 657, column 17 - line 658, column 8: " + [ v1.value0.constructor.name ]);
                          })();
                          return mod(go);
                      };
                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 577, column 5 - line 586, column 5: " + [ v1.constructor.name, v2.constructor.name ]);
                  };
              };
              var genExhaustiveParser = function (v1) {
                  return function (canSkip2) {
                      if (v1 instanceof Data_List.Nil) {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Data_Monoid.mempty(monoidScoredResult(Data_List.monoidList)));
                      };
                      var draw = function (v2) {
                          return function (v3) {
                              return function (v4) {
                                  if (v2 instanceof Data_List.Cons && v3 >= 0) {
                                      return Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))((function () {
                                          if (debug) {
                                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Language_Docopt_Parser_Base.getInput(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_List.showList(Language_Docopt_ParserGen_Token_1.showPositionedToken)))(function (v5) {
                                                  return Debug_Trace.traceA(Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))("draw: (" + (Language_Docopt_Argument.prettyPrintArg(v2.value0) + (":" + (Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(":")(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Argument.prettyPrintArg)(v2.value1)) + (") - n: " + (Prelude.show(Prelude.showInt)(v3) + ("from input: " + Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(" ")(Prelude["<$>"](Data_List.functorList)(function ($373) {
                                                      return Language_Docopt_ParserGen_Token_1.prettyPrintToken((function (v6) {
                                                          return v6.token;
                                                      })(Language_Docopt_ParserGen_Token_1.unPositionedToken($373)));
                                                  })(v5)))))))));
                                              });
                                          };
                                          if (!debug) {
                                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude.unit);
                                          };
                                          throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 434, column 11 - line 450, column 11: " + [ debug.constructor.name ]);
                                      })())(function () {
                                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(unScoredResult)(Text_Parsing_Parser_Combinators["try"](Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(genParser(Language_Docopt_Argument.setRequired(v2.value0)(true))(!(v3 > 0)))))(function (v5) {
                                              var missing = Prelude["<$>"](Data_List.functorList)(Data_Tuple.fst)(Prelude.flip(Data_List.filter)(v5.result)(function (v6) {
                                                  return Data_Maybe.fromMaybe(false)(Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Option.runArgument)(Language_Docopt_Argument.getArgument(v6.value0)))(function (v8) {
                                                      return Prelude["return"](Data_Maybe.applicativeMaybe)(!v8.optional);
                                                  })) && (!Language_Docopt_Argument.isFlag(v6.value0) && Language_Docopt_Value_1.isBoolValue(v6.value1));
                                              }));
                                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))((function () {
                                                  var $310 = Data_List.length(missing) === 0;
                                                  if ($310) {
                                                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude.unit);
                                                  };
                                                  if (!$310) {
                                                      return Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("Missing required arguments for " + Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(", ")(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Argument.prettyPrintArgNaked)(missing)));
                                                  };
                                                  throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 465, column 11 - line 470, column 11: " + [ $310.constructor.name ]);
                                              })())(function () {
                                                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(unScoredResult)(Text_Parsing_Parser_Combinators["try"](Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))((function () {
                                                      var $311 = Language_Docopt_Argument.isRepeatable(v2.value0);
                                                      if ($311) {
                                                          return draw(v2)(Data_List.length(v2))(Data_List[":"](v2.value0)(v4));
                                                      };
                                                      if (!$311) {
                                                          return draw(v2.value1)(Data_List.length(v2.value1))(Data_List[":"](v2.value0)(v4));
                                                      };
                                                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 471, column 19 - line 475, column 11: " + [ $311.constructor.name ]);
                                                  })())))(function (v6) {
                                                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["++"](semigroupScoredResult(Data_List.semigroupList))(v5)(v6));
                                                  });
                                              });
                                          });
                                      }))(Control_Lazy.defer(Text_Parsing_Parser.lazyParserT)(function (v5) {
                                          return draw(Prelude["++"](Data_List.semigroupList)(v2.value1)(Data_List.singleton(v2.value0)))(v3 - 1)(v4);
                                      }));
                                  };
                                  if (Data_List.length(v2) > 0 && v3 < 0) {
                                      var isSkippable = function (env) {
                                          return function (v5) {
                                              if (v5 instanceof Language_Docopt_Argument.Group) {
                                                  return v5.value0 || Data_Foldable.all(Data_List.foldableList)(Prelude.booleanAlgebraBoolean)(function ($374) {
                                                      return Data_Foldable.all(Data_List.foldableList)(Prelude.booleanAlgebraBoolean)(isSkippable(env))(Language_Docopt_Argument.runBranch($374));
                                                  })(v5.value1);
                                              };
                                              return Language_Docopt_Argument.hasDefault(v5) || (Data_Maybe.maybe(true)(Prelude.id(Prelude.categoryFn))(Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Option.runArgument)(Language_Docopt_Argument.getArgument(v5)))(function (v6) {
                                                  return Prelude["return"](Data_Maybe.applicativeMaybe)(v6.optional);
                                              })) || (Language_Docopt_Argument.hasEnvBacking(v5)(env) || Language_Docopt_Argument.isRepeatable(v5) && Data_Foldable.any(Data_List.foldableList)(Prelude.booleanAlgebraBoolean)(function (v6) {
                                                  return Prelude["=="](Language_Docopt_Argument.eqArgument)(v6)(v5);
                                              })(v4)));
                                          };
                                      };
                                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Reader_Class.ask(Control_Monad_Reader_Trans.monadReaderReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))))(function (v5) {
                                          var missing = Data_List.filter(function (o) {
                                              return !((canSkip2 || Data_List.length(v2) < Data_List.length(v1)) && isSkippable(v5)(o));
                                          })(v2);
                                          var $323 = Data_List.length(missing) > 0;
                                          if ($323) {
                                              return Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("Expected option(s): " + Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(", ")(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Argument.prettyPrintArgNaked)(missing)));
                                          };
                                          if (!$323) {
                                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))({
                                                  score: Data_Foldable.sum(Data_List.foldableList)(Prelude.semiringInt)(Prelude["<#>"](Data_List.functorList)(v2)(function (o) {
                                                      var $324 = Language_Docopt_Argument.hasEnvBacking(o)(v5);
                                                      if ($324) {
                                                          return 2;
                                                      };
                                                      if (!$324) {
                                                          var $325 = Language_Docopt_Argument.hasDefault(o);
                                                          if ($325) {
                                                              return 1;
                                                          };
                                                          if (!$325) {
                                                              return 0;
                                                          };
                                                          throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 499, column 34 - line 502, column 13: " + [ $325.constructor.name ]);
                                                      };
                                                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 497, column 25 - line 502, column 13: " + [ $324.constructor.name ]);
                                                  })), 
                                                  result: Data_List.Nil.value
                                              });
                                          };
                                          throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 491, column 11 - line 505, column 11: " + [ $323.constructor.name ]);
                                      });
                                  };
                                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Data_Monoid.mempty(monoidScoredResult(Data_List.monoidList)));
                              };
                          };
                      };
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))((function () {
                          if (debug) {
                              return Debug_Trace.traceA(Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))("genExhaustiveParser: " + (Data_Foldable.intercalate(Data_List.foldableList)(Data_Monoid.monoidString)(" ")(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Argument.prettyPrintArg)(v1)) + (" - canSkip: " + Prelude.show(Prelude.showBoolean)(canSkip2))));
                          };
                          if (!debug) {
                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude.unit);
                          };
                          throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 418, column 7 - line 424, column 7: " + [ debug.constructor.name ]);
                      })())(function () {
                          return draw(v1)(Data_List.length(v1))(Data_List.Nil.value);
                      });
                  };
              };
              var step = function (v1) {
                  return function (v2) {
                      if (v1 instanceof Free && v2 instanceof Language_Docopt_Argument.Option) {
                          return Prelude["return"](Data_Either.applicativeEither)(new Pending(v1.value0, Data_List.singleton(v2)));
                      };
                      if (v1 instanceof Free && (v2 instanceof Language_Docopt_Argument.Group && Language_Docopt_Argument.isFree(v2))) {
                          return Prelude["return"](Data_Either.applicativeEither)(new Pending(v1.value0, Data_List.singleton(v2)));
                      };
                      if (v1 instanceof Free) {
                          return Data_Either.Right.create(new Free(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(v1.value0)(function (v3) {
                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(genParser(v2)(false))(function (v4) {
                                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["++"](semigroupScoredResult(Data_List.semigroupList))(v3)(v4));
                              });
                          })));
                      };
                      if (v1 instanceof Pending && v2 instanceof Language_Docopt_Argument.Option) {
                          return Prelude["return"](Data_Either.applicativeEither)(new Pending(v1.value0, Data_List[":"](v2)(v1.value1)));
                      };
                      if (v1 instanceof Pending && (v2 instanceof Language_Docopt_Argument.Group && Language_Docopt_Argument.isFree(v2))) {
                          return Prelude["return"](Data_Either.applicativeEither)(new Pending(v1.value0, Data_List[":"](v2)(v1.value1)));
                      };
                      if (v1 instanceof Pending) {
                          return Data_Either.Right.create(new Free(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(v1.value0)(function (v3) {
                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(genExhaustiveParser(v1.value1)(true))(function (v4) {
                                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(genParser(v2)(false))(function (v5) {
                                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["++"](semigroupScoredResult(Data_List.semigroupList))(v3)(Prelude["++"](semigroupScoredResult(Data_List.semigroupList))(v4)(v5)));
                                  });
                              });
                          })));
                      };
                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 525, column 5 - line 529, column 5: " + [ v1.constructor.name, v2.constructor.name ]);
                  };
              };
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_State_Class.put(Control_Monad_Reader_Trans.monadStateReaderT(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity)))(0)))(function () {
                  return Data_Either.either(function (v1) {
                      return Text_Parsing_Parser.fail(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))("Failed to generate parser");
                  })(function (acc) {
                      if (acc instanceof Free) {
                          return acc.value0;
                      };
                      if (acc instanceof Pending) {
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(acc.value0)(function (v1) {
                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(genExhaustiveParser(Data_List.reverse(acc.value1))(canSkip))(function (v2) {
                                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude["++"](semigroupScoredResult(Data_List.semigroupList))(v1)(v2));
                              });
                          });
                      };
                      throw new Error("Failed pattern match at Language.Docopt.ParserGen.Parser line 401, column 14 - line 407, column 5: " + [ acc.constructor.name ]);
                  })(Data_List.foldM(Data_Either.monadEither)(step)(Free.create(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Data_Monoid.mempty(monoidScoredResult(Data_List.monoidList)))))(v));
              });
          };
      };
  };
  var genUsageParser = function (xs) {
      return function (optsFirst) {
          return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_Reader_Trans.functorReaderT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))))(function ($375) {
              return (function (v) {
                  return v.result;
              })(unScoredResult($375));
          })(genBranchesParser(Data_List.concat(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Usage.runUsage)(xs)))(true)(optsFirst)(true));
      };
  };
  exports["genUsageParser"] = genUsageParser;
})(PS["Language.Docopt.ParserGen.Parser"] = PS["Language.Docopt.ParserGen.Parser"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Debug_Trace = PS["Debug.Trace"];
  var Data_Either = PS["Data.Either"];
  var Data_Maybe = PS["Data.Maybe"];
  var Control_Apply = PS["Control.Apply"];
  var Control_Alt = PS["Control.Alt"];
  var Data_String = PS["Data.String"];
  var Data_List = PS["Data.List"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Combinators = PS["Text.Parsing.Parser.Combinators"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Text_Parsing_Parser_String = PS["Text.Parsing.Parser.String"];
  var Data_Array = PS["Data.Array"];
  var Control_Plus = PS["Control.Plus"];
  var Language_Docopt_ParserGen_Token = PS["Language.Docopt.ParserGen.Token"];
  var Language_Docopt_Parser_Base = PS["Language.Docopt.Parser.Base"];
  var Language_Docopt_Value = PS["Language.Docopt.Value"];
  var Data_Identity = PS["Data.Identity"];
  var Data_Foldable = PS["Data.Foldable"];        
  var parseToken = (function () {
      var stdin = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("-"))(function () {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity))(function () {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(Language_Docopt_ParserGen_Token.Stdin.value);
          });
      });
      var lit = Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(function ($22) {
          return Language_Docopt_ParserGen_Token.Lit.create(Data_String.fromCharArray($22));
      })(Data_Array.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.anyChar(Data_Identity.monadIdentity)));
      var eoa = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("--"))(function () {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity))(function () {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new Language_Docopt_ParserGen_Token.EOA(Control_Plus.empty(Data_List.plusList)));
          });
      });
      var arg = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("="))(function () {
          return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_String.fromCharArray)(Data_Array.some(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.anyChar(Data_Identity.monadIdentity)));
      });
      var lopt = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("--"))(function () {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_String.fromCharArray)(Data_Array.some(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ "=" ]))))(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.optionMaybe(Data_Identity.monadIdentity)(arg))(function (v1) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity))(function () {
                      return Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new Language_Docopt_ParserGen_Token.LOpt(v, v1));
                  });
              });
          });
      });
      var sopt = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("-"))(function () {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Base.alphaNum(Data_Identity.monadIdentity))(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_Array.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ "=" ])))(function (v1) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.optionMaybe(Data_Identity.monadIdentity)(arg))(function (v2) {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity))(function () {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new Language_Docopt_ParserGen_Token.SOpt(v, v1, v2));
                      });
                  });
              });
          });
      });
      return Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(stdin)(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity)), Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(sopt)(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity)), Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(lopt)(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity)), Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(eoa)(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity)), Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(lit)(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity)) ]));
  })();
  var lex = function (xs) {
      var go = function (v) {
          return function (v1) {
              if (v instanceof Data_List.Nil) {
                  return Prelude["return"](Data_Either.applicativeEither)(Data_List.Nil.value);
              };
              if (v instanceof Data_List.Cons) {
                  return Prelude.bind(Data_Either.bindEither)(Text_Parsing_Parser.runParser(v.value0)(parseToken))(function (v2) {
                      if (v2 instanceof Language_Docopt_ParserGen_Token.EOA) {
                          return Prelude["return"](Data_Either.applicativeEither)(Data_List.singleton(new Language_Docopt_ParserGen_Token.PositionedToken({
                              token: new Language_Docopt_ParserGen_Token.EOA(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Value.StringValue.create)(v.value1)), 
                              sourcePos: new Text_Parsing_Parser_Pos.Position({
                                  line: 1, 
                                  column: v1
                              }), 
                              source: v.value0
                          })));
                      };
                      return Prelude.bind(Data_Either.bindEither)(go(v.value1)(v1 + 1 | 0))(function (v3) {
                          return Prelude["return"](Data_Either.applicativeEither)(Prelude["++"](Data_List.semigroupList)(Data_List.singleton(new Language_Docopt_ParserGen_Token.PositionedToken({
                              token: v2, 
                              sourcePos: new Text_Parsing_Parser_Pos.Position({
                                  line: 1, 
                                  column: v1
                              }), 
                              source: v.value0
                          })))(v3));
                      });
                  });
              };
              throw new Error("Failed pattern match at Language.Docopt.ParserGen.Lexer line 88, column 1 - line 107, column 31: " + [ v.constructor.name, v1.constructor.name ]);
          };
      };
      return go(xs)(1);
  };
  exports["lex"] = lex;
})(PS["Language.Docopt.ParserGen.Lexer"] = PS["Language.Docopt.ParserGen.Lexer"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_List = PS["Data.List"];
  var Data_Either = PS["Data.Either"];
  var Data_Tuple = PS["Data.Tuple"];
  var Control_Monad_Reader_Trans = PS["Control.Monad.Reader.Trans"];
  var Control_Monad_State = PS["Control.Monad.State"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Language_Docopt_Argument = PS["Language.Docopt.Argument"];
  var Language_Docopt_Usage = PS["Language.Docopt.Usage"];
  var Language_Docopt_Env = PS["Language.Docopt.Env"];
  var Language_Docopt_ParserGen_Token = PS["Language.Docopt.ParserGen.Token"];
  var Language_Docopt_ParserGen_Parser = PS["Language.Docopt.ParserGen.Parser"];
  var Language_Docopt_ParserGen_Lexer = PS["Language.Docopt.ParserGen.Lexer"];
  var Language_Docopt_ParserGen_ValueMapping = PS["Language.Docopt.ParserGen.ValueMapping"];
  var Control_Monad_State_Trans = PS["Control.Monad.State.Trans"];
  var Data_Identity = PS["Data.Identity"];
  var Data_Foldable = PS["Data.Foldable"];        
  var runParser = function (env) {
      return function (argv) {
          return function (p) {
              var go = function (i) {
                  return Text_Parsing_Parser.runParserT(Control_Monad_Reader_Trans.monadReaderT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(new Text_Parsing_Parser.PState({
                      input: i, 
                      position: Text_Parsing_Parser_Pos.initialPos
                  }));
              };
              return Prelude.bind(Data_Either.bindEither)(Language_Docopt_ParserGen_Lexer.lex(Data_List.toList(Data_Foldable.foldableArray)(argv)))(function (v) {
                  return Control_Monad_State.evalState(Control_Monad_Reader_Trans.runReaderT(go(v)(p))(env))(0);
              });
          };
      };
  };
  var genParser = function (us) {
      return function (optsFirst) {
          return Language_Docopt_ParserGen_Parser.genUsageParser(us)(optsFirst);
      };
  };
  exports["runParser"] = runParser;
  exports["genParser"] = genParser;
})(PS["Language.Docopt.ParserGen"] = PS["Language.Docopt.ParserGen"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Bifunctor = PS["Data.Bifunctor"];
  var Data_Array = PS["Data.Array"];
  var Data_StrMap_1 = PS["Data.StrMap"];
  var Data_StrMap_1 = PS["Data.StrMap"];
  var Data_Map_1 = PS["Data.Map"];
  var Data_String_1 = PS["Data.String"];
  var Data_Map_1 = PS["Data.Map"];
  var Data_String_1 = PS["Data.String"];
  var Data_Tuple = PS["Data.Tuple"];
  var Control_Alt = PS["Control.Alt"];
  var Data_Function = PS["Data.Function"];
  var Language_Docopt_Usage = PS["Language.Docopt.Usage"];
  var Language_Docopt_Env_1 = PS["Language.Docopt.Env"];
  var Language_Docopt_Value = PS["Language.Docopt.Value"];
  var Language_Docopt_Argument = PS["Language.Docopt.Argument"];
  var Language_Docopt_Option = PS["Language.Docopt.Option"];
  var Language_Docopt_Env_1 = PS["Language.Docopt.Env"];
  var Data_String_Ext = PS["Data.String.Ext"];
  var Data_List = PS["Data.List"];
  var Language_Docopt_ParserGen_ValueMapping = PS["Language.Docopt.ParserGen.ValueMapping"];
  var toKeys = function (v) {
      if (v instanceof Language_Docopt_Argument.Command) {
          return [ v.value0 ];
      };
      if (v instanceof Language_Docopt_Argument.Positional) {
          return [ "<" + (Data_String_1.toLower(v.value0) + ">"), Data_String_1.toUpper(v.value0) ];
      };
      if (v instanceof Language_Docopt_Argument.Group) {
          return [  ];
      };
      if (v instanceof Language_Docopt_Argument.EOA) {
          return [ "--" ];
      };
      if (v instanceof Language_Docopt_Argument.Stdin) {
          return [ "-" ];
      };
      if (v instanceof Language_Docopt_Argument.Option) {
          return Prelude["++"](Prelude.semigroupArray)([  ])(Prelude["++"](Prelude.semigroupArray)(Data_Maybe.maybe([  ])(function (c) {
              return [ "-" + Data_String_1.fromChar(c) ];
          })(v.value0.flag))(Data_Maybe.maybe([  ])(function (s) {
              return [ "--" + s ];
          })(v.value0.name)));
      };
      throw new Error("Failed pattern match at Language.Docopt.Trans line 235, column 1 - line 236, column 1: " + [ v.constructor.name ]);
  };
  var showKey = new Prelude.Show(function (v) {
      if (v.arg instanceof Language_Docopt_Argument.Option) {
          return Data_Maybe.maybe("")(function (c) {
              return Data_String_1.fromChar(c) + ", ";
          })(v.arg.value0.flag) + Data_Maybe.maybe("")(Prelude.id(Prelude.categoryFn))(v.arg.value0.name);
      };
      if (v.arg instanceof Language_Docopt_Argument.Positional) {
          return v.arg.value0;
      };
      if (v.arg instanceof Language_Docopt_Argument.Command) {
          return v.arg.value0;
      };
      return "invalid";
  });
  var key = function (arg) {
      return {
          arg: arg
      };
  };
  var eqKey = new Prelude.Eq(function (v) {
      return function (v1) {
          var go = function (v2) {
              return function (v3) {
                  if (v2 instanceof Language_Docopt_Argument.Positional && v3 instanceof Language_Docopt_Argument.Positional) {
                      return Data_String_Ext.upperCaseEq(v2.value0)(v3.value0);
                  };
                  if (v2 instanceof Language_Docopt_Argument.Option && v3 instanceof Language_Docopt_Argument.Option) {
                      return Prelude["=="](Data_Maybe.eqMaybe(Prelude.eqChar))(v2.value0.flag)(v3.value0.flag) && Prelude["=="](Data_Maybe.eqMaybe(Prelude.eqString))(v2.value0.name)(v3.value0.name);
                  };
                  if (v2 instanceof Language_Docopt_Argument.Command && v3 instanceof Language_Docopt_Argument.Command) {
                      return v2.value0 === v3.value0;
                  };
                  return Prelude["=="](Language_Docopt_Argument.eqArgument)(v2)(v3);
              };
          };
          return go(v.arg)(v1.arg);
      };
  });
  var ordKey = new Prelude.Ord(function () {
      return eqKey;
  }, Data_Function.on(Prelude.compare(Prelude.ordString))(Prelude.show(showKey)));
  var reduce = function (us) {
      return function (env) {
          return function (b) {
              return function (vs) {
                  var valIntoArray = function (v) {
                      if (v instanceof Language_Docopt_Value.ArrayValue) {
                          return v.value0;
                      };
                      return [ v ];
                  };
                  var resolveArg = function (v) {
                      return function (v$prime) {
                          return Language_Docopt_Value.ArrayValue.create(Prelude["++"](Prelude.semigroupArray)(valIntoArray(v$prime))(valIntoArray(v)));
                      };
                  };
                  var reduceUsages = function (us1) {
                      var resolveOR = function (v) {
                          return function (v1) {
                              if (v instanceof Language_Docopt_Argument.Option && v1 instanceof Language_Docopt_Argument.Option) {
                                  return new Language_Docopt_Argument.Option((function () {
                                      var $67 = {};
                                      for (var $68 in v.value0) {
                                          if (v.value0.hasOwnProperty($68)) {
                                              $67[$68] = v.value0[$68];
                                          };
                                      };
                                      $67.arg = Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Option.runArgument)(Control_Alt["<|>"](Data_Maybe.altMaybe)(v.value0.arg)(v1.value0.arg)))(function (v2) {
                                          return Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Option.runArgument)(Control_Alt["<|>"](Data_Maybe.altMaybe)(v1.value0.arg)(v.value0.arg)))(function (v3) {
                                              return Prelude["return"](Data_Maybe.applicativeMaybe)({
                                                  name: v2.name, 
                                                  "default": Control_Alt["<|>"](Data_Maybe.altMaybe)(v2["default"])(v3["default"]), 
                                                  optional: v2.optional || v3.optional
                                              });
                                          });
                                      });
                                      $67.repeatable = v.value0.repeatable || v1.value0.repeatable;
                                      return $67;
                                  })());
                              };
                              return Language_Docopt_Argument.setRepeatable(v)(Language_Docopt_Argument.isRepeatable(v) || Language_Docopt_Argument.isRepeatable(v1));
                          };
                      };
                      var resolveLCD = function (v) {
                          return function (v1) {
                              if (v instanceof Language_Docopt_Argument.Option && v1 instanceof Language_Docopt_Argument.Option) {
                                  return new Language_Docopt_Argument.Option((function () {
                                      var $75 = {};
                                      for (var $76 in v.value0) {
                                          if (v.value0.hasOwnProperty($76)) {
                                              $75[$76] = v.value0[$76];
                                          };
                                      };
                                      $75.arg = Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Option.runArgument)(Control_Alt["<|>"](Data_Maybe.altMaybe)(v.value0.arg)(v1.value0.arg)))(function (v2) {
                                          return Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Option.runArgument)(Control_Alt["<|>"](Data_Maybe.altMaybe)(v1.value0.arg)(v.value0.arg)))(function (v3) {
                                              return Prelude["return"](Data_Maybe.applicativeMaybe)({
                                                  name: v2.name, 
                                                  "default": Control_Alt["<|>"](Data_Maybe.altMaybe)(v2["default"])(v3["default"]), 
                                                  optional: v2.optional || v3.optional
                                              });
                                          });
                                      });
                                      $75.repeatable = true;
                                      return $75;
                                  })());
                              };
                              return Language_Docopt_Argument.setRepeatable(v)(true);
                          };
                      };
                      var reduceBranches = function (bs) {
                          var combine = function (xs) {
                              return Data_Foldable.foldl(Data_List.foldableList)(Data_Map_1.unionWith(ordKey)(resolveLCD))(Data_Map_1.empty)(xs);
                          };
                          var ms = Prelude["<$>"](Data_List.functorList)(function ($120) {
                              return combine((function (v) {
                                  return Prelude["<$>"](Data_List.functorList)(expand)(v);
                              })(Language_Docopt_Argument.runBranch($120)));
                          })(bs);
                          return Data_Foldable.foldl(Data_List.foldableList)(Data_Map_1.unionWith(ordKey)(resolveOR))(Data_Map_1.empty)(ms);
                      };
                      var expand = function (v) {
                          if (v instanceof Language_Docopt_Argument.Group) {
                              return reduceBranches(Prelude["<$>"](Data_List.functorList)(function ($121) {
                                  return Language_Docopt_Argument.Branch((function (v1) {
                                      return Prelude["<$>"](Data_List.functorList)(Prelude.flip(Language_Docopt_Argument.setRepeatableOr)(v.value2))(v1);
                                  })(Language_Docopt_Argument.runBranch($121)));
                              })(v.value1));
                          };
                          return Data_Map_1.singleton(key(v))(v);
                      };
                      var ms = Prelude["<$>"](Data_List.functorList)(function ($122) {
                          return reduceBranches(Language_Docopt_Usage.runUsage($122));
                      })(us1);
                      return Data_Map_1.values(Data_Foldable.foldl(Data_List.foldableList)(Data_Map_1.unionWith(ordKey)(resolveLCD))(Data_Map_1.empty)(ms));
                  };
                  var prepare = function (v) {
                      if (Language_Docopt_Argument.isRepeatable(v.value0)) {
                          return new Data_Tuple.Tuple(v.value0, Language_Docopt_Value.ArrayValue.create(valIntoArray(v.value1)));
                      };
                      return v;
                  };
                  var getValue = function (vm) {
                      return function (a) {
                          return Data_Map_1.lookup(ordKey)(key(a))(vm);
                      };
                  };
                  var getEnvValue = function (v) {
                      if (v instanceof Language_Docopt_Argument.Option && v.value0.env instanceof Data_Maybe.Just) {
                          return Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Value.StringValue.create)(Language_Docopt_Env_1.lookup(v.value0.env.value0)(env));
                      };
                      return Data_Maybe.Nothing.value;
                  };
                  var getDefaultValue = function (v) {
                      if (v instanceof Language_Docopt_Argument.Option && (v.value0.arg instanceof Data_Maybe.Just && v.value0.arg.value0["default"] instanceof Data_Maybe.Just)) {
                          return Prelude["return"](Data_Maybe.applicativeMaybe)((function () {
                              var $91 = Language_Docopt_Value.isArrayValue((v.value0.arg.value0["default"]).value0) || !v.value0.repeatable;
                              if ($91) {
                                  return (v.value0.arg.value0["default"]).value0;
                              };
                              if (!$91) {
                                  return new Language_Docopt_Value.ArrayValue([ (v.value0.arg.value0["default"]).value0 ]);
                              };
                              throw new Error("Failed pattern match at Language.Docopt.Trans line 213, column 9 - line 218, column 5: " + [ $91.constructor.name ]);
                          })());
                      };
                      if (v instanceof Language_Docopt_Argument.Option && v.value0.arg instanceof Data_Maybe.Nothing) {
                          return Prelude["return"](Data_Maybe.applicativeMaybe)((function () {
                              if (v.value0.repeatable) {
                                  return new Language_Docopt_Value.ArrayValue([ new Language_Docopt_Value.BoolValue(false) ]);
                              };
                              if (!v.value0.repeatable) {
                                  return new Language_Docopt_Value.BoolValue(false);
                              };
                              throw new Error("Failed pattern match at Language.Docopt.Trans line 219, column 9 - line 221, column 5: " + [ v.value0.repeatable.constructor.name ]);
                          })());
                      };
                      if (v instanceof Language_Docopt_Argument.Positional) {
                          if (v.value1) {
                              return Prelude["return"](Data_Maybe.applicativeMaybe)(new Language_Docopt_Value.ArrayValue([  ]));
                          };
                          if (!v.value1) {
                              return Data_Maybe.Nothing.value;
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Trans line 222, column 9 - line 224, column 5: " + [ v.value1.constructor.name ]);
                      };
                      if (v instanceof Language_Docopt_Argument.Command) {
                          if (v.value1) {
                              return Prelude["return"](Data_Maybe.applicativeMaybe)(new Language_Docopt_Value.ArrayValue([ new Language_Docopt_Value.BoolValue(false) ]));
                          };
                          if (!v.value1) {
                              return Prelude["return"](Data_Maybe.applicativeMaybe)(new Language_Docopt_Value.BoolValue(false));
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Trans line 225, column 9 - line 227, column 5: " + [ v.value1.constructor.name ]);
                      };
                      if (v instanceof Language_Docopt_Argument.Stdin) {
                          return Prelude["return"](Data_Maybe.applicativeMaybe)(new Language_Docopt_Value.BoolValue(false));
                      };
                      if (v instanceof Language_Docopt_Argument.EOA) {
                          return Data_Maybe.Just.create(new Language_Docopt_Value.ArrayValue([  ]));
                      };
                      return Data_Maybe.Nothing.value;
                  };
                  var getFallback = function (a) {
                      return Control_Alt["<|>"](Data_Maybe.altMaybe)(getEnvValue(a))(getDefaultValue(a));
                  };
                  var expandMap = function (m) {
                      return Data_StrMap_1.fromFoldable(Data_List.foldableList)(Data_List.concat(Prelude["<#>"](Data_List.functorList)(Data_Map_1.toList(m))(function (v) {
                          var v$prime = (function () {
                              var $107 = Language_Docopt_Argument.isFlag(v.value0.arg) || Language_Docopt_Argument.isCommand(v.value0.arg);
                              if ($107) {
                                  if (v.value1 instanceof Language_Docopt_Value.ArrayValue) {
                                      return new Language_Docopt_Value.IntValue(Data_Array.length(Prelude.flip(Data_Array.filter)(v.value1.value0)(function (x) {
                                          if (x instanceof Language_Docopt_Value.BoolValue && x.value0) {
                                              return true;
                                          };
                                          return false;
                                      })));
                                  };
                                  if (v.value1 instanceof Language_Docopt_Value.BoolValue) {
                                      var $112 = Language_Docopt_Argument.isRepeatable(v.value0.arg);
                                      if ($112) {
                                          if (v.value1.value0) {
                                              return new Language_Docopt_Value.IntValue(1);
                                          };
                                          if (!v.value1.value0) {
                                              return new Language_Docopt_Value.IntValue(0);
                                          };
                                          throw new Error("Failed pattern match at Language.Docopt.Trans line 116, column 39 - line 117, column 34: " + [ v.value1.value0.constructor.name ]);
                                      };
                                      if (!$112) {
                                          return v.value1;
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.Trans line 115, column 31 - line 118, column 29: " + [ $112.constructor.name ]);
                                  };
                                  return v.value1;
                              };
                              if (!$107) {
                                  return v.value1;
                              };
                              throw new Error("Failed pattern match at Language.Docopt.Trans line 106, column 25 - line 120, column 22: " + [ $107.constructor.name ]);
                          })();
                          return Prelude["<$>"](Data_List.functorList)(Prelude.flip(Data_Tuple.Tuple.create)(v$prime))(Data_List.toList(Data_Foldable.foldableArray)(toKeys(v.value0.arg)));
                      })));
                  };
                  var applyValues = function (vm) {
                      return function (as) {
                          return Data_Map_1.fromFoldableWith(ordKey)(Data_List.foldableList)(resolveArg)(Data_List.catMaybes(Prelude["<#>"](Data_List.functorList)(as)(function (a) {
                              return Prelude["<$>"](Data_Maybe.functorMaybe)(Data_Tuple.Tuple.create(key(a)))(Prelude.bind(Data_Maybe.bindMaybe)(Control_Alt["<|>"](Data_Maybe.altMaybe)(getValue(vm)(a))(getFallback(a)))(function (v) {
                                  return Prelude["return"](Data_Maybe.applicativeMaybe)((function () {
                                      var $119 = Language_Docopt_Argument.isRepeatable(a);
                                      if ($119) {
                                          return Language_Docopt_Value.ArrayValue.create(valIntoArray(v));
                                      };
                                      if (!$119) {
                                          return v;
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.Trans line 127, column 9 - line 131, column 5: " + [ $119.constructor.name ]);
                                  })());
                              }));
                          })));
                      };
                  };
                  var vm = Data_Map_1.fromFoldableWith(ordKey)(Data_List.foldableList)(resolveArg)(Prelude["<$>"](Data_List.functorList)(Data_Bifunctor.lmap(Data_Tuple.bifunctorTuple)(key))(Prelude["<$>"](Data_List.functorList)(prepare)(vs)));
                  var m = applyValues(vm)(reduceUsages(Data_List.singleton(Data_List.singleton(b))));
                  return expandMap(m);
              };
          };
      };
  };
  exports["reduce"] = reduce;
})(PS["Language.Docopt.Trans"] = PS["Language.Docopt.Trans"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Data_List = PS["Data.List"];
  var Data_Array = PS["Data.Array"];
  var Data_String_1 = PS["Data.String"];
  var Data_String_Regex_1 = PS["Data.String.Regex"];
  var Data_String_Regex_1 = PS["Data.String.Regex"];
  var Data_String_1 = PS["Data.String"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Either = PS["Data.Either"];
  var Data_Foldable = PS["Data.Foldable"];        
  var section = function (name) {
      return Data_String_Regex_1.regex("^([^\n]*" + (name + "[^\n]*:(?:.*$)\n?(?:(?:[ \t].*)?(?:\n|$))*)"))(Data_String_Regex_1.parseFlags("gmi"));
  };
  var fixSection = function (s) {
      return Data_String_Regex_1["replace'"](Data_String_Regex_1.regex("(^[^:]+:)")(Data_String_Regex_1.noFlags))(function (m) {
          return function (v) {
              return Data_String_1.fromCharArray(Data_Array.replicate(Data_String_1.length(m))(" "));
          };
      })(s);
  };
  var scan = function (text) {
      var sections = function (n) {
          return Data_Maybe.maybe(Data_List.Nil.value)(function ($7) {
              return Data_List.catMaybes(Data_List.toList(Data_Foldable.foldableArray)($7));
          })(Data_String_Regex_1.match(section(n))(text));
      };
      var fail = function (msg) {
          return Data_Either.Left.create(new Text_Parsing_Parser.ParseError({
              message: msg, 
              position: Text_Parsing_Parser_Pos.initialPos
          }));
      };
      return Prelude.bind(Data_Either.bindEither)((function () {
          var $3 = sections("usage");
          if ($3 instanceof Data_List.Nil) {
              return fail("No usage section found!");
          };
          if ($3 instanceof Data_List.Cons && $3.value1 instanceof Data_List.Nil) {
              return Prelude["return"](Data_Either.applicativeEither)($3.value0);
          };
          return fail("Multiple usage sections found!");
      })())(function (v) {
          return Prelude["return"](Data_Either.applicativeEither)({
              usage: fixSection(v), 
              options: Prelude["<$>"](Data_List.functorList)(fixSection)(sections("options"))
          });
      });
  };
  exports["scan"] = scan;
})(PS["Language.Docopt.Scanner"] = PS["Language.Docopt.Scanner"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Language.Docopt.Solver

  exports.undefined = undefined;
})(PS["Language.Docopt.Solver"] = PS["Language.Docopt.Solver"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Array = PS["Data.Array"];
  var Data_List_1 = PS["Data.List"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Apply = PS["Control.Apply"];
  var Control_Monad_State = PS["Control.Monad.State"];
  var Control_Monad_State_Trans = PS["Control.Monad.State.Trans"];
  var Data_Either = PS["Data.Either"];
  var Data_Identity = PS["Data.Identity"];
  var Data_List_1 = PS["Data.List"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_String = PS["Data.String"];
  var Data_String_Ext = PS["Data.String.Ext"];
  var Language_Docopt_Parser_Base = PS["Language.Docopt.Parser.Base"];
  var Language_Docopt_Parser_State = PS["Language.Docopt.Parser.State"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Combinators = PS["Text.Parsing.Parser.Combinators"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Text_Parsing_Parser_String = PS["Text.Parsing.Parser.String"];
  var Data_Unfoldable = PS["Data.Unfoldable"];
  var Data_Foldable = PS["Data.Foldable"];        
  var LParen = (function () {
      function LParen() {

      };
      LParen.value = new LParen();
      return LParen;
  })();
  var RParen = (function () {
      function RParen() {

      };
      RParen.value = new RParen();
      return RParen;
  })();
  var LSquare = (function () {
      function LSquare() {

      };
      LSquare.value = new LSquare();
      return LSquare;
  })();
  var RSquare = (function () {
      function RSquare() {

      };
      RSquare.value = new RSquare();
      return RSquare;
  })();
  var Dash = (function () {
      function Dash() {

      };
      Dash.value = new Dash();
      return Dash;
  })();
  var VBar = (function () {
      function VBar() {

      };
      VBar.value = new VBar();
      return VBar;
  })();
  var Colon = (function () {
      function Colon() {

      };
      Colon.value = new Colon();
      return Colon;
  })();
  var Comma = (function () {
      function Comma() {

      };
      Comma.value = new Comma();
      return Comma;
  })();
  var TripleDot = (function () {
      function TripleDot() {

      };
      TripleDot.value = new TripleDot();
      return TripleDot;
  })();
  var Reference = (function () {
      function Reference(value0) {
          this.value0 = value0;
      };
      Reference.create = function (value0) {
          return new Reference(value0);
      };
      return Reference;
  })();
  var LOpt = (function () {
      function LOpt(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      LOpt.create = function (value0) {
          return function (value1) {
              return new LOpt(value0, value1);
          };
      };
      return LOpt;
  })();
  var SOpt = (function () {
      function SOpt(value0, value1, value2) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
      };
      SOpt.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return new SOpt(value0, value1, value2);
              };
          };
      };
      return SOpt;
  })();
  var Tag = (function () {
      function Tag(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Tag.create = function (value0) {
          return function (value1) {
              return new Tag(value0, value1);
          };
      };
      return Tag;
  })();
  var Name = (function () {
      function Name(value0) {
          this.value0 = value0;
      };
      Name.create = function (value0) {
          return new Name(value0);
      };
      return Name;
  })();
  var ShoutName = (function () {
      function ShoutName(value0) {
          this.value0 = value0;
      };
      ShoutName.create = function (value0) {
          return new ShoutName(value0);
      };
      return ShoutName;
  })();
  var AngleName = (function () {
      function AngleName(value0) {
          this.value0 = value0;
      };
      AngleName.create = function (value0) {
          return new AngleName(value0);
      };
      return AngleName;
  })();
  var Garbage = (function () {
      function Garbage(value0) {
          this.value0 = value0;
      };
      Garbage.create = function (value0) {
          return new Garbage(value0);
      };
      return Garbage;
  })();
  var DoubleDash = (function () {
      function DoubleDash() {

      };
      DoubleDash.value = new DoubleDash();
      return DoubleDash;
  })();
  var PositionedToken = (function () {
      function PositionedToken(value0) {
          this.value0 = value0;
      };
      PositionedToken.create = function (value0) {
          return new PositionedToken(value0);
      };
      return PositionedToken;
  })();
  var Usage = (function () {
      function Usage() {

      };
      Usage.value = new Usage();
      return Usage;
  })();
  var Descriptions = (function () {
      function Descriptions() {

      };
      Descriptions.value = new Descriptions();
      return Descriptions;
  })();
  var token = function (test) {
      return Text_Parsing_Parser.ParserT(function (v) {
          return Prelude["return"](Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity))((function () {
              if (v.value0.input instanceof Data_List_1.Cons) {
                  var $49 = test(v.value0.input.value0.value0.token);
                  if ($49 instanceof Data_Maybe.Just) {
                      var nextpos = (function () {
                          if (v.value0.input.value1 instanceof Data_List_1.Cons) {
                              return v.value0.input.value1.value0.value0.sourcePos;
                          };
                          if (v.value0.input.value1 instanceof Data_List_1.Nil) {
                              return v.value0.input.value0.value0.sourcePos;
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 425, column 15 - line 428, column 11: " + [ v.value0.input.value1.constructor.name ]);
                      })();
                      return {
                          consumed: true, 
                          input: v.value0.input.value1, 
                          result: new Data_Either.Right($49.value0), 
                          position: nextpos
                      };
                  };
                  if ($49 instanceof Data_Maybe.Nothing) {
                      return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("a better error message!");
                  };
                  throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 422, column 7 - line 435, column 5: " + [ $49.constructor.name ]);
              };
              return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("expected token, met EOF");
          })());
      });
  };
  var tag = function (s) {
      var go = function (v) {
          if (v instanceof Tag && (v.value1 instanceof Data_Maybe.Just && Data_String_Ext.upperCaseEq(v.value0)(s))) {
              return new Data_Maybe.Just(v.value1.value0);
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(token(go))("tag: " + s);
  };
  var sopt = (function () {
      var go = function (v) {
          if (v instanceof SOpt) {
              return new Data_Maybe.Just({
                  flag: v.value0, 
                  stack: v.value1, 
                  arg: v.value2
              });
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(token(go))("short-option");
  })();
  var shoutName = (function () {
      var go = function (v) {
          if (v instanceof ShoutName) {
              return new Data_Maybe.Just(v.value0);
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(token(go))("NAME");
  })();
  var runTokenParser = function (s) {
      return function ($174) {
          return Prelude.flip(Control_Monad_State.evalState)({
              indentation: 0, 
              line: 0
          })(Text_Parsing_Parser.runParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(new Text_Parsing_Parser.PState({
              input: s, 
              position: Text_Parsing_Parser_Pos.initialPos
          }))($174));
      };
  };
  var reference = (function () {
      var go = function (v) {
          if (v instanceof Reference) {
              return new Data_Maybe.Just(v.value0);
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(token(go))("reference");
  })();
  var prettyPrintToken = function (v) {
      if (v instanceof LParen) {
          return Prelude.show(Prelude.showChar)("(");
      };
      if (v instanceof RParen) {
          return Prelude.show(Prelude.showChar)(")");
      };
      if (v instanceof LSquare) {
          return Prelude.show(Prelude.showChar)("[");
      };
      if (v instanceof RSquare) {
          return Prelude.show(Prelude.showChar)("]");
      };
      if (v instanceof Dash) {
          return Prelude.show(Prelude.showChar)("-");
      };
      if (v instanceof VBar) {
          return Prelude.show(Prelude.showChar)("|");
      };
      if (v instanceof Colon) {
          return Prelude.show(Prelude.showChar)(":");
      };
      if (v instanceof Comma) {
          return Prelude.show(Prelude.showChar)(",");
      };
      if (v instanceof TripleDot) {
          return "...";
      };
      if (v instanceof DoubleDash) {
          return "--";
      };
      if (v instanceof Reference) {
          return "Reference " + Prelude.show(Prelude.showString)(v.value0);
      };
      if (v instanceof Garbage) {
          return "Garbage " + Prelude.show(Prelude.showChar)(v.value0);
      };
      if (v instanceof Tag) {
          return "Tag " + (v.value0 + (" " + Prelude.show(Data_Maybe.showMaybe(Prelude.showString))(v.value1)));
      };
      if (v instanceof Name) {
          return "Name " + Prelude.show(Prelude.showString)(v.value0);
      };
      if (v instanceof ShoutName) {
          return "ShoutName " + Prelude.show(Prelude.showString)(v.value0);
      };
      if (v instanceof AngleName) {
          return "AngleName " + Prelude.show(Prelude.showString)(v.value0);
      };
      if (v instanceof LOpt) {
          return "--" + (v.value0 + Data_Maybe.fromMaybe("")(Prelude.bind(Data_Maybe.bindMaybe)(v.value1)(function (v1) {
              return Prelude["return"](Data_Maybe.applicativeMaybe)((function () {
                  if (v1.optional) {
                      return "[";
                  };
                  if (!v1.optional) {
                      return "" + (v1.name + (function () {
                          if (v1.optional) {
                              return "]";
                          };
                          if (!v1.optional) {
                              return "";
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 89, column 52 - line 92, column 13: " + [ v1.optional.constructor.name ]);
                      })());
                  };
                  throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 89, column 15 - line 92, column 13: " + [ v1.optional.constructor.name ]);
              })());
          })));
      };
      if (v instanceof SOpt) {
          return "-" + (Data_String.fromCharArray(Data_Array.cons(v.value0)(v.value1)) + Data_Maybe.fromMaybe("")(Prelude.bind(Data_Maybe.bindMaybe)(v.value2)(function (v1) {
              return Prelude["return"](Data_Maybe.applicativeMaybe)((function () {
                  if (v1.optional) {
                      return "[";
                  };
                  if (!v1.optional) {
                      return "" + (v1.name + (function () {
                          if (v1.optional) {
                              return "]";
                          };
                          if (!v1.optional) {
                              return "";
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 97, column 52 - line 100, column 13: " + [ v1.optional.constructor.name ]);
                      })());
                  };
                  throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 97, column 15 - line 100, column 13: " + [ v1.optional.constructor.name ]);
              })());
          })));
      };
      throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 69, column 1 - line 70, column 1: " + [ v.constructor.name ]);
  }; 
  var nextTokPos = Text_Parsing_Parser.ParserT(function (v) {
      return Prelude["return"](Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity))((function () {
          if (v.value0.input instanceof Data_List_1.Cons) {
              return {
                  consumed: false, 
                  input: v.value0.input, 
                  result: new Data_Either.Right(v.value0.input.value0.value0.sourcePos), 
                  position: v.value0.position
              };
          };
          return Text_Parsing_Parser.parseFailed(v.value0.input)(v.value0.position)("expected token, met EOF");
      })());
  });
  var name = (function () {
      var go = function (v) {
          if (v instanceof Name) {
              return new Data_Maybe.Just(v.value0);
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(token(go))("name");
  })();
  var lopt = (function () {
      var go = function (v) {
          if (v instanceof LOpt) {
              return new Data_Maybe.Just({
                  name: v.value0, 
                  arg: v.value1
              });
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(token(go))("long-option");
  })();
  var isDescMode = function (v) {
      if (v instanceof Descriptions) {
          return true;
      };
      return false;
  };
  var parseToken = function (m) {
      var whitespace = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.satisfy(Data_Identity.monadIdentity)(function (c) {
          return c === "\n" || (c === "\r" || (c === " " || c === "\t"));
      }))(function () {
          return Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(Prelude.unit);
      });
      var identStart = Language_Docopt_Parser_Base.alpha(Data_Identity.monadIdentity);
      var identLetter = Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Base.alphaNum(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.oneOf(Data_Identity.monadIdentity)([ "_", "-" ]));
      var flag = Language_Docopt_Parser_Base.lowerAlphaNum(Data_Identity.monadIdentity);
      var _tag = (function () {
          var withoutValue = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(function ($176) {
              return Data_String.trim(Data_String.fromCharArray($176));
          })(Data_Array.some(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ "]" ]))))(function (v) {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new Tag(v, Data_Maybe.Nothing.value));
          });
          var withValue = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(whitespace))(function () {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_String.fromCharArray)(Data_Array.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ ":" ]))))(function (v) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(":"))(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(whitespace))(function () {
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(function ($177) {
                              return Data_String.trim(Data_String.fromCharArray($177));
                          })(Data_Array.some(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ "]" ]))))(function (v1) {
                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(whitespace))(function () {
                                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new Tag(v, new Data_Maybe.Just(v1)));
                              });
                          });
                      });
                  });
              });
          });
          return Text_Parsing_Parser_Combinators.between(Data_Identity.monadIdentity)(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("["))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("]"))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Data_Identity.monadIdentity))(withValue)(withoutValue));
      })();
      var _shoutName = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_String.fromCharArray)(Prelude["<*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Array.cons)(Language_Docopt_Parser_Base.upperAlpha(Data_Identity.monadIdentity)))(Data_Array.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.regex(Data_Identity.monadIdentity)("[A-Z_-]")))))(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.notFollowedBy(Data_Identity.monadIdentity)(Language_Docopt_Parser_Base.lowerAlpha(Data_Identity.monadIdentity)))(function () {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(v);
          });
      });
      var _reference = (function () {
          var end = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(function () {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.optional(Data_Identity.monadIdentity)(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("-")))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Base["string'"](Data_Identity.monadIdentity)("options"))(function () {
                      return Text_Parsing_Parser_Combinators.optional(Data_Identity.monadIdentity)(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("..."));
                  });
              });
          });
          var go = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(function () {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(function ($178) {
                  return Data_String.fromCharArray(Data_List_1.fromList(Data_Unfoldable.unfoldableArray)($178));
              })(Prelude.flip(Text_Parsing_Parser_Combinators.manyTill(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.lookAhead(Data_Identity.monadIdentity)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(end)))(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ "]" ]))))(function (v) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(end)(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(function () {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(v);
                      });
                  });
              });
          });
          return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Reference.create)(Text_Parsing_Parser_Combinators.between(Data_Identity.monadIdentity)(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("["))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("]"))(go));
      })();
      var _name = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Base.alphaNum(Data_Identity.monadIdentity))(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_Array.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ identLetter, Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("."))(Text_Parsing_Parser_Combinators.notFollowedBy(Data_Identity.monadIdentity)(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)(".."))), Text_Parsing_Parser_String.oneOf(Data_Identity.monadIdentity)([ "-", "_" ]) ])))))(function (v1) {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(Data_String.fromCharArray(Data_Array[":"](v)(v1)));
          });
      });
      var _angleName = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("<"))(function () {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_String.fromCharArray)(Data_Array.some(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)([ identLetter, Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Text_Parsing_Parser_String.noneOf(Data_Identity.monadIdentity)([ "<", ">" ])) ]))))(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(">"))(function () {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(v);
              });
          });
      });
      var _longOption = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("--"))(function () {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_String.fromCharArray)(Prelude["<*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Array.cons)(Language_Docopt_Parser_Base.alphaNum(Data_Identity.monadIdentity)))(Data_Array.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)([ Language_Docopt_Parser_Base.alphaNum(Data_Identity.monadIdentity), Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.oneOf(Data_Identity.monadIdentity)([ "-" ]))(Text_Parsing_Parser_Combinators.lookAhead(Data_Identity.monadIdentity)(Language_Docopt_Parser_Base.alphaNum(Data_Identity.monadIdentity))) ])))))(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("=")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ _angleName, _shoutName, _name ])))(function (v1) {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))({
                          name: v1, 
                          optional: false
                      });
                  });
              })), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("["))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.optional(Data_Identity.monadIdentity)(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("=")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))))(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ _angleName, _shoutName, _name ])))(function (v1) {
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("]")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))({
                                  name: v1, 
                                  optional: true
                              });
                          });
                      });
                  });
              })), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("["))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.optional(Data_Identity.monadIdentity)(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("=")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))))(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ _angleName, _shoutName, _name ])))(function (v1) {
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("]")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))({
                                  name: v1, 
                                  optional: true
                              });
                          });
                      });
                  });
              })), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("[")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("=")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ _angleName, _shoutName, _name ])))(function (v1) {
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("]")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))({
                                  name: v1, 
                                  optional: true
                              });
                          });
                      });
                  });
              })), Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(Data_Maybe.Nothing.value) ])))(function (v1) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.lookAhead(Data_Identity.monadIdentity)(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)([ Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String.whiteSpace(Data_Identity.monadIdentity))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(","))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("|"))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("["))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("("))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("..."))) ])))(function () {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new LOpt(v, v1));
                  });
              });
          });
      });
      var _shortOption = Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("-"))(function () {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Base.alphaNum(Data_Identity.monadIdentity))(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_Array.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.alphaNum(Data_Identity.monadIdentity)))(function (v1) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("=")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ _angleName, _shoutName, _name ])))(function (v2) {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))({
                              name: v2, 
                              optional: false
                          });
                      });
                  })), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("["))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.optional(Data_Identity.monadIdentity)(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("=")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))))(function () {
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ _angleName, _shoutName, _name ])))(function (v2) {
                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("]")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))({
                                      name: v2, 
                                      optional: true
                                  });
                              });
                          });
                      });
                  })), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("[")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("=")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))([ _angleName, _shoutName, _name ])))(function (v2) {
                              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity)))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("]")))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(Language_Docopt_Parser_Base.space(Data_Identity.monadIdentity))))(function () {
                                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))({
                                      name: v2, 
                                      optional: true
                                  });
                              });
                          });
                      });
                  })), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Data_Maybe.Just.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(_angleName)(function (v2) {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))({
                          name: v2, 
                          optional: false
                      });
                  })), Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(Data_Maybe.Nothing.value) ])))(function (v2) {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.lookAhead(Data_Identity.monadIdentity)(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)([ Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String.whiteSpace(Data_Identity.monadIdentity))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(","))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("|"))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("["))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("("))), Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("..."))) ])))(function () {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new SOpt(v, v1, v2));
                      });
                  });
              });
          });
      });
      return Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Data_Identity.monadIdentity)(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity))(Data_Array.concat([ [ Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("("))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(LParen.value)), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(")"))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(RParen.value)) ], (function () {
          var $137 = isDescMode(m);
          if ($137) {
              return [ _tag ];
          };
          if (!$137) {
              return [  ];
          };
          throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 170, column 5 - line 171, column 3: " + [ $137.constructor.name ]);
      })(), [ _reference, Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("["))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(LSquare.value)), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("]"))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(RSquare.value)), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("|"))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(VBar.value)), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(":"))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(Colon.value)), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)(","))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(Comma.value)), _longOption, _shortOption, Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(AngleName.create)(_angleName), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("--"))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(DoubleDash.value)), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String["char"](Data_Identity.monadIdentity)("-"))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(Dash.value)), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.string(Data_Identity.monadIdentity)("..."))(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(TripleDot.value)), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(ShoutName.create)(_shoutName), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Name.create)(_name) ], (function () {
          var $138 = isDescMode(m);
          if ($138) {
              return [ Prelude["<$>"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Garbage.create)(Text_Parsing_Parser_String.anyChar(Data_Identity.monadIdentity)) ];
          };
          if (!$138) {
              return [  ];
          };
          throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 186, column 5 - line 189, column 3: " + [ $138.constructor.name ]);
      })() ]))))(Text_Parsing_Parser_String.skipSpaces(Data_Identity.monadIdentity));
  };
  var parsePositionedToken = function (m) {
      return Text_Parsing_Parser_Combinators["try"](Data_Identity.functorIdentity)(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Base.getPosition(Data_Identity.monadIdentity))(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(parseToken(m))(function (v1) {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(new PositionedToken({
                  sourcePos: v, 
                  token: v1
              }));
          });
      }));
  };
  var parseTokens = function (m) {
      return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.skipSpaces(Data_Identity.monadIdentity))(function () {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Data_List_1.many(Text_Parsing_Parser.alternativeParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser.lazyParserT)(parsePositionedToken(m)))(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Data_Identity.monadIdentity))(Text_Parsing_Parser_String.eof(Data_Identity.monadIdentity))(Prelude["void"](Text_Parsing_Parser.functorParserT(Data_Identity.functorIdentity))(Prelude.bind(Text_Parsing_Parser.bindParserT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Base.getInput(Data_Identity.monadIdentity)(Prelude.showString))(function (v1) {
                  return Text_Parsing_Parser.fail(Data_Identity.monadIdentity)("Unexpected input: " + v1);
              }))))(function () {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Data_Identity.monadIdentity))(v);
              });
          });
      });
  };
  var lex = function (m) {
      return Prelude.flip(Text_Parsing_Parser.runParser)(parseTokens(m));
  };
  var lexDescs = lex(Descriptions.value);
  var lexUsage = lex(Usage.value);
  var eqToken = new Prelude.Eq(function (v) {
      return function (v1) {
          if (v instanceof LParen && v1 instanceof LParen) {
              return true;
          };
          if (v instanceof RParen && v1 instanceof RParen) {
              return true;
          };
          if (v instanceof LSquare && v1 instanceof LSquare) {
              return true;
          };
          if (v instanceof RSquare && v1 instanceof RSquare) {
              return true;
          };
          if (v instanceof VBar && v1 instanceof VBar) {
              return true;
          };
          if (v instanceof Colon && v1 instanceof Colon) {
              return true;
          };
          if (v instanceof Comma && v1 instanceof Comma) {
              return true;
          };
          if (v instanceof Dash && v1 instanceof Dash) {
              return true;
          };
          if (v instanceof DoubleDash && v1 instanceof DoubleDash) {
              return true;
          };
          if (v instanceof TripleDot && v1 instanceof TripleDot) {
              return true;
          };
          if (v instanceof Reference && v1 instanceof Reference) {
              return v.value0 === v1.value0;
          };
          if (v instanceof LOpt && v1 instanceof LOpt) {
              return v.value0 === v1.value0 && (Data_Maybe.isNothing(v.value1) && Data_Maybe.isNothing(v1.value1) || Data_Maybe.fromMaybe(false)(Prelude.bind(Data_Maybe.bindMaybe)(v.value1)(function (v2) {
                  return Prelude.bind(Data_Maybe.bindMaybe)(v1.value1)(function (v3) {
                      return Prelude["return"](Data_Maybe.applicativeMaybe)(v2.name === v2.name && v2.optional === v2.optional);
                  });
              })));
          };
          if (v instanceof SOpt && v1 instanceof SOpt) {
              return v.value0 === v1.value0 && (Prelude["=="](Prelude.eqArray(Prelude.eqChar))(v1.value1)(v1.value1) && (Data_Maybe.isNothing(v.value2) && Data_Maybe.isNothing(v1.value2) || Data_Maybe.fromMaybe(false)(Prelude.bind(Data_Maybe.bindMaybe)(v.value2)(function (v2) {
                  return Prelude.bind(Data_Maybe.bindMaybe)(v1.value2)(function (v3) {
                      return Prelude["return"](Data_Maybe.applicativeMaybe)(v2.name === v2.name && v2.optional === v2.optional);
                  });
              }))));
          };
          if (v instanceof AngleName && v1 instanceof AngleName) {
              return v.value0 === v1.value0;
          };
          if (v instanceof ShoutName && v1 instanceof ShoutName) {
              return v.value0 === v1.value0;
          };
          if (v instanceof Name && v1 instanceof Name) {
              return v.value0 === v1.value0;
          };
          if (v instanceof Garbage && v1 instanceof Garbage) {
              return v.value0 === v1.value0;
          };
          return false;
      };
  });
  var match = function (tok) {
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(token(function (tok$prime) {
          var $171 = Prelude["=="](eqToken)(tok$prime)(tok);
          if ($171) {
              return new Data_Maybe.Just(Prelude.unit);
          };
          if (!$171) {
              return Data_Maybe.Nothing.value;
          };
          throw new Error("Failed pattern match at Language.Docopt.Parser.Lexer line 439, column 29 - line 439, column 73: " + [ $171.constructor.name ]);
      }))(prettyPrintToken(tok));
  };
  var lparen = match(LParen.value);
  var lsquare = match(LSquare.value);
  var rparen = match(RParen.value);
  var rsquare = match(RSquare.value);
  var tripleDot = match(TripleDot.value);
  var vbar = match(VBar.value);
  var doubleDash = match(DoubleDash.value);
  var dash = match(Dash.value);
  var comma = match(Comma.value);
  var colon = match(Colon.value);
  var anyToken = token(Data_Maybe.Just.create);
  var eof = Text_Parsing_Parser_Combinators.notFollowedBy(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(anyToken);
  var angleName = (function () {
      var go = function (v) {
          if (v instanceof AngleName) {
              return new Data_Maybe.Just(v.value0);
          };
          return Data_Maybe.Nothing.value;
      };
      return Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(token(go))("<name>");
  })();
  exports["PositionedToken"] = PositionedToken;
  exports["LParen"] = LParen;
  exports["RParen"] = RParen;
  exports["LSquare"] = LSquare;
  exports["RSquare"] = RSquare;
  exports["Dash"] = Dash;
  exports["VBar"] = VBar;
  exports["Colon"] = Colon;
  exports["Comma"] = Comma;
  exports["TripleDot"] = TripleDot;
  exports["Reference"] = Reference;
  exports["LOpt"] = LOpt;
  exports["SOpt"] = SOpt;
  exports["Tag"] = Tag;
  exports["Name"] = Name;
  exports["ShoutName"] = ShoutName;
  exports["AngleName"] = AngleName;
  exports["Garbage"] = Garbage;
  exports["DoubleDash"] = DoubleDash;
  exports["Usage"] = Usage;
  exports["Descriptions"] = Descriptions;
  exports["runTokenParser"] = runTokenParser;
  exports["nextTokPos"] = nextTokPos;
  exports["shoutName"] = shoutName;
  exports["angleName"] = angleName;
  exports["reference"] = reference;
  exports["tag"] = tag;
  exports["name"] = name;
  exports["sopt"] = sopt;
  exports["lopt"] = lopt;
  exports["tripleDot"] = tripleDot;
  exports["colon"] = colon;
  exports["comma"] = comma;
  exports["vbar"] = vbar;
  exports["doubleDash"] = doubleDash;
  exports["dash"] = dash;
  exports["rsquare"] = rsquare;
  exports["lsquare"] = lsquare;
  exports["rparen"] = rparen;
  exports["lparen"] = lparen;
  exports["eof"] = eof;
  exports["anyToken"] = anyToken;
  exports["match"] = match;
  exports["token"] = token;
  exports["parseToken"] = parseToken;
  exports["parsePositionedToken"] = parsePositionedToken;
  exports["parseTokens"] = parseTokens;
  exports["prettyPrintToken"] = prettyPrintToken;
  exports["lexUsage"] = lexUsage;
  exports["lexDescs"] = lexDescs;
  exports["lex"] = lex;
  exports["isDescMode"] = isDescMode;
  exports["eqToken"] = eqToken;
})(PS["Language.Docopt.Parser.Lexer"] = PS["Language.Docopt.Parser.Lexer"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Monad_Trans = PS["Control.Monad.Trans"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_Monad_State = PS["Control.Monad.State"];
  var Data_List = PS["Data.List"];
  var Data_Either = PS["Data.Either"];
  var Language_Docopt_Parser_Lexer = PS["Language.Docopt.Parser.Lexer"];
  var Language_Docopt_Parser_State = PS["Language.Docopt.Parser.State"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Combinators = PS["Text.Parsing.Parser.Combinators"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Control_Monad_State_Trans = PS["Control.Monad.State.Trans"];
  var Data_Identity = PS["Data.Identity"];
  var Control_Monad_State_Class = PS["Control.Monad.State.Class"];
  var markIndent$prime = function (level) {
      return function (p) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.get(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.modify(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))(function (st) {
                  var $16 = {};
                  for (var $17 in st) {
                      if (st.hasOwnProperty($17)) {
                          $16[$17] = st[$17];
                      };
                  };
                  $16.indentation = level;
                  return $16;
              })))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(p)(function (v1) {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.modify(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))(function (st) {
                          var $19 = {};
                          for (var $20 in st) {
                              if (st.hasOwnProperty($20)) {
                                  $19[$20] = st[$20];
                              };
                          };
                          $19.indentation = v.indentation;
                          return $19;
                      })))(function () {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(v1);
                      });
                  });
              });
          });
      };
  };
  var getTokenPosition = Text_Parsing_Parser.ParserT(function (v) {
      return Prelude["return"](Control_Monad_State_Trans.applicativeStateT(Data_Identity.monadIdentity))((function () {
          if (v.value0.input instanceof Data_List.Cons) {
              return {
                  input: v.value0.input, 
                  result: new Data_Either.Right(v.value0.input.value0.value0.sourcePos), 
                  consumed: false, 
                  position: v.value0.position
              };
          };
          return {
              input: v.value0.input, 
              result: new Data_Either.Right(v.value0.position), 
              consumed: false, 
              position: v.value0.position
          };
      })());
  });
  var markIndent = function (p) {
      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.get(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(getTokenPosition)(function (v1) {
              return Text_Parsing_Parser_Combinators["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.modify(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))(function (st) {
                  var $33 = {};
                  for (var $34 in st) {
                      if (st.hasOwnProperty($34)) {
                          $33[$34] = st[$34];
                      };
                  };
                  $33.indentation = v1.value0.column;
                  return $33;
              })))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(p)(function (v2) {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.modify(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))(function (st) {
                          var $36 = {};
                          for (var $37 in st) {
                              if (st.hasOwnProperty($37)) {
                                  $36[$37] = st[$37];
                              };
                          };
                          $36.indentation = v.indentation;
                          return $36;
                      })))(function () {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(v2);
                      });
                  });
              }));
          });
      });
  };
  var markLine = function (p) {
      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.get(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(getTokenPosition)(function (v1) {
              return Text_Parsing_Parser_Combinators["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.modify(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))(function (st) {
                  var $43 = {};
                  for (var $44 in st) {
                      if (st.hasOwnProperty($44)) {
                          $43[$44] = st[$44];
                      };
                  };
                  $43.line = v1.value0.line;
                  return $43;
              })))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(p)(function (v2) {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.modify(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))(function (st) {
                          var $46 = {};
                          for (var $47 in st) {
                              if (st.hasOwnProperty($47)) {
                                  $46[$47] = st[$47];
                              };
                          };
                          $46.line = v.line;
                          return $46;
                      })))(function () {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(v2);
                      });
                  });
              }));
          });
      });
  };
  var checkLine = function (rel) {
      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(getTokenPosition)(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.get(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v1) {
              return Control_MonadPlus.guard(Text_Parsing_Parser.monadPlusParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(rel(v.value0.line)(v1.line));
          });
      });
  };
  var sameLine = Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(checkLine(Prelude["=="](Prelude.eqInt)))("same line");            
  var checkIndentation = function (rel) {
      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(getTokenPosition)(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Monad_Trans.lift(Text_Parsing_Parser.monadTransParserT)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Monad_State_Class.get(Control_Monad_State_Trans.monadStateStateT(Data_Identity.monadIdentity))))(function (v1) {
              return Control_MonadPlus.guard(Text_Parsing_Parser.monadPlusParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(rel(v.value0.column)(v1.indentation));
          });
      });
  };
  var indented = Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(checkIndentation(Prelude[">="](Prelude.ordInt)))("indentation");
  var lessIndented = Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(checkIndentation(Prelude["<"](Prelude.ordInt)))("less indentation");                   
  var moreIndented = Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(checkIndentation(Prelude[">"](Prelude.ordInt)))("more indentation");
  var sameIndent = Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(checkIndentation(Prelude["=="](Prelude.eqInt)))("same indentation");
  exports["sameLine"] = sameLine;
  exports["checkLine"] = checkLine;
  exports["sameIndent"] = sameIndent;
  exports["lessIndented"] = lessIndented;
  exports["moreIndented"] = moreIndented;
  exports["indented"] = indented;
  exports["checkIndentation"] = checkIndentation;
  exports["markIndent'"] = markIndent$prime;
  exports["markLine"] = markLine;
  exports["markIndent"] = markIndent;
  exports["getTokenPosition"] = getTokenPosition;
})(PS["Language.Docopt.Parser.Common"] = PS["Language.Docopt.Parser.Common"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Functor = PS["Data.Functor"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Apply = PS["Control.Apply"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Data_List = PS["Data.List"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Combinators = PS["Text.Parsing.Parser.Combinators"];
  var Data_Either = PS["Data.Either"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Generic = PS["Data.Generic"];
  var Data_String = PS["Data.String"];
  var Data_Array = PS["Data.Array"];
  var Data_String_Ext = PS["Data.String.Ext"];
  var Language_Docopt_Value_1 = PS["Language.Docopt.Value"];
  var Language_Docopt_Parser_Common = PS["Language.Docopt.Parser.Common"];
  var Language_Docopt_Parser_Lexer_1 = PS["Language.Docopt.Parser.Lexer"];
  var Language_Docopt_Parser_Lexer_1 = PS["Language.Docopt.Parser.Lexer"];
  var Language_Docopt_Value_1 = PS["Language.Docopt.Value"];
  var Control_Monad_State_Trans = PS["Control.Monad.State.Trans"];
  var Data_Identity = PS["Data.Identity"];
  var Data_Foldable = PS["Data.Foldable"];        
  var Flag = (function () {
      function Flag(value0) {
          this.value0 = value0;
      };
      Flag.create = function (value0) {
          return new Flag(value0);
      };
      return Flag;
  })();
  var Long = (function () {
      function Long(value0) {
          this.value0 = value0;
      };
      Long.create = function (value0) {
          return new Long(value0);
      };
      return Long;
  })();
  var Full = (function () {
      function Full(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Full.create = function (value0) {
          return function (value1) {
              return new Full(value0, value1);
          };
      };
      return Full;
  })();
  var Text = (function () {
      function Text() {

      };
      Text.value = new Text();
      return Text;
  })();
  var Default = (function () {
      function Default(value0) {
          this.value0 = value0;
      };
      Default.create = function (value0) {
          return new Default(value0);
      };
      return Default;
  })();
  var Env = (function () {
      function Env(value0) {
          this.value0 = value0;
      };
      Env.create = function (value0) {
          return new Env(value0);
      };
      return Env;
  })();
  var Argument = function (x) {
      return x;
  };
  var Option = function (x) {
      return x;
  };
  var OptionDesc = (function () {
      function OptionDesc(value0) {
          this.value0 = value0;
      };
      OptionDesc.create = function (value0) {
          return new OptionDesc(value0);
      };
      return OptionDesc;
  })();
  var runArgument = function (v) {
      return v;
  };
  var prettyPrintOption = function (v) {
      var name = function (v1) {
          if (v1 instanceof Flag) {
              return "-" + Data_String.fromChar(v1.value0);
          };
          if (v1 instanceof Long) {
              return "--" + v1.value0;
          };
          if (v1 instanceof Full) {
              return "-" + (Data_String.fromChar(v1.value0) + (", --" + v1.value1));
          };
          throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 126, column 7 - line 137, column 7: " + [ v1.constructor.name ]);
      };
      var env = Data_Maybe.maybe("")(Prelude.id(Prelude.categoryFn))(Prelude.bind(Data_Maybe.bindMaybe)(v.env)(function (v1) {
          return Prelude["return"](Data_Maybe.applicativeMaybe)(" [env: " + (v1 + "]"));
      }));
      var arg = Data_Maybe.maybe("")(Prelude.id(Prelude.categoryFn))(Prelude.bind(Data_Maybe.bindMaybe)(v.arg)(function (v1) {
          return Prelude["return"](Data_Maybe.applicativeMaybe)((function () {
              if (v1.optional) {
                  return "[";
              };
              if (!v1.optional) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 129, column 12 - line 129, column 42: " + [ v1.optional.constructor.name ]);
          })() + ("=" + (v1.name + ((function () {
              if (v1.optional) {
                  return "]";
              };
              if (!v1.optional) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 131, column 17 - line 131, column 47: " + [ v1.optional.constructor.name ]);
          })() + ((function () {
              if (v.repeatable) {
                  return "...";
              };
              if (!v.repeatable) {
                  return "";
              };
              throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 132, column 17 - line 132, column 53: " + [ v.repeatable.constructor.name ]);
          })() + Data_Maybe.maybe("")(function (v2) {
              return "[default: " + (Language_Docopt_Value_1.prettyPrintValue(v2) + "]");
          })(v1["default"]))))));
      }));
      return name(v.name) + (arg + env);
  };
  var prettyPrintArgument = function (v) {
      return (function () {
          if (v.optional) {
              return "[";
          };
          if (!v.optional) {
              return "";
          };
          throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 143, column 6 - line 143, column 27: " + [ v.optional.constructor.name ]);
      })() + (v.name + ((function () {
          if (v.optional) {
              return "]";
          };
          if (!v.optional) {
              return "";
          };
          throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 143, column 38 - line 143, column 59: " + [ v.optional.constructor.name ]);
      })() + Data_Maybe.maybe("")(function (v1) {
          return " [default: " + (Language_Docopt_Value_1.prettyPrintValue(v1) + "]");
      })(v["default"])));
  };
  var isEnvTag = function (v) {
      if (v instanceof Env) {
          return true;
      };
      return false;
  };
  var isDefaultTag = function (v) {
      if (v instanceof Default) {
          return true;
      };
      return false;
  };
  var getName = function (v) {
      if (v instanceof Long) {
          return Prelude.pure(Data_Maybe.applicativeMaybe)(v.value0);
      };
      if (v instanceof Full) {
          return Prelude.pure(Data_Maybe.applicativeMaybe)(v.value1);
      };
      return Data_Maybe.Nothing.value;
  };
  var getFlag = function (v) {
      if (v instanceof Flag) {
          return Prelude.pure(Data_Maybe.applicativeMaybe)(v.value0);
      };
      if (v instanceof Full) {
          return Prelude.pure(Data_Maybe.applicativeMaybe)(v.value0);
      };
      return Data_Maybe.Nothing.value;
  };
  var getEnvKey = function (v) {
      if (v instanceof Env) {
          return new Data_Maybe.Just(v.value0);
      };
      return Data_Maybe.Nothing.value;
  };
  var getDefaultValue = function (v) {
      if (v instanceof Default) {
          return Data_Either.either(Prelude["const"](Data_Maybe.Nothing.value))(Data_Maybe.Just.create)(Language_Docopt_Value_1.parse(v.value0)(true));
      };
      return Data_Maybe.Nothing.value;
  };                                                                 
  var descParser = (function () {
      var sopt = Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.sopt)(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_MonadPlus.guard(Text_Parsing_Parser.monadPlusParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Array.length(v.stack) === 0))("No stacked options"))(function () {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))({
                  flag: v.flag, 
                  arg: v.arg
              });
          });
      });
      var option = (function () {
          var $$short = Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(sopt)(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Maybe.maybe(Text_Parsing_Parser_Combinators.optionMaybe(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.shoutName)(Language_Docopt_Parser_Lexer_1.angleName))(function (v1) {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))({
                      name: v1, 
                      optional: false
                  });
              })))(function ($197) {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Maybe.Just.create($197));
              })(v.arg))(function (v1) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators.option(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(false)(Data_Functor["$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.tripleDot)(true)))(function (v2) {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))({
                          name: new Flag(v.flag), 
                          arg: Prelude["<$>"](Data_Maybe.functorMaybe)(Argument)(Prelude.bind(Data_Maybe.bindMaybe)(v1)(function (v3) {
                              return Prelude["return"](Data_Maybe.applicativeMaybe)({
                                  name: v3.name, 
                                  optional: v3.optional, 
                                  "default": Data_Maybe.Nothing.value
                              });
                          })), 
                          env: Data_Maybe.Nothing.value, 
                          repeatable: v2
                      });
                  });
              });
          });
          var $$long = Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.lopt)(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Maybe.maybe(Text_Parsing_Parser_Combinators.optionMaybe(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.shoutName)(Language_Docopt_Parser_Lexer_1.angleName))(function (v1) {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))({
                      name: v1, 
                      optional: false
                  });
              })))(function ($198) {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Maybe.Just.create($198));
              })(v.arg))(function (v1) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators.option(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(false)(Data_Functor["$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.tripleDot)(true)))(function (v2) {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))({
                          name: new Long(v.name), 
                          arg: Prelude["<$>"](Data_Maybe.functorMaybe)(Argument)(Prelude.bind(Data_Maybe.bindMaybe)(v1)(function (v3) {
                              return Prelude["return"](Data_Maybe.applicativeMaybe)({
                                  name: v3.name, 
                                  optional: v3.optional, 
                                  "default": Data_Maybe.Nothing.value
                              });
                          })), 
                          env: Data_Maybe.Nothing.value, 
                          repeatable: v2
                      });
                  });
              });
          });
          var both = (function () {
              var combine = function (v) {
                  return function (v1) {
                      if (v.name instanceof Flag && v1.name instanceof Long) {
                          var combineArg = function (v2) {
                              return function (v3) {
                                  if (v2 instanceof Data_Maybe.Just && (v3 instanceof Data_Maybe.Just && Data_String_Ext.upperCaseEq(v2.value0.name)(v3.value0.name))) {
                                      return Prelude["return"](Data_Either.applicativeEither)(Data_Maybe.Just.create({
                                          name: v2.value0.name, 
                                          optional: v2.value0.optional || v3.value0.optional, 
                                          "default": Control_Alt["<|>"](Data_Maybe.altMaybe)(v2.value0["default"])(v3.value0["default"])
                                      }));
                                  };
                                  if (v2 instanceof Data_Maybe.Nothing && v3 instanceof Data_Maybe.Just) {
                                      return Prelude["return"](Data_Either.applicativeEither)(Prelude.pure(Data_Maybe.applicativeMaybe)(v3.value0));
                                  };
                                  if (v2 instanceof Data_Maybe.Just && v3 instanceof Data_Maybe.Nothing) {
                                      return Prelude["return"](Data_Either.applicativeEither)(Prelude.pure(Data_Maybe.applicativeMaybe)(v2.value0));
                                  };
                                  if (v2 instanceof Data_Maybe.Nothing && v3 instanceof Data_Maybe.Nothing) {
                                      return Prelude["return"](Data_Either.applicativeEither)(Data_Maybe.Nothing.value);
                                  };
                                  if (v2 instanceof Data_Maybe.Just && v3 instanceof Data_Maybe.Just) {
                                      return Data_Either.Left.create("Arguments mismatch: " + (Prelude.show(Prelude.showString)(prettyPrintArgument(v2.value0)) + (" and " + Prelude.show(Prelude.showString)(prettyPrintArgument(v3.value0)))));
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 314, column 17 - line 320, column 17: " + [ v2.constructor.name, v3.constructor.name ]);
                              };
                          };
                          return Data_Either.either(Text_Parsing_Parser.fail(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))))(Prelude.bind(Data_Either.bindEither)(combineArg(v.arg)(v1.arg))(function (v2) {
                              return Prelude["return"](Data_Either.applicativeEither)({
                                  name: new Full(v.name.value0, v1.name.value0), 
                                  arg: v2, 
                                  env: Data_Maybe.Nothing.value, 
                                  repeatable: v.repeatable || v1.repeatable
                              });
                          }));
                      };
                      return Text_Parsing_Parser.fail(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))("Invalid case - expected flag and long option");
                  };
              };
              return Language_Docopt_Parser_Common.markLine(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))($$short)(function (v) {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Common.sameLine)(function () {
                      return Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))([ Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.comma)($$long), $$long ]));
                  }))(function (v1) {
                      return combine(v)(v1);
                  });
              }));
          })();
          var start = Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))([ Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))($$short)(Text_Parsing_Parser_Combinators.notFollowedBy(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))([ Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.comma)($$long), $$long ])))), Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))($$long)(Text_Parsing_Parser_Combinators.notFollowedBy(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))([ Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.comma)($$short), $$short ])))), both ]));
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(start)(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude.flip(Text_Parsing_Parser_Combinators.manyTill(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.eof)(Text_Parsing_Parser_Combinators.lookAhead(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))(Prelude["void"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(start)))))(Text_Parsing_Parser_Combinators.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))([ Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Default.create)(Language_Docopt_Parser_Lexer_1.tag("default")), Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Env.create)(Language_Docopt_Parser_Lexer_1.tag("env")), Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.anyToken)(Prelude.pure(Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text.value)) ]))))(function (v1) {
                  var envs = Prelude["<$>"](Data_List.functorList)(getEnvKey)(Data_List.filter(isEnvTag)(v1));
                  var defaults = Prelude["<$>"](Data_List.functorList)(getDefaultValue)(Data_List.filter(isDefaultTag)(v1));
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))((function () {
                      var $187 = Data_List.length(defaults) > 1;
                      if ($187) {
                          return Text_Parsing_Parser.fail(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))("Option " + (Prelude.show(Prelude.showString)(prettyPrintOption(v)) + " has multiple defaults!"));
                      };
                      if (!$187) {
                          return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude.unit);
                      };
                      throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 187, column 7 - line 193, column 7: " + [ $187.constructor.name ]);
                  })())(function () {
                      return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))((function () {
                          var $188 = Data_List.length(envs) > 1;
                          if ($188) {
                              return Text_Parsing_Parser.fail(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))("Option " + (Prelude.show(Prelude.showString)(prettyPrintOption(v)) + " has multiple environment mappings!"));
                          };
                          if (!$188) {
                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude.unit);
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 193, column 7 - line 199, column 7: " + [ $188.constructor.name ]);
                      })())(function () {
                          var env = Prelude[">>="](Data_Maybe.bindMaybe)(Data_List.head(envs))(Prelude.id(Prelude.categoryFn));
                          var $$default = Prelude[">>="](Data_Maybe.bindMaybe)(Data_List.head(defaults))(Prelude.id(Prelude.categoryFn));
                          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))((function () {
                              var $189 = Data_Maybe.isJust($$default) && !Data_Maybe.isJust(v.arg);
                              if ($189) {
                                  return Text_Parsing_Parser.fail(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))("Option " + (Prelude.show(Prelude.showString)(prettyPrintOption(v)) + (" does not take arguments. " + "Cannot specify defaults.")));
                              };
                              if (!$189) {
                                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude.unit);
                              };
                              throw new Error("Failed pattern match at Language.Docopt.Parser.Desc line 202, column 7 - line 209, column 7: " + [ $189.constructor.name ]);
                          })())(function () {
                              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(OptionDesc.create(Option((function () {
                                  var $193 = {};
                                  for (var $194 in v) {
                                      if (v.hasOwnProperty($194)) {
                                          $193[$194] = v[$194];
                                      };
                                  };
                                  $193.env = env;
                                  $193.arg = Prelude.bind(Data_Maybe.bindMaybe)(v.arg)(function (v2) {
                                      return Prelude["return"](Data_Maybe.applicativeMaybe)(Argument((function () {
                                          var $191 = {};
                                          for (var $192 in v2) {
                                              if (v2.hasOwnProperty($192)) {
                                                  $191[$192] = v2[$192];
                                              };
                                          };
                                          $191.default = $$default;
                                          return $191;
                                      })()));
                                  });
                                  return $193;
                              })())));
                          });
                      });
                  });
              });
          });
      })();
      var anyName = Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer_1.angleName)(Language_Docopt_Parser_Lexer_1.shoutName))(Language_Docopt_Parser_Lexer_1.name);
      return Language_Docopt_Parser_Common.markIndent(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(option)(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_List.many(Text_Parsing_Parser.alternativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser.lazyParserT)(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Common.sameIndent)(option)))(function (v1) {
              return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_List[":"](v)(v1));
          });
      }));
  })();
  var parse = Prelude.flip(Language_Docopt_Parser_Lexer_1.runTokenParser)(descParser);
  var run = function (x) {
      return Prelude[">>="](Data_Either.bindEither)(Language_Docopt_Parser_Lexer_1.lexDescs(x))(parse);
  };
  exports["Text"] = Text;
  exports["Default"] = Default;
  exports["Env"] = Env;
  exports["Option"] = Option;
  exports["Argument"] = Argument;
  exports["Flag"] = Flag;
  exports["Long"] = Long;
  exports["Full"] = Full;
  exports["OptionDesc"] = OptionDesc;
  exports["descParser"] = descParser;
  exports["parse"] = parse;
  exports["run"] = run;
  exports["prettyPrintArgument"] = prettyPrintArgument;
  exports["prettyPrintOption"] = prettyPrintOption;
  exports["getEnvKey"] = getEnvKey;
  exports["isEnvTag"] = isEnvTag;
  exports["getDefaultValue"] = getDefaultValue;
  exports["isDefaultTag"] = isDefaultTag;
  exports["runArgument"] = runArgument;
  exports["getName"] = getName;
  exports["getFlag"] = getFlag;
})(PS["Language.Docopt.Parser.Desc"] = PS["Language.Docopt.Parser.Desc"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_String = PS["Data.String"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_List = PS["Data.List"];
  var Data_Monoid = PS["Data.Monoid"];        
  var LOpt = function (x) {
      return x;
  };
  var SOpt = function (x) {
      return x;
  };
  var sopt$prime = function (f) {
      return function (fs) {
          return function (a) {
              return function (r) {
                  return {
                      flag: f, 
                      stack: fs, 
                      arg: a, 
                      repeatable: r
                  };
              };
          };
      };
  };
  var lopt$prime = function (n) {
      return function (a) {
          return function (r) {
              return {
                  name: n, 
                  arg: a, 
                  repeatable: r
              };
          };
      };
  };
  exports["SOpt"] = SOpt;
  exports["LOpt"] = LOpt;
  exports["sopt'"] = sopt$prime;
  exports["lopt'"] = lopt$prime;
})(PS["Language.Docopt.Parser.Usage.Option"] = PS["Language.Docopt.Parser.Usage.Option"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_List = PS["Data.List"];
  var Data_Foldable = PS["Data.Foldable"];
  var Language_Docopt_Parser_Usage_Option = PS["Language.Docopt.Parser.Usage.Option"];
  var Data_Monoid = PS["Data.Monoid"];        
  var Command = (function () {
      function Command(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Command.create = function (value0) {
          return function (value1) {
              return new Command(value0, value1);
          };
      };
      return Command;
  })();
  var Positional = (function () {
      function Positional(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Positional.create = function (value0) {
          return function (value1) {
              return new Positional(value0, value1);
          };
      };
      return Positional;
  })();
  var Option = (function () {
      function Option(value0) {
          this.value0 = value0;
      };
      Option.create = function (value0) {
          return new Option(value0);
      };
      return Option;
  })();
  var OptionStack = (function () {
      function OptionStack(value0) {
          this.value0 = value0;
      };
      OptionStack.create = function (value0) {
          return new OptionStack(value0);
      };
      return OptionStack;
  })();
  var Group = (function () {
      function Group(value0, value1, value2) {
          this.value0 = value0;
          this.value1 = value1;
          this.value2 = value2;
      };
      Group.create = function (value0) {
          return function (value1) {
              return function (value2) {
                  return new Group(value0, value1, value2);
              };
          };
      };
      return Group;
  })();
  var EOA = (function () {
      function EOA() {

      };
      EOA.value = new EOA();
      return EOA;
  })();
  var Stdin = (function () {
      function Stdin() {

      };
      Stdin.value = new Stdin();
      return Stdin;
  })();
  var Reference = (function () {
      function Reference(value0) {
          this.value0 = value0;
      };
      Reference.create = function (value0) {
          return new Reference(value0);
      };
      return Reference;
  })();
  exports["Command"] = Command;
  exports["Positional"] = Positional;
  exports["Option"] = Option;
  exports["OptionStack"] = OptionStack;
  exports["Group"] = Group;
  exports["EOA"] = EOA;
  exports["Stdin"] = Stdin;
  exports["Reference"] = Reference;
})(PS["Language.Docopt.Parser.Usage.Argument"] = PS["Language.Docopt.Parser.Usage.Argument"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_List = PS["Data.List"];
  var Data_Foldable = PS["Data.Foldable"];
  var Language_Docopt_Parser_Usage_Argument = PS["Language.Docopt.Parser.Usage.Argument"];
  var Data_Monoid = PS["Data.Monoid"];        
  var Usage = (function () {
      function Usage(value0, value1) {
          this.value0 = value0;
          this.value1 = value1;
      };
      Usage.create = function (value0) {
          return function (value1) {
              return new Usage(value0, value1);
          };
      };
      return Usage;
  })();
  exports["Usage"] = Usage;
})(PS["Language.Docopt.Parser.Usage.Usage"] = PS["Language.Docopt.Parser.Usage.Usage"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Language_Docopt_Parser_Lexer = PS["Language.Docopt.Parser.Lexer"];
  var Language_Docopt_Parser_Usage_Option = PS["Language.Docopt.Parser.Usage.Option"];
  var Language_Docopt_Parser_Usage_Usage_1 = PS["Language.Docopt.Parser.Usage.Usage"];
  var Control_Alt = PS["Control.Alt"];
  var Control_Apply = PS["Control.Apply"];
  var Control_Bind = PS["Control.Bind"];
  var Control_Lazy = PS["Control.Lazy"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Data_Either = PS["Data.Either"];
  var Data_List = PS["Data.List"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Tuple = PS["Data.Tuple"];
  var Data_Tuple_Nested = PS["Data.Tuple.Nested"];
  var Language_Docopt_Parser_Common = PS["Language.Docopt.Parser.Common"];
  var Language_Docopt_Parser_Usage_Argument = PS["Language.Docopt.Parser.Usage.Argument"];
  var Language_Docopt_Parser_Usage_Usage_1 = PS["Language.Docopt.Parser.Usage.Usage"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Parsing_Parser_Combinators_1 = PS["Text.Parsing.Parser.Combinators"];
  var Text_Parsing_Parser_Combinators_1 = PS["Text.Parsing.Parser.Combinators"];
  var Text_Parsing_Parser_Pos = PS["Text.Parsing.Parser.Pos"];
  var Control_Monad_State_Trans = PS["Control.Monad.State.Trans"];
  var Data_Identity = PS["Data.Identity"];
  var Data_Foldable = PS["Data.Foldable"];        
  var usageParser = function (smartOpts) {
      var trySmartOpt = function (v) {
          if (v instanceof Language_Docopt_Parser_Usage_Argument.Group) {
              return Data_Maybe.fromMaybe(v)(Prelude.bind(Data_Maybe.bindMaybe)((function () {
                  if (v.value1 instanceof Data_List.Cons && (v.value1.value0 instanceof Data_List.Cons && (v.value1.value0.value1 instanceof Data_List.Cons && (v.value1.value0.value1.value1 instanceof Data_List.Nil && v.value1.value1 instanceof Data_List.Nil)))) {
                      return Prelude["return"](Data_Maybe.applicativeMaybe)(new Data_Tuple.Tuple(v.value1.value0.value0, v.value1.value0.value1.value0));
                  };
                  return Data_Maybe.Nothing.value;
              })())(function (v1) {
                  return Prelude.bind(Data_Maybe.bindMaybe)((function () {
                      if (v1.value0 instanceof Language_Docopt_Parser_Usage_Argument.Option && Data_Maybe.isNothing(v1.value0.value0.arg)) {
                          return Prelude["return"](Data_Maybe.applicativeMaybe)(function (argName) {
                              return function (isArgOptional) {
                                  return function (isRepeatable) {
                                      return Language_Docopt_Parser_Usage_Argument.Option.create(Language_Docopt_Parser_Usage_Option.LOpt((function () {
                                          var $26 = {};
                                          for (var $27 in v1.value0.value0) {
                                              if (v1.value0.value0.hasOwnProperty($27)) {
                                                  $26[$27] = v1.value0.value0[$27];
                                              };
                                          };
                                          $26.arg = Prelude["return"](Data_Maybe.applicativeMaybe)({
                                              name: argName, 
                                              optional: isArgOptional
                                          });
                                          $26.repeatable = isRepeatable;
                                          return $26;
                                      })()));
                                  };
                              };
                          });
                      };
                      if (v1.value0 instanceof Language_Docopt_Parser_Usage_Argument.OptionStack && Data_Maybe.isNothing(v1.value0.value0.arg)) {
                          return Prelude["return"](Data_Maybe.applicativeMaybe)(function (argName) {
                              return function (isArgOptional) {
                                  return function (isRepeatable) {
                                      return Language_Docopt_Parser_Usage_Argument.OptionStack.create(Language_Docopt_Parser_Usage_Option.SOpt((function () {
                                          var $29 = {};
                                          for (var $30 in v1.value0.value0) {
                                              if (v1.value0.value0.hasOwnProperty($30)) {
                                                  $29[$30] = v1.value0.value0[$30];
                                              };
                                          };
                                          $29.arg = Prelude["return"](Data_Maybe.applicativeMaybe)({
                                              name: argName, 
                                              optional: isArgOptional
                                          });
                                          $29.repeatable = isRepeatable;
                                          return $29;
                                      })()));
                                  };
                              };
                          });
                      };
                      return Data_Maybe.Nothing.value;
                  })())(function (v2) {
                      return Prelude.bind(Data_Maybe.bindMaybe)((function () {
                          if (v1.value1 instanceof Language_Docopt_Parser_Usage_Argument.Positional) {
                              return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Tuple_Nested.tuple3(v1.value1.value0)(v1.value1.value1 || v.value2)(false));
                          };
                          if (v1.value1 instanceof Language_Docopt_Parser_Usage_Argument.Command) {
                              return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Tuple_Nested.tuple3(v1.value1.value0)(v1.value1.value1 || v.value2)(false));
                          };
                          if (v1.value1 instanceof Language_Docopt_Parser_Usage_Argument.Group && (v1.value1.value1 instanceof Data_List.Cons && (v1.value1.value1.value0 instanceof Data_List.Cons && (v1.value1.value1.value0.value1 instanceof Data_List.Nil && v1.value1.value1.value1 instanceof Data_List.Nil)))) {
                              if (v1.value1.value1.value0.value0 instanceof Language_Docopt_Parser_Usage_Argument.Positional) {
                                  return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Tuple_Nested.tuple3(v1.value1.value1.value0.value0.value0)(v1.value1.value1.value0.value0.value1 || v1.value1.value2)(v1.value1.value0));
                              };
                              if (v1.value1.value1.value0.value0 instanceof Language_Docopt_Parser_Usage_Argument.Command) {
                                  return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Tuple_Nested.tuple3(v1.value1.value1.value0.value0.value0)(v1.value1.value1.value0.value0.value1 || v1.value1.value2)(v1.value1.value0));
                              };
                              return Data_Maybe.Nothing.value;
                          };
                          return Data_Maybe.Nothing.value;
                      })())(function (v3) {
                          return Prelude["return"](Data_Maybe.applicativeMaybe)(new Language_Docopt_Parser_Usage_Argument.Group(v.value0, Data_List.singleton(Data_List.singleton(v2(v3.value0.value0)(v3.value1)(v3.value0.value1))), v.value2));
                      });
                  });
              }));
          };
          return v;
      };
      var stdin = Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer.dash)(Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Argument.Stdin.value));
      var repetition = Text_Parsing_Parser_Combinators_1.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))([ Text_Parsing_Parser_Combinators_1["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Common.indented)(Language_Docopt_Parser_Lexer.tripleDot))(Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(true))), Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(false) ]);
      var shortOption = Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Argument.OptionStack.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer.sopt)(function (v) {
          return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Option["sopt'"](v.flag)(v.stack)(v.arg))(repetition);
      }));
      var reference = Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Argument.Reference.create)(Language_Docopt_Parser_Lexer.reference);
      var program = Text_Parsing_Parser_Combinators_1["<??>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))("Program name")(Language_Docopt_Parser_Lexer.name);
      var positional = Prelude["<*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Argument.Positional.create)(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer.angleName)(Language_Docopt_Parser_Lexer.shoutName)))(repetition);
      var longOption = Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Argument.Option.create)(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer.lopt)(function (v) {
          return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Option["lopt'"](v.name)(v.arg))(repetition);
      }));
      var option = Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(longOption)(shortOption);
      var command = Prelude["<*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Argument.Command.create)(Language_Docopt_Parser_Lexer.name))(repetition);
      var reqGroup = Control_Lazy.defer(Text_Parsing_Parser.lazyParserT)(function (v) {
          return Prelude["<*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Argument.Group.create(false))(Text_Parsing_Parser_Combinators_1.between(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Common.indented)(Language_Docopt_Parser_Lexer.lparen))(Language_Docopt_Parser_Lexer.rparen)(Text_Parsing_Parser_Combinators_1.sepBy1(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Data_List.some(Text_Parsing_Parser.alternativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser.lazyParserT)(elem))(Language_Docopt_Parser_Lexer.vbar))))(repetition);
      });
      var optGroup = Control_Lazy.defer(Text_Parsing_Parser.lazyParserT)(function (v) {
          return Prelude["<*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Argument.Group.create(true))(Text_Parsing_Parser_Combinators_1.between(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Common.indented)(Language_Docopt_Parser_Lexer.lsquare))(Language_Docopt_Parser_Lexer.rsquare)(Text_Parsing_Parser_Combinators_1.sepBy1(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Data_List.some(Text_Parsing_Parser.alternativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser.lazyParserT)(elem))(Language_Docopt_Parser_Lexer.vbar))))(repetition);
      });
      var group = Control_Lazy.defer(Text_Parsing_Parser.lazyParserT)(function (v) {
          return Text_Parsing_Parser_Combinators_1.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))([ reqGroup, optGroup ]);
      });
      var elem = Control_Lazy.defer(Text_Parsing_Parser.lazyParserT)(function (v) {
          return Text_Parsing_Parser_Combinators_1["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators_1.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude["<$>"](Prelude.functorArray)(Text_Parsing_Parser_Combinators_1["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))([ option, positional, command, Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))((function () {
              if (smartOpts) {
                  return trySmartOpt;
              };
              if (!smartOpts) {
                  return Prelude.id(Prelude.categoryFn);
              };
              throw new Error("Failed pattern match at Language.Docopt.Parser.Usage line 101, column 12 - line 101, column 49: " + [ smartOpts.constructor.name ]);
          })())(group), reference, stdin ])))("Option, Positional, Command, Group or Reference");
      });
      var usageLine = function (name) {
          return Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Usage_Usage_1.Usage.create(name))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators_1["<??>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))("Option, Positional, Command, Group or Reference elements")(Text_Parsing_Parser_Combinators_1.sepBy1(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Data_List.many(Text_Parsing_Parser.alternativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser.lazyParserT)(Text_Parsing_Parser_Combinators_1["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Common.moreIndented)(elem))))(Language_Docopt_Parser_Lexer.vbar)))(function (v) {
              return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators_1.choice(Data_Foldable.foldableArray)(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))([ Text_Parsing_Parser_Combinators_1["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Apply["*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Common.moreIndented)(Language_Docopt_Parser_Lexer.doubleDash))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators_1.optional(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Data_List.many(Text_Parsing_Parser.alternativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser.lazyParserT)(elem)))(function () {
                      return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(new Data_Maybe.Just(Language_Docopt_Parser_Usage_Argument.EOA.value));
                  });
              })), Text_Parsing_Parser_Combinators_1["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer.eof)(Text_Parsing_Parser_Combinators_1.lookAhead(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Control_Alt["<|>"](Text_Parsing_Parser.altParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Common.lessIndented)(Language_Docopt_Parser_Common.sameIndent))))(function () {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Maybe.Nothing.value);
              }))("End of usage line") ]))(function (v1) {
                  return Prelude["return"](Text_Parsing_Parser.applicativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Data_Maybe.maybe(v)(Prelude.id(Prelude.categoryFn))(Prelude.bind(Data_Maybe.bindMaybe)(v1)(function (v2) {
                      return Data_List.modifyAt(Data_List.length(v) - 1)(function (as) {
                          return Prelude["++"](Data_List.semigroupList)(as)(Data_List.singleton(v2));
                      })(v);
                  })));
              });
          }));
      };
      return Control_Apply["<*"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators_1["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Lexer.nextTokPos)("Program name"))(function (v) {
          return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(program)(function (v1) {
              return Language_Docopt_Parser_Common.markLine(Language_Docopt_Parser_Common["markIndent'"](v.value0.column)(Prelude["<*>"](Text_Parsing_Parser.applyParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude["<$>"](Text_Parsing_Parser.functorParserT(Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity)))(Data_List.Cons.create)(usageLine(v1)))(Data_List.many(Text_Parsing_Parser.alternativeParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser.lazyParserT)(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Text_Parsing_Parser_Combinators_1.optional(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Text_Parsing_Parser_Combinators_1["try"](Control_Monad_State_Trans.functorStateT(Data_Identity.monadIdentity))(Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Prelude[">>="](Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(Language_Docopt_Parser_Lexer.name)(function ($79) {
                  return Control_MonadPlus.guard(Text_Parsing_Parser.monadPlusParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))((function (v2) {
                      return v2 === "or";
                  })($79));
              }))(function () {
                  return Language_Docopt_Parser_Lexer.colon;
              }))))(function () {
                  return Prelude.bind(Text_Parsing_Parser.bindParserT(Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity)))(program)(function () {
                      return usageLine(v1);
                  });
              })))));
          });
      }))(Text_Parsing_Parser_Combinators_1["<?>"](Control_Monad_State_Trans.monadStateT(Data_Identity.monadIdentity))(Language_Docopt_Parser_Lexer.eof)("End of usage section"));
  };
  var parse = function (smartOpts) {
      return Prelude.flip(Language_Docopt_Parser_Lexer.runTokenParser)(usageParser(smartOpts));
  };
  var run = function (x) {
      return function (smartOpts) {
          return Control_Bind["=<<"](Data_Either.bindEither)(parse(smartOpts))(Language_Docopt_Parser_Lexer.lexUsage(x));
      };
  };
  exports["parse"] = parse;
  exports["run"] = run;
  exports["usageParser"] = usageParser;
})(PS["Language.Docopt.Parser.Usage"] = PS["Language.Docopt.Parser.Usage"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Language.Docopt.Solver"];
  var Prelude = PS["Prelude"];
  var Data_Array = PS["Data.Array"];
  var Data_String_1 = PS["Data.String"];
  var Data_String_Unsafe = PS["Data.String.Unsafe"];
  var Language_Docopt_Argument_1 = PS["Language.Docopt.Argument"];
  var Language_Docopt_Option = PS["Language.Docopt.Option"];
  var Language_Docopt_Parser_Desc_1 = PS["Language.Docopt.Parser.Desc"];
  var Language_Docopt_Parser_Usage_Option = PS["Language.Docopt.Parser.Usage.Option"];
  var Control_Alt = PS["Control.Alt"];
  var Control_MonadPlus = PS["Control.MonadPlus"];
  var Control_MonadPlus_Partial = PS["Control.MonadPlus.Partial"];
  var Data_Bifunctor = PS["Data.Bifunctor"];
  var Data_Either = PS["Data.Either"];
  var Data_Foldable = PS["Data.Foldable"];
  var Data_Function = PS["Data.Function"];
  var Data_Functor = PS["Data.Functor"];
  var Data_List = PS["Data.List"];
  var Data_Maybe = PS["Data.Maybe"];
  var Data_Maybe_Unsafe = PS["Data.Maybe.Unsafe"];
  var Data_String_1 = PS["Data.String"];
  var Data_String_Ext = PS["Data.String.Ext"];
  var Data_Traversable = PS["Data.Traversable"];
  var Data_Tuple = PS["Data.Tuple"];
  var Language_Docopt_Argument_1 = PS["Language.Docopt.Argument"];
  var Language_Docopt_Errors = PS["Language.Docopt.Errors"];
  var Language_Docopt_Parser_Desc_1 = PS["Language.Docopt.Parser.Desc"];
  var Language_Docopt_Parser_Usage = PS["Language.Docopt.Parser.Usage"];
  var Language_Docopt_Parser_Usage_Argument = PS["Language.Docopt.Parser.Usage.Argument"];
  var Language_Docopt_Usage = PS["Language.Docopt.Usage"];
  var Language_Docopt_Parser_Usage_Usage = PS["Language.Docopt.Parser.Usage.Usage"];        
  var Slurp = (function () {
      function Slurp(value0) {
          this.value0 = value0;
      };
      Slurp.create = function (value0) {
          return new Slurp(value0);
      };
      return Slurp;
  })();
  var Keep = (function () {
      function Keep(value0) {
          this.value0 = value0;
      };
      Keep.create = function (value0) {
          return new Keep(value0);
      };
      return Keep;
  })();
  var Resolved = (function () {
      function Resolved(value0) {
          this.value0 = value0;
      };
      Resolved.create = function (value0) {
          return new Resolved(value0);
      };
      return Resolved;
  })();
  var Unresolved = (function () {
      function Unresolved(value0) {
          this.value0 = value0;
      };
      Unresolved.create = function (value0) {
          return new Unresolved(value0);
      };
      return Unresolved;
  })();
  var fail = function ($199) {
      return Data_Either.Left.create(Language_Docopt_Errors.SolveError($199));
  };
  var solveBranch = function (as) {
      return function (ds) {
          var simpleResolve = function (v) {
              return Data_Either.Right.create(Resolved.create(Keep.create(Data_List.singleton(v))));
          };
          var resolveOptArg = function (v) {
              return function (v1) {
                  if (v instanceof Data_Maybe.Just && v1 instanceof Data_Maybe.Nothing) {
                      return Prelude["return"](Data_Either.applicativeEither)(Prelude.pure(Data_Maybe.applicativeMaybe)({
                          name: v.value0.name, 
                          optional: v.value0.optional, 
                          "default": Data_Maybe.Nothing.value
                      }));
                  };
                  if (v instanceof Data_Maybe.Nothing && v1 instanceof Data_Maybe.Just) {
                      return Prelude["return"](Data_Either.applicativeEither)(Prelude.pure(Data_Maybe.applicativeMaybe)({
                          name: v1.value0.name, 
                          optional: v1.value0.optional, 
                          "default": v1.value0["default"]
                      }));
                  };
                  if (v instanceof Data_Maybe.Just && v1 instanceof Data_Maybe.Just) {
                      return Prelude["return"](Data_Either.applicativeEither)(Prelude.pure(Data_Maybe.applicativeMaybe)({
                          name: v1.value0.name, 
                          optional: v1.value0.optional || v.value0.optional, 
                          "default": v1.value0["default"]
                      }));
                  };
                  return Prelude["return"](Data_Either.applicativeEither)(Data_Maybe.Nothing.value);
              };
          };
          var convertArg = function (arg) {
              return Prelude.bind(Data_Maybe.bindMaybe)(arg)(function (v) {
                  return Prelude["return"](Data_Maybe.applicativeMaybe)({
                      name: v.name, 
                      optional: v.optional, 
                      "default": Data_Maybe.Nothing.value
                  });
              });
          };
          var solveArg = function (v) {
              return function (v1) {
                  if (v instanceof Language_Docopt_Parser_Usage_Argument.EOA) {
                      return simpleResolve(Language_Docopt_Argument_1.EOA.value);
                  };
                  if (v instanceof Language_Docopt_Parser_Usage_Argument.Stdin) {
                      return simpleResolve(Language_Docopt_Argument_1.Stdin.value);
                  };
                  if (v instanceof Language_Docopt_Parser_Usage_Argument.Command) {
                      return simpleResolve(new Language_Docopt_Argument_1.Command(v.value0, v.value1));
                  };
                  if (v instanceof Language_Docopt_Parser_Usage_Argument.Positional) {
                      return simpleResolve(new Language_Docopt_Argument_1.Positional(v.value0, v.value1));
                  };
                  if (v instanceof Language_Docopt_Parser_Usage_Argument.Group) {
                      return Prelude["<$>"](Data_Either.functorEither)(function ($200) {
                          return Resolved.create(Keep.create(Data_List.singleton($200)));
                      })(Prelude["<$>"](Data_Either.functorEither)(Prelude.flip(Language_Docopt_Argument_1.Group.create(v.value0))(v.value2))(Data_Traversable.traverse(Data_List.traversableList)(Data_Either.applicativeEither)(Prelude.flip(solveBranch)(ds))(v.value1)));
                  };
                  if (v instanceof Language_Docopt_Parser_Usage_Argument.Reference) {
                      return Prelude["return"](Data_Either.applicativeEither)(new Unresolved(v.value0));
                  };
                  if (v instanceof Language_Docopt_Parser_Usage_Argument.Option) {
                      var matchDesc = function (n) {
                          var isMatch = function (v2) {
                              if (v2 instanceof Language_Docopt_Parser_Desc_1.OptionDesc && v2.value0.name instanceof Language_Docopt_Parser_Desc_1.Long) {
                                  return n === v2.value0.name.value0;
                              };
                              if (v2 instanceof Language_Docopt_Parser_Desc_1.OptionDesc && v2.value0.name instanceof Language_Docopt_Parser_Desc_1.Full) {
                                  return n === v2.value0.name.value1;
                              };
                              return false;
                          };
                          var $70 = Data_List.filter(isMatch)(ds);
                          if (Data_List.length($70) > 1) {
                              return fail("Multiple option descriptions for option --" + n);
                          };
                          if ($70 instanceof Data_List.Cons && ($70.value0 instanceof Language_Docopt_Parser_Desc_1.OptionDesc && $70.value1 instanceof Data_List.Nil)) {
                              return Prelude.bind(Data_Either.bindEither)(resolveOptArg(v.value0.arg)($70.value0.value0.arg))(function (v2) {
                                  return Prelude["return"](Data_Either.applicativeEither)({
                                      flag: Language_Docopt_Parser_Desc_1.getFlag($70.value0.value0.name), 
                                      name: Language_Docopt_Parser_Desc_1.getName($70.value0.value0.name), 
                                      arg: v2, 
                                      env: $70.value0.value0.env, 
                                      repeatable: v.value0.repeatable
                                  });
                              });
                          };
                          return Prelude["return"](Data_Either.applicativeEither)(Language_Docopt_Option.Option({
                              flag: Data_Maybe.Nothing.value, 
                              name: Prelude.pure(Data_Maybe.applicativeMaybe)(n), 
                              env: Data_Maybe.Nothing.value, 
                              arg: convertArg(v.value0.arg), 
                              repeatable: v.value0.repeatable
                          }));
                      };
                      var guardArgs = function (n) {
                          return function (n$prime) {
                              if (Data_String_Ext.upperCaseEq(n)(n$prime)) {
                                  return Prelude["return"](Data_Either.applicativeEither)(true);
                              };
                              return fail("Arguments mismatch for option --" + (v.value0.name + (": " + (Prelude.show(Prelude.showString)(n) + (" and " + Prelude.show(Prelude.showString)(n$prime))))));
                          };
                      };
                      return Prelude.bind(Data_Either.bindEither)(Prelude["<$>"](Data_Either.functorEither)(Language_Docopt_Option.runOption)(matchDesc(v.value0.name)))(function (v2) {
                          if (v.value0.arg instanceof Data_Maybe.Just) {
                              return Prelude["return"](Data_Either.applicativeEither)(Resolved.create(Keep.create(Data_List.singleton(Language_Docopt_Argument_1.Option.create(v2)))));
                          };
                          if (v.value0.arg instanceof Data_Maybe.Nothing) {
                              var mr = Prelude.bind(Data_Maybe.bindMaybe)(Control_MonadPlus.guard(Data_Maybe.monadPlusMaybe)(!v.value0.repeatable))(function () {
                                  return Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Option.runArgument)(v2.arg))(function (v3) {
                                      if (v1 instanceof Data_Maybe.Just && v1.value0 instanceof Language_Docopt_Parser_Usage_Argument.Positional) {
                                          return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Functor["<$"](Data_Either.functorEither)(v1.value0.value1)(guardArgs(v1.value0.value0)(v3.name)));
                                      };
                                      if (v1 instanceof Data_Maybe.Just && v1.value0 instanceof Language_Docopt_Parser_Usage_Argument.Command) {
                                          return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Functor["<$"](Data_Either.functorEither)(v1.value0.value1)(guardArgs(v1.value0.value0)(v3.name)));
                                      };
                                      return Prelude["return"](Data_Maybe.applicativeMaybe)(fail("Option-Argument specified in options-section missing" + (" --" + v.value0.name)));
                                  });
                              });
                              if (mr instanceof Data_Maybe.Nothing) {
                                  return Prelude["return"](Data_Either.applicativeEither)(Resolved.create(Keep.create(Data_List.singleton(Language_Docopt_Argument_1.Option.create(v2)))));
                              };
                              if (mr instanceof Data_Maybe.Just) {
                                  return Prelude.bind(Data_Either.bindEither)(mr.value0)(function (v3) {
                                      return Prelude["return"](Data_Either.applicativeEither)(Resolved.create(Slurp.create(Data_List.singleton(Language_Docopt_Argument_1.Option.create(Language_Docopt_Option.Option((function () {
                                          var $90 = {};
                                          for (var $91 in v2) {
                                              if (v2.hasOwnProperty($91)) {
                                                  $90[$91] = v2[$91];
                                              };
                                          };
                                          $90.repeatable = v3;
                                          return $90;
                                      })()))))));
                                  });
                              };
                              throw new Error("Failed pattern match at Language.Docopt.Solver line 203, column 11 - line 215, column 7: " + [ mr.constructor.name ]);
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Solver line 176, column 7 - line 215, column 7: " + [ v.value0.arg.constructor.name ]);
                      });
                  };
                  if (v instanceof Language_Docopt_Parser_Usage_Argument.OptionStack) {
                      var matchDesc = function (isTrailing) {
                          return function (f) {
                              var isMatch = function (v2) {
                                  if (v2 instanceof Language_Docopt_Parser_Desc_1.OptionDesc && v2.value0.name instanceof Language_Docopt_Parser_Desc_1.Flag) {
                                      return f === v2.value0.name.value0;
                                  };
                                  if (v2 instanceof Language_Docopt_Parser_Desc_1.OptionDesc && v2.value0.name instanceof Language_Docopt_Parser_Desc_1.Full) {
                                      return f === v2.value0.name.value0;
                                  };
                                  return false;
                              };
                              var $102 = Data_List.filter(isMatch)(ds);
                              if (Data_List.length($102) > 1) {
                                  return fail("Multiple option descriptions for option -" + Data_String_1.fromChar(f));
                              };
                              if ($102 instanceof Data_List.Cons && ($102.value0 instanceof Language_Docopt_Parser_Desc_1.OptionDesc && $102.value1 instanceof Data_List.Nil)) {
                                  return Prelude.bind(Data_Either.bindEither)((function () {
                                      if (isTrailing) {
                                          return resolveOptArg(v.value0.arg)($102.value0.value0.arg);
                                      };
                                      if (!isTrailing) {
                                          var $104 = Data_Maybe.isNothing($102.value0.value0.arg);
                                          if ($104) {
                                              return Prelude["return"](Data_Either.applicativeEither)(Data_Maybe.Nothing.value);
                                          };
                                          if (!$104) {
                                              return fail("Stacked option -" + (Data_String_1.fromChar(f) + " may not specify arguments"));
                                          };
                                          throw new Error("Failed pattern match at Language.Docopt.Solver line 434, column 32 - line 440, column 15: " + [ $104.constructor.name ]);
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.Solver line 432, column 22 - line 440, column 15: " + [ isTrailing.constructor.name ]);
                                  })())(function (v2) {
                                      return Prelude["return"](Data_Either.applicativeEither)({
                                          flag: Language_Docopt_Parser_Desc_1.getFlag($102.value0.value0.name), 
                                          name: Language_Docopt_Parser_Desc_1.getName($102.value0.value0.name), 
                                          arg: v2, 
                                          env: $102.value0.value0.env, 
                                          repeatable: v.value0.repeatable
                                      });
                                  });
                              };
                              return Prelude["return"](Data_Either.applicativeEither)(Language_Docopt_Option.Option({
                                  flag: Prelude.pure(Data_Maybe.applicativeMaybe)(f), 
                                  name: Data_Maybe.Nothing.value, 
                                  env: Data_Maybe.Nothing.value, 
                                  arg: (function () {
                                      if (isTrailing) {
                                          return convertArg(v.value0.arg);
                                      };
                                      if (!isTrailing) {
                                          return Data_Maybe.Nothing.value;
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.Solver line 452, column 31 - line 455, column 23: " + [ isTrailing.constructor.name ]);
                                  })(), 
                                  repeatable: v.value0.repeatable
                              }));
                          };
                      };
                      var guardArgs = function (n) {
                          return function (n$prime) {
                              if (Data_String_Ext.upperCaseEq(n)(n$prime)) {
                                  return Prelude["return"](Data_Either.applicativeEither)(true);
                              };
                              return fail("Arguments mismatch for option -" + (Data_String_1.fromChar(v.value0.flag) + (": " + (Prelude.show(Prelude.showString)(n) + (" and " + Prelude.show(Prelude.showString)(n$prime))))));
                          };
                      };
                      var fromSubsumption = (function () {
                          var subsume = function (v2) {
                              return function (v3) {
                                  if (v3 instanceof Language_Docopt_Parser_Desc_1.OptionDesc) {
                                      return Prelude.bind(Data_Maybe.bindMaybe)(Language_Docopt_Parser_Desc_1.getFlag(v3.value0.name))(function (v4) {
                                          return Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Parser_Desc_1.runArgument)(v3.value0.arg))(function (v5) {
                                              var needle = Data_String_1.toUpper(Data_String_1.fromChar(v4) + v5.name);
                                              var haystack = Data_String_1.toUpper(v2);
                                              return Prelude.bind(Data_Maybe.bindMaybe)((function () {
                                                  var $116 = Data_String_Ext.endsWith(needle)(haystack);
                                                  if ($116) {
                                                      var ix = Data_String_1.length(haystack) - Data_String_1.length(needle);
                                                      var $117 = Data_String_Unsafe.charAt(ix)(v2) === v4;
                                                      if ($117) {
                                                          return Prelude["return"](Data_Maybe.applicativeMaybe)(new Data_Tuple.Tuple(Data_String_1.toCharArray(Data_String_1.take(Data_String_1.length(v2) - Data_String_1.length(v5.name) - 1)(v2)), {
                                                              flag: Prelude.pure(Data_Maybe.applicativeMaybe)(v4), 
                                                              name: Language_Docopt_Parser_Desc_1.getName(v3.value0.name), 
                                                              arg: Prelude.pure(Data_Maybe.applicativeMaybe)(v5), 
                                                              env: v3.value0.env, 
                                                              repeatable: v.value0.repeatable
                                                          }));
                                                      };
                                                      if (!$117) {
                                                          return Data_Maybe.Nothing.value;
                                                      };
                                                      throw new Error("Failed pattern match at Language.Docopt.Solver line 310, column 23 - line 321, column 17: " + [ $117.constructor.name ]);
                                                  };
                                                  if (!$116) {
                                                      return Data_Maybe.Nothing.value;
                                                  };
                                                  throw new Error("Failed pattern match at Language.Docopt.Solver line 307, column 31 - line 323, column 15: " + [ $116.constructor.name ]);
                                              })())(function (v6) {
                                                  return Prelude.bind(Data_Maybe.bindMaybe)(Data_Either.either(Prelude["const"](Data_Maybe.Nothing.value))(function ($201) {
                                                      return Prelude.pure(Data_Maybe.applicativeMaybe)(Prelude.id(Prelude.categoryFn)($201));
                                                  })(Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Either.applicativeEither)(matchDesc(false))(v6.value0)))(function (v7) {
                                                      return Prelude["return"](Data_Maybe.applicativeMaybe)(Resolved.create(Keep.create(Prelude["++"](Data_List.semigroupList)(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Argument_1.Option.create)(Data_List.toList(Data_Foldable.foldableArray)(v7)))(Data_List.singleton(new Language_Docopt_Argument_1.Option(v6.value1))))));
                                                  });
                                              });
                                          });
                                      });
                                  };
                                  return Data_Maybe.Nothing.value;
                              };
                          };
                          return Prelude.bind(Data_Either.bindEither)((function () {
                              var $123 = Data_Maybe.isJust(v.value0.arg);
                              if ($123) {
                                  return fail("Option stacks with explicit argument binding " + "may not be subsumed.");
                              };
                              if (!$123) {
                                  return Prelude.pure(Data_Either.applicativeEither)(Prelude.unit);
                              };
                              throw new Error("Failed pattern match at Language.Docopt.Solver line 281, column 11 - line 286, column 11: " + [ $123.constructor.name ]);
                          })())(function () {
                              var fs = Data_String_1.fromCharArray(Data_Array[":"](v.value0.flag)(v.value0.stack));
                              return Data_Maybe.maybe(fail("No description subsumed option"))(Prelude["return"](Data_Either.applicativeEither))(Data_List.head(Data_List.catMaybes(Prelude["<$>"](Data_List.functorList)(subsume(fs))(ds))));
                          });
                      })();
                      var fromAdjacentArgOrDefault = Prelude.bind(Data_Either.bindEither)(Prelude["return"](Data_Either.applicativeEither)((function () {
                          var $124 = Data_Array.last(v.value0.stack);
                          if ($124 instanceof Data_Maybe.Just) {
                              return new Data_Tuple.Tuple(Data_Array[":"](v.value0.flag)(Data_Maybe_Unsafe.fromJust(Data_Array.init(v.value0.stack))), $124.value0);
                          };
                          if ($124 instanceof Data_Maybe.Nothing) {
                              return new Data_Tuple.Tuple([  ], v.value0.flag);
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Solver line 362, column 13 - line 369, column 11: " + [ $124.constructor.name ]);
                      })()))(function (v2) {
                          return Prelude.bind(Data_Either.bindEither)(Prelude["<$>"](Data_Either.functorEither)(Language_Docopt_Option.runOption)(matchDesc(true)(v2.value1)))(function (v3) {
                              return Prelude.bind(Data_Either.bindEither)(Prelude["<$>"](Data_Either.functorEither)(function (v4) {
                                  return Prelude["<$>"](Prelude.functorArray)(Language_Docopt_Argument_1.Option.create)(v4);
                              })(Data_Traversable.traverse(Data_Traversable.traversableArray)(Data_Either.applicativeEither)(matchDesc(false))(v2.value0)))(function (v4) {
                                  if (v.value0.arg instanceof Data_Maybe.Just) {
                                      return Prelude["return"](Data_Either.applicativeEither)(Resolved.create(Keep.create(Prelude["++"](Data_List.semigroupList)(Data_List.toList(Data_Foldable.foldableArray)(v4))(Data_List.singleton(Language_Docopt_Argument_1.Option.create(v3))))));
                                  };
                                  if (v.value0.arg instanceof Data_Maybe.Nothing) {
                                      var mr = Prelude.bind(Data_Maybe.bindMaybe)(Control_MonadPlus.guard(Data_Maybe.monadPlusMaybe)(!v3.repeatable))(function () {
                                          return Prelude.bind(Data_Maybe.bindMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Language_Docopt_Option.runArgument)(v3.arg))(function (v5) {
                                              if (v1 instanceof Data_Maybe.Just && v1.value0 instanceof Language_Docopt_Parser_Usage_Argument.Positional) {
                                                  return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Functor["<$"](Data_Either.functorEither)(v1.value0.value1)(guardArgs(v1.value0.value0)(v5.name)));
                                              };
                                              if (v1 instanceof Data_Maybe.Just && v1.value0 instanceof Language_Docopt_Parser_Usage_Argument.Command) {
                                                  return Prelude["return"](Data_Maybe.applicativeMaybe)(Data_Functor["<$"](Data_Either.functorEither)(v1.value0.value1)(guardArgs(v1.value0.value0)(v5.name)));
                                              };
                                              return Prelude["return"](Data_Maybe.applicativeMaybe)(fail("Option-Argument specified in options-section missing" + (" -" + Data_String_1.fromChar(v.value0.flag))));
                                          });
                                      });
                                      if (mr instanceof Data_Maybe.Nothing) {
                                          return Prelude["return"](Data_Either.applicativeEither)(Resolved.create(Keep.create(Prelude["++"](Data_List.semigroupList)(Data_List.toList(Data_Foldable.foldableArray)(v4))(Data_List.singleton(Language_Docopt_Argument_1.Option.create(v3))))));
                                      };
                                      if (mr instanceof Data_Maybe.Just) {
                                          return Prelude.bind(Data_Either.bindEither)(mr.value0)(function (v5) {
                                              return Prelude["return"](Data_Either.applicativeEither)(Resolved.create(Slurp.create(Prelude["++"](Data_List.semigroupList)(Data_List.toList(Data_Foldable.foldableArray)(v4))(Data_List.singleton(Language_Docopt_Argument_1.Option.create((function () {
                                                  var $141 = {};
                                                  for (var $142 in v3) {
                                                      if (v3.hasOwnProperty($142)) {
                                                          $141[$142] = v3[$142];
                                                      };
                                                  };
                                                  $141.repeatable = v5;
                                                  return $141;
                                              })()))))));
                                          });
                                      };
                                      throw new Error("Failed pattern match at Language.Docopt.Solver line 401, column 19 - line 413, column 9: " + [ mr.constructor.name ]);
                                  };
                                  throw new Error("Failed pattern match at Language.Docopt.Solver line 375, column 11 - line 413, column 9: " + [ v.value0.arg.constructor.name ]);
                              });
                          });
                      });
                      return Control_Alt["<|>"](Data_Either.altEither)(fromSubsumption)(fromAdjacentArgOrDefault);
                  };
                  throw new Error("Failed pattern match at Language.Docopt.Solver line 156, column 5 - line 157, column 5: " + [ v.constructor.name, v1.constructor.name ]);
              };
          };
          var solveArgs = function (v) {
              if (v instanceof Data_List.Nil) {
                  return Prelude["return"](Data_Either.applicativeEither)(Data_List.Nil.value);
              };
              if (v instanceof Data_List.Cons && v.value1 instanceof Data_List.Nil) {
                  return Prelude.bind(Data_Either.bindEither)(solveArg(v.value0)(Data_Maybe.Nothing.value))(function (v1) {
                      return Prelude["return"](Data_Either.applicativeEither)((function () {
                          if (v1 instanceof Resolved && v1.value0 instanceof Slurp) {
                              return Prelude["<$>"](Data_List.functorList)(Resolved.create)(v1.value0.value0);
                          };
                          if (v1 instanceof Resolved && v1.value0 instanceof Keep) {
                              return Prelude["<$>"](Data_List.functorList)(Resolved.create)(v1.value0.value0);
                          };
                          if (v1 instanceof Unresolved) {
                              return Data_List.singleton(new Unresolved(v1.value0));
                          };
                          throw new Error("Failed pattern match at Language.Docopt.Solver line 134, column 7 - line 138, column 5: " + [ v1.constructor.name ]);
                      })());
                  });
              };
              if (v instanceof Data_List.Cons && v.value1 instanceof Data_List.Cons) {
                  return Prelude.bind(Data_Either.bindEither)(solveArg(v.value0)(new Data_Maybe.Just(v.value1.value0)))(function (v1) {
                      if (v1 instanceof Resolved && v1.value0 instanceof Keep) {
                          return Prelude["<$>"](Data_Either.functorEither)(function (v2) {
                              return Prelude["++"](Data_List.semigroupList)(Prelude["<$>"](Data_List.functorList)(Resolved.create)(v1.value0.value0))(v2);
                          })(solveArgs(Data_List[":"](v.value1.value0)(v.value1.value1)));
                      };
                      if (v1 instanceof Resolved && v1.value0 instanceof Slurp) {
                          return Prelude["<$>"](Data_Either.functorEither)(function (v2) {
                              return Prelude["++"](Data_List.semigroupList)(Prelude["<$>"](Data_List.functorList)(Resolved.create)(v1.value0.value0))(v2);
                          })(solveArgs(v.value1.value1));
                      };
                      if (v1 instanceof Unresolved) {
                          return Prelude["<$>"](Data_Either.functorEither)(function (v2) {
                              return Prelude["++"](Data_List.semigroupList)(Data_List.singleton(new Unresolved(v1.value0)))(v2);
                          })(solveArgs(Data_List[":"](v.value1.value0)(v.value1.value1)));
                      };
                      throw new Error("Failed pattern match at Language.Docopt.Solver line 140, column 7 - line 146, column 5: " + [ v1.constructor.name ]);
                  });
              };
              throw new Error("Failed pattern match at Language.Docopt.Solver line 131, column 5 - line 132, column 5: " + [ v.constructor.name ]);
          };
          var go = function (us) {
              var isResolved = function (v) {
                  if (v instanceof Resolved) {
                      return true;
                  };
                  return false;
              };
              var partition = function (xs) {
                  var f = Data_Bifunctor.bimap(Data_Tuple.bifunctorTuple)(function (v) {
                      return Prelude["<#>"](Data_List.functorList)(v)(function (a) {
                          if (a instanceof Resolved) {
                              return a.value0;
                          };
                          return $foreign["undefined"];
                      });
                  })(function (v) {
                      return Prelude["<#>"](Data_List.functorList)(v)(function (a) {
                          if (a instanceof Unresolved) {
                              return a.value0;
                          };
                          return $foreign["undefined"];
                      });
                  });
                  return Prelude["<$>"](Data_List.functorList)(f)(Prelude["<$>"](Data_List.functorList)(Control_MonadPlus_Partial.mpartition(Data_List.monadPlusList)(isResolved))(xs));
              };
              var isFree = function (v) {
                  if (v instanceof Resolved) {
                      return Language_Docopt_Argument_1.isFree(v.value0);
                  };
                  if (v instanceof Unresolved) {
                      return true;
                  };
                  throw new Error("Failed pattern match at Language.Docopt.Solver line 61, column 5 - line 128, column 5: " + [ v.constructor.name ]);
              };
              var groupFree = Data_List.groupBy(Data_Function.on(Prelude.eq(Prelude.eqBoolean))(isFree));
              var expand = (function () {
                  var expand$prime = function (v) {
                      if (Data_List.length(v.value1) > 0) {
                          var map = function (__copy_args) {
                              return function (__copy_v1) {
                                  var args = __copy_args;
                                  var v1 = __copy_v1;
                                  tco: while (true) {
                                      if (v1 instanceof Data_List.Cons && v1.value0 instanceof Language_Docopt_Parser_Desc_1.OptionDesc) {
                                          var isMatch = function (v2) {
                                              if (v2 instanceof Language_Docopt_Argument_1.Option) {
                                                  var $181 = Data_Maybe.isJust(Language_Docopt_Parser_Desc_1.getFlag(v1.value0.value0.name)) && Data_Maybe.isJust(v2.value0.flag);
                                                  if ($181) {
                                                      return Data_Maybe.fromMaybe(false)(Prelude["<*>"](Data_Maybe.applyMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Prelude.eq(Prelude.eqChar))(Language_Docopt_Parser_Desc_1.getFlag(v1.value0.value0.name)))(v2.value0.flag));
                                                  };
                                                  if (!$181) {
                                                      var $182 = Data_Maybe.isJust(Language_Docopt_Parser_Desc_1.getName(v1.value0.value0.name)) && Data_Maybe.isJust(v2.value0.name);
                                                      if ($182) {
                                                          return Data_Maybe.fromMaybe(false)(Prelude["<*>"](Data_Maybe.applyMaybe)(Prelude["<$>"](Data_Maybe.functorMaybe)(Data_String_Ext.upperCaseEq)(Language_Docopt_Parser_Desc_1.getName(v1.value0.value0.name)))(v2.value0.name));
                                                      };
                                                      if (!$182) {
                                                          return false;
                                                      };
                                                      throw new Error("Failed pattern match at Language.Docopt.Solver line 108, column 34 - line 114, column 21: " + [ $182.constructor.name ]);
                                                  };
                                                  throw new Error("Failed pattern match at Language.Docopt.Solver line 103, column 25 - line 114, column 21: " + [ $181.constructor.name ]);
                                              };
                                              if (v2 instanceof Language_Docopt_Argument_1.Group) {
                                                  return Data_Foldable.any(Data_List.foldableList)(Prelude.booleanAlgebraBoolean)(isMatch)(Data_List.concat(Prelude["<$>"](Data_List.functorList)(Language_Docopt_Argument_1.runBranch)(v2.value1)));
                                              };
                                              return false;
                                          };
                                          var convArg = function (arg) {
                                              return Prelude["<$>"](Data_Maybe.functorMaybe)(function ($202) {
                                                  return Language_Docopt_Option.Argument(Language_Docopt_Parser_Desc_1.runArgument($202));
                                              })(arg);
                                          };
                                          var $187 = Data_Maybe.isJust(Data_List.findIndex(isMatch)(args));
                                          if ($187) {
                                              var __tco_args = args;
                                              var __tco_v1 = v1.value1;
                                              args = __tco_args;
                                              v1 = __tco_v1;
                                              continue tco;
                                          };
                                          if (!$187) {
                                              var converted = new Language_Docopt_Argument_1.Group(true, Data_List.singleton(Language_Docopt_Argument_1.Branch(Data_List.singleton(Language_Docopt_Argument_1.Option.create({
                                                  flag: Language_Docopt_Parser_Desc_1.getFlag(v1.value0.value0.name), 
                                                  name: Language_Docopt_Parser_Desc_1.getName(v1.value0.value0.name), 
                                                  arg: convArg(v1.value0.value0.arg), 
                                                  env: v1.value0.value0.env, 
                                                  repeatable: false
                                              })))), v1.value0.value0.repeatable);
                                              var __tco_args = Data_List[":"](converted)(args);
                                              var __tco_v1 = v1.value1;
                                              args = __tco_args;
                                              v1 = __tco_v1;
                                              continue tco;
                                          };
                                          throw new Error("Failed pattern match at Language.Docopt.Solver line 84, column 19 - line 101, column 19: " + [ $187.constructor.name ]);
                                      };
                                      return args;
                                  };
                              };
                          };
                          return map(v.value0)(ds);
                      };
                      return v.value0;
                  };
                  return function (v) {
                      return Prelude["<$>"](Data_List.functorList)(expand$prime)(v);
                  };
              })();
              return Prelude["<$>"](Data_Either.functorEither)(function ($203) {
                  return Data_List.concat(expand(partition(groupFree($203))));
              })(solveArgs(us));
          };
          return Prelude["<$>"](Data_Either.functorEither)(Language_Docopt_Argument_1.Branch)(go(as));
      };
  };
  var solveUsage = function (v) {
      return function (ds) {
          return Prelude["<$>"](Data_Either.functorEither)(Language_Docopt_Usage.Usage)(Data_Traversable.traverse(Data_List.traversableList)(Data_Either.applicativeEither)(Prelude.flip(solveBranch)(ds))(v.value1));
      };
  };
  var solve = function (us) {
      return function (ds) {
          return Data_Traversable.traverse(Data_List.traversableList)(Data_Either.applicativeEither)(Prelude.flip(solveUsage)(ds))(us);
      };
  };
  exports["Resolved"] = Resolved;
  exports["Unresolved"] = Unresolved;
  exports["Slurp"] = Slurp;
  exports["Keep"] = Keep;
  exports["solve"] = solve;
  exports["solveUsage"] = solveUsage;
  exports["solveBranch"] = solveBranch;
  exports["fail"] = fail;
})(PS["Language.Docopt.Solver"] = PS["Language.Docopt.Solver"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Data_Either = PS["Data.Either"];
  var Data_List = PS["Data.List"];
  var Data_StrMap = PS["Data.StrMap"];
  var Data_Tuple = PS["Data.Tuple"];
  var Data_Bifunctor = PS["Data.Bifunctor"];
  var Data_Traversable = PS["Data.Traversable"];
  var Text_Parsing_Parser = PS["Text.Parsing.Parser"];
  var Text_Wrap = PS["Text.Wrap"];
  var Language_Docopt_Usage = PS["Language.Docopt.Usage"];
  var Language_Docopt_Errors = PS["Language.Docopt.Errors"];
  var Language_Docopt_Value = PS["Language.Docopt.Value"];
  var Language_Docopt_ParserGen = PS["Language.Docopt.ParserGen"];
  var Language_Docopt_Trans = PS["Language.Docopt.Trans"];
  var Language_Docopt_Scanner = PS["Language.Docopt.Scanner"];
  var Language_Docopt_Solver = PS["Language.Docopt.Solver"];
  var Language_Docopt_Parser_Usage = PS["Language.Docopt.Parser.Usage"];
  var Language_Docopt_Parser_Desc = PS["Language.Docopt.Parser.Desc"];        
  var toUserParseErr = function (argv) {
      return Data_Bifunctor.lmap(Data_Either.bifunctorEither)(function ($13) {
          return Language_Docopt_Errors.prettyPrintDocoptError(Language_Docopt_Errors.DocoptUserParseError.create(argv)($13));
      });
  };
  var toUsageParseErr = Data_Bifunctor.lmap(Data_Either.bifunctorEither)(function ($14) {
      return Language_Docopt_Errors.prettyPrintDocoptError(Language_Docopt_Errors.DocoptUsageParseError.create($14));
  });
  var toSolveErr = Data_Bifunctor.lmap(Data_Either.bifunctorEither)(function ($15) {
      return Language_Docopt_Errors.prettyPrintDocoptError(Language_Docopt_Errors.DocoptSolveError.create($15));
  });
  var toScanErr = Data_Bifunctor.lmap(Data_Either.bifunctorEither)(function ($16) {
      return Language_Docopt_Errors.prettyPrintDocoptError(Language_Docopt_Errors.DocoptScanError.create($16));
  });
  var toDescParseErr = Data_Bifunctor.lmap(Data_Either.bifunctorEither)(function ($17) {
      return Language_Docopt_Errors.prettyPrintDocoptError(Language_Docopt_Errors.DocoptDescParseError.create($17));
  });
  var parseDocopt = function (docopt) {
      return function (smartOpts) {
          return Prelude.bind(Data_Either.bindEither)(toScanErr(Language_Docopt_Scanner.scan(Text_Wrap.dedent(docopt))))(function (v) {
              return Prelude.bind(Data_Either.bindEither)(toUsageParseErr(Language_Docopt_Parser_Usage.run(v.usage)(smartOpts)))(function (v1) {
                  return Prelude.bind(Data_Either.bindEither)(toDescParseErr(Prelude["<$>"](Data_Either.functorEither)(Data_List.concat)(Data_Traversable.traverse(Data_List.traversableList)(Data_Either.applicativeEither)(Language_Docopt_Parser_Desc.run)(v.options))))(function (v2) {
                      return Prelude.bind(Data_Either.bindEither)(toSolveErr(Language_Docopt_Solver.solve(v1)(v2)))(function (v3) {
                          return Prelude["return"](Data_Either.applicativeEither)({
                              specification: v3, 
                              usage: v.usage
                          });
                      });
                  });
              });
          });
      };
  };
  var applyDocopt = function (prg) {
      return function (env) {
          return function (argv) {
              return function (optsFirst) {
                  return Prelude.bind(Data_Either.bindEither)(toUserParseErr(argv)(Language_Docopt_ParserGen.runParser(env)(argv)(Language_Docopt_ParserGen.genParser(prg)(optsFirst))))(function (v) {
                      return Prelude["return"](Data_Either.applicativeEither)(Data_Tuple.uncurry(Language_Docopt_Trans.reduce(prg)(env))(v));
                  });
              };
          };
      };
  };
  exports["applyDocopt"] = applyDocopt;
  exports["parseDocopt"] = parseDocopt;
})(PS["Language.Docopt"] = PS["Language.Docopt"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var Prelude = PS["Prelude"];
  var Control_Monad_Aff = PS["Control.Monad.Aff"];
  var Control_Monad_Eff_Exception = PS["Control.Monad.Eff.Exception"];
  var Data_Either = PS["Data.Either"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  var Data_Maybe = PS["Data.Maybe"];
  var Node_FS = PS["Node.FS"];
  var Node_Process_1 = PS["Node.Process"];
  var Node_Process_1 = PS["Node.Process"];
  var Control_Monad_Eff_Class = PS["Control.Monad.Eff.Class"];
  var Control_Monad_Eff_Console_1 = PS["Control.Monad.Eff.Console"];
  var Control_Monad_Eff_Console_1 = PS["Control.Monad.Eff.Console"];
  var Text_Wrap = PS["Text.Wrap"];
  var Data_StrMap = PS["Data.StrMap"];
  var Data_Array = PS["Data.Array"];
  var Data_Bifunctor = PS["Data.Bifunctor"];
  var Data_List_WordsLines = PS["Data.List.WordsLines"];
  var Language_Docopt_1 = PS["Language.Docopt"];
  var Language_Docopt_1 = PS["Language.Docopt"];
  var Language_Docopt_Env = PS["Language.Docopt.Env"];
  var Data_List = PS["Data.List"];        
  var run = function (d) {
      return function (o) {
          var onError = function (e) {
              var $5 = !o.dontExit;
              if ($5) {
                  return function __do() {
                      Control_Monad_Eff_Console_1.log(e)();
                      return Node_Process_1.exit(1)();
                  };
              };
              if (!$5) {
                  return Control_Monad_Eff_Exception.throwException(Control_Monad_Eff_Exception.error(e));
              };
              throw new Error("Failed pattern match at Docopt line 91, column 7 - line 98, column 5: " + [ $5.constructor.name ]);
          };
          var help = function (usage) {
              return "Usage:\n" + (Data_List_WordsLines.unlines(Prelude["<$>"](Data_List.functorList)(function (v) {
                  return "  " + v;
              })(Data_List_WordsLines.lines(Text_Wrap.dedent(usage)))) + "\n");
          };
          return function __do() {
              var v = Data_Maybe.maybe(Prelude["<$>"](Control_Monad_Eff.functorEff)(Data_Array.drop(2))(Node_Process_1.argv))(function ($11) {
                  return Prelude["return"](Control_Monad_Eff.applicativeEff)(Prelude.id(Prelude.categoryFn)($11));
              })(o.argv)();
              var v1 = Data_Maybe.maybe(Node_Process_1.getEnv)(function ($12) {
                  return Prelude["return"](Control_Monad_Eff.applicativeEff)(Prelude.id(Prelude.categoryFn)($12));
              })(o.env)();
              return Data_Either.either(onError)(Prelude["return"](Control_Monad_Eff.applicativeEff))(Prelude.bind(Data_Either.bindEither)(Language_Docopt_1.parseDocopt(d)(o.smartOptions))(function (v2) {
                  return Data_Bifunctor.lmap(Data_Either.bifunctorEither)(function (v3) {
                      return help(v2.usage) + v3;
                  })(Language_Docopt_1.applyDocopt(v2.specification)(v1)(v)(o.optionsFirst));
              }))();
          };
      };
  };                                                                            
  var defaultOptions = {
      argv: Data_Maybe.Nothing.value, 
      env: Data_Maybe.Nothing.value, 
      optionsFirst: false, 
      dontExit: false, 
      smartOptions: false
  };
  exports["defaultOptions"] = defaultOptions;
  exports["run"] = run;
})(PS["Docopt"] = PS["Docopt"] || {});
(function(exports) {
  /* global exports */
  "use strict";

  // module Docopt.FFI

  exports.isTruthy = function (value) {
    return (value == true);
  };
})(PS["Docopt.FFI"] = PS["Docopt.FFI"] || {});
(function(exports) {
  // Generated by psc version 0.8.5.0
  "use strict";
  var $foreign = PS["Docopt.FFI"];
  var Prelude = PS["Prelude"];
  var Data_Function = PS["Data.Function"];
  var Data_Maybe = PS["Data.Maybe"];
  var Control_Monad_Eff = PS["Control.Monad.Eff"];
  var Data_Either = PS["Data.Either"];
  var Data_StrMap = PS["Data.StrMap"];
  var Control_Bind = PS["Control.Bind"];
  var Control_Alt = PS["Control.Alt"];
  var Data_Foreign_1 = PS["Data.Foreign"];
  var Data_Foreign_1 = PS["Data.Foreign"];
  var Data_Foreign_Class = PS["Data.Foreign.Class"];
  var Unsafe_Coerce = PS["Unsafe.Coerce"];
  var Docopt = PS["Docopt"];
  var Language_Docopt_Value = PS["Language.Docopt.Value"];
  var Data_Foreign_Index = PS["Data.Foreign.Index"];        
  var rawValue = function (v) {
      if (v instanceof Language_Docopt_Value.BoolValue) {
          return Unsafe_Coerce.unsafeCoerce(v.value0);
      };
      if (v instanceof Language_Docopt_Value.IntValue) {
          return Unsafe_Coerce.unsafeCoerce(v.value0);
      };
      if (v instanceof Language_Docopt_Value.FloatValue) {
          return Unsafe_Coerce.unsafeCoerce(v.value0);
      };
      if (v instanceof Language_Docopt_Value.StringValue) {
          return Unsafe_Coerce.unsafeCoerce(v.value0);
      };
      if (v instanceof Language_Docopt_Value.ArrayValue) {
          return Unsafe_Coerce.unsafeCoerce(Prelude["<$>"](Prelude.functorArray)(rawValue)(v.value0));
      };
      throw new Error("Failed pattern match at Docopt.FFI line 31, column 1 - line 32, column 1: " + [ v.constructor.name ]);
  };
  var run = (function () {
      var go = function (docopt) {
          return function (fopts) {
              var toMaybe = function (e) {
                  return Data_Either.either(Prelude["const"](Data_Maybe.Nothing.value))(function ($12) {
                      return Prelude["return"](Data_Maybe.applicativeMaybe)(Prelude.id(Prelude.categoryFn)($12));
                  })(e);
              };
              var isObject = function (f) {
                  return Data_Foreign_1.typeOf(f) === "object";
              };
              var readObject = function (value) {
                  if (isObject(value)) {
                      return Prelude.pure(Data_Either.applicativeEither)(Data_Foreign_1.unsafeFromForeign(value));
                  };
                  return new Data_Either.Left(new Data_Foreign_1.TypeMismatch("object", Data_Foreign_1.typeOf(value)));
              };
              var opts = (function () {
                  var $9 = {};
                  for (var $10 in Docopt.defaultOptions) {
                      if (Docopt.defaultOptions.hasOwnProperty($10)) {
                          $9[$10] = Docopt.defaultOptions[$10];
                      };
                  };
                  $9.argv = Prelude.flip(Control_Alt.alt(Data_Maybe.altMaybe))(Docopt.defaultOptions.argv)(toMaybe(Prelude["<$>"](Data_Either.functorEither)(Unsafe_Coerce.unsafeCoerce)(Control_Bind["=<<"](Data_Either.bindEither)(Data_Foreign_1.readArray)(Data_Foreign_Class.readProp(Data_Foreign_Class.foreignIsForeign)(Data_Foreign_Index.indexString)("argv")(fopts)))));
                  $9.env = Prelude.flip(Control_Alt.alt(Data_Maybe.altMaybe))(Docopt.defaultOptions.env)(toMaybe(Prelude["<$>"](Data_Either.functorEither)(Unsafe_Coerce.unsafeCoerce)(Control_Bind["=<<"](Data_Either.bindEither)(readObject)(Data_Foreign_Class.readProp(Data_Foreign_Class.foreignIsForeign)(Data_Foreign_Index.indexString)("env")(fopts)))));
                  $9.optionsFirst = Data_Either.either(Prelude["const"](Docopt.defaultOptions.optionsFirst))(Prelude.id(Prelude.categoryFn))(Prelude["<$>"](Data_Either.functorEither)($foreign.isTruthy)(Data_Foreign_Class.readProp(Data_Foreign_Class.foreignIsForeign)(Data_Foreign_Index.indexString)("optionsFirst")(fopts)));
                  $9.smartOptions = Data_Either.either(Prelude["const"](Docopt.defaultOptions.smartOptions))(Prelude.id(Prelude.categoryFn))(Prelude["<$>"](Data_Either.functorEither)($foreign.isTruthy)(Data_Foreign_Class.readProp(Data_Foreign_Class.foreignIsForeign)(Data_Foreign_Index.indexString)("smartOptions")(fopts)));
                  $9.dontExit = Data_Either.either(Prelude["const"](Docopt.defaultOptions.dontExit))(Prelude.id(Prelude.categoryFn))(Prelude["<$>"](Data_Either.functorEither)($foreign.isTruthy)(Data_Foreign_Class.readProp(Data_Foreign_Class.foreignIsForeign)(Data_Foreign_Index.indexString)("dontExit")(fopts)));
                  return $9;
              })();
              return function __do() {
                  var v = Docopt.run(docopt)(opts)();
                  return Prelude["<$>"](Data_StrMap.functorStrMap)(rawValue)(v);
              };
          };
      };
      return Data_Function.mkFn2(go);
  })();
  exports["run"] = run;
})(PS["Docopt.FFI"] = PS["Docopt.FFI"] || {});
module.exports = PS;
